<?php

function php_cache_compatibility_check(){
	
if (version_compare(PHP_VERSION, '5.3.0') >= 0) {
return true;
}

return false;
	
}

function check_server(){

if (!check_writeable(MAD_PATH . '/conf/')){
return false;	
}

if (!check_writeable(MAD_PATH . '/data/creative/')){
return false;	
}

if (!check_xml()){
return false;	
}

if (!check_mbstring()){
return false;	
}


return true;

}

function check_writeable($dir){
if (is_writable($dir)){
	return true;
}
return false;
}

function step_check($step){
if ($step>1 && !check_server()){
echo "Server check failed. Please re-start installation."; exit;	
}
}

function check_mbstring(){
if(extension_loaded("mbstring")){
return true;
}
return false;
}

function check_xml(){
if(extension_loaded("SimpleXML")){
return true;
}
else if (function_exists('simplexml_load_file')){
return true;
}else{
return false;
}	
}

function verify_main_config($data){

if (empty($data['server_name']) or empty($data['admin_firstname']) or empty($data['admin_lastname']) or empty($data['admin_email']) or empty($data['admin_pass']) or empty($data['admin_pass2'])){
global $errormessage;
$errormessage='Some fields are missing. Please fill all required fields.';
global $editdata;
$editdata=$data;
return false;
}

if ($data['admin_pass']!=$data['admin_pass2']){
global $errormessage;
$errormessage='The passwords you entered to not match.';
global $editdata;
$editdata=$data;
return false;
}

require_once MAD_PATH . '/modules/validation/validate.class.php';

$validate = new Validate;

if (($validate->isEmail($data['admin_email'])!=true)){
global $errormessage;
$errormessage='Please enter a valid e-mail address.';
global $editdata;
$editdata=$data;
return false;
}

	
	return true;
	}
	
	function verify_db_config($data){
		
error_reporting(0);
		
if (empty($data['db_host']) or empty($data['db_name']) or empty($data['db_user'])){
global $errormessage;
$errormessage='Some fields are missing. Please fill all required fields.';
global $editdata;
$editdata=$data;
return false;
}

$repdb=mysql_connect($data['db_host'], $data['db_user'], $data['db_pass']);

if (!$repdb){
global $errormessage;
$errormessage='Unable to connect to database. Please double check database details. Error #1';
global $editdata;
$editdata=$data;
return false;	
}

if (!mysql_select_db ($data['db_name'], $repdb)){
global $errormessage;
$errormessage='Unable to connect to database. Please double check database details. Error #2';
global $editdata;
$editdata=$data;
return false;		
}

return true;
		
	}
	
	function check_mf($data){
		
if (!isset($data['mobfox_connect_type']) or ($data['mobfox_connect_type']!=1 && $data['mobfox_connect_type']!=2)){
	global $errormessage;
$errormessage="Please tell us if you would like to use your existing account for MobFox:Connect, or if you'd like to create a new one.";
global $editdata;
$editdata=$data;
return false;
}

if ($data['mobfox_connect_type']==1){
	
	
if (empty($data['mf_user']) or empty($data['mf_pass'])){
global $errormessage;
$errormessage="Please enter your MobFox User Name and Password.";
global $editdata;
$editdata=$data;
return false;	
}

if (!mfconcheck($data['mf_user'], md5($data['mf_pass']), 0)){
global $errormessage;
$errormessage="Unable to validate your MobFox login credentials. Please try again.";
global $editdata;
$editdata=$data;
return false;		
}
	
}

else if ($data['mobfox_connect_type']==2){
	
if (empty($data['mf_email']) or empty($data['mf_password']) or empty($data['mf_password2']) or empty($data['mf_first_name']) or empty($data['mf_last_name'])){
global $errormessage;
$errormessage="Please enter all required fields.";
global $editdata;
$editdata=$data;
return false;	
}

if ($data['mf_password']!=$data['mf_password2']){
global $errormessage;
$errormessage='The passwords you entered to not match.';
global $editdata;
$editdata=$data;
return false;
}

if (!c_m_f($data)){
global $errormessage;
global $editdata;
$editdata=$data;
return false;	
}
	
	
}


if (finalize_install($data)){
return true;	
}
else {
global $errormessage;
global $editdata;
$editdata=$data;
return false;			
}

	
	}
	
	
function c_m_f($data){

require_once MAD_PATH . '/modules/http/class.http.php';


// Instantiate it
$http = new Http();

$http->execute('http://api.mobfox.com/createAccount/MADSERVE&email_address='.$data['mf_email'].'&password='.$data['mf_password'].'&first_name='.$data['mf_first_name'].'&last_name='.$data['mf_last_name'].'&phone_number='.$data['mf_phone'].'&portal=MADSERVE');

if ($http->error){
return false;
}

try {
$xml_response = new SimpleXmlElement($http->result, LIBXML_NOCDATA);
} catch (Exception $e) {
   // handle the error
return false;
}

if (isset($xml_response['status']) && $xml_response['status']=='error') {
global $errormessage;
$errormessage=$xml_response->error;
global $editdata;
$editdata=$data;
return false;
}

else if (isset($xml_response['status']) && $xml_response['status']=='success') {
return true;
}
else {
global $errormessage;
$errormessage='Unknown Error while trying to create your MobFox account. Please try again in a few minutes';
global $editdata;
$editdata=$data;
return false;	
}
		
	}
	
function finalize_install($data){
	
if (!$basic_config=read_config(MAD_PATH . '/conf/INSTALLTEMP_MAINCONFIG')){
global $errormessage;
$errormessage='Could not read from temporary Installation configuration file. Please check /conf/ directory read permissions and try again.';
global $editdata;
$editdata=$data;
return false;		
}

if (!$db_config=read_config(MAD_PATH . '/conf/INSTALLTEMP_DBCONFIG')){
global $errormessage;
$errormessage='Could not read from temporary Installation DB configuration file. Please check /conf/ directory read permissions and try again.';
global $editdata;
$editdata=$data;
return false;		
}

$mad_basic_configuration=unserialize($basic_config);
$mad_db_configuration=unserialize($db_config);


$maindb=mysql_connect($mad_db_configuration['db_host'], $mad_db_configuration['db_user'], $mad_db_configuration['db_pass']);

if (!$maindb){
global $errormessage;
$errormessage='Unable to connect to database. Please double check database details. Error #1';
global $editdata;
$editdata=$data;
return false;	
}

if (!mysql_select_db ($mad_db_configuration['db_name'], $maindb)){
global $errormessage;
$errormessage='Unable to connect to database. Please double check database details. Error #2';
global $editdata;
$editdata=$data;
return false;		
}

mysql_query("CREATE TABLE IF NOT EXISTS `md_ad_units` (
  `adv_id` int(11) NOT NULL auto_increment,
  `campaign_id` varchar(100) NOT NULL,
  `unit_hash` varchar(100) NOT NULL,
  `adv_type` varchar(100) NOT NULL,
  `adv_status` varchar(100) NOT NULL,
  `adv_click_url` longtext NOT NULL,
  `adv_click_opentype` varchar(100) NOT NULL,
  `adv_chtml` longtext NOT NULL,
  `adv_mraid` varchar(1) NOT NULL,
  `adv_bannerurl` longtext NOT NULL,
  `adv_impression_tracking_url` longtext NOT NULL,
  `adv_name` varchar(100) NOT NULL,
  `adv_clickthrough_type` varchar(100) NOT NULL,
  `adv_creative_extension` varchar(100) NOT NULL,
  `adv_height` varchar(100) NOT NULL,
  `adv_width` varchar(100) NOT NULL,
  `creativeserver_id` varchar(100) NOT NULL,
  PRIMARY KEY  (`adv_id`),
  KEY `campaign_id` (`campaign_id`,`adv_status`,`adv_height`,`adv_width`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);

mysql_query("CREATE TABLE IF NOT EXISTS `md_campaigns` (
  `campaign_id` int(11) NOT NULL auto_increment,
  `campaign_owner` varchar(100) NOT NULL,
  `campaign_status` varchar(100) NOT NULL,
  `campaign_type` varchar(100) NOT NULL,
  `campaign_name` varchar(100) NOT NULL,
  `campaign_desc` text NOT NULL,
  `campaign_start` date NOT NULL,
  `campaign_end` date NOT NULL,
  `campaign_creationdate` varchar(100) NOT NULL,
  `campaign_networkid` varchar(100) NOT NULL,
  `campaign_priority` varchar(100) NOT NULL,
  `campaign_rate_type` varchar(100) NOT NULL,
  `campaign_rate` varchar(100) NOT NULL,
  `target_iphone` varchar(1) NOT NULL,
  `target_ipod` varchar(1) NOT NULL,
  `target_ipad` varchar(1) NOT NULL,
  `target_android` varchar(1) NOT NULL,
  `target_other` varchar(1) NOT NULL,
  `ios_version_min` varchar(100) NOT NULL,
  `ios_version_max` varchar(100) NOT NULL,
  `android_version_min` varchar(100) NOT NULL,
  `android_version_max` varchar(100) NOT NULL,
  `country_target` varchar(1) NOT NULL,
  `publication_target` varchar(1) NOT NULL,
  `channel_target` varchar(1) NOT NULL,
  `device_target` varchar(1) NOT NULL,
  PRIMARY KEY  (`campaign_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_campaign_limit` (
  `entry_id` int(11) NOT NULL auto_increment,
  `campaign_id` varchar(100) NOT NULL,
  `cap_type` varchar(100) NOT NULL,
  `total_amount` varchar(100) NOT NULL,
  `total_amount_left` varchar(100) NOT NULL,
  `last_refresh` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  KEY `campaign_id` (`campaign_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_campaign_priorities` (
  `entry_id` int(11) NOT NULL auto_increment,
  `priority_id` varchar(100) NOT NULL,
  `priority_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;", $maindb);
mysql_query("INSERT INTO `md_campaign_priorities` (`entry_id`, `priority_id`, `priority_name`) VALUES
(1, '1', '1 - Lowest'),
(2, '2', '2 - Low'),
(3, '3', '3 - Medium'),
(4, '4', '4 - High'),
(5, '5', '5 - Highest');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_campaign_targeting` (
  `entry_id` int(11) NOT NULL auto_increment,
  `campaign_id` int(11) NOT NULL,
  `targeting_type` varchar(100) NOT NULL,
  `targeting_code` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  KEY `s2` (`campaign_id`),
  KEY `s1` (`targeting_type`,`targeting_code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_channels` (
  `channel_id` int(11) NOT NULL auto_increment,
  `channel_type` varchar(100) NOT NULL,
  `channel_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`channel_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=12 ;", $maindb);
mysql_query("INSERT INTO `md_channels` (`channel_id`, `channel_type`, `channel_name`) VALUES
(1, '1', 'Finance'),
(2, '1', 'IT'),
(3, '1', 'Business'),
(4, '1', 'Entertainment'),
(5, '1', 'News'),
(6, '1', 'Auto & Motor'),
(7, '1', 'Sport'),
(9, '1', 'Information'),
(10, '1', 'Community'),
(11, '1', 'Women');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_code_snippets` (
  `entry_id` int(11) NOT NULL auto_increment,
  `snippet_name` varchar(100) NOT NULL,
  `snippet_file` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;", $maindb);
mysql_query("INSERT INTO `md_code_snippets` (`entry_id`, `snippet_name`, `snippet_file`) VALUES
(1, 'JavaScript', 'javascript.txt'),
(2, 'PHP cURL', 'phpcurl.txt');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_configuration` (
  `entry_id` int(11) NOT NULL auto_increment,
  `var_name` varchar(200) NOT NULL,
  `var_value` varchar(200) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  UNIQUE KEY `var_name` (`var_name`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_creative_servers` (
  `entry_id` int(11) NOT NULL auto_increment,
  `server_type` varchar(255) NOT NULL,
  `server_name` varchar(255) NOT NULL,
  `remote_host` varchar(255) NOT NULL,
  `remote_port` varchar(255) NOT NULL,
  `remote_user` varchar(255) NOT NULL,
  `remote_password` varchar(255) NOT NULL,
  `remote_directory` varchar(255) NOT NULL,
  `server_default_url` varchar(255) NOT NULL,
  `server_status` varchar(1) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;", $maindb);
mysql_query("INSERT INTO `md_creative_servers` (`entry_id`, `server_type`, `server_name`, `remote_host`, `remote_port`, `remote_user`, `remote_password`, `remote_directory`, `server_default_url`, `server_status`) VALUES
(1, 'local', 'Local Creative Server', 'n/a', '', '', '', '', '', '');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_log_types` (
  `entry_id` int(11) NOT NULL auto_increment,
  `log_id` varchar(100) NOT NULL,
  `log_name` longtext NOT NULL,
  `log_desc` longtext NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;", $maindb);
mysql_query("INSERT INTO `md_log_types` (`entry_id`, `log_id`, `log_name`, `log_desc`) VALUES
(1, 'daily_cron', 'mAdserve Daily Cron Job', 'Daily cron job ran successfully.'),
(2, 'system_install', 'mAdserve Installation', 'mAdserve was installed successfully'),
(3, 'campaign_limit_update', 'Campaign Limits Reset', 'Daily Campaign Impression Caps have successfully been reset.');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_networks` (
  `entry_id` int(11) NOT NULL auto_increment,
  `network_name` varchar(100) NOT NULL,
  `network_logo` varchar(100) NOT NULL,
  `network_description` longtext NOT NULL,
  `network_identifier` varchar(100) NOT NULL,
  `network_d1_name` varchar(100) NOT NULL,
  `network_d2_name` varchar(100) NOT NULL,
  `network_d3_name` varchar(100) NOT NULL,
  `network_d4_name` varchar(100) NOT NULL,
  `signup_url` varchar(100) NOT NULL,
  `info_content` longtext NOT NULL,
  `banner_support` varchar(1) NOT NULL,
  `interstitial_support` varchar(1) NOT NULL,
  `network_auto_approve` varchar(1) NOT NULL,
  `network_aa_min` varchar(1) NOT NULL,
  `network_aa_min_cpc` decimal(5,3) NOT NULL,
  `network_aa_min_cpm` decimal(5,3) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  KEY `network_identifier` (`network_identifier`(6))
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_network_config` (
  `entry_id` int(11) NOT NULL auto_increment,
  `config_type` varchar(100) NOT NULL,
  `publication_id` varchar(100) NOT NULL,
  `zone_id` varchar(100) NOT NULL,
  `network_id` varchar(100) NOT NULL,
  `p_1` varchar(100) NOT NULL,
  `p_2` varchar(100) NOT NULL,
  `p_3` varchar(100) NOT NULL,
  `p_4` varchar(100) NOT NULL,
  `priority` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  KEY `pub_sel` (`publication_id`,`zone_id`,`network_id`,`priority`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_passwordresets` (
  `entry_id` int(11) NOT NULL auto_increment,
  `reset_status` varchar(100) NOT NULL,
  `reset_hash` varchar(100) NOT NULL,
  `reset_accountid` varchar(100) NOT NULL,
  `ip_address` varchar(100) NOT NULL,
  `time_stamp` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_pending_actions` (
  `entry_id` int(11) NOT NULL auto_increment,
  `action_id` varchar(100) NOT NULL,
  `action_detail` longtext NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_publications` (
  `inv_id` int(11) NOT NULL auto_increment,
  `creator_id` varchar(100) NOT NULL,
  `inv_status` varchar(100) NOT NULL,
  `inv_type` varchar(100) NOT NULL,
  `inv_name` varchar(100) NOT NULL,
  `inv_description` varchar(100) NOT NULL,
  `inv_address` varchar(100) NOT NULL,
  `inv_defaultchannel` varchar(100) NOT NULL,
  `md_lastrequest` varchar(100) NOT NULL,
  PRIMARY KEY  (`inv_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_publication_types` (
  `entry_id` int(11) NOT NULL auto_increment,
  `pub_identification` varchar(100) NOT NULL,
  `pub_name` varchar(100) NOT NULL,
  `pub_description` varchar(100) NOT NULL,
  `pub_sdk_url` varchar(100) NOT NULL,
  `pub_info_content` longtext NOT NULL,
  `pub_icon` varchar(100) NOT NULL,
  `output_type` varchar(100) NOT NULL,
  `code_type` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=4 ;", $maindb);
mysql_query("INSERT INTO `md_publication_types` (`entry_id`, `pub_identification`, `pub_name`, `pub_description`, `pub_sdk_url`, `pub_info_content`, `pub_icon`, `output_type`, `code_type`) VALUES
(1, 'ios_app', 'iOS Application', 'iOS Application', 'http://www.madserve.org/ios-latest', '', 'ios.png', 'xml', 'sdk'),
(2, 'android_app', 'Android Application', 'Android Application', 'http://www.madserve.org/android-latest', '', 'android.png', 'xml', 'sdk'),
(3, 'mobileweb', 'Mobile Website', 'Mobile Website', '', '', 'web.png', 'html', 'standard_code');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_regional_targeting` (
  `entry_id` int(11) NOT NULL auto_increment,
  `targeting_code` varchar(100) NOT NULL,
  `targeting_type` varchar(100) NOT NULL,
  `region_code` varchar(100) NOT NULL,
  `region_name` varchar(100) NOT NULL,
  `head_country` varchar(100) NOT NULL,
  `head_region` varchar(100) NOT NULL,
  `head_city` varchar(100) NOT NULL,
  `entry_status` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=8521 ;", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(1, 'AT', 'COUNTRY', 'AT', 'Austria', '', '', '', '1'),
(2, 'AT_01', 'REGION', '01', 'Burgenland', 'AT', '', '', '1'),
(3, 'AT_02', 'REGION', '02', 'Karnten', 'AT', '', '', '1'),
(4, 'AT_03', 'REGION', '03', 'Niederosterreich', 'AT', '', '', '1'),
(5, 'AT_04', 'REGION', '04', 'Oberosterreich', 'AT', '', '', '1'),
(6, 'AT_05', 'REGION', '05', 'Salzburg', 'AT', '', '', '1'),
(7, 'AT_06', 'REGION', '06', 'Steiermark', 'AT', '', '', '1'),
(8, 'AT_07', 'REGION', '07', 'Tirol', 'AT', '', '', '1'),
(9, 'AT_08', 'REGION', '08', 'Vorarlberg', 'AT', '', '', '1'),
(10, 'AT_09', 'REGION', '09', 'Wien', 'AT', '', '', '1'),
(11, 'DE', 'COUNTRY', 'DE', 'Germany', '', '', '', '1'),
(12, 'DE_01', 'REGION', '01', 'Baden-Wurttemberg', 'DE', '', '', '1'),
(13, 'DE_02', 'REGION', '02', 'Bayern', 'DE', '', '', '1'),
(14, 'DE_03', 'REGION', '03', 'Bremen', 'DE', '', '', '1'),
(15, 'DE_04', 'REGION', '04', 'Hamburg', 'DE', '', '', '1'),
(16, 'DE_05', 'REGION', '05', 'Hessen', 'DE', '', '', '1'),
(17, 'DE_06', 'REGION', '06', 'Niedersachsen', 'DE', '', '', '1'),
(18, 'DE_07', 'REGION', '07', 'Nordrhein-Westfalen', 'DE', '', '', '1'),
(19, 'DE_08', 'REGION', '08', 'Rheinland-Pfalz', 'DE', '', '', '1'),
(20, 'DE_09', 'REGION', '09', 'Saarland', 'DE', '', '', '1'),
(21, 'DE_10', 'REGION', '10', 'Schleswig-Holstein', 'DE', '', '', '1'),
(22, 'DE_11', 'REGION', '11', 'Brandenburg', 'DE', '', '', '1'),
(23, 'DE_12', 'REGION', '12', 'Mecklenburg-Vorpommern', 'DE', '', '', '1'),
(24, 'DE_13', 'REGION', '13', 'Sachsen', 'DE', '', '', '1'),
(25, 'DE_14', 'REGION', '14', 'Sachsen-Anhalt', 'DE', '', '', '1'),
(26, 'DE_15', 'REGION', '15', 'Thuringen', 'DE', '', '', '1'),
(27, 'DE_16', 'REGION', '16', 'Berlin', 'DE', '', '', '1'),
(28, 'CH', 'COUNTRY', 'CH', 'Switzerland', '', '', '', '1'),
(30, 'FR', 'COUNTRY', 'FR', 'France', '', '', '', '1'),
(31, 'ES', 'COUNTRY', 'ES', 'Spain', '', '', '', '1'),
(32, 'IT', 'COUNTRY', 'IT', 'Italy', '', '', '', '1'),
(33, 'US', 'COUNTRY', 'US', 'United States', '', '', '', '1'),
(34, 'AD', 'COUNTRY', 'AD', 'Andorra', '', '', '', '1'),
(35, 'AE', 'COUNTRY', 'AE', 'United Arab Emirates', '', '', '', '1'),
(36, 'AF', 'COUNTRY', 'AF', 'Afghanistan', '', '', '', '1'),
(37, 'AG', 'COUNTRY', 'AG', 'Antigua and Barbuda', '', '', '', '1'),
(38, 'AI', 'COUNTRY', 'AI', 'Anguilla', '', '', '', '1'),
(39, 'AL', 'COUNTRY', 'AL', 'Albania', '', '', '', '1'),
(40, 'AM', 'COUNTRY', 'AM', 'Armenia', '', '', '', '1'),
(41, 'AN', 'COUNTRY', 'AN', 'Netherlands Antilles', '', '', '', '1'),
(42, 'AO', 'COUNTRY', 'AO', 'Angola', '', '', '', '1'),
(43, 'AQ', 'COUNTRY', 'AQ', 'Antarctica', '', '', '', '1'),
(44, 'AR', 'COUNTRY', 'AR', 'Argentina', '', '', '', '1'),
(45, 'AS', 'COUNTRY', 'AS', 'American Samoa', '', '', '', '1'),
(46, 'AU', 'COUNTRY', 'AU', 'Australia', '', '', '', '1'),
(47, 'AW', 'COUNTRY', 'AW', 'Aruba', '', '', '', '1'),
(48, 'AX', 'COUNTRY', 'AX', 'Aland Islands', '', '', '', '1'),
(49, 'AZ', 'COUNTRY', 'AZ', 'Azerbaijan', '', '', '', '1'),
(50, 'BA', 'COUNTRY', 'BA', 'Bosnia and Herzegovina', '', '', '', '1'),
(51, 'BB', 'COUNTRY', 'BB', 'Barbados', '', '', '', '1'),
(52, 'BD', 'COUNTRY', 'BD', 'Bangladesh', '', '', '', '1'),
(53, 'BE', 'COUNTRY', 'BE', 'Belgium', '', '', '', '1'),
(54, 'BF', 'COUNTRY', 'BF', 'Burkina Faso', '', '', '', '1'),
(55, 'BG', 'COUNTRY', 'BG', 'Bulgaria', '', '', '', '1'),
(56, 'BH', 'COUNTRY', 'BH', 'Bahrain', '', '', '', '1'),
(57, 'BI', 'COUNTRY', 'BI', 'Burundi', '', '', '', '1'),
(58, 'BJ', 'COUNTRY', 'BJ', 'Benin', '', '', '', '1'),
(59, 'BM', 'COUNTRY', 'BM', 'Bermuda', '', '', '', '1'),
(60, 'BN', 'COUNTRY', 'BN', 'Brunei Darussalam', '', '', '', '1'),
(61, 'BO', 'COUNTRY', 'BO', 'Bolivia', '', '', '', '1'),
(62, 'BR', 'COUNTRY', 'BR', 'Brazil', '', '', '', '1'),
(63, 'BS', 'COUNTRY', 'BS', 'Bahamas', '', '', '', '1'),
(64, 'BT', 'COUNTRY', 'BT', 'Bhutan', '', '', '', '1'),
(65, 'BV', 'COUNTRY', 'BV', 'Bouvet Island', '', '', '', '1'),
(66, 'BW', 'COUNTRY', 'BW', 'Botswana', '', '', '', '1'),
(67, 'BY', 'COUNTRY', 'BY', 'Belarus', '', '', '', '1'),
(68, 'BZ', 'COUNTRY', 'BZ', 'Belize', '', '', '', '1'),
(69, 'CA', 'COUNTRY', 'CA', 'Canada', '', '', '', '1'),
(70, 'CC', 'COUNTRY', 'CC', 'Cocos (Keeling) Islands', '', '', '', '1'),
(71, 'CD', 'COUNTRY', 'CD', 'The Democrativ Republic of the Congo', '', '', '', '1'),
(72, 'CF', 'COUNTRY', 'CF', 'Central African Republic', '', '', '', '1'),
(73, 'CG', 'COUNTRY', 'CG', 'Congo', '', '', '', '1'),
(74, 'CI', 'COUNTRY', 'CI', 'Cote d''Ivoire', '', '', '', '1'),
(75, 'CK', 'COUNTRY', 'CK', 'Cook Islands', '', '', '', '1'),
(76, 'CL', 'COUNTRY', 'CL', 'Chile', '', '', '', '1'),
(77, 'CM', 'COUNTRY', 'CM', 'Cameroon', '', '', '', '1'),
(78, 'CN', 'COUNTRY', 'CN', 'China', '', '', '', '1'),
(79, 'CO', 'COUNTRY', 'CO', 'Colombia', '', '', '', '1'),
(80, 'CR', 'COUNTRY', 'CR', 'Costa Rica', '', '', '', '1'),
(81, 'CU', 'COUNTRY', 'CU', 'Cuba', '', '', '', '1'),
(82, 'CV', 'COUNTRY', 'CV', 'Cape Verde', '', '', '', '1'),
(83, 'CX', 'COUNTRY', 'CX', 'Christmas Island', '', '', '', '1'),
(84, 'CY', 'COUNTRY', 'CY', 'Cyprus', '', '', '', '1'),
(85, 'CZ', 'COUNTRY', 'CZ', 'Czech Republic', '', '', '', '1'),
(86, 'DJ', 'COUNTRY', 'DJ', 'Djibouti', '', '', '', '1'),
(87, 'DK', 'COUNTRY', 'DK', 'Denmark', '', '', '', '1'),
(88, 'DM', 'COUNTRY', 'DM', 'Dominica', '', '', '', '1'),
(89, 'DO', 'COUNTRY', 'DO', 'Dominican Republic', '', '', '', '1'),
(90, 'DZ', 'COUNTRY', 'DZ', 'Algeria', '', '', '', '1'),
(91, 'EC', 'COUNTRY', 'EC', 'Ecuador', '', '', '', '1'),
(92, 'EE', 'COUNTRY', 'EE', 'Estonia', '', '', '', '1'),
(93, 'EG', 'COUNTRY', 'EG', 'Egypt', '', '', '', '1'),
(94, 'EH', 'COUNTRY', 'EH', 'Western Sahara', '', '', '', '1'),
(95, 'ER', 'COUNTRY', 'ER', 'Eritrea', '', '', '', '1'),
(96, 'ET', 'COUNTRY', 'ET', 'Ethiopia', '', '', '', '1'),
(97, 'FI', 'COUNTRY', 'FI', 'Finland', '', '', '', '1'),
(98, 'FJ', 'COUNTRY', 'FJ', 'Fiji', '', '', '', '1'),
(99, 'FK', 'COUNTRY', 'FK', 'Falkland Islands (Malvinas)', '', '', '', '1'),
(100, 'FM', 'COUNTRY', 'FM', 'Federated States of Micronesia', '', '', '', '1'),
(101, 'FO', 'COUNTRY', 'FO', 'Faroe Islands', '', '', '', '1'),
(102, 'GA', 'COUNTRY', 'GA', 'Gabon', '', '', '', '1'),
(103, 'GB', 'COUNTRY', 'GB', 'United Kingdom', '', '', '', '1'),
(104, 'GD', 'COUNTRY', 'GD', 'Grenada', '', '', '', '1'),
(105, 'GE', 'COUNTRY', 'GE', 'Georgia', '', '', '', '1'),
(106, 'GF', 'COUNTRY', 'GF', 'French Guiana', '', '', '', '1'),
(107, 'GG', 'COUNTRY', 'GG', 'Guernsey', '', '', '', '1'),
(108, 'GH', 'COUNTRY', 'GH', 'Ghana', '', '', '', '1'),
(109, 'GI', 'COUNTRY', 'GI', 'Gibraltar', '', '', '', '1'),
(110, 'GL', 'COUNTRY', 'GL', 'Greenland', '', '', '', '1'),
(111, 'GM', 'COUNTRY', 'GM', 'Gambia', '', '', '', '1'),
(112, 'GN', 'COUNTRY', 'GN', 'Guinea', '', '', '', '1'),
(113, 'GP', 'COUNTRY', 'GP', 'Guadeloupe', '', '', '', '1'),
(114, 'GQ', 'COUNTRY', 'GQ', 'Equatorial Guinea', '', '', '', '1'),
(115, 'GR', 'COUNTRY', 'GR', 'Greece', '', '', '', '1'),
(116, 'GS', 'COUNTRY', 'GS', 'South Georgia and the South Sandwich Islands', '', '', '', '1'),
(117, 'GT', 'COUNTRY', 'GT', 'Guatemala', '', '', '', '1'),
(118, 'GU', 'COUNTRY', 'GU', 'Guam', '', '', '', '1'),
(119, 'GW', 'COUNTRY', 'GW', 'Guinea-Bissau', '', '', '', '1'),
(120, 'GY', 'COUNTRY', 'GY', 'Guyana', '', '', '', '1'),
(121, 'HK', 'COUNTRY', 'HK', 'Hong Kong', '', '', '', '1'),
(122, 'HM', 'COUNTRY', 'HM', 'Heard Island and McDonald Islands', '', '', '', '1'),
(123, 'HN', 'COUNTRY', 'HN', 'Honduras', '', '', '', '1'),
(124, 'HR', 'COUNTRY', 'HR', 'Croatia', '', '', '', '1'),
(125, 'HT', 'COUNTRY', 'HT', 'Haiti', '', '', '', '1'),
(126, 'HU', 'COUNTRY', 'HU', 'Hungary', '', '', '', '1'),
(127, 'ID', 'COUNTRY', 'ID', 'Indonesia', '', '', '', '1'),
(128, 'IE', 'COUNTRY', 'IE', 'Ireland', '', '', '', '1'),
(129, 'IL', 'COUNTRY', 'IL', 'Israel', '', '', '', '1'),
(130, 'IM', 'COUNTRY', 'IM', 'Isle of Man', '', '', '', '1'),
(131, 'IN', 'COUNTRY', 'IN', 'India', '', '', '', '1'),
(132, 'IO', 'COUNTRY', 'IO', 'British Indian Ocean Territory', '', '', '', '1'),
(133, 'IQ', 'COUNTRY', 'IQ', 'Iraq', '', '', '', '1'),
(134, 'IR', 'COUNTRY', 'IR', 'Islamic Republic of Iran', '', '', '', '1'),
(135, 'IS', 'COUNTRY', 'IS', 'Iceland', '', '', '', '1'),
(136, 'JE', 'COUNTRY', 'JE', 'Jersey', '', '', '', '1'),
(137, 'JM', 'COUNTRY', 'JM', 'Jamaica', '', '', '', '1'),
(138, 'JO', 'COUNTRY', 'JO', 'Jordan', '', '', '', '1'),
(139, 'JP', 'COUNTRY', 'JP', 'Japan', '', '', '', '1'),
(140, 'KE', 'COUNTRY', 'KE', 'Kenya', '', '', '', '1'),
(141, 'KG', 'COUNTRY', 'KG', 'Kyrgyzstan', '', '', '', '1'),
(142, 'KH', 'COUNTRY', 'KH', 'Cambodia', '', '', '', '1'),
(143, 'KI', 'COUNTRY', 'KI', 'Kiribati', '', '', '', '1'),
(144, 'KM', 'COUNTRY', 'KM', 'Comoros', '', '', '', '1'),
(145, 'KN', 'COUNTRY', 'KN', 'Saint Kitts and Nevis', '', '', '', '1'),
(146, 'KP', 'COUNTRY', 'KP', 'Democratic People''s Pepublic of Korea', '', '', '', '1'),
(147, 'KR', 'COUNTRY', 'KR', 'Republic of Korea', '', '', '', '1'),
(148, 'KW', 'COUNTRY', 'KW', 'Kuwait', '', '', '', '1'),
(149, 'KY', 'COUNTRY', 'KY', 'Cayman Islands', '', '', '', '1'),
(150, 'KZ', 'COUNTRY', 'KZ', 'Kazakhstan', '', '', '', '1'),
(151, 'LA', 'COUNTRY', 'LA', 'Lao People''s Democratic Republic', '', '', '', '1'),
(152, 'LB', 'COUNTRY', 'LB', 'Lebanon', '', '', '', '1'),
(153, 'LC', 'COUNTRY', 'LC', 'Saint Lucia', '', '', '', '1'),
(154, 'LI', 'COUNTRY', 'LI', 'Liechtenstein', '', '', '', '1'),
(155, 'LK', 'COUNTRY', 'LK', 'Sri Lanka', '', '', '', '1'),
(156, 'LR', 'COUNTRY', 'LR', 'Liberia', '', '', '', '1'),
(157, 'LS', 'COUNTRY', 'LS', 'Lesotho', '', '', '', '1'),
(158, 'LT', 'COUNTRY', 'LT', 'Lithuania', '', '', '', '1'),
(159, 'LU', 'COUNTRY', 'LU', 'Luxembourg', '', '', '', '1'),
(160, 'LV', 'COUNTRY', 'LV', 'Latvia', '', '', '', '1'),
(161, 'LY', 'COUNTRY', 'LY', 'Libyan Arab Jamahiriya', '', '', '', '1'),
(162, 'MA', 'COUNTRY', 'MA', 'Morocco', '', '', '', '1'),
(163, 'MC', 'COUNTRY', 'MC', 'Monaco', '', '', '', '1'),
(164, 'MD', 'COUNTRY', 'MD', 'Republic of Moldova', '', '', '', '1'),
(165, 'ME', 'COUNTRY', 'ME', 'Montenegro', '', '', '', '1'),
(166, 'MG', 'COUNTRY', 'MG', 'Madagascar', '', '', '', '1'),
(167, 'MH', 'COUNTRY', 'MH', 'Marshall Islands', '', '', '', '1'),
(168, 'MK', 'COUNTRY', 'MK', 'Macedonia', '', '', '', '1'),
(169, 'ML', 'COUNTRY', 'ML', 'Mali', '', '', '', '1'),
(170, 'MM', 'COUNTRY', 'MM', 'Myanmar', '', '', '', '1'),
(171, 'MN', 'COUNTRY', 'MN', 'Mongolia', '', '', '', '1'),
(172, 'MO', 'COUNTRY', 'MO', 'Macao', '', '', '', '1'),
(173, 'MP', 'COUNTRY', 'MP', 'Northern Mariana Islands', '', '', '', '1'),
(174, 'MQ', 'COUNTRY', 'MQ', 'Martinique', '', '', '', '1'),
(175, 'MR', 'COUNTRY', 'MR', 'Mauritania', '', '', '', '1'),
(176, 'MS', 'COUNTRY', 'MS', 'Montserrat', '', '', '', '1'),
(177, 'MT', 'COUNTRY', 'MT', 'Malta', '', '', '', '1'),
(178, 'MU', 'COUNTRY', 'MU', 'Mauritius', '', '', '', '1'),
(179, 'MV', 'COUNTRY', 'MV', 'Maldives', '', '', '', '1'),
(180, 'MW', 'COUNTRY', 'MW', 'Malawi', '', '', '', '1'),
(181, 'MX', 'COUNTRY', 'MX', 'Mexico', '', '', '', '1'),
(182, 'MY', 'COUNTRY', 'MY', 'Malaysia', '', '', '', '1'),
(183, 'MZ', 'COUNTRY', 'MZ', 'Mozambique', '', '', '', '1'),
(184, 'NA', 'COUNTRY', 'NA', 'Namibia', '', '', '', '1'),
(185, 'NC', 'COUNTRY', 'NC', 'New Caledonia', '', '', '', '1'),
(186, 'NE', 'COUNTRY', 'NE', 'Niger', '', '', '', '1'),
(187, 'NF', 'COUNTRY', 'NF', 'Norfolk Island', '', '', '', '1'),
(188, 'NG', 'COUNTRY', 'NG', 'Nigeria', '', '', '', '1'),
(189, 'NI', 'COUNTRY', 'NI', 'Nicaragua', '', '', '', '1'),
(190, 'NL', 'COUNTRY', 'NL', 'Netherlands', '', '', '', '1'),
(191, 'NO', 'COUNTRY', 'NO', 'Norway', '', '', '', '1'),
(192, 'NP', 'COUNTRY', 'NP', 'Nepal', '', '', '', '1'),
(193, 'NR', 'COUNTRY', 'NR', 'Nauru', '', '', '', '1'),
(194, 'NU', 'COUNTRY', 'NU', 'Niue', '', '', '', '1'),
(195, 'NZ', 'COUNTRY', 'NZ', 'New Zealand', '', '', '', '1'),
(196, 'OM', 'COUNTRY', 'OM', 'Oman', '', '', '', '1'),
(197, 'PA', 'COUNTRY', 'PA', 'Panama', '', '', '', '1'),
(198, 'PE', 'COUNTRY', 'PE', 'Peru', '', '', '', '1'),
(199, 'PF', 'COUNTRY', 'PF', 'French Polynesia', '', '', '', '1'),
(200, 'PG', 'COUNTRY', 'PG', 'Papua New Guinea', '', '', '', '1'),
(201, 'PH', 'COUNTRY', 'PH', 'Philippines', '', '', '', '1'),
(202, 'PK', 'COUNTRY', 'PK', 'Pakistan', '', '', '', '1'),
(203, 'PL', 'COUNTRY', 'PL', 'Poland', '', '', '', '1'),
(204, 'PM', 'COUNTRY', 'PM', 'Saint Pierre and Miquelon', '', '', '', '1'),
(205, 'PN', 'COUNTRY', 'PN', 'Pitcairn', '', '', '', '1'),
(206, 'PR', 'COUNTRY', 'PR', 'Puerto Rico', '', '', '', '1'),
(207, 'PS', 'COUNTRY', 'PS', 'Palestinian Territory', '', '', '', '1'),
(208, 'PT', 'COUNTRY', 'PT', 'Portugal', '', '', '', '1'),
(209, 'PW', 'COUNTRY', 'PW', 'Palau', '', '', '', '1'),
(210, 'PY', 'COUNTRY', 'PY', 'Paraguay', '', '', '', '1'),
(211, 'QA', 'COUNTRY', 'QA', 'Qatar', '', '', '', '1'),
(212, 'RE', 'COUNTRY', 'RE', 'Reunion', '', '', '', '1'),
(213, 'RO', 'COUNTRY', 'RO', 'Romania', '', '', '', '1'),
(214, 'RS', 'COUNTRY', 'RS', 'Serbia', '', '', '', '1'),
(215, 'RU', 'COUNTRY', 'RU', 'Russian Federation', '', '', '', '1'),
(216, 'RW', 'COUNTRY', 'RW', 'Rwanda', '', '', '', '1'),
(217, 'SA', 'COUNTRY', 'SA', 'Saudi Arabia', '', '', '', '1'),
(218, 'SB', 'COUNTRY', 'SB', 'Solomon Islands', '', '', '', '1'),
(219, 'SC', 'COUNTRY', 'SC', 'Seychelles', '', '', '', '1'),
(220, 'SD', 'COUNTRY', 'SD', 'Sudan', '', '', '', '1'),
(221, 'SE', 'COUNTRY', 'SE', 'Sweden', '', '', '', '1'),
(222, 'SG', 'COUNTRY', 'SG', 'Singapore', '', '', '', '1'),
(223, 'SH', 'COUNTRY', 'SH', 'Saint Helena', '', '', '', '1'),
(224, 'SI', 'COUNTRY', 'SI', 'Slovenia', '', '', '', '1'),
(225, 'SJ', 'COUNTRY', 'SJ', 'Svalbard and Jan Mayen', '', '', '', '1'),
(226, 'SK', 'COUNTRY', 'SK', 'Slovakia', '', '', '', '1'),
(227, 'SL', 'COUNTRY', 'SL', 'Sierra Leone', '', '', '', '1'),
(228, 'SM', 'COUNTRY', 'SM', 'San Marino', '', '', '', '1'),
(229, 'SN', 'COUNTRY', 'SN', 'Senegal', '', '', '', '1'),
(230, 'SO', 'COUNTRY', 'SO', 'Somalia', '', '', '', '1'),
(231, 'SR', 'COUNTRY', 'SR', 'Suriname', '', '', '', '1'),
(232, 'ST', 'COUNTRY', 'ST', 'Sao Tome and Principe', '', '', '', '1'),
(233, 'SV', 'COUNTRY', 'SV', 'El Salvador', '', '', '', '1'),
(234, 'SY', 'COUNTRY', 'SY', 'Syrian Arab Republic', '', '', '', '1'),
(235, 'SZ', 'COUNTRY', 'SZ', 'Swaziland', '', '', '', '1'),
(236, 'TC', 'COUNTRY', 'TC', 'Turks and Caicos Islands', '', '', '', '1'),
(237, 'TD', 'COUNTRY', 'TD', 'Chad', '', '', '', '1'),
(238, 'TF', 'COUNTRY', 'TF', 'French Southern Territories', '', '', '', '1'),
(239, 'TG', 'COUNTRY', 'TG', 'Togo', '', '', '', '1'),
(240, 'TH', 'COUNTRY', 'TH', 'Thailand', '', '', '', '1'),
(241, 'TJ', 'COUNTRY', 'TJ', 'Tajikistan', '', '', '', '1'),
(242, 'TK', 'COUNTRY', 'TK', 'Tokelau', '', '', '', '1'),
(243, 'TL', 'COUNTRY', 'TL', 'Timor-Leste', '', '', '', '1'),
(244, 'TM', 'COUNTRY', 'TM', 'Turkmenistan', '', '', '', '1'),
(245, 'TN', 'COUNTRY', 'TN', 'Tunisia', '', '', '', '1'),
(246, 'TO', 'COUNTRY', 'TO', 'Tonga', '', '', '', '1'),
(247, 'TR', 'COUNTRY', 'TR', 'Turkey', '', '', '', '1'),
(248, 'TT', 'COUNTRY', 'TT', 'Trinidad and Tobago', '', '', '', '1'),
(249, 'TV', 'COUNTRY', 'TV', 'Tuvalu', '', '', '', '1'),
(250, 'TW', 'COUNTRY', 'TW', 'Taiwan', '', '', '', '1'),
(251, 'TZ', 'COUNTRY', 'TZ', 'United Republic of Tanzania', '', '', '', '1'),
(252, 'UA', 'COUNTRY', 'UA', 'Ukraine', '', '', '', '1'),
(253, 'UG', 'COUNTRY', 'UG', 'Uganda', '', '', '', '1'),
(254, 'UM', 'COUNTRY', 'UM', 'United States Minor Outlying Islands', '', '', '', '1'),
(255, 'UY', 'COUNTRY', 'UY', 'Uruguay', '', '', '', '1'),
(256, 'UZ', 'COUNTRY', 'UZ', 'Uzbekistan', '', '', '', '1'),
(257, 'VA', 'COUNTRY', 'VA', 'Holy See (Vatican City State)', '', '', '', '1'),
(258, 'VC', 'COUNTRY', 'VC', 'Saint Vincent and the Grenadines', '', '', '', '1'),
(259, 'VE', 'COUNTRY', 'VE', 'Venezuela', '', '', '', '1'),
(260, 'VG', 'COUNTRY', 'VG', 'Virgin Islands (British)', '', '', '', '1'),
(261, 'VI', 'COUNTRY', 'VI', 'Virgin Islands (U.S.)', '', '', '', '1'),
(262, 'VN', 'COUNTRY', 'VN', 'Vietnam', '', '', '', '1'),
(263, 'VU', 'COUNTRY', 'VU', 'Vanuatu', '', '', '', '1'),
(264, 'WF', 'COUNTRY', 'WF', 'Wallis and Futuna', '', '', '', '1'),
(265, 'WS', 'COUNTRY', 'WS', 'Samoa', '', '', '', '1'),
(266, 'YE', 'COUNTRY', 'YE', 'Yemen', '', '', '', '1'),
(267, 'YT', 'COUNTRY', 'YT', 'Mayotte', '', '', '', '1'),
(268, 'ZA', 'COUNTRY', 'ZA', 'South Africa', '', '', '', '1'),
(269, 'ZM', 'COUNTRY', 'ZM', 'Zambia', '', '', '', '1'),
(270, 'ZW', 'COUNTRY', 'ZW', 'Zimbabwe', '', '', '', '1'),
(6989, 'NA_14', 'REGION', '14', 'Outjo', 'NA', '', '', '1'),
(6988, 'NA_13', 'REGION', '13', 'Otjiwarongo', 'NA', '', '', '1'),
(6987, 'NA_12', 'REGION', '12', 'Omaruru', 'NA', '', '', '1'),
(6986, 'NA_11', 'REGION', '11', 'Okahandja', 'NA', '', '', '1'),
(6985, 'NA_10', 'REGION', '10', 'Maltahohe', 'NA', '', '', '1'),
(6984, 'NA_09', 'REGION', '09', 'Luderitz', 'NA', '', '', '1'),
(6983, 'NA_08', 'REGION', '08', 'Keetmanshoop', 'NA', '', '', '1'),
(6982, 'NA_07', 'REGION', '07', 'Karibib', 'NA', '', '', '1'),
(6981, 'NA_06', 'REGION', '06', 'Kaokoland', 'NA', '', '', '1'),
(6980, 'NA_05', 'REGION', '05', 'Grootfontein', 'NA', '', '', '1'),
(6979, 'NA_04', 'REGION', '04', 'Gobabis', 'NA', '', '', '1'),
(6978, 'NA_03', 'REGION', '03', 'Boesmanland', 'NA', '', '', '1'),
(6977, 'NA_02', 'REGION', '02', 'Caprivi Oos', 'NA', '', '', '1'),
(6976, 'NA_01', 'REGION', '01', 'Bethanien', 'NA', '', '', '1'),
(6975, 'MZ_11', 'REGION', '11', 'Maputo', 'MZ', '', '', '1'),
(6974, 'MZ_10', 'REGION', '10', 'Manica', 'MZ', '', '', '1'),
(6973, 'MZ_09', 'REGION', '09', 'Zambezia', 'MZ', '', '', '1'),
(6972, 'MZ_08', 'REGION', '08', 'Tete', 'MZ', '', '', '1'),
(6971, 'MZ_07', 'REGION', '07', 'Niassa', 'MZ', '', '', '1'),
(6970, 'MZ_06', 'REGION', '06', 'Nampula', 'MZ', '', '', '1'),
(6969, 'MZ_05', 'REGION', '05', 'Sofala', 'MZ', '', '', '1'),
(6968, 'MZ_04', 'REGION', '04', 'Maputo', 'MZ', '', '', '1'),
(6967, 'MZ_03', 'REGION', '03', 'Inhambane', 'MZ', '', '', '1'),
(6966, 'MZ_02', 'REGION', '02', 'Gaza', 'MZ', '', '', '1'),
(6965, 'MZ_01', 'REGION', '01', 'Cabo Delgado', 'MZ', '', '', '1'),
(6964, 'MY_17', 'REGION', '17', 'Putrajaya', 'MY', '', '', '1'),
(6963, 'MY_16', 'REGION', '16', 'Sabah', 'MY', '', '', '1'),
(6962, 'MY_15', 'REGION', '15', 'Labuan', 'MY', '', '', '1'),
(6961, 'MY_14', 'REGION', '14', 'Kuala Lumpur', 'MY', '', '', '1'),
(6960, 'MY_13', 'REGION', '13', 'Terengganu', 'MY', '', '', '1'),
(6959, 'MY_12', 'REGION', '12', 'Selangor', 'MY', '', '', '1'),
(6958, 'MY_11', 'REGION', '11', 'Sarawak', 'MY', '', '', '1'),
(6957, 'MY_09', 'REGION', '09', 'Pulau Pinang', 'MY', '', '', '1'),
(6956, 'MY_08', 'REGION', '08', 'Perlis', 'MY', '', '', '1'),
(6955, 'MY_07', 'REGION', '07', 'Perak', 'MY', '', '', '1'),
(6954, 'MY_06', 'REGION', '06', 'Pahang', 'MY', '', '', '1'),
(6953, 'MY_05', 'REGION', '05', 'Negeri Sembilan', 'MY', '', '', '1'),
(6952, 'MY_04', 'REGION', '04', 'Melaka', 'MY', '', '', '1'),
(6951, 'MY_03', 'REGION', '03', 'Kelantan', 'MY', '', '', '1'),
(6950, 'MY_02', 'REGION', '02', 'Kedah', 'MY', '', '', '1'),
(6949, 'MY_01', 'REGION', '01', 'Johor', 'MY', '', '', '1'),
(6948, 'MX_32', 'REGION', '32', 'Zacatecas', 'MX', '', '', '1'),
(6947, 'MX_31', 'REGION', '31', 'Yucatan', 'MX', '', '', '1'),
(6946, 'MX_30', 'REGION', '30', 'Veracruz-Llave', 'MX', '', '', '1'),
(6945, 'MX_29', 'REGION', '29', 'Tlaxcala', 'MX', '', '', '1'),
(6944, 'MX_28', 'REGION', '28', 'Tamaulipas', 'MX', '', '', '1'),
(6943, 'MX_27', 'REGION', '27', 'Tabasco', 'MX', '', '', '1'),
(6942, 'MX_26', 'REGION', '26', 'Sonora', 'MX', '', '', '1'),
(6941, 'MX_25', 'REGION', '25', 'Sinaloa', 'MX', '', '', '1'),
(6940, 'MX_24', 'REGION', '24', 'San Luis Potosi', 'MX', '', '', '1'),
(6939, 'MX_23', 'REGION', '23', 'Quintana Roo', 'MX', '', '', '1'),
(6938, 'MX_22', 'REGION', '22', 'Queretaro de Arteaga', 'MX', '', '', '1'),
(6937, 'MX_21', 'REGION', '21', 'Puebla', 'MX', '', '', '1'),
(6936, 'MX_20', 'REGION', '20', 'Oaxaca', 'MX', '', '', '1'),
(6935, 'MX_19', 'REGION', '19', 'Nuevo Leon', 'MX', '', '', '1'),
(6934, 'MX_18', 'REGION', '18', 'Nayarit', 'MX', '', '', '1'),
(6933, 'MX_17', 'REGION', '17', 'Morelos', 'MX', '', '', '1'),
(6932, 'MX_16', 'REGION', '16', 'Michoacan de Ocampo', 'MX', '', '', '1'),
(6931, 'MX_15', 'REGION', '15', 'Mexico', 'MX', '', '', '1'),
(6930, 'MX_14', 'REGION', '14', 'Jalisco', 'MX', '', '', '1'),
(6929, 'MX_13', 'REGION', '13', 'Hidalgo', 'MX', '', '', '1'),
(6928, 'MX_12', 'REGION', '12', 'Guerrero', 'MX', '', '', '1'),
(6927, 'MX_11', 'REGION', '11', 'Guanajuato', 'MX', '', '', '1'),
(6926, 'MX_10', 'REGION', '10', 'Durango', 'MX', '', '', '1'),
(6925, 'MX_09', 'REGION', '09', 'Distrito Federal', 'MX', '', '', '1'),
(6924, 'MX_08', 'REGION', '08', 'Colima', 'MX', '', '', '1'),
(6923, 'MX_07', 'REGION', '07', 'Coahuila de Zaragoza', 'MX', '', '', '1'),
(6922, 'MX_06', 'REGION', '06', 'Chihuahua', 'MX', '', '', '1'),
(6921, 'MX_05', 'REGION', '05', 'Chiapas', 'MX', '', '', '1'),
(6920, 'MX_04', 'REGION', '04', 'Campeche', 'MX', '', '', '1'),
(6919, 'MX_03', 'REGION', '03', 'Baja California Sur', 'MX', '', '', '1'),
(6918, 'MX_02', 'REGION', '02', 'Baja California', 'MX', '', '', '1'),
(6917, 'MX_01', 'REGION', '01', 'Aguascalientes', 'MX', '', '', '1'),
(6916, 'MW_30', 'REGION', '30', 'Phalombe', 'MW', '', '', '1'),
(6915, 'MW_29', 'REGION', '29', 'Mulanje', 'MW', '', '', '1'),
(6914, 'MW_28', 'REGION', '28', 'Machinga', 'MW', '', '', '1'),
(6913, 'MW_27', 'REGION', '27', 'Likoma', 'MW', '', '', '1'),
(6912, 'MW_26', 'REGION', '26', 'Balaka', 'MW', '', '', '1'),
(6911, 'MW_25', 'REGION', '25', 'Mwanza', 'MW', '', '', '1'),
(6910, 'MW_24', 'REGION', '24', 'Blantyre', 'MW', '', '', '1'),
(6909, 'MW_23', 'REGION', '23', 'Zomba', 'MW', '', '', '1'),
(6908, 'MW_22', 'REGION', '22', 'Salima', 'MW', '', '', '1'),
(6907, 'MW_21', 'REGION', '21', 'Rumphi', 'MW', '', '', '1'),
(6906, 'MW_20', 'REGION', '20', 'Ntchisi', 'MW', '', '', '1'),
(6905, 'MW_19', 'REGION', '19', 'Nsanje', 'MW', '', '', '1'),
(6904, 'MW_18', 'REGION', '18', 'Nkhotakota', 'MW', '', '', '1'),
(6903, 'MW_17', 'REGION', '17', 'Nkhata Bay', 'MW', '', '', '1'),
(6902, 'MW_16', 'REGION', '16', 'Ntcheu', 'MW', '', '', '1'),
(6901, 'MW_15', 'REGION', '15', 'Mzimba', 'MW', '', '', '1'),
(6900, 'MW_13', 'REGION', '13', 'Mchinji', 'MW', '', '', '1'),
(6899, 'MW_12', 'REGION', '12', 'Mangochi', 'MW', '', '', '1'),
(6898, 'MW_11', 'REGION', '11', 'Lilongwe', 'MW', '', '', '1'),
(6897, 'MW_09', 'REGION', '09', 'Kasungu', 'MW', '', '', '1'),
(6896, 'MW_08', 'REGION', '08', 'Karonga', 'MW', '', '', '1'),
(6895, 'MW_07', 'REGION', '07', 'Dowa', 'MW', '', '', '1'),
(6894, 'MW_06', 'REGION', '06', 'Dedza', 'MW', '', '', '1'),
(6893, 'MW_05', 'REGION', '05', 'Thyolo', 'MW', '', '', '1'),
(6892, 'MW_04', 'REGION', '04', 'Chitipa', 'MW', '', '', '1'),
(6891, 'MW_03', 'REGION', '03', 'Chiradzulu', 'MW', '', '', '1'),
(6890, 'MW_02', 'REGION', '02', 'Chikwawa', 'MW', '', '', '1'),
(6889, 'MV_40', 'REGION', '40', 'Male', 'MV', '', '', '1'),
(6888, 'MV_29', 'REGION', '29', 'Naviyani', 'MV', '', '', '1'),
(6887, 'MV_28', 'REGION', '28', 'Gaafu Daalu', 'MV', '', '', '1'),
(6886, 'MV_27', 'REGION', '27', 'Gaafu Aliff', 'MV', '', '', '1'),
(6885, 'MV_26', 'REGION', '26', 'Kaafu', 'MV', '', '', '1'),
(6884, 'MV_25', 'REGION', '25', 'Noonu', 'MV', '', '', '1'),
(6883, 'MV_24', 'REGION', '24', 'Shaviyani', 'MV', '', '', '1'),
(6882, 'MV_23', 'REGION', '23', 'Haa Daalu', 'MV', '', '', '1'),
(6881, 'MV_20', 'REGION', '20', 'Baa', 'MV', '', '', '1'),
(6880, 'MV_17', 'REGION', '17', 'Daalu', 'MV', '', '', '1'),
(6879, 'MV_14', 'REGION', '14', 'Faafu', 'MV', '', '', '1'),
(6878, 'MV_13', 'REGION', '13', 'Raa', 'MV', '', '', '1'),
(6877, 'MV_12', 'REGION', '12', 'Meemu', 'MV', '', '', '1'),
(6876, 'MV_08', 'REGION', '08', 'Thaa', 'MV', '', '', '1'),
(6875, 'MV_07', 'REGION', '07', 'Haa Aliff', 'MV', '', '', '1'),
(6874, 'MV_05', 'REGION', '05', 'Laamu', 'MV', '', '', '1'),
(6873, 'MV_04', 'REGION', '04', 'Waavu', 'MV', '', '', '1'),
(6872, 'MV_03', 'REGION', '03', 'Laviyani', 'MV', '', '', '1'),
(6871, 'MV_02', 'REGION', '02', 'Aliff', 'MV', '', '', '1'),
(6870, 'MV_01', 'REGION', '01', 'Seenu', 'MV', '', '', '1'),
(6869, 'MU_23', 'REGION', '23', 'Rodrigues', 'MU', '', '', '1'),
(6868, 'MU_22', 'REGION', '22', 'Cargados Carajos', 'MU', '', '', '1'),
(6867, 'MU_21', 'REGION', '21', 'Agalega Islands', 'MU', '', '', '1'),
(6866, 'MU_20', 'REGION', '20', 'Savanne', 'MU', '', '', '1'),
(6865, 'MU_19', 'REGION', '19', 'Riviere du Rempart', 'MU', '', '', '1'),
(6864, 'MU_18', 'REGION', '18', 'Port Louis', 'MU', '', '', '1'),
(6863, 'MU_17', 'REGION', '17', 'Plaines Wilhems', 'MU', '', '', '1'),
(6862, 'MU_16', 'REGION', '16', 'Pamplemousses', 'MU', '', '', '1'),
(6861, 'MU_15', 'REGION', '15', 'Moka', 'MU', '', '', '1'),
(6860, 'MU_14', 'REGION', '14', 'Grand Port', 'MU', '', '', '1'),
(6859, 'MU_13', 'REGION', '13', 'Flacq', 'MU', '', '', '1'),
(6858, 'MU_12', 'REGION', '12', 'Black River', 'MU', '', '', '1'),
(6857, 'MS_03', 'REGION', '03', 'Saint Peter', 'MS', '', '', '1'),
(6856, 'MS_02', 'REGION', '02', 'Saint Georges', 'MS', '', '', '1'),
(6855, 'MS_01', 'REGION', '01', 'Saint Anthony', 'MS', '', '', '1'),
(6854, 'MR_12', 'REGION', '12', 'Inchiri', 'MR', '', '', '1'),
(6853, 'MR_11', 'REGION', '11', 'Tiris Zemmour', 'MR', '', '', '1'),
(6852, 'MR_10', 'REGION', '10', 'Guidimaka', 'MR', '', '', '1'),
(6851, 'MR_09', 'REGION', '09', 'Tagant', 'MR', '', '', '1'),
(6850, 'MR_08', 'REGION', '08', 'Dakhlet Nouadhibou', 'MR', '', '', '1'),
(6849, 'MR_07', 'REGION', '07', 'Adrar', 'MR', '', '', '1'),
(6848, 'MR_06', 'REGION', '06', 'Trarza', 'MR', '', '', '1'),
(6847, 'MR_05', 'REGION', '05', 'Brakna', 'MR', '', '', '1'),
(6846, 'MR_04', 'REGION', '04', 'Gorgol', 'MR', '', '', '1'),
(6845, 'MR_03', 'REGION', '03', 'Assaba', 'MR', '', '', '1'),
(6844, 'MR_02', 'REGION', '02', 'Hodh El Gharbi', 'MR', '', '', '1'),
(6843, 'MR_01', 'REGION', '01', 'Hodh Ech Chargui', 'MR', '', '', '1'),
(6842, 'MO_02', 'REGION', '02', 'Macau', 'MO', '', '', '1'),
(6841, 'MO_01', 'REGION', '01', 'Ilhas', 'MO', '', '', '1'),
(6840, 'MN_25', 'REGION', '25', 'Orhon', 'MN', '', '', '1'),
(6839, 'MN_24', 'REGION', '24', 'Govisumber', 'MN', '', '', '1'),
(6838, 'MN_23', 'REGION', '23', 'Darhan-Uul', 'MN', '', '', '1'),
(6837, 'MN_22', 'REGION', '22', 'Erdenet', 'MN', '', '', '1'),
(6836, 'MN_21', 'REGION', '21', 'Bulgan', 'MN', '', '', '1'),
(6835, 'MN_20', 'REGION', '20', 'Ulaanbaatar', 'MN', '', '', '1'),
(6834, 'MN_19', 'REGION', '19', 'Uvs', 'MN', '', '', '1'),
(6833, 'MN_18', 'REGION', '18', 'Tov', 'MN', '', '', '1'),
(6832, 'MN_17', 'REGION', '17', 'Suhbaatar', 'MN', '', '', '1'),
(6831, 'MN_16', 'REGION', '16', 'Selenge', 'MN', '', '', '1'),
(6830, 'MN_15', 'REGION', '15', 'Ovorhangay', 'MN', '', '', '1'),
(6829, 'MN_14', 'REGION', '14', 'Omnogovi', 'MN', '', '', '1'),
(6828, 'MN_13', 'REGION', '13', 'Hovsgol', 'MN', '', '', '1'),
(6827, 'MN_12', 'REGION', '12', 'Hovd', 'MN', '', '', '1'),
(6826, 'MN_11', 'REGION', '11', 'Hentiy', 'MN', '', '', '1'),
(6825, 'MN_10', 'REGION', '10', 'Govi-Altay', 'MN', '', '', '1'),
(6824, 'MN_09', 'REGION', '09', 'Dzavhan', 'MN', '', '', '1'),
(6823, 'MN_08', 'REGION', '08', 'Dundgovi', 'MN', '', '', '1'),
(6822, 'MN_07', 'REGION', '07', 'Dornogovi', 'MN', '', '', '1'),
(6821, 'MN_06', 'REGION', '06', 'Dornod', 'MN', '', '', '1'),
(6820, 'MN_05', 'REGION', '05', 'Darhan', 'MN', '', '', '1'),
(6819, 'MN_03', 'REGION', '03', 'Bayan-Olgiy', 'MN', '', '', '1'),
(6818, 'MN_02', 'REGION', '02', 'Bayanhongor', 'MN', '', '', '1'),
(6817, 'MN_01', 'REGION', '01', 'Arhangay', 'MN', '', '', '1'),
(6816, 'MM_17', 'REGION', '17', 'Yangon', 'MM', '', '', '1'),
(6815, 'MM_14', 'REGION', '14', 'Rangoon', 'MM', '', '', '1'),
(6814, 'MM_13', 'REGION', '13', 'Mon State', 'MM', '', '', '1'),
(6813, 'MM_12', 'REGION', '12', 'Tenasserim', 'MM', '', '', '1'),
(6812, 'MM_11', 'REGION', '11', 'Shan State', 'MM', '', '', '1'),
(6811, 'MM_10', 'REGION', '10', 'Sagaing', 'MM', '', '', '1'),
(6810, 'MM_09', 'REGION', '09', 'Pegu', 'MM', '', '', '1'),
(6809, 'MM_08', 'REGION', '08', 'Mandalay', 'MM', '', '', '1'),
(6808, 'MM_07', 'REGION', '07', 'Magwe', 'MM', '', '', '1'),
(6807, 'MM_06', 'REGION', '06', 'Kayah State', 'MM', '', '', '1'),
(6806, 'MM_05', 'REGION', '05', 'Karan State', 'MM', '', '', '1'),
(6805, 'MM_04', 'REGION', '04', 'Kachin State', 'MM', '', '', '1'),
(6804, 'MM_03', 'REGION', '03', 'Irrawaddy', 'MM', '', '', '1'),
(6803, 'MM_02', 'REGION', '02', 'Chin State', 'MM', '', '', '1'),
(6802, 'MM_01', 'REGION', '01', 'Rakhine State', 'MM', '', '', '1'),
(6801, 'ML_10', 'REGION', '10', 'Kidal', 'ML', '', '', '1'),
(6800, 'ML_09', 'REGION', '09', 'Gao', 'ML', '', '', '1'),
(6799, 'ML_08', 'REGION', '08', 'Tombouctou', 'ML', '', '', '1'),
(6798, 'ML_07', 'REGION', '07', 'Koulikoro', 'ML', '', '', '1'),
(6797, 'ML_06', 'REGION', '06', 'Sikasso', 'ML', '', '', '1'),
(6796, 'ML_05', 'REGION', '05', 'Segou', 'ML', '', '', '1'),
(6795, 'ML_04', 'REGION', '04', 'Mopti', 'ML', '', '', '1'),
(6794, 'ML_03', 'REGION', '03', 'Kayes', 'ML', '', '', '1'),
(6793, 'ML_01', 'REGION', '01', 'Bamako', 'ML', '', '', '1'),
(6792, 'MK_C6', 'REGION', 'C6', 'Zrnovci', 'MK', '', '', '1'),
(6791, 'MK_C5', 'REGION', 'C5', 'Zletovo', 'MK', '', '', '1'),
(6790, 'MK_C4', 'REGION', 'C4', 'Zitose', 'MK', '', '', '1'),
(6789, 'MK_C3', 'REGION', 'C3', 'Zelino', 'MK', '', '', '1'),
(6788, 'MK_C2', 'REGION', 'C2', 'Zelenikovo', 'MK', '', '', '1'),
(6787, 'MK_C1', 'REGION', 'C1', 'Zajas', 'MK', '', '', '1'),
(6786, 'MK_B9', 'REGION', 'B9', 'Vrutok', 'MK', '', '', '1'),
(6785, 'MK_B8', 'REGION', 'B8', 'Vratnica', 'MK', '', '', '1'),
(6784, 'MK_B7', 'REGION', 'B7', 'Vrapciste', 'MK', '', '', '1'),
(6783, 'MK_B6', 'REGION', 'B6', 'Vranestica', 'MK', '', '', '1'),
(6782, 'MK_B5', 'REGION', 'B5', 'Vitoliste', 'MK', '', '', '1'),
(6781, 'MK_B4', 'REGION', 'B4', 'Vinica', 'MK', '', '', '1'),
(6780, 'MK_B3', 'REGION', 'B3', 'Vevcani', 'MK', '', '', '1'),
(6779, 'MK_B2', 'REGION', 'B2', 'Velesta', 'MK', '', '', '1'),
(6778, 'MK_B1', 'REGION', 'B1', 'Veles', 'MK', '', '', '1'),
(6777, 'MK_A9', 'REGION', 'A9', 'Vasilevo', 'MK', '', '', '1'),
(6776, 'MK_A8', 'REGION', 'A8', 'Valandovo', 'MK', '', '', '1'),
(6775, 'MK_A7', 'REGION', 'A7', 'Topolcani', 'MK', '', '', '1'),
(6774, 'MK_A6', 'REGION', 'A6', 'Tetovo', 'MK', '', '', '1'),
(6773, 'MK_A5', 'REGION', 'A5', 'Tearce', 'MK', '', '', '1'),
(6772, 'MK_A4', 'REGION', 'A4', 'Sveti Nikole', 'MK', '', '', '1'),
(6771, 'MK_A3', 'REGION', 'A3', 'Suto Orizari', 'MK', '', '', '1'),
(6770, 'MK_A2', 'REGION', 'A2', 'Studenicani', 'MK', '', '', '1'),
(6769, 'MK_A1', 'REGION', 'A1', 'Strumica', 'MK', '', '', '1'),
(6768, 'MK_99', 'REGION', '99', 'Struga', 'MK', '', '', '1'),
(6767, 'MK_98', 'REGION', '98', 'Stip', 'MK', '', '', '1'),
(6766, 'MK_97', 'REGION', '97', 'Staro Nagoricane', 'MK', '', '', '1'),
(6765, 'MK_96', 'REGION', '96', 'Star Dojran', 'MK', '', '', '1'),
(6764, 'MK_95', 'REGION', '95', 'Staravina', 'MK', '', '', '1'),
(6763, 'MK_94', 'REGION', '94', 'Srbinovo', 'MK', '', '', '1'),
(6762, 'MK_93', 'REGION', '93', 'Sopotnica', 'MK', '', '', '1'),
(6761, 'MK_92', 'REGION', '92', 'Sopiste', 'MK', '', '', '1'),
(6760, 'MK_91', 'REGION', '91', 'Sipkovica', 'MK', '', '', '1'),
(6759, 'MK_90', 'REGION', '90', 'Saraj', 'MK', '', '', '1'),
(6758, 'MK_89', 'REGION', '89', 'Samokov', 'MK', '', '', '1'),
(6757, 'MK_88', 'REGION', '88', 'Rostusa', 'MK', '', '', '1'),
(6756, 'MK_87', 'REGION', '87', 'Rosoman', 'MK', '', '', '1'),
(6755, 'MK_86', 'REGION', '86', 'Resen', 'MK', '', '', '1'),
(6754, 'MK_85', 'REGION', '85', 'Rankovce', 'MK', '', '', '1'),
(6753, 'MK_84', 'REGION', '84', 'Radovis', 'MK', '', '', '1'),
(6752, 'MK_83', 'REGION', '83', 'Probistip', 'MK', '', '', '1'),
(6751, 'MK_82', 'REGION', '82', 'Prilep', 'MK', '', '', '1'),
(6750, 'MK_81', 'REGION', '81', 'Podares', 'MK', '', '', '1'),
(6749, 'MK_80', 'REGION', '80', 'Plasnica', 'MK', '', '', '1'),
(6748, 'MK_79', 'REGION', '79', 'Petrovec', 'MK', '', '', '1'),
(6747, 'MK_78', 'REGION', '78', 'Pehcevo', 'MK', '', '', '1'),
(6746, 'MK_77', 'REGION', '77', 'Oslomej', 'MK', '', '', '1'),
(6745, 'MK_76', 'REGION', '76', 'Orizari', 'MK', '', '', '1'),
(6744, 'MK_75', 'REGION', '75', 'Orasac', 'MK', '', '', '1'),
(6743, 'MK_74', 'REGION', '74', 'Ohrid', 'MK', '', '', '1'),
(6742, 'MK_73', 'REGION', '73', 'Oblesevo', 'MK', '', '', '1'),
(6741, 'MK_72', 'REGION', '72', 'Novo Selo', 'MK', '', '', '1'),
(6740, 'MK_71', 'REGION', '71', 'Novaci', 'MK', '', '', '1'),
(6739, 'MK_70', 'REGION', '70', 'Negotino-Polosko', 'MK', '', '', '1'),
(6738, 'MK_69', 'REGION', '69', 'Negotino', 'MK', '', '', '1'),
(6737, 'MK_68', 'REGION', '68', 'Murtino', 'MK', '', '', '1'),
(6736, 'MK_67', 'REGION', '67', 'Mogila', 'MK', '', '', '1'),
(6735, 'MK_66', 'REGION', '66', 'Miravci', 'MK', '', '', '1'),
(6734, 'MK_65', 'REGION', '65', 'Meseista', 'MK', '', '', '1'),
(6733, 'MK_64', 'REGION', '64', 'Mavrovi Anovi', 'MK', '', '', '1'),
(6732, 'MK_63', 'REGION', '63', 'Makedonski Brod', 'MK', '', '', '1'),
(6731, 'MK_62', 'REGION', '62', 'Makedonska Kamenica', 'MK', '', '', '1'),
(6730, 'MK_61', 'REGION', '61', 'Lukovo', 'MK', '', '', '1'),
(6729, 'MK_60', 'REGION', '60', 'Lozovo', 'MK', '', '', '1'),
(6728, 'MK_59', 'REGION', '59', 'Lipkovo', 'MK', '', '', '1'),
(6727, 'MK_58', 'REGION', '58', 'Labunista', 'MK', '', '', '1'),
(6726, 'MK_57', 'REGION', '57', 'Kumanovo', 'MK', '', '', '1'),
(6725, 'MK_56', 'REGION', '56', 'Kukurecani', 'MK', '', '', '1'),
(6724, 'MK_55', 'REGION', '55', 'Kuklis', 'MK', '', '', '1'),
(6723, 'MK_54', 'REGION', '54', 'Krusevo', 'MK', '', '', '1'),
(6722, 'MK_53', 'REGION', '53', 'Krivogastani', 'MK', '', '', '1'),
(6721, 'MK_52', 'REGION', '52', 'Kriva Palanka', 'MK', '', '', '1'),
(6720, 'MK_51', 'REGION', '51', 'Kratovo', 'MK', '', '', '1'),
(6719, 'MK_50', 'REGION', '50', 'Kosel', 'MK', '', '', '1'),
(6718, 'MK_49', 'REGION', '49', 'Konopiste', 'MK', '', '', '1'),
(6717, 'MK_48', 'REGION', '48', 'Kondovo', 'MK', '', '', '1'),
(6716, 'MK_47', 'REGION', '47', 'Konce', 'MK', '', '', '1'),
(6715, 'MK_46', 'REGION', '46', 'Kocani', 'MK', '', '', '1'),
(6714, 'MK_45', 'REGION', '45', 'Klecevce', 'MK', '', '', '1'),
(6713, 'MK_44', 'REGION', '44', 'Kisela Voda', 'MK', '', '', '1'),
(6712, 'MK_43', 'REGION', '43', 'Kicevo', 'MK', '', '', '1'),
(6711, 'MK_42', 'REGION', '42', 'Kavadarci', 'MK', '', '', '1'),
(6710, 'MK_41', 'REGION', '41', 'Karpos', 'MK', '', '', '1'),
(6709, 'MK_40', 'REGION', '40', 'Karbinci', 'MK', '', '', '1'),
(6708, 'MK_39', 'REGION', '39', 'Kamenjane', 'MK', '', '', '1'),
(6707, 'MK_38', 'REGION', '38', 'Jegunovce', 'MK', '', '', '1'),
(6706, 'MK_37', 'REGION', '37', 'Izvor', 'MK', '', '', '1'),
(6705, 'MK_36', 'REGION', '36', 'Ilinden', 'MK', '', '', '1'),
(6704, 'MK_35', 'REGION', '35', 'Gradsko', 'MK', '', '', '1'),
(6703, 'MK_34', 'REGION', '34', 'Gostivar', 'MK', '', '', '1'),
(6702, 'MK_33', 'REGION', '33', 'Gevgelija', 'MK', '', '', '1'),
(6701, 'MK_32', 'REGION', '32', 'Gazi Baba', 'MK', '', '', '1'),
(6700, 'MK_31', 'REGION', '31', 'Dzepciste', 'MK', '', '', '1'),
(6699, 'MK_30', 'REGION', '30', 'Drugovo', 'MK', '', '', '1'),
(6698, 'MK_29', 'REGION', '29', 'Dorce Petrov', 'MK', '', '', '1'),
(6697, 'MK_28', 'REGION', '28', 'Dolneni', 'MK', '', '', '1'),
(6696, 'MK_27', 'REGION', '27', 'Dolna Banjica', 'MK', '', '', '1'),
(6695, 'MK_26', 'REGION', '26', 'Dobrusevo', 'MK', '', '', '1'),
(6694, 'MK_25', 'REGION', '25', 'Demir Kapija', 'MK', '', '', '1'),
(6693, 'MK_24', 'REGION', '24', 'Demir Hisar', 'MK', '', '', '1'),
(6692, 'MK_23', 'REGION', '23', 'Delogozdi', 'MK', '', '', '1'),
(6691, 'MK_22', 'REGION', '22', 'Delcevo', 'MK', '', '', '1'),
(6690, 'MK_21', 'REGION', '21', 'Debar', 'MK', '', '', '1'),
(6689, 'MK_20', 'REGION', '20', 'Cucer-Sandevo', 'MK', '', '', '1'),
(6688, 'MK_19', 'REGION', '19', 'Cesinovo', 'MK', '', '', '1'),
(6687, 'MK_18', 'REGION', '18', 'Centar Zupa', 'MK', '', '', '1'),
(6686, 'MK_17', 'REGION', '17', 'Centar', 'MK', '', '', '1'),
(6685, 'MK_16', 'REGION', '16', 'Cegrane', 'MK', '', '', '1'),
(6684, 'MK_15', 'REGION', '15', 'Caska', 'MK', '', '', '1'),
(6683, 'MK_14', 'REGION', '14', 'Capari', 'MK', '', '', '1'),
(6682, 'MK_13', 'REGION', '13', 'Cair', 'MK', '', '', '1'),
(6681, 'MK_12', 'REGION', '12', 'Brvenica', 'MK', '', '', '1'),
(6680, 'MK_11', 'REGION', '11', 'Bosilovo', 'MK', '', '', '1'),
(6679, 'MK_10', 'REGION', '10', 'Bogovinje', 'MK', '', '', '1'),
(6678, 'MK_09', 'REGION', '09', 'Bogomila', 'MK', '', '', '1'),
(6677, 'MK_08', 'REGION', '08', 'Bogdanci', 'MK', '', '', '1'),
(6676, 'MK_07', 'REGION', '07', 'Blatec', 'MK', '', '', '1'),
(6675, 'MK_06', 'REGION', '06', 'Bitola', 'MK', '', '', '1'),
(6674, 'MK_05', 'REGION', '05', 'Bistrica', 'MK', '', '', '1'),
(6673, 'MK_04', 'REGION', '04', 'Berovo', 'MK', '', '', '1'),
(6672, 'MK_03', 'REGION', '03', 'Belcista', 'MK', '', '', '1'),
(6671, 'MK_02', 'REGION', '02', 'Bac', 'MK', '', '', '1'),
(6670, 'MK_01', 'REGION', '01', 'Aracinovo', 'MK', '', '', '1'),
(6669, 'MG_06', 'REGION', '06', 'Toliara', 'MG', '', '', '1'),
(6668, 'MG_05', 'REGION', '05', 'Antananarivo', 'MG', '', '', '1'),
(6667, 'MG_04', 'REGION', '04', 'Toamasina', 'MG', '', '', '1'),
(6666, 'MG_03', 'REGION', '03', 'Mahajanga', 'MG', '', '', '1'),
(6665, 'MG_02', 'REGION', '02', 'Fianarantsoa', 'MG', '', '', '1'),
(6664, 'MG_01', 'REGION', '01', 'Antsiranana', 'MG', '', '', '1'),
(6663, 'MD_92', 'REGION', '92', 'Ungheni', 'MD', '', '', '1'),
(6662, 'MD_91', 'REGION', '91', 'Telenesti', 'MD', '', '', '1'),
(6661, 'MD_90', 'REGION', '90', 'Taraclia', 'MD', '', '', '1'),
(6660, 'MD_89', 'REGION', '89', 'Straseni', 'MD', '', '', '1'),
(6659, 'MD_88', 'REGION', '88', 'Stefan-Voda', 'MD', '', '', '1'),
(6658, 'MD_87', 'REGION', '87', 'Soroca', 'MD', '', '', '1'),
(6657, 'MD_86', 'REGION', '86', 'Soldanesti', 'MD', '', '', '1'),
(6656, 'MD_85', 'REGION', '85', 'Singerei', 'MD', '', '', '1'),
(6655, 'MD_84', 'REGION', '84', 'Riscani', 'MD', '', '', '1'),
(6654, 'MD_83', 'REGION', '83', 'Rezina', 'MD', '', '', '1'),
(6653, 'MD_81', 'REGION', '81', 'Ocnita', 'MD', '', '', '1'),
(6652, 'MD_80', 'REGION', '80', 'Nisporeni', 'MD', '', '', '1'),
(6651, 'MD_79', 'REGION', '79', 'Leova', 'MD', '', '', '1'),
(6650, 'MD_78', 'REGION', '78', 'Ialoveni', 'MD', '', '', '1'),
(6649, 'MD_77', 'REGION', '77', 'Hincesti', 'MD', '', '', '1'),
(6648, 'MD_76', 'REGION', '76', 'Glodeni', 'MD', '', '', '1'),
(6647, 'MD_75', 'REGION', '75', 'Floresti', 'MD', '', '', '1'),
(6646, 'MD_74', 'REGION', '74', 'Falesti', 'MD', '', '', '1'),
(6645, 'MD_73', 'REGION', '73', 'Edinet', 'MD', '', '', '1'),
(6644, 'MD_72', 'REGION', '72', 'Dubasari', 'MD', '', '', '1'),
(6643, 'MD_71', 'REGION', '71', 'Drochia', 'MD', '', '', '1'),
(6642, 'MD_70', 'REGION', '70', 'Donduseni', 'MD', '', '', '1'),
(6641, 'MD_69', 'REGION', '69', 'Criuleni', 'MD', '', '', '1'),
(6640, 'MD_68', 'REGION', '68', 'Cimislia', 'MD', '', '', '1'),
(6639, 'MD_67', 'REGION', '67', 'Causeni', 'MD', '', '', '1'),
(6638, 'MD_66', 'REGION', '66', 'Calarasi', 'MD', '', '', '1'),
(6637, 'MD_65', 'REGION', '65', 'Cantemir', 'MD', '', '', '1'),
(6636, 'MD_64', 'REGION', '64', 'Cahul', 'MD', '', '', '1'),
(6635, 'MD_63', 'REGION', '63', 'Briceni', 'MD', '', '', '1'),
(6634, 'MD_62', 'REGION', '62', 'Bender', 'MD', '', '', '1'),
(6633, 'MD_61', 'REGION', '61', 'Basarabeasca', 'MD', '', '', '1'),
(6632, 'MD_60', 'REGION', '60', 'Balti', 'MD', '', '', '1'),
(6631, 'MD_59', 'REGION', '59', 'Anenii Noi', 'MD', '', '', '1'),
(6630, 'MD_58', 'REGION', '58', 'Stinga Nistrului', 'MD', '', '', '1'),
(6629, 'MD_56', 'REGION', '56', 'Ungheni', 'MD', '', '', '1'),
(6628, 'MD_55', 'REGION', '55', 'Tighina', 'MD', '', '', '1'),
(6627, 'MD_54', 'REGION', '54', 'Soroca', 'MD', '', '', '1'),
(6626, 'MD_53', 'REGION', '53', 'Orhei', 'MD', '', '', '1'),
(6625, 'MD_52', 'REGION', '52', 'Lapusna', 'MD', '', '', '1'),
(6624, 'MD_51', 'REGION', '51', 'Gagauzia', 'MD', '', '', '1'),
(6623, 'MD_50', 'REGION', '50', 'Edinet', 'MD', '', '', '1'),
(6622, 'MD_49', 'REGION', '49', 'Stinga Nistrului', 'MD', '', '', '1'),
(6621, 'MD_48', 'REGION', '48', 'Chisinau', 'MD', '', '', '1'),
(6620, 'MD_47', 'REGION', '47', 'Cahul', 'MD', '', '', '1'),
(6619, 'MD_46', 'REGION', '46', 'Balti', 'MD', '', '', '1'),
(6618, 'MC_03', 'REGION', '03', 'Monte-Carlo', 'MC', '', '', '1'),
(6617, 'MC_02', 'REGION', '02', 'Monaco', 'MC', '', '', '1'),
(6616, 'MC_01', 'REGION', '01', 'La Condamine', 'MC', '', '', '1'),
(6615, 'MA_59', 'REGION', '59', 'La,youne-Boujdour-Sakia El Hamra', 'MA', '', '', '1'),
(6614, 'MA_58', 'REGION', '58', 'Taza-Al Hoceima-Taounate', 'MA', '', '', '1'),
(6613, 'MA_57', 'REGION', '57', 'Tanger-Tetouan', 'MA', '', '', '1'),
(6612, 'MA_56', 'REGION', '56', 'Tadla-Azilal', 'MA', '', '', '1'),
(6611, 'MA_55', 'REGION', '55', 'Souss-Massa-Dr,a', 'MA', '', '', '1'),
(6610, 'MA_54', 'REGION', '54', 'Oriental', 'MA', '', '', '1'),
(6609, 'MA_53', 'REGION', '53', 'Guelmim-Es Smara', 'MA', '', '', '1'),
(6608, 'MA_52', 'REGION', '52', 'Gharb-Chrarda-Beni Hssen', 'MA', '', '', '1'),
(6607, 'MA_51', 'REGION', '51', 'Doukkala-Abda', 'MA', '', '', '1'),
(6606, 'MA_50', 'REGION', '50', 'Chaouia-Ouardigha', 'MA', '', '', '1'),
(6605, 'MA_49', 'REGION', '49', 'Rabat-Sale-Zemmour-Zaer', 'MA', '', '', '1'),
(6604, 'MA_48', 'REGION', '48', 'Meknes-Tafilalet', 'MA', '', '', '1'),
(6603, 'MA_47', 'REGION', '47', 'Marrakech-Tensift-Al Haouz', 'MA', '', '', '1'),
(6602, 'MA_46', 'REGION', '46', 'Fes-Boulemane', 'MA', '', '', '1'),
(6601, 'MA_45', 'REGION', '45', 'Grand Casablanca', 'MA', '', '', '1'),
(6600, 'MA_41', 'REGION', '41', 'Larache', 'MA', '', '', '1'),
(6599, 'MA_40', 'REGION', '40', 'Tetouan', 'MA', '', '', '1'),
(6598, 'MA_39', 'REGION', '39', 'Taroudannt', 'MA', '', '', '1'),
(6597, 'MA_38', 'REGION', '38', 'Sidi Kacem', 'MA', '', '', '1'),
(6596, 'MA_37', 'REGION', '37', 'Taounate', 'MA', '', '', '1'),
(6595, 'MA_36', 'REGION', '36', 'Tan-Tan', 'MA', '', '', '1'),
(6594, 'MA_35', 'REGION', '35', 'Laayoune', 'MA', '', '', '1'),
(6593, 'MA_34', 'REGION', '34', 'Ifrane', 'MA', '', '', '1'),
(6592, 'MA_33', 'REGION', '33', 'Guelmim', 'MA', '', '', '1'),
(6591, 'MA_32', 'REGION', '32', 'Tiznit', 'MA', '', '', '1'),
(6590, 'MA_30', 'REGION', '30', 'Taza', 'MA', '', '', '1'),
(6589, 'MA_29', 'REGION', '29', 'Tata', 'MA', '', '', '1'),
(6588, 'MA_27', 'REGION', '27', 'Tanger', 'MA', '', '', '1'),
(6587, 'MA_26', 'REGION', '26', 'Settat', 'MA', '', '', '1'),
(6586, 'MA_25', 'REGION', '25', 'Safi', 'MA', '', '', '1'),
(6585, 'MA_24', 'REGION', '24', 'Rabat-Sale', 'MA', '', '', '1'),
(6584, 'MA_23', 'REGION', '23', 'Oujda', 'MA', '', '', '1'),
(6583, 'MA_22', 'REGION', '22', 'Ouarzazate', 'MA', '', '', '1'),
(6582, 'MA_21', 'REGION', '21', 'Nador', 'MA', '', '', '1'),
(6581, 'MA_20', 'REGION', '20', 'Meknes', 'MA', '', '', '1'),
(6580, 'MA_19', 'REGION', '19', 'Marrakech', 'MA', '', '', '1'),
(6579, 'MA_18', 'REGION', '18', 'Khouribga', 'MA', '', '', '1'),
(6578, 'MA_17', 'REGION', '17', 'Khenifra', 'MA', '', '', '1'),
(6577, 'MA_16', 'REGION', '16', 'Khemisset', 'MA', '', '', '1'),
(6576, 'MA_15', 'REGION', '15', 'Kenitra', 'MA', '', '', '1'),
(6575, 'MA_14', 'REGION', '14', 'Figuig', 'MA', '', '', '1'),
(6574, 'MA_13', 'REGION', '13', 'Fes', 'MA', '', '', '1'),
(6573, 'MA_12', 'REGION', '12', 'Essaouira', 'MA', '', '', '1'),
(6572, 'MA_11', 'REGION', '11', 'Er Rachidia', 'MA', '', '', '1'),
(6571, 'MA_10', 'REGION', '10', 'El Kelaa des Srarhna', 'MA', '', '', '1'),
(6570, 'MA_09', 'REGION', '09', 'El Jadida', 'MA', '', '', '1'),
(6569, 'MA_08', 'REGION', '08', 'Chaouen', 'MA', '', '', '1'),
(6568, 'MA_07', 'REGION', '07', 'Casablanca', 'MA', '', '', '1'),
(6567, 'MA_06', 'REGION', '06', 'Boulemane', 'MA', '', '', '1'),
(6566, 'MA_05', 'REGION', '05', 'Beni Mellal', 'MA', '', '', '1'),
(6565, 'MA_04', 'REGION', '04', 'Ben Slimane', 'MA', '', '', '1'),
(6564, 'MA_03', 'REGION', '03', 'Azilal', 'MA', '', '', '1'),
(6563, 'MA_02', 'REGION', '02', 'Al Hoceima', 'MA', '', '', '1'),
(6562, 'MA_01', 'REGION', '01', 'Agadir', 'MA', '', '', '1'),
(6561, 'LY_62', 'REGION', '62', 'Yafran', 'LY', '', '', '1'),
(6560, 'LY_61', 'REGION', '61', 'Tarabulus', 'LY', '', '', '1'),
(6559, 'LY_60', 'REGION', '60', 'Surt', 'LY', '', '', '1'),
(6558, 'LY_59', 'REGION', '59', 'Sawfajjin', 'LY', '', '', '1'),
(6557, 'LY_58', 'REGION', '58', 'Misratah', 'LY', '', '', '1'),
(6556, 'LY_57', 'REGION', '57', 'Gharyan', 'LY', '', '', '1'),
(6555, 'LY_56', 'REGION', '56', 'Ghadamis', 'LY', '', '', '1'),
(6554, 'LY_55', 'REGION', '55', 'Darnah', 'LY', '', '', '1'),
(6553, 'LY_54', 'REGION', '54', 'Banghazi', 'LY', '', '', '1'),
(6552, 'LY_53', 'REGION', '53', 'Az Zawiyah', 'LY', '', '', '1'),
(6551, 'LY_52', 'REGION', '52', 'Awbari', 'LY', '', '', '1'),
(6550, 'LY_51', 'REGION', '51', 'An Nuqat al Khams', 'LY', '', '', '1'),
(6549, 'LY_50', 'REGION', '50', 'Al Khums', 'LY', '', '', '1'),
(6548, 'LY_49', 'REGION', '49', 'Al Jabal al Akhdar', 'LY', '', '', '1'),
(6547, 'LY_48', 'REGION', '48', 'Al Fatih', 'LY', '', '', '1'),
(6546, 'LY_47', 'REGION', '47', 'Ajdabiya', 'LY', '', '', '1'),
(6545, 'LY_45', 'REGION', '45', 'Zlitan', 'LY', '', '', '1'),
(6544, 'LY_42', 'REGION', '42', 'Tubruq', 'LY', '', '', '1'),
(6543, 'LY_41', 'REGION', '41', 'Tarhunah', 'LY', '', '', '1'),
(6542, 'LY_34', 'REGION', '34', 'Sabha', 'LY', '', '', '1'),
(6541, 'LY_30', 'REGION', '30', 'Murzuq', 'LY', '', '', '1'),
(6540, 'LY_08', 'REGION', '08', 'Al Kufrah', 'LY', '', '', '1'),
(6539, 'LY_05', 'REGION', '05', 'Al Jufrah', 'LY', '', '', '1'),
(6538, 'LY_03', 'REGION', '03', 'Al Aziziyah', 'LY', '', '', '1'),
(6537, 'LV_33', 'REGION', '33', 'Ventspils', 'LV', '', '', '1'),
(6536, 'LV_32', 'REGION', '32', 'Ventspils', 'LV', '', '', '1'),
(6535, 'LV_31', 'REGION', '31', 'Valmieras', 'LV', '', '', '1'),
(6534, 'LV_30', 'REGION', '30', 'Valkas', 'LV', '', '', '1'),
(6533, 'LV_29', 'REGION', '29', 'Tukuma', 'LV', '', '', '1'),
(6532, 'LV_28', 'REGION', '28', 'Talsu', 'LV', '', '', '1'),
(6531, 'LV_27', 'REGION', '27', 'Saldus', 'LV', '', '', '1'),
(6530, 'LV_26', 'REGION', '26', 'Rigas', 'LV', '', '', '1'),
(6529, 'LV_25', 'REGION', '25', 'Riga', 'LV', '', '', '1'),
(6528, 'LV_24', 'REGION', '24', 'Rezeknes', 'LV', '', '', '1'),
(6527, 'LV_23', 'REGION', '23', 'Rezekne', 'LV', '', '', '1'),
(6526, 'LV_22', 'REGION', '22', 'Preilu', 'LV', '', '', '1'),
(6525, 'LV_21', 'REGION', '21', 'Ogres', 'LV', '', '', '1'),
(6524, 'LV_20', 'REGION', '20', 'Madonas', 'LV', '', '', '1'),
(6523, 'LV_19', 'REGION', '19', 'Ludzas', 'LV', '', '', '1'),
(6522, 'LV_18', 'REGION', '18', 'Limbazu', 'LV', '', '', '1'),
(6521, 'LV_17', 'REGION', '17', 'Liepajas', 'LV', '', '', '1'),
(6520, 'LV_16', 'REGION', '16', 'Liepaja', 'LV', '', '', '1'),
(6519, 'LV_15', 'REGION', '15', 'Kuldigas', 'LV', '', '', '1'),
(6518, 'LV_14', 'REGION', '14', 'Kraslavas', 'LV', '', '', '1'),
(6517, 'LV_13', 'REGION', '13', 'Jurmala', 'LV', '', '', '1'),
(6516, 'LV_12', 'REGION', '12', 'Jelgavas', 'LV', '', '', '1'),
(6515, 'LV_11', 'REGION', '11', 'Jelgava', 'LV', '', '', '1'),
(6514, 'LV_10', 'REGION', '10', 'Jekabpils', 'LV', '', '', '1'),
(6513, 'LV_09', 'REGION', '09', 'Gulbenes', 'LV', '', '', '1'),
(6512, 'LV_08', 'REGION', '08', 'Dobeles', 'LV', '', '', '1'),
(6511, 'LV_07', 'REGION', '07', 'Daugavpils', 'LV', '', '', '1'),
(6510, 'LV_06', 'REGION', '06', 'Daugavpils', 'LV', '', '', '1'),
(6509, 'LV_05', 'REGION', '05', 'Cesu', 'LV', '', '', '1'),
(6508, 'LV_04', 'REGION', '04', 'Bauskas', 'LV', '', '', '1'),
(6507, 'LV_03', 'REGION', '03', 'Balvu', 'LV', '', '', '1'),
(6506, 'LV_02', 'REGION', '02', 'Aluksnes', 'LV', '', '', '1'),
(6505, 'LV_01', 'REGION', '01', 'Aizkraukles', 'LV', '', '', '1'),
(6504, 'LU_03', 'REGION', '03', 'Luxembourg', 'LU', '', '', '1'),
(6503, 'LU_02', 'REGION', '02', 'Grevenmacher', 'LU', '', '', '1'),
(6502, 'LU_01', 'REGION', '01', 'Diekirch', 'LU', '', '', '1'),
(6501, 'LT_65', 'REGION', '65', 'Vilniaus Apskritis', 'LT', '', '', '1'),
(6500, 'LT_64', 'REGION', '64', 'Utenos Apskritis', 'LT', '', '', '1'),
(6499, 'LT_63', 'REGION', '63', 'Telsiu Apskritis', 'LT', '', '', '1'),
(6498, 'LT_62', 'REGION', '62', 'Taurages Apskritis', 'LT', '', '', '1'),
(6497, 'LT_61', 'REGION', '61', 'Siauliu Apskritis', 'LT', '', '', '1'),
(6496, 'LT_60', 'REGION', '60', 'Panevezio Apskritis', 'LT', '', '', '1'),
(6495, 'LT_59', 'REGION', '59', 'Marijampoles Apskritis', 'LT', '', '', '1'),
(6494, 'LT_58', 'REGION', '58', 'Klaipedos Apskritis', 'LT', '', '', '1'),
(6493, 'LT_57', 'REGION', '57', 'Kauno Apskritis', 'LT', '', '', '1'),
(6492, 'LT_56', 'REGION', '56', 'Alytaus Apskritis', 'LT', '', '', '1'),
(6491, 'LS_19', 'REGION', '19', 'Thaba-Tseka', 'LS', '', '', '1'),
(6490, 'LS_18', 'REGION', '18', 'Quthing', 'LS', '', '', '1'),
(6489, 'LS_17', 'REGION', '17', 'Qachas Nek', 'LS', '', '', '1'),
(6488, 'LS_16', 'REGION', '16', 'Mokhotlong', 'LS', '', '', '1'),
(6487, 'LS_15', 'REGION', '15', 'Mohales Hoek', 'LS', '', '', '1'),
(6486, 'LS_14', 'REGION', '14', 'Maseru', 'LS', '', '', '1'),
(6485, 'LS_13', 'REGION', '13', 'Mafeteng', 'LS', '', '', '1'),
(6484, 'LS_12', 'REGION', '12', 'Leribe', 'LS', '', '', '1'),
(6483, 'LS_11', 'REGION', '11', 'Butha-Buthe', 'LS', '', '', '1'),
(6482, 'LS_10', 'REGION', '10', 'Berea', 'LS', '', '', '1'),
(6481, 'LR_22', 'REGION', '22', 'River Gee', 'LR', '', '', '1'),
(6480, 'LR_21', 'REGION', '21', 'Gbarpolu', 'LR', '', '', '1'),
(6479, 'LR_20', 'REGION', '20', 'Lofa', 'LR', '', '', '1'),
(6478, 'LR_19', 'REGION', '19', 'Grand Gedeh', 'LR', '', '', '1'),
(6477, 'LR_18', 'REGION', '18', 'River Cess', 'LR', '', '', '1'),
(6476, 'LR_17', 'REGION', '17', 'Margibi', 'LR', '', '', '1'),
(6475, 'LR_14', 'REGION', '14', 'Montserrado', 'LR', '', '', '1'),
(6474, 'LR_13', 'REGION', '13', 'Maryland', 'LR', '', '', '1'),
(6473, 'LR_12', 'REGION', '12', 'Grand Cape Mount', 'LR', '', '', '1'),
(6472, 'LR_11', 'REGION', '11', 'Grand Bassa', 'LR', '', '', '1'),
(6471, 'LR_10', 'REGION', '10', 'Sino', 'LR', '', '', '1'),
(6470, 'LR_09', 'REGION', '09', 'Nimba', 'LR', '', '', '1'),
(6469, 'LR_07', 'REGION', '07', 'Monrovia', 'LR', '', '', '1'),
(6468, 'LR_06', 'REGION', '06', 'Maryland', 'LR', '', '', '1'),
(6467, 'LR_05', 'REGION', '05', 'Lofa', 'LR', '', '', '1'),
(6466, 'LR_04', 'REGION', '04', 'Grand Cape Mount', 'LR', '', '', '1'),
(6465, 'LR_01', 'REGION', '01', 'Bong', 'LR', '', '', '1'),
(6464, 'LK_36', 'REGION', '36', 'Western', 'LK', '', '', '1'),
(6463, 'LK_35', 'REGION', '35', 'Uva', 'LK', '', '', '1'),
(6462, 'LK_34', 'REGION', '34', 'Southern', 'LK', '', '', '1'),
(6461, 'LK_33', 'REGION', '33', 'Sabaragamuwa', 'LK', '', '', '1'),
(6460, 'LK_32', 'REGION', '32', 'North Western', 'LK', '', '', '1'),
(6459, 'LK_31', 'REGION', '31', 'Northern', 'LK', '', '', '1'),
(6458, 'LK_30', 'REGION', '30', 'North Central', 'LK', '', '', '1'),
(6457, 'LK_29', 'REGION', '29', 'Central', 'LK', '', '', '1'),
(6456, 'LK_28', 'REGION', '28', 'Vavuniya', 'LK', '', '', '1'),
(6455, 'LK_27', 'REGION', '27', 'Mullaittivu', 'LK', '', '', '1'),
(6454, 'LK_26', 'REGION', '26', 'Mannar', 'LK', '', '', '1'),
(6453, 'LK_25', 'REGION', '25', 'Jaffna', 'LK', '', '', '1'),
(6452, 'LK_24', 'REGION', '24', 'Gampaha', 'LK', '', '', '1'),
(6451, 'LK_23', 'REGION', '23', 'Colombo', 'LK', '', '', '1');", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(6450, 'LK_21', 'REGION', '21', 'Trincomalee', 'LK', '', '', '1'),
(6449, 'LK_20', 'REGION', '20', 'Ratnapura', 'LK', '', '', '1'),
(6448, 'LK_19', 'REGION', '19', 'Puttalam', 'LK', '', '', '1'),
(6447, 'LK_18', 'REGION', '18', 'Polonnaruwa', 'LK', '', '', '1'),
(6446, 'LK_17', 'REGION', '17', 'Nuwara Eliya', 'LK', '', '', '1'),
(6445, 'LK_16', 'REGION', '16', 'Moneragala', 'LK', '', '', '1'),
(6444, 'LK_15', 'REGION', '15', 'Matara', 'LK', '', '', '1'),
(6443, 'LK_14', 'REGION', '14', 'Matale', 'LK', '', '', '1'),
(6442, 'LK_12', 'REGION', '12', 'Kurunegala', 'LK', '', '', '1'),
(6441, 'LK_11', 'REGION', '11', 'Kegalla', 'LK', '', '', '1'),
(6440, 'LK_10', 'REGION', '10', 'Kandy', 'LK', '', '', '1'),
(6439, 'LK_09', 'REGION', '09', 'Kalutara', 'LK', '', '', '1'),
(6438, 'LK_07', 'REGION', '07', 'Hambantota', 'LK', '', '', '1'),
(6437, 'LK_06', 'REGION', '06', 'Galle', 'LK', '', '', '1'),
(6436, 'LK_04', 'REGION', '04', 'Batticaloa', 'LK', '', '', '1'),
(6435, 'LK_03', 'REGION', '03', 'Badulla', 'LK', '', '', '1'),
(6434, 'LK_02', 'REGION', '02', 'Anuradhapura', 'LK', '', '', '1'),
(6433, 'LK_01', 'REGION', '01', 'Amparai', 'LK', '', '', '1'),
(6432, 'LI_22', 'REGION', '22', 'River Gee', 'LI', '', '', '1'),
(6431, 'LI_21', 'REGION', '21', 'Gbarpolu', 'LI', '', '', '1'),
(6430, 'LI_11', 'REGION', '11', 'Vaduz', 'LI', '', '', '1'),
(6429, 'LI_10', 'REGION', '10', 'Triesenberg', 'LI', '', '', '1'),
(6428, 'LI_09', 'REGION', '09', 'Triesen', 'LI', '', '', '1'),
(6427, 'LI_08', 'REGION', '08', 'Schellenberg', 'LI', '', '', '1'),
(6426, 'LI_07', 'REGION', '07', 'Schaan', 'LI', '', '', '1'),
(6425, 'LI_06', 'REGION', '06', 'Ruggell', 'LI', '', '', '1'),
(6424, 'LI_05', 'REGION', '05', 'Planken', 'LI', '', '', '1'),
(6423, 'LI_04', 'REGION', '04', 'Mauren', 'LI', '', '', '1'),
(6422, 'LI_03', 'REGION', '03', 'Gamprin', 'LI', '', '', '1'),
(6421, 'LI_02', 'REGION', '02', 'Eschen', 'LI', '', '', '1'),
(6420, 'LI_01', 'REGION', '01', 'Balzers', 'LI', '', '', '1'),
(6419, 'LC_11', 'REGION', '11', 'Praslin', 'LC', '', '', '1'),
(6418, 'LC_10', 'REGION', '10', 'Vieux-Fort', 'LC', '', '', '1'),
(6417, 'LC_09', 'REGION', '09', 'Soufriere', 'LC', '', '', '1'),
(6416, 'LC_08', 'REGION', '08', 'Micoud', 'LC', '', '', '1'),
(6415, 'LC_07', 'REGION', '07', 'Laborie', 'LC', '', '', '1'),
(6414, 'LC_06', 'REGION', '06', 'Gros-Islet', 'LC', '', '', '1'),
(6413, 'LC_05', 'REGION', '05', 'Dennery', 'LC', '', '', '1'),
(6412, 'LC_04', 'REGION', '04', 'Choiseul', 'LC', '', '', '1'),
(6411, 'LC_03', 'REGION', '03', 'Castries', 'LC', '', '', '1'),
(6410, 'LC_02', 'REGION', '02', 'Dauphin', 'LC', '', '', '1'),
(6409, 'LC_01', 'REGION', '01', 'Anse-la-Raye', 'LC', '', '', '1'),
(6408, 'LB_11', 'REGION', '11', 'Baalbek-Hermel', 'LB', '', '', '1'),
(6407, 'LB_10', 'REGION', '10', 'Aakk,r', 'LB', '', '', '1'),
(6406, 'LB_09', 'REGION', '09', 'Liban-Nord', 'LB', '', '', '1'),
(6405, 'LB_08', 'REGION', '08', 'Beqaa', 'LB', '', '', '1'),
(6404, 'LB_07', 'REGION', '07', 'Nabatiye', 'LB', '', '', '1'),
(6403, 'LB_06', 'REGION', '06', 'Liban-Sud', 'LB', '', '', '1'),
(6402, 'LB_05', 'REGION', '05', 'Mont-Liban', 'LB', '', '', '1'),
(6401, 'LB_04', 'REGION', '04', 'Beyrouth', 'LB', '', '', '1'),
(6400, 'LB_03', 'REGION', '03', 'Liban-Nord', 'LB', '', '', '1'),
(6399, 'LB_02', 'REGION', '02', 'Al Janub', 'LB', '', '', '1'),
(6398, 'LB_01', 'REGION', '01', 'Beqaa', 'LB', '', '', '1'),
(6397, 'LA_17', 'REGION', '17', 'Louangphrabang', 'LA', '', '', '1'),
(6396, 'LA_14', 'REGION', '14', 'Xiangkhoang', 'LA', '', '', '1'),
(6395, 'LA_13', 'REGION', '13', 'Xaignabouri', 'LA', '', '', '1'),
(6394, 'LA_11', 'REGION', '11', 'Vientiane', 'LA', '', '', '1'),
(6393, 'LA_10', 'REGION', '10', 'Savannakhet', 'LA', '', '', '1'),
(6392, 'LA_09', 'REGION', '09', 'Saravan', 'LA', '', '', '1'),
(6391, 'LA_08', 'REGION', '08', 'Phongsali', 'LA', '', '', '1'),
(6390, 'LA_07', 'REGION', '07', 'Oudomxai', 'LA', '', '', '1'),
(6389, 'LA_05', 'REGION', '05', 'Louang Namtha', 'LA', '', '', '1'),
(6388, 'LA_04', 'REGION', '04', 'Khammouan', 'LA', '', '', '1'),
(6387, 'LA_03', 'REGION', '03', 'Houaphan', 'LA', '', '', '1'),
(6386, 'LA_02', 'REGION', '02', 'Champasak', 'LA', '', '', '1'),
(6385, 'LA_01', 'REGION', '01', 'Attapu', 'LA', '', '', '1'),
(6384, 'KZ_17', 'REGION', '17', 'Zhambyl', 'KZ', '', '', '1'),
(6383, 'KZ_16', 'REGION', '16', 'North Kazakhstan', 'KZ', '', '', '1'),
(6382, 'KZ_15', 'REGION', '15', 'East Kazakhstan', 'KZ', '', '', '1'),
(6381, 'KZ_14', 'REGION', '14', 'Qyzylorda', 'KZ', '', '', '1'),
(6380, 'KZ_13', 'REGION', '13', 'Qostanay', 'KZ', '', '', '1'),
(6379, 'KZ_12', 'REGION', '12', 'Qaraghandy', 'KZ', '', '', '1'),
(6378, 'KZ_11', 'REGION', '11', 'Pavlodar', 'KZ', '', '', '1'),
(6377, 'KZ_10', 'REGION', '10', 'South Kazakhstan', 'KZ', '', '', '1'),
(6376, 'KZ_09', 'REGION', '09', 'Mangghystau', 'KZ', '', '', '1'),
(6375, 'KZ_08', 'REGION', '08', 'Bayqonyr', 'KZ', '', '', '1'),
(6374, 'KZ_07', 'REGION', '07', 'West Kazakhstan', 'KZ', '', '', '1'),
(6373, 'KZ_06', 'REGION', '06', 'Atyrau', 'KZ', '', '', '1'),
(6372, 'KZ_05', 'REGION', '05', 'Astana', 'KZ', '', '', '1'),
(6371, 'KZ_04', 'REGION', '04', 'Aqtobe', 'KZ', '', '', '1'),
(6370, 'KZ_03', 'REGION', '03', 'Aqmola', 'KZ', '', '', '1'),
(6369, 'KZ_02', 'REGION', '02', 'Almaty City', 'KZ', '', '', '1'),
(6368, 'KZ_01', 'REGION', '01', 'Almaty', 'KZ', '', '', '1'),
(6367, 'KY_08', 'REGION', '08', 'Western', 'KY', '', '', '1'),
(6366, 'KY_07', 'REGION', '07', 'West End', 'KY', '', '', '1'),
(6365, 'KY_06', 'REGION', '06', 'Stake Bay', 'KY', '', '', '1'),
(6364, 'KY_05', 'REGION', '05', 'Spot Bay', 'KY', '', '', '1'),
(6363, 'KY_04', 'REGION', '04', 'South Town', 'KY', '', '', '1'),
(6362, 'KY_03', 'REGION', '03', 'Midland', 'KY', '', '', '1'),
(6361, 'KY_02', 'REGION', '02', 'Eastern', 'KY', '', '', '1'),
(6360, 'KY_01', 'REGION', '01', 'Creek', 'KY', '', '', '1'),
(6359, 'KW_09', 'REGION', '09', 'Mubarak al Kabir', 'KW', '', '', '1'),
(6358, 'KW_08', 'REGION', '08', 'Hawalli', 'KW', '', '', '1'),
(6357, 'KW_07', 'REGION', '07', 'Al Farwaniyah', 'KW', '', '', '1'),
(6356, 'KW_05', 'REGION', '05', 'Al Jahra', 'KW', '', '', '1'),
(6355, 'KW_02', 'REGION', '02', 'Al Kuwayt', 'KW', '', '', '1'),
(6354, 'KW_01', 'REGION', '01', 'Al Ahmadi', 'KW', '', '', '1'),
(6353, 'KR_21', 'REGION', '21', 'Ulsan-gwangyoksi', 'KR', '', '', '1'),
(6352, 'KR_20', 'REGION', '20', 'Kyongsang-namdo', 'KR', '', '', '1'),
(6351, 'KR_19', 'REGION', '19', 'Taejon-jikhalsi', 'KR', '', '', '1'),
(6350, 'KR_18', 'REGION', '18', 'Kwangju-jikhalsi', 'KR', '', '', '1'),
(6349, 'KR_16', 'REGION', '16', 'Cholla-namdo', 'KR', '', '', '1'),
(6348, 'KR_15', 'REGION', '15', 'Taegu-jikhalsi', 'KR', '', '', '1'),
(6347, 'KR_14', 'REGION', '14', 'Kyongsang-bukto', 'KR', '', '', '1'),
(6346, 'KR_13', 'REGION', '13', 'Kyonggi-do', 'KR', '', '', '1'),
(6345, 'KR_10', 'REGION', '10', 'Pusan-jikhalsi', 'KR', '', '', '1'),
(6344, 'KR_06', 'REGION', '06', 'Kangwon-do', 'KR', '', '', '1'),
(6343, 'KR_03', 'REGION', '03', 'Cholla-bukto', 'KR', '', '', '1'),
(6342, 'KR_01', 'REGION', '01', 'Cheju-do', 'KR', '', '', '1'),
(6341, 'KP_18', 'REGION', '18', 'Najin Sonbong-si', 'KP', '', '', '1'),
(6340, 'KP_17', 'REGION', '17', 'Hamgyong-bukto', 'KP', '', '', '1'),
(6339, 'KP_13', 'REGION', '13', 'Yanggang-do', 'KP', '', '', '1'),
(6338, 'KP_09', 'REGION', '09', 'Kangwon-do', 'KP', '', '', '1'),
(6337, 'KP_08', 'REGION', '08', 'Kaesong-si', 'KP', '', '', '1'),
(6336, 'KP_07', 'REGION', '07', 'Hwanghae-bukto', 'KP', '', '', '1'),
(6335, 'KP_06', 'REGION', '06', 'Hwanghae-namdo', 'KP', '', '', '1'),
(6334, 'KP_03', 'REGION', '03', 'Hamgyong-namdo', 'KP', '', '', '1'),
(6333, 'KP_01', 'REGION', '01', 'Chagang-do', 'KP', '', '', '1'),
(6332, 'KN_15', 'REGION', '15', 'Trinity Palmetto Point', 'KN', '', '', '1'),
(6331, 'KN_13', 'REGION', '13', 'Saint Thomas Middle Island', 'KN', '', '', '1'),
(6330, 'KN_12', 'REGION', '12', 'Saint Thomas Lowland', 'KN', '', '', '1'),
(6329, 'KN_11', 'REGION', '11', 'Saint Peter Basseterre', 'KN', '', '', '1'),
(6328, 'KN_10', 'REGION', '10', 'Saint Paul Charlestown', 'KN', '', '', '1'),
(6327, 'KN_09', 'REGION', '09', 'Saint Paul Capisterre', 'KN', '', '', '1'),
(6326, 'KN_08', 'REGION', '08', 'Saint Mary Cayon', 'KN', '', '', '1'),
(6325, 'KN_07', 'REGION', '07', 'Saint John Figtree', 'KN', '', '', '1'),
(6324, 'KN_06', 'REGION', '06', 'Saint John Capisterre', 'KN', '', '', '1'),
(6323, 'KN_05', 'REGION', '05', 'Saint James Windward', 'KN', '', '', '1'),
(6322, 'KN_04', 'REGION', '04', 'Saint George Gingerland', 'KN', '', '', '1'),
(6321, 'KN_03', 'REGION', '03', 'Saint George Basseterre', 'KN', '', '', '1'),
(6320, 'KN_02', 'REGION', '02', 'Saint Anne Sandy Point', 'KN', '', '', '1'),
(6319, 'KN_01', 'REGION', '01', 'Christ Church Nichola Town', 'KN', '', '', '1'),
(6318, 'KM_03', 'REGION', '03', 'Moheli', 'KM', '', '', '1'),
(6317, 'KM_02', 'REGION', '02', 'Grande Comore', 'KM', '', '', '1'),
(6316, 'KM_01', 'REGION', '01', 'Anjouan', 'KM', '', '', '1'),
(6315, 'KI_03', 'REGION', '03', 'Phoenix Islands', 'KI', '', '', '1'),
(6314, 'KI_02', 'REGION', '02', 'Line Islands', 'KI', '', '', '1'),
(6313, 'KI_01', 'REGION', '01', 'Gilbert Islands', 'KI', '', '', '1'),
(6312, 'KH_30', 'REGION', '30', 'Pailin', 'KH', '', '', '1'),
(6311, 'KH_29', 'REGION', '29', 'Batdambang', 'KH', '', '', '1'),
(6310, 'KH_19', 'REGION', '19', 'Takeo', 'KH', '', '', '1'),
(6309, 'KH_18', 'REGION', '18', 'Svay Rieng', 'KH', '', '', '1'),
(6308, 'KH_17', 'REGION', '17', 'Stung Treng', 'KH', '', '', '1'),
(6307, 'KH_16', 'REGION', '16', 'Siem Reap', 'KH', '', '', '1'),
(6306, 'KH_15', 'REGION', '15', 'Ratanakiri Kiri', 'KH', '', '', '1'),
(6305, 'KH_14', 'REGION', '14', 'Prey Veng', 'KH', '', '', '1'),
(6304, 'KH_13', 'REGION', '13', 'Preah Vihear', 'KH', '', '', '1'),
(6303, 'KH_12', 'REGION', '12', 'Pursat', 'KH', '', '', '1'),
(6302, 'KH_11', 'REGION', '11', 'Phnum Penh', 'KH', '', '', '1'),
(6301, 'KH_10', 'REGION', '10', 'Mondulkiri', 'KH', '', '', '1'),
(6300, 'KH_09', 'REGION', '09', 'Kracheh', 'KH', '', '', '1'),
(6299, 'KH_08', 'REGION', '08', 'Koh Kong', 'KH', '', '', '1'),
(6298, 'KH_07', 'REGION', '07', 'Kandal', 'KH', '', '', '1'),
(6297, 'KH_06', 'REGION', '06', 'Kampot', 'KH', '', '', '1'),
(6296, 'KH_05', 'REGION', '05', 'Kampong Thum', 'KH', '', '', '1'),
(6295, 'KH_04', 'REGION', '04', 'Kampong Speu', 'KH', '', '', '1'),
(6294, 'KH_03', 'REGION', '03', 'Kampong Chhnang', 'KH', '', '', '1'),
(6293, 'KH_02', 'REGION', '02', 'Kampong Cham', 'KH', '', '', '1'),
(6292, 'KH_01', 'REGION', '01', 'Batdambang', 'KH', '', '', '1'),
(6291, 'KH_00', 'REGION', '00', 'Banteay Meanchey', 'KH', '', '', '1'),
(6290, 'KG_09', 'REGION', '09', 'Batken', 'KG', '', '', '1'),
(6289, 'KG_08', 'REGION', '08', 'Osh', 'KG', '', '', '1'),
(6288, 'KG_07', 'REGION', '07', 'Ysyk-Kol', 'KG', '', '', '1'),
(6287, 'KG_06', 'REGION', '06', 'Talas', 'KG', '', '', '1'),
(6286, 'KG_05', 'REGION', '05', 'Osh', 'KG', '', '', '1'),
(6285, 'KG_04', 'REGION', '04', 'Naryn', 'KG', '', '', '1'),
(6284, 'KG_03', 'REGION', '03', 'Jalal-Abad', 'KG', '', '', '1'),
(6283, 'KG_02', 'REGION', '02', 'Chuy', 'KG', '', '', '1'),
(6282, 'KG_01', 'REGION', '01', 'Bishkek', 'KG', '', '', '1'),
(6281, 'KE_09', 'REGION', '09', 'Western', 'KE', '', '', '1'),
(6280, 'KE_08', 'REGION', '08', 'Rift Valley', 'KE', '', '', '1'),
(6279, 'KE_07', 'REGION', '07', 'Nyanza', 'KE', '', '', '1'),
(6278, 'KE_06', 'REGION', '06', 'North-Eastern', 'KE', '', '', '1'),
(6277, 'KE_05', 'REGION', '05', 'Nairobi Area', 'KE', '', '', '1'),
(6276, 'KE_03', 'REGION', '03', 'Eastern', 'KE', '', '', '1'),
(6275, 'KE_02', 'REGION', '02', 'Coast', 'KE', '', '', '1'),
(6274, 'KE_01', 'REGION', '01', 'Central', 'KE', '', '', '1'),
(6273, 'JP_47', 'REGION', '47', 'Okinawa', 'JP', '', '', '1'),
(6272, 'JP_46', 'REGION', '46', 'Yamanashi', 'JP', '', '', '1'),
(6271, 'JP_45', 'REGION', '45', 'Yamaguchi', 'JP', '', '', '1'),
(6270, 'JP_44', 'REGION', '44', 'Yamagata', 'JP', '', '', '1'),
(6269, 'JP_43', 'REGION', '43', 'Wakayama', 'JP', '', '', '1'),
(6268, 'JP_42', 'REGION', '42', 'Toyama', 'JP', '', '', '1'),
(6267, 'JP_41', 'REGION', '41', 'Tottori', 'JP', '', '', '1'),
(6266, 'JP_40', 'REGION', '40', 'Tokyo', 'JP', '', '', '1'),
(6265, 'JP_39', 'REGION', '39', 'Tokushima', 'JP', '', '', '1'),
(6264, 'JP_38', 'REGION', '38', 'Tochigi', 'JP', '', '', '1'),
(6263, 'JP_37', 'REGION', '37', 'Shizuoka', 'JP', '', '', '1'),
(6262, 'JP_36', 'REGION', '36', 'Shimane', 'JP', '', '', '1'),
(6261, 'JP_35', 'REGION', '35', 'Shiga', 'JP', '', '', '1'),
(6260, 'JP_34', 'REGION', '34', 'Saitama', 'JP', '', '', '1'),
(6259, 'JP_33', 'REGION', '33', 'Saga', 'JP', '', '', '1'),
(6258, 'JP_32', 'REGION', '32', 'Osaka', 'JP', '', '', '1'),
(6257, 'JP_31', 'REGION', '31', 'Okayama', 'JP', '', '', '1'),
(6256, 'JP_30', 'REGION', '30', 'Oita', 'JP', '', '', '1'),
(6255, 'JP_29', 'REGION', '29', 'Niigata', 'JP', '', '', '1'),
(6254, 'JP_28', 'REGION', '28', 'Nara', 'JP', '', '', '1'),
(6253, 'JP_27', 'REGION', '27', 'Nagasaki', 'JP', '', '', '1'),
(6252, 'JP_26', 'REGION', '26', 'Nagano', 'JP', '', '', '1'),
(6251, 'JP_25', 'REGION', '25', 'Miyazaki', 'JP', '', '', '1'),
(6250, 'JP_24', 'REGION', '24', 'Miyagi', 'JP', '', '', '1'),
(6249, 'JP_23', 'REGION', '23', 'Mie', 'JP', '', '', '1'),
(6248, 'JP_22', 'REGION', '22', 'Kyoto', 'JP', '', '', '1'),
(6247, 'JP_21', 'REGION', '21', 'Kumamoto', 'JP', '', '', '1'),
(6246, 'JP_20', 'REGION', '20', 'Kochi', 'JP', '', '', '1'),
(6245, 'JP_19', 'REGION', '19', 'Kanagawa', 'JP', '', '', '1'),
(6244, 'JP_18', 'REGION', '18', 'Kagoshima', 'JP', '', '', '1'),
(6243, 'JP_17', 'REGION', '17', 'Kagawa', 'JP', '', '', '1'),
(6242, 'JP_16', 'REGION', '16', 'Iwate', 'JP', '', '', '1'),
(6241, 'JP_15', 'REGION', '15', 'Ishikawa', 'JP', '', '', '1'),
(6240, 'JP_14', 'REGION', '14', 'Ibaraki', 'JP', '', '', '1'),
(6239, 'JP_13', 'REGION', '13', 'Hyogo', 'JP', '', '', '1'),
(6238, 'JP_12', 'REGION', '12', 'Hokkaido', 'JP', '', '', '1'),
(6237, 'JP_11', 'REGION', '11', 'Hiroshima', 'JP', '', '', '1'),
(6236, 'JP_10', 'REGION', '10', 'Gumma', 'JP', '', '', '1'),
(6235, 'JP_09', 'REGION', '09', 'Gifu', 'JP', '', '', '1'),
(6234, 'JP_08', 'REGION', '08', 'Fukushima', 'JP', '', '', '1'),
(6233, 'JP_07', 'REGION', '07', 'Fukuoka', 'JP', '', '', '1'),
(6232, 'JP_06', 'REGION', '06', 'Fukui', 'JP', '', '', '1'),
(6231, 'JP_05', 'REGION', '05', 'Ehime', 'JP', '', '', '1'),
(6230, 'JP_04', 'REGION', '04', 'Chiba', 'JP', '', '', '1'),
(6229, 'JP_03', 'REGION', '03', 'Aomori', 'JP', '', '', '1'),
(6228, 'JP_02', 'REGION', '02', 'Akita', 'JP', '', '', '1'),
(6227, 'JP_01', 'REGION', '01', 'Aichi', 'JP', '', '', '1'),
(6226, 'JO_16', 'REGION', '16', 'Amman', 'JO', '', '', '1'),
(6225, 'JO_14', 'REGION', '14', 'Irbid', 'JO', '', '', '1'),
(6224, 'JO_13', 'REGION', '13', 'Az Zarqa', 'JO', '', '', '1'),
(6223, 'JO_12', 'REGION', '12', 'At Tafilah', 'JO', '', '', '1'),
(6222, 'JO_11', 'REGION', '11', 'Amman Governorate', 'JO', '', '', '1'),
(6221, 'JO_10', 'REGION', '10', 'Al Mafraq', 'JO', '', '', '1'),
(6220, 'JO_09', 'REGION', '09', 'Al Karak', 'JO', '', '', '1'),
(6219, 'JO_07', 'REGION', '07', 'Ma', 'JO', '', '', '1'),
(6218, 'JM_17', 'REGION', '17', 'Kingston', 'JM', '', '', '1'),
(6217, 'JM_16', 'REGION', '16', 'Westmoreland', 'JM', '', '', '1'),
(6216, 'JM_15', 'REGION', '15', 'Trelawny', 'JM', '', '', '1'),
(6215, 'JM_14', 'REGION', '14', 'Saint Thomas', 'JM', '', '', '1'),
(6214, 'JM_13', 'REGION', '13', 'Saint Mary', 'JM', '', '', '1'),
(6213, 'JM_12', 'REGION', '12', 'Saint James', 'JM', '', '', '1'),
(6212, 'JM_11', 'REGION', '11', 'Saint Elizabeth', 'JM', '', '', '1'),
(6211, 'JM_10', 'REGION', '10', 'Saint Catherine', 'JM', '', '', '1'),
(6210, 'JM_09', 'REGION', '09', 'Saint Ann', 'JM', '', '', '1'),
(6209, 'JM_08', 'REGION', '08', 'Saint Andrew', 'JM', '', '', '1'),
(6208, 'JM_07', 'REGION', '07', 'Portland', 'JM', '', '', '1'),
(6207, 'JM_04', 'REGION', '04', 'Manchester', 'JM', '', '', '1'),
(6206, 'JM_02', 'REGION', '02', 'Hanover', 'JM', '', '', '1'),
(6205, 'JM_01', 'REGION', '01', 'Clarendon', 'JM', '', '', '1'),
(6204, 'IT_20', 'REGION', '20', 'Veneto', 'IT', '', '', '1'),
(6203, 'IT_18', 'REGION', '18', 'Umbria', 'IT', '', '', '1'),
(6202, 'IT_17', 'REGION', '17', 'Trentino-Alto Adige', 'IT', '', '', '1'),
(6201, 'IT_16', 'REGION', '16', 'Toscana', 'IT', '', '', '1'),
(6200, 'IT_15', 'REGION', '15', 'Sicilia', 'IT', '', '', '1'),
(6199, 'IT_14', 'REGION', '14', 'Sardegna', 'IT', '', '', '1'),
(6198, 'IT_13', 'REGION', '13', 'Puglia', 'IT', '', '', '1'),
(6197, 'IT_12', 'REGION', '12', 'Piemonte', 'IT', '', '', '1'),
(6196, 'IT_11', 'REGION', '11', 'Molise', 'IT', '', '', '1'),
(6195, 'IT_10', 'REGION', '10', 'Marche', 'IT', '', '', '1'),
(6194, 'IT_09', 'REGION', '09', 'Lombardia', 'IT', '', '', '1'),
(6193, 'IT_08', 'REGION', '08', 'Liguria', 'IT', '', '', '1'),
(6192, 'IT_07', 'REGION', '07', 'Lazio', 'IT', '', '', '1'),
(6191, 'IT_06', 'REGION', '06', 'Friuli-Venezia Giulia', 'IT', '', '', '1'),
(6190, 'IT_05', 'REGION', '05', 'Emilia-Romagna', 'IT', '', '', '1'),
(6189, 'IT_04', 'REGION', '04', 'Campania', 'IT', '', '', '1'),
(6188, 'IT_03', 'REGION', '03', 'Calabria', 'IT', '', '', '1'),
(6187, 'IT_02', 'REGION', '02', 'Basilicata', 'IT', '', '', '1'),
(6186, 'IT_01', 'REGION', '01', 'Abruzzi', 'IT', '', '', '1'),
(6185, 'IS_45', 'REGION', '45', 'Vesturland', 'IS', '', '', '1'),
(6184, 'IS_44', 'REGION', '44', 'Vestfiroir', 'IS', '', '', '1'),
(6183, 'IS_43', 'REGION', '43', 'Suournes', 'IS', '', '', '1'),
(6182, 'IS_42', 'REGION', '42', 'Suourland', 'IS', '', '', '1'),
(6181, 'IS_41', 'REGION', '41', 'Norourland Vestra', 'IS', '', '', '1'),
(6180, 'IS_40', 'REGION', '40', 'Norourland Eystra', 'IS', '', '', '1'),
(6179, 'IS_37', 'REGION', '37', 'Vestur-Skaftafellssysla', 'IS', '', '', '1'),
(6178, 'IS_36', 'REGION', '36', 'Vestur-Isafjardarsysla', 'IS', '', '', '1'),
(6177, 'IS_35', 'REGION', '35', 'Vestur-Hunavatnssysla', 'IS', '', '', '1'),
(6176, 'IS_34', 'REGION', '34', 'Vestur-Bardastrandarsysla', 'IS', '', '', '1'),
(6175, 'IS_32', 'REGION', '32', 'Sudur-Tingeyjarsysla', 'IS', '', '', '1'),
(6174, 'IS_31', 'REGION', '31', 'Sudur-Mulasysla', 'IS', '', '', '1'),
(6173, 'IS_30', 'REGION', '30', 'Strandasysla', 'IS', '', '', '1'),
(6172, 'IS_29', 'REGION', '29', 'Snafellsnes- og Hnappadalssysla', 'IS', '', '', '1'),
(6171, 'IS_28', 'REGION', '28', 'Skagafjardarsysla', 'IS', '', '', '1'),
(6170, 'IS_23', 'REGION', '23', 'Rangarvallasysla', 'IS', '', '', '1'),
(6169, 'IS_21', 'REGION', '21', 'Nordur-Tingeyjarsysla', 'IS', '', '', '1'),
(6168, 'IS_20', 'REGION', '20', 'Nordur-Mulasysla', 'IS', '', '', '1'),
(6167, 'IS_17', 'REGION', '17', 'Myrasysla', 'IS', '', '', '1'),
(6166, 'IS_15', 'REGION', '15', 'Kjosarsysla', 'IS', '', '', '1'),
(6165, 'IS_10', 'REGION', '10', 'Gullbringusysla', 'IS', '', '', '1'),
(6164, 'IS_09', 'REGION', '09', 'Eyjafjardarsysla', 'IS', '', '', '1'),
(6163, 'IS_07', 'REGION', '07', 'Borgarfjardarsysla', 'IS', '', '', '1'),
(6162, 'IS_06', 'REGION', '06', 'Austur-Skaftafellssysla', 'IS', '', '', '1'),
(6161, 'IS_05', 'REGION', '05', 'Austur-Hunavatnssysla', 'IS', '', '', '1'),
(6160, 'IS_03', 'REGION', '03', 'Arnessysla', 'IS', '', '', '1'),
(6159, 'IR_43', 'REGION', '43', 'Khorasan-e Shemali', 'IR', '', '', '1'),
(6158, 'IR_42', 'REGION', '42', 'Khorasan-e Razavi', 'IR', '', '', '1'),
(6157, 'IR_41', 'REGION', '41', 'Khorasan-e Janubi', 'IR', '', '', '1'),
(6156, 'IR_40', 'REGION', '40', 'Yazd', 'IR', '', '', '1'),
(6155, 'IR_39', 'REGION', '39', 'Qom', 'IR', '', '', '1'),
(6154, 'IR_38', 'REGION', '38', 'Qazvin', 'IR', '', '', '1'),
(6153, 'IR_37', 'REGION', '37', 'Golestan', 'IR', '', '', '1'),
(6152, 'IR_36', 'REGION', '36', 'Zanjan', 'IR', '', '', '1'),
(6151, 'IR_35', 'REGION', '35', 'Mazandaran', 'IR', '', '', '1'),
(6150, 'IR_34', 'REGION', '34', 'Markazi', 'IR', '', '', '1'),
(6149, 'IR_33', 'REGION', '33', 'East Azarbaijan', 'IR', '', '', '1'),
(6148, 'IR_32', 'REGION', '32', 'Ardabil', 'IR', '', '', '1'),
(6147, 'IR_31', 'REGION', '31', 'Yazd', 'IR', '', '', '1'),
(6146, 'IR_30', 'REGION', '30', 'Khorasan', 'IR', '', '', '1'),
(6145, 'IR_29', 'REGION', '29', 'Kerman', 'IR', '', '', '1'),
(6144, 'IR_28', 'REGION', '28', 'Esfahan', 'IR', '', '', '1'),
(6143, 'IR_27', 'REGION', '27', 'Zanjan', 'IR', '', '', '1'),
(6142, 'IR_26', 'REGION', '26', 'Tehran', 'IR', '', '', '1'),
(6141, 'IR_25', 'REGION', '25', 'Semnan', 'IR', '', '', '1'),
(6140, 'IR_24', 'REGION', '24', 'Markazi', 'IR', '', '', '1'),
(6139, 'IR_23', 'REGION', '23', 'Lorestan', 'IR', '', '', '1'),
(6138, 'IR_22', 'REGION', '22', 'Bushehr', 'IR', '', '', '1'),
(6137, 'IR_21', 'REGION', '21', 'Zanjan', 'IR', '', '', '1'),
(6136, 'IR_19', 'REGION', '19', 'Markazi', 'IR', '', '', '1'),
(6135, 'IR_18', 'REGION', '18', 'Semnan Province', 'IR', '', '', '1'),
(6134, 'IR_17', 'REGION', '17', 'Mazandaran', 'IR', '', '', '1'),
(6133, 'IR_16', 'REGION', '16', 'Kordestan', 'IR', '', '', '1'),
(6132, 'IR_15', 'REGION', '15', 'Khuzestan', 'IR', '', '', '1'),
(6131, 'IR_13', 'REGION', '13', 'Bakhtaran', 'IR', '', '', '1'),
(6130, 'IR_12', 'REGION', '12', 'Kerman', 'IR', '', '', '1'),
(6129, 'IR_11', 'REGION', '11', 'Hormozgan', 'IR', '', '', '1'),
(6128, 'IR_10', 'REGION', '10', 'Ilam', 'IR', '', '', '1'),
(6127, 'IR_09', 'REGION', '09', 'Hamadan', 'IR', '', '', '1'),
(6126, 'IR_08', 'REGION', '08', 'Gilan', 'IR', '', '', '1'),
(6125, 'IR_07', 'REGION', '07', 'Fars', 'IR', '', '', '1'),
(6124, 'IR_05', 'REGION', '05', 'Kohkiluyeh va Buyer Ahmadi', 'IR', '', '', '1'),
(6123, 'IR_04', 'REGION', '04', 'Sistan va Baluchestan', 'IR', '', '', '1'),
(6122, 'IR_03', 'REGION', '03', 'Chahar Mahall va Bakhtiari', 'IR', '', '', '1'),
(6121, 'IR_02', 'REGION', '02', 'Azarbayjan-e Khavari', 'IR', '', '', '1'),
(6120, 'IR_01', 'REGION', '01', 'Azarbayjan-e Bakhtari', 'IR', '', '', '1'),
(6119, 'IQ_18', 'REGION', '18', 'Salah ad Din', 'IQ', '', '', '1'),
(6118, 'IQ_17', 'REGION', '17', 'An Najaf', 'IQ', '', '', '1'),
(6117, 'IQ_16', 'REGION', '16', 'Wasit', 'IQ', '', '', '1'),
(6116, 'IQ_15', 'REGION', '15', 'Ninawa', 'IQ', '', '', '1'),
(6115, 'IQ_14', 'REGION', '14', 'Maysan', 'IQ', '', '', '1'),
(6114, 'IQ_11', 'REGION', '11', 'Arbil', 'IQ', '', '', '1'),
(6113, 'IQ_10', 'REGION', '10', 'Diyala', 'IQ', '', '', '1'),
(6112, 'IQ_09', 'REGION', '09', 'Dhi Qar', 'IQ', '', '', '1'),
(6111, 'IQ_08', 'REGION', '08', 'Dahuk', 'IQ', '', '', '1'),
(6110, 'IQ_07', 'REGION', '07', 'Baghdad', 'IQ', '', '', '1'),
(6109, 'IQ_06', 'REGION', '06', 'Babil', 'IQ', '', '', '1'),
(6108, 'IQ_05', 'REGION', '05', 'As Sulaymaniyah', 'IQ', '', '', '1'),
(6107, 'IQ_04', 'REGION', '04', 'Al Qadisiyah', 'IQ', '', '', '1'),
(6106, 'IQ_03', 'REGION', '03', 'Al Muthanna', 'IQ', '', '', '1'),
(6105, 'IQ_02', 'REGION', '02', 'Al Basrah', 'IQ', '', '', '1'),
(6104, 'IQ_01', 'REGION', '01', 'Al Anbar', 'IQ', '', '', '1'),
(6103, 'IN_39', 'REGION', '39', 'Uttarakhand', 'IN', '', '', '1'),
(6102, 'IN_38', 'REGION', '38', 'Jharkhand', 'IN', '', '', '1'),
(6101, 'IN_37', 'REGION', '37', 'Chhattisgarh', 'IN', '', '', '1'),
(6100, 'IN_36', 'REGION', '36', 'Uttar Pradesh', 'IN', '', '', '1'),
(6099, 'IN_35', 'REGION', '35', 'Madhya Pradesh', 'IN', '', '', '1'),
(6098, 'IN_34', 'REGION', '34', 'Bihar', 'IN', '', '', '1'),
(6097, 'IN_33', 'REGION', '33', 'Goa', 'IN', '', '', '1'),
(6096, 'IN_32', 'REGION', '32', 'Daman and Diu', 'IN', '', '', '1'),
(6095, 'IN_31', 'REGION', '31', 'Mizoram', 'IN', '', '', '1'),
(6094, 'IN_30', 'REGION', '30', 'Arunachal Pradesh', 'IN', '', '', '1'),
(6093, 'IN_29', 'REGION', '29', 'Sikkim', 'IN', '', '', '1'),
(6092, 'IN_28', 'REGION', '28', 'West Bengal', 'IN', '', '', '1'),
(6091, 'IN_26', 'REGION', '26', 'Tripura', 'IN', '', '', '1'),
(6090, 'IN_25', 'REGION', '25', 'Tamil Nadu', 'IN', '', '', '1'),
(6089, 'IN_24', 'REGION', '24', 'Rajasthan', 'IN', '', '', '1'),
(6088, 'IN_23', 'REGION', '23', 'Punjab', 'IN', '', '', '1'),
(6087, 'IN_22', 'REGION', '22', 'Puducherry', 'IN', '', '', '1'),
(6086, 'IN_21', 'REGION', '21', 'Orissa', 'IN', '', '', '1'),
(6085, 'IN_20', 'REGION', '20', 'Nagaland', 'IN', '', '', '1'),
(6084, 'IN_19', 'REGION', '19', 'Karnataka', 'IN', '', '', '1'),
(6083, 'IN_18', 'REGION', '18', 'Meghalaya', 'IN', '', '', '1'),
(6082, 'IN_17', 'REGION', '17', 'Manipur', 'IN', '', '', '1'),
(6081, 'IN_16', 'REGION', '16', 'Maharashtra', 'IN', '', '', '1'),
(6080, 'IN_14', 'REGION', '14', 'Lakshadweep', 'IN', '', '', '1'),
(6079, 'IN_13', 'REGION', '13', 'Kerala', 'IN', '', '', '1'),
(6078, 'IN_12', 'REGION', '12', 'Jammu and Kashmir', 'IN', '', '', '1'),
(6077, 'IN_11', 'REGION', '11', 'Himachal Pradesh', 'IN', '', '', '1'),
(6076, 'IN_10', 'REGION', '10', 'Haryana', 'IN', '', '', '1'),
(6075, 'IN_09', 'REGION', '09', 'Gujarat', 'IN', '', '', '1'),
(6074, 'IN_07', 'REGION', '07', 'Delhi', 'IN', '', '', '1'),
(6073, 'IN_06', 'REGION', '06', 'Dadra and Nagar Haveli', 'IN', '', '', '1'),
(6072, 'IN_05', 'REGION', '05', 'Chandigarh', 'IN', '', '', '1'),
(6071, 'IN_03', 'REGION', '03', 'Assam', 'IN', '', '', '1'),
(6070, 'IN_02', 'REGION', '02', 'Andhra Pradesh', 'IN', '', '', '1'),
(6069, 'IN_01', 'REGION', '01', 'Andaman and Nicobar Islands', 'IN', '', '', '1'),
(6068, 'IL_06', 'REGION', '06', 'Yerushalayim', 'IL', '', '', '1'),
(6067, 'IL_05', 'REGION', '05', 'Tel Aviv', 'IL', '', '', '1'),
(6066, 'IL_04', 'REGION', '04', 'Hefa', 'IL', '', '', '1'),
(6065, 'IL_03', 'REGION', '03', 'HaZafon', 'IL', '', '', '1'),
(6064, 'IL_02', 'REGION', '02', 'HaMerkaz', 'IL', '', '', '1'),
(6063, 'IL_01', 'REGION', '01', 'HaDarom', 'IL', '', '', '1'),
(6062, 'IE_31', 'REGION', '31', 'Wicklow', 'IE', '', '', '1'),
(6061, 'IE_30', 'REGION', '30', 'Wexford', 'IE', '', '', '1'),
(6060, 'IE_29', 'REGION', '29', 'Westmeath', 'IE', '', '', '1'),
(6059, 'IE_27', 'REGION', '27', 'Waterford', 'IE', '', '', '1'),
(6058, 'IE_26', 'REGION', '26', 'Tipperary', 'IE', '', '', '1'),
(6057, 'IE_25', 'REGION', '25', 'Sligo', 'IE', '', '', '1'),
(6056, 'IE_24', 'REGION', '24', 'Roscommon', 'IE', '', '', '1'),
(6055, 'IE_23', 'REGION', '23', 'Offaly', 'IE', '', '', '1'),
(6054, 'IE_22', 'REGION', '22', 'Monaghan', 'IE', '', '', '1'),
(6053, 'IE_21', 'REGION', '21', 'Meath', 'IE', '', '', '1'),
(6052, 'IE_20', 'REGION', '20', 'Mayo', 'IE', '', '', '1'),
(6051, 'IE_19', 'REGION', '19', 'Louth', 'IE', '', '', '1'),
(6050, 'IE_18', 'REGION', '18', 'Longford', 'IE', '', '', '1'),
(6049, 'IE_16', 'REGION', '16', 'Limerick', 'IE', '', '', '1'),
(6048, 'IE_15', 'REGION', '15', 'Laois', 'IE', '', '', '1'),
(6047, 'IE_14', 'REGION', '14', 'Leitrim', 'IE', '', '', '1'),
(6046, 'IE_13', 'REGION', '13', 'Kilkenny', 'IE', '', '', '1'),
(6045, 'IE_12', 'REGION', '12', 'Kildare', 'IE', '', '', '1'),
(6044, 'IE_11', 'REGION', '11', 'Kerry', 'IE', '', '', '1'),
(6043, 'IE_10', 'REGION', '10', 'Galway', 'IE', '', '', '1'),
(6042, 'IE_07', 'REGION', '07', 'Dublin', 'IE', '', '', '1'),
(6041, 'IE_06', 'REGION', '06', 'Donegal', 'IE', '', '', '1'),
(6040, 'IE_04', 'REGION', '04', 'Cork', 'IE', '', '', '1'),
(6039, 'IE_03', 'REGION', '03', 'Clare', 'IE', '', '', '1'),
(6038, 'IE_02', 'REGION', '02', 'Cavan', 'IE', '', '', '1'),
(6037, 'IE_01', 'REGION', '01', 'Carlow', 'IE', '', '', '1'),
(6036, 'ID_41', 'REGION', '41', 'Sulawesi Barat', 'ID', '', '', '1'),
(6035, 'ID_40', 'REGION', '40', 'Kepulauan Riau', 'ID', '', '', '1'),
(6034, 'ID_39', 'REGION', '39', 'Irian Jaya Barat', 'ID', '', '', '1'),
(6033, 'ID_38', 'REGION', '38', 'Sulawesi Selatan', 'ID', '', '', '1'),
(6032, 'ID_37', 'REGION', '37', 'Riau', 'ID', '', '', '1'),
(6031, 'ID_36', 'REGION', '36', 'Papua', 'ID', '', '', '1'),
(6030, 'ID_35', 'REGION', '35', 'Kepulauan Bangka Belitung', 'ID', '', '', '1'),
(6029, 'ID_34', 'REGION', '34', 'Gorontalo', 'ID', '', '', '1'),
(6028, 'ID_33', 'REGION', '33', 'Banten', 'ID', '', '', '1'),
(6027, 'ID_32', 'REGION', '32', 'Sumatera Selatan', 'ID', '', '', '1'),
(6026, 'ID_31', 'REGION', '31', 'Sulawesi Utara', 'ID', '', '', '1'),
(6025, 'ID_30', 'REGION', '30', 'Jawa Barat', 'ID', '', '', '1'),
(6024, 'ID_29', 'REGION', '29', 'Maluku Utara', 'ID', '', '', '1'),
(6023, 'ID_28', 'REGION', '28', 'Maluku', 'ID', '', '', '1'),
(6022, 'ID_26', 'REGION', '26', 'Sumatera Utara', 'ID', '', '', '1'),
(6021, 'ID_25', 'REGION', '25', 'Sumatera Selatan', 'ID', '', '', '1'),
(6020, 'ID_24', 'REGION', '24', 'Sumatera Barat', 'ID', '', '', '1'),
(6019, 'ID_23', 'REGION', '23', 'Sulawesi Utara', 'ID', '', '', '1'),
(6018, 'ID_22', 'REGION', '22', 'Sulawesi Tenggara', 'ID', '', '', '1'),
(6017, 'ID_21', 'REGION', '21', 'Sulawesi Tengah', 'ID', '', '', '1'),
(6016, 'ID_20', 'REGION', '20', 'Sulawesi Selatan', 'ID', '', '', '1'),
(6015, 'ID_19', 'REGION', '19', 'Riau', 'ID', '', '', '1'),
(6014, 'ID_18', 'REGION', '18', 'Nusa Tenggara Timur', 'ID', '', '', '1'),
(6013, 'ID_17', 'REGION', '17', 'Nusa Tenggara Barat', 'ID', '', '', '1'),
(6012, 'ID_16', 'REGION', '16', 'Maluku', 'ID', '', '', '1'),
(6011, 'ID_15', 'REGION', '15', 'Lampung', 'ID', '', '', '1'),
(6010, 'ID_14', 'REGION', '14', 'Kalimantan Timur', 'ID', '', '', '1'),
(6009, 'ID_13', 'REGION', '13', 'Kalimantan Tengah', 'ID', '', '', '1'),
(6008, 'ID_12', 'REGION', '12', 'Kalimantan Selatan', 'ID', '', '', '1'),
(6007, 'ID_11', 'REGION', '11', 'Kalimantan Barat', 'ID', '', '', '1'),
(6006, 'ID_10', 'REGION', '10', 'Yogyakarta', 'ID', '', '', '1'),
(6005, 'ID_09', 'REGION', '09', 'Papua', 'ID', '', '', '1'),
(6004, 'ID_08', 'REGION', '08', 'Jawa Timur', 'ID', '', '', '1'),
(6003, 'ID_07', 'REGION', '07', 'Jawa Tengah', 'ID', '', '', '1'),
(6002, 'ID_06', 'REGION', '06', 'Jawa Barat', 'ID', '', '', '1'),
(6001, 'ID_05', 'REGION', '05', 'Jambi', 'ID', '', '', '1'),
(6000, 'ID_04', 'REGION', '04', 'Jakarta Raya', 'ID', '', '', '1'),
(5999, 'ID_03', 'REGION', '03', 'Bengkulu', 'ID', '', '', '1'),
(5998, 'ID_02', 'REGION', '02', 'Bali', 'ID', '', '', '1'),
(5997, 'ID_01', 'REGION', '01', 'Aceh', 'ID', '', '', '1'),
(5996, 'HU_42', 'REGION', '42', 'Szekszard', 'HU', '', '', '1'),
(5995, 'HU_41', 'REGION', '41', 'Salgotarjan', 'HU', '', '', '1'),
(5994, 'HU_40', 'REGION', '40', 'Zalaegerszeg', 'HU', '', '', '1'),
(5993, 'HU_39', 'REGION', '39', 'Veszprem', 'HU', '', '', '1'),
(5992, 'HU_38', 'REGION', '38', 'Tatabanya', 'HU', '', '', '1'),
(5991, 'HU_37', 'REGION', '37', 'Szombathely', 'HU', '', '', '1'),
(5990, 'HU_36', 'REGION', '36', 'Szolnok', 'HU', '', '', '1'),
(5989, 'HU_35', 'REGION', '35', 'Szekesfehervar', 'HU', '', '', '1'),
(5988, 'HU_34', 'REGION', '34', 'Sopron', 'HU', '', '', '1'),
(5987, 'HU_33', 'REGION', '33', 'Nyiregyhaza', 'HU', '', '', '1'),
(5986, 'HU_32', 'REGION', '32', 'Nagykanizsa', 'HU', '', '', '1'),
(5985, 'HU_31', 'REGION', '31', 'Kecskemet', 'HU', '', '', '1'),
(5984, 'HU_30', 'REGION', '30', 'Kaposvar', 'HU', '', '', '1'),
(5983, 'HU_29', 'REGION', '29', 'Hodmezovasarhely', 'HU', '', '', '1'),
(5982, 'HU_28', 'REGION', '28', 'Eger', 'HU', '', '', '1'),
(5981, 'HU_27', 'REGION', '27', 'Dunaujvaros', 'HU', '', '', '1'),
(5980, 'HU_26', 'REGION', '26', 'Bekescsaba', 'HU', '', '', '1'),
(5979, 'HU_25', 'REGION', '25', 'Gyor', 'HU', '', '', '1'),
(5978, 'HU_24', 'REGION', '24', 'Zala', 'HU', '', '', '1'),
(5977, 'HU_23', 'REGION', '23', 'Veszprem', 'HU', '', '', '1'),
(5976, 'HU_22', 'REGION', '22', 'Vas', 'HU', '', '', '1'),
(5975, 'HU_21', 'REGION', '21', 'Tolna', 'HU', '', '', '1'),
(5974, 'HU_20', 'REGION', '20', 'Jasz-Nagykun-Szolnok', 'HU', '', '', '1'),
(5973, 'HU_19', 'REGION', '19', 'Szeged', 'HU', '', '', '1'),
(5972, 'HU_18', 'REGION', '18', 'Szabolcs-Szatmar-Bereg', 'HU', '', '', '1'),
(5971, 'HU_17', 'REGION', '17', 'Somogy', 'HU', '', '', '1'),
(5970, 'HU_16', 'REGION', '16', 'Pest', 'HU', '', '', '1'),
(5969, 'HU_15', 'REGION', '15', 'Pecs', 'HU', '', '', '1'),
(5968, 'HU_14', 'REGION', '14', 'Nograd', 'HU', '', '', '1'),
(5967, 'HU_13', 'REGION', '13', 'Miskolc', 'HU', '', '', '1'),
(5966, 'HU_12', 'REGION', '12', 'Komarom-Esztergom', 'HU', '', '', '1'),
(5965, 'HU_11', 'REGION', '11', 'Heves', 'HU', '', '', '1'),
(5964, 'HU_10', 'REGION', '10', 'Hajdu-Bihar', 'HU', '', '', '1'),
(5963, 'HU_09', 'REGION', '09', 'Gyor-Moson-Sopron', 'HU', '', '', '1'),
(5962, 'HU_08', 'REGION', '08', 'Fejer', 'HU', '', '', '1'),
(5961, 'HU_07', 'REGION', '07', 'Debrecen', 'HU', '', '', '1'),
(5960, 'HU_06', 'REGION', '06', 'Csongrad', 'HU', '', '', '1'),
(5959, 'HU_05', 'REGION', '05', 'Budapest', 'HU', '', '', '1'),
(5958, 'HU_04', 'REGION', '04', 'Borsod-Abauj-Zemplen', 'HU', '', '', '1'),
(5957, 'HU_03', 'REGION', '03', 'Bekes', 'HU', '', '', '1'),
(5956, 'HU_02', 'REGION', '02', 'Baranya', 'HU', '', '', '1'),
(5955, 'HU_01', 'REGION', '01', 'Bacs-Kiskun', 'HU', '', '', '1'),
(5954, 'HT_15', 'REGION', '15', 'Nippes', 'HT', '', '', '1'),
(5953, 'HT_13', 'REGION', '13', 'Sud-Est', 'HT', '', '', '1'),
(5952, 'HT_12', 'REGION', '12', 'Sud', 'HT', '', '', '1'),
(5951, 'HT_11', 'REGION', '11', 'Ouest', 'HT', '', '', '1'),
(5950, 'HT_10', 'REGION', '10', 'Nord-Est', 'HT', '', '', '1'),
(5949, 'HT_09', 'REGION', '09', 'Nord', 'HT', '', '', '1'),
(5948, 'HT_07', 'REGION', '07', 'Centre', 'HT', '', '', '1'),
(5947, 'HT_06', 'REGION', '06', 'Artibonite', 'HT', '', '', '1'),
(5946, 'HT_03', 'REGION', '03', 'Nord-Ouest', 'HT', '', '', '1'),
(5945, 'HR_21', 'REGION', '21', 'Grad Zagreb', 'HR', '', '', '1'),
(5944, 'HR_20', 'REGION', '20', 'Zagrebacka', 'HR', '', '', '1'),
(5943, 'HR_19', 'REGION', '19', 'Zadarska', 'HR', '', '', '1'),
(5942, 'HR_18', 'REGION', '18', 'Vukovarsko-Srijemska', 'HR', '', '', '1'),
(5941, 'HR_17', 'REGION', '17', 'Viroviticko-Podravska', 'HR', '', '', '1'),
(5940, 'HR_16', 'REGION', '16', 'Varazdinska', 'HR', '', '', '1'),
(5939, 'HR_15', 'REGION', '15', 'Splitsko-Dalmatinska', 'HR', '', '', '1'),
(5938, 'HR_14', 'REGION', '14', 'Sisacko-Moslavacka', 'HR', '', '', '1'),
(5937, 'HR_13', 'REGION', '13', 'Sibensko-Kninska', 'HR', '', '', '1'),
(5936, 'HR_12', 'REGION', '12', 'Primorsko-Goranska', 'HR', '', '', '1'),
(5935, 'HR_11', 'REGION', '11', 'Pozesko-Slavonska', 'HR', '', '', '1'),
(5934, 'HR_10', 'REGION', '10', 'Osjecko-Baranjska', 'HR', '', '', '1'),
(5933, 'HR_09', 'REGION', '09', 'Medimurska', 'HR', '', '', '1'),
(5932, 'HR_08', 'REGION', '08', 'Licko-Senjska', 'HR', '', '', '1'),
(5931, 'HR_07', 'REGION', '07', 'Krapinsko-Zagorska', 'HR', '', '', '1'),
(5930, 'HR_06', 'REGION', '06', 'Koprivnicko-Krizevacka', 'HR', '', '', '1'),
(5929, 'HR_05', 'REGION', '05', 'Karlovacka', 'HR', '', '', '1'),
(5928, 'HR_04', 'REGION', '04', 'Istarska', 'HR', '', '', '1'),
(5927, 'HR_03', 'REGION', '03', 'Dubrovacko-Neretvanska', 'HR', '', '', '1'),
(5926, 'HR_02', 'REGION', '02', 'Brodsko-Posavska', 'HR', '', '', '1'),
(5925, 'HR_01', 'REGION', '01', 'Bjelovarsko-Bilogorska', 'HR', '', '', '1'),
(5924, 'HN_18', 'REGION', '18', 'Yoro', 'HN', '', '', '1'),
(5923, 'HN_17', 'REGION', '17', 'Valle', 'HN', '', '', '1'),
(5922, 'HN_16', 'REGION', '16', 'Santa Barbara', 'HN', '', '', '1'),
(5921, 'HN_15', 'REGION', '15', 'Olancho', 'HN', '', '', '1'),
(5920, 'HN_14', 'REGION', '14', 'Ocotepeque', 'HN', '', '', '1'),
(5919, 'HN_13', 'REGION', '13', 'Lempira', 'HN', '', '', '1'),
(5918, 'HN_12', 'REGION', '12', 'La Paz', 'HN', '', '', '1'),
(5917, 'HN_11', 'REGION', '11', 'Islas de la Bahia', 'HN', '', '', '1'),
(5916, 'HN_10', 'REGION', '10', 'Intibuca', 'HN', '', '', '1'),
(5915, 'HN_09', 'REGION', '09', 'Gracias a Dios', 'HN', '', '', '1'),
(5914, 'HN_08', 'REGION', '08', 'Francisco Morazan', 'HN', '', '', '1'),
(5913, 'HN_07', 'REGION', '07', 'El Paraiso', 'HN', '', '', '1'),
(5912, 'HN_06', 'REGION', '06', 'Cortes', 'HN', '', '', '1'),
(5911, 'HN_05', 'REGION', '05', 'Copan', 'HN', '', '', '1'),
(5910, 'HN_04', 'REGION', '04', 'Comayagua', 'HN', '', '', '1'),
(5909, 'HN_03', 'REGION', '03', 'Colon', 'HN', '', '', '1'),
(5908, 'HN_02', 'REGION', '02', 'Choluteca', 'HN', '', '', '1'),
(5907, 'HN_01', 'REGION', '01', 'Atlantida', 'HN', '', '', '1'),
(5906, 'GY_19', 'REGION', '19', 'Upper Takutu-Upper Essequibo', 'GY', '', '', '1'),
(5905, 'GY_18', 'REGION', '18', 'Upper Demerara-Berbice', 'GY', '', '', '1'),
(5904, 'GY_17', 'REGION', '17', 'Potaro-Siparuni', 'GY', '', '', '1'),
(5903, 'GY_16', 'REGION', '16', 'Pomeroon-Supenaam', 'GY', '', '', '1'),
(5902, 'GY_15', 'REGION', '15', 'Mahaica-Berbice', 'GY', '', '', '1'),
(5901, 'GY_14', 'REGION', '14', 'Essequibo Islands-West Demerara', 'GY', '', '', '1'),
(5900, 'GY_13', 'REGION', '13', 'East Berbice-Corentyne', 'GY', '', '', '1'),
(5899, 'GY_12', 'REGION', '12', 'Demerara-Mahaica', 'GY', '', '', '1'),
(5898, 'GY_11', 'REGION', '11', 'Cuyuni-Mazaruni', 'GY', '', '', '1'),
(5897, 'GY_10', 'REGION', '10', 'Barima-Waini', 'GY', '', '', '1'),
(5896, 'GW_12', 'REGION', '12', 'Biombo', 'GW', '', '', '1'),
(5895, 'GW_11', 'REGION', '11', 'Bissau', 'GW', '', '', '1'),
(5894, 'GW_10', 'REGION', '10', 'Gabu', 'GW', '', '', '1'),
(5893, 'GW_07', 'REGION', '07', 'Tombali', 'GW', '', '', '1'),
(5892, 'GW_06', 'REGION', '06', 'Cacheu', 'GW', '', '', '1'),
(5891, 'GW_05', 'REGION', '05', 'Bolama', 'GW', '', '', '1'),
(5890, 'GW_04', 'REGION', '04', 'Oio', 'GW', '', '', '1'),
(5889, 'GW_02', 'REGION', '02', 'Quinara', 'GW', '', '', '1'),
(5888, 'GW_01', 'REGION', '01', 'Bafata', 'GW', '', '', '1'),
(5887, 'GT_22', 'REGION', '22', 'Zacapa', 'GT', '', '', '1'),
(5886, 'GT_21', 'REGION', '21', 'Totonicapan', 'GT', '', '', '1'),
(5885, 'GT_20', 'REGION', '20', 'Suchitepequez', 'GT', '', '', '1'),
(5884, 'GT_19', 'REGION', '19', 'Solola', 'GT', '', '', '1'),
(5883, 'GT_18', 'REGION', '18', 'Santa Rosa', 'GT', '', '', '1'),
(5882, 'GT_17', 'REGION', '17', 'San Marcos', 'GT', '', '', '1'),
(5881, 'GT_16', 'REGION', '16', 'Sacatepequez', 'GT', '', '', '1'),
(5880, 'GT_15', 'REGION', '15', 'Retalhuleu', 'GT', '', '', '1'),
(5879, 'GT_14', 'REGION', '14', 'Quiche', 'GT', '', '', '1'),
(5878, 'GT_13', 'REGION', '13', 'Quetzaltenango', 'GT', '', '', '1'),
(5877, 'GT_12', 'REGION', '12', 'Peten', 'GT', '', '', '1'),
(5876, 'GT_11', 'REGION', '11', 'Jutiapa', 'GT', '', '', '1'),
(5875, 'GT_10', 'REGION', '10', 'Jalapa', 'GT', '', '', '1'),
(5874, 'GT_09', 'REGION', '09', 'Izabal', 'GT', '', '', '1'),
(5873, 'GT_08', 'REGION', '08', 'Huehuetenango', 'GT', '', '', '1'),
(5872, 'GT_07', 'REGION', '07', 'Guatemala', 'GT', '', '', '1'),
(5871, 'GT_06', 'REGION', '06', 'Escuintla', 'GT', '', '', '1'),
(5870, 'GT_05', 'REGION', '05', 'El Progreso', 'GT', '', '', '1'),
(5869, 'GT_04', 'REGION', '04', 'Chiquimula', 'GT', '', '', '1'),
(5868, 'GT_03', 'REGION', '03', 'Chimaltenango', 'GT', '', '', '1'),
(5867, 'GT_02', 'REGION', '02', 'Baja Verapaz', 'GT', '', '', '1'),
(5866, 'GT_01', 'REGION', '01', 'Alta Verapaz', 'GT', '', '', '1'),
(5865, 'GR_51', 'REGION', '51', 'Lesvos', 'GR', '', '', '1'),
(5864, 'GR_50', 'REGION', '50', 'Khios', 'GR', '', '', '1'),
(5863, 'GR_49', 'REGION', '49', 'Kikladhes', 'GR', '', '', '1'),
(5862, 'GR_48', 'REGION', '48', 'Samos', 'GR', '', '', '1'),
(5861, 'GR_47', 'REGION', '47', 'Dhodhekanisos', 'GR', '', '', '1'),
(5860, 'GR_46', 'REGION', '46', 'Lasithi', 'GR', '', '', '1'),
(5859, 'GR_45', 'REGION', '45', 'Iraklion', 'GR', '', '', '1'),
(5858, 'GR_44', 'REGION', '44', 'Rethimni', 'GR', '', '', '1'),
(5857, 'GR_43', 'REGION', '43', 'Khania', 'GR', '', '', '1'),
(5856, 'GR_42', 'REGION', '42', 'Lakonia', 'GR', '', '', '1'),
(5855, 'GR_41', 'REGION', '41', 'Arkadhia', 'GR', '', '', '1'),
(5854, 'GR_40', 'REGION', '40', 'Messinia', 'GR', '', '', '1'),
(5853, 'GR_39', 'REGION', '39', 'Ilia', 'GR', '', '', '1'),
(5852, 'GR_38', 'REGION', '38', 'Akhaia', 'GR', '', '', '1'),
(5851, 'GR_37', 'REGION', '37', 'Korinthia', 'GR', '', '', '1'),
(5850, 'GR_36', 'REGION', '36', 'Argolis', 'GR', '', '', '1'),
(5849, 'GR_35', 'REGION', '35', 'Attiki', 'GR', '', '', '1'),
(5848, 'GR_34', 'REGION', '34', 'Evvoia', 'GR', '', '', '1'),
(5847, 'GR_33', 'REGION', '33', 'Voiotia', 'GR', '', '', '1'),
(5846, 'GR_32', 'REGION', '32', 'Fokis', 'GR', '', '', '1'),
(5845, 'GR_31', 'REGION', '31', 'Aitolia kai Akarnania', 'GR', '', '', '1'),
(5844, 'GR_30', 'REGION', '30', 'Evritania', 'GR', '', '', '1'),
(5843, 'GR_29', 'REGION', '29', 'Fthiotis', 'GR', '', '', '1'),
(5842, 'GR_28', 'REGION', '28', 'Zakinthos', 'GR', '', '', '1'),
(5841, 'GR_27', 'REGION', '27', 'Kefallinia', 'GR', '', '', '1'),
(5840, 'GR_26', 'REGION', '26', 'Levkas', 'GR', '', '', '1'),
(5839, 'GR_25', 'REGION', '25', 'Kerkira', 'GR', '', '', '1'),
(5838, 'GR_24', 'REGION', '24', 'Magnisia', 'GR', '', '', '1'),
(5837, 'GR_23', 'REGION', '23', 'Kardhitsa', 'GR', '', '', '1'),
(5836, 'GR_22', 'REGION', '22', 'Trikala', 'GR', '', '', '1'),
(5835, 'GR_21', 'REGION', '21', 'Larisa', 'GR', '', '', '1'),
(5834, 'GR_20', 'REGION', '20', 'Arta', 'GR', '', '', '1'),
(5833, 'GR_19', 'REGION', '19', 'Preveza', 'GR', '', '', '1'),
(5832, 'GR_18', 'REGION', '18', 'Thesprotia', 'GR', '', '', '1'),
(5831, 'GR_17', 'REGION', '17', 'Ioannina', 'GR', '', '', '1'),
(5830, 'GR_16', 'REGION', '16', 'Pieria', 'GR', '', '', '1'),
(5829, 'GR_15', 'REGION', '15', 'Khalkidhiki', 'GR', '', '', '1'),
(5828, 'GR_14', 'REGION', '14', 'Kavala', 'GR', '', '', '1'),
(5827, 'GR_13', 'REGION', '13', 'Thessaloniki', 'GR', '', '', '1'),
(5826, 'GR_12', 'REGION', '12', 'Imathia', 'GR', '', '', '1'),
(5825, 'GR_11', 'REGION', '11', 'Kozani', 'GR', '', '', '1'),
(5824, 'GR_10', 'REGION', '10', 'Grevena', 'GR', '', '', '1'),
(5823, 'GR_09', 'REGION', '09', 'Kastoria', 'GR', '', '', '1'),
(5822, 'GR_08', 'REGION', '08', 'Florina', 'GR', '', '', '1'),
(5821, 'GR_07', 'REGION', '07', 'Pella', 'GR', '', '', '1'),
(5820, 'GR_06', 'REGION', '06', 'Kilkis', 'GR', '', '', '1'),
(5819, 'GR_05', 'REGION', '05', 'Serrai', 'GR', '', '', '1'),
(5818, 'GR_04', 'REGION', '04', 'Drama', 'GR', '', '', '1'),
(5817, 'GR_03', 'REGION', '03', 'Xanthi', 'GR', '', '', '1'),
(5816, 'GR_02', 'REGION', '02', 'Rodhopi', 'GR', '', '', '1'),
(5815, 'GR_01', 'REGION', '01', 'Evros', 'GR', '', '', '1'),
(5814, 'GQ_09', 'REGION', '09', 'Wele-Nzas', 'GQ', '', '', '1'),
(5813, 'GQ_08', 'REGION', '08', 'Litoral', 'GQ', '', '', '1'),
(5812, 'GQ_07', 'REGION', '07', 'Kie-Ntem', 'GQ', '', '', '1'),
(5811, 'GQ_06', 'REGION', '06', 'Centro Sur', 'GQ', '', '', '1'),
(5810, 'GQ_05', 'REGION', '05', 'Bioko Sur', 'GQ', '', '', '1'),
(5809, 'GQ_04', 'REGION', '04', 'Bioko Norte', 'GQ', '', '', '1'),
(5808, 'GQ_03', 'REGION', '03', 'Annobon', 'GQ', '', '', '1'),
(5807, 'GN_39', 'REGION', '39', 'Siguiri', 'GN', '', '', '1'),
(5806, 'GN_38', 'REGION', '38', 'Nzerekore', 'GN', '', '', '1'),
(5805, 'GN_37', 'REGION', '37', 'Mandiana', 'GN', '', '', '1'),
(5804, 'GN_36', 'REGION', '36', 'Lola', 'GN', '', '', '1'),
(5803, 'GN_35', 'REGION', '35', 'Lelouma', 'GN', '', '', '1'),
(5802, 'GN_34', 'REGION', '34', 'Labe', 'GN', '', '', '1'),
(5801, 'GN_33', 'REGION', '33', 'Koubia', 'GN', '', '', '1'),
(5800, 'GN_32', 'REGION', '32', 'Kankan', 'GN', '', '', '1'),
(5799, 'GN_31', 'REGION', '31', 'Dubreka', 'GN', '', '', '1'),
(5798, 'GN_30', 'REGION', '30', 'Coyah', 'GN', '', '', '1'),
(5797, 'GN_29', 'REGION', '29', 'Yomou', 'GN', '', '', '1'),
(5796, 'GN_28', 'REGION', '28', 'Tougue', 'GN', '', '', '1'),
(5795, 'GN_27', 'REGION', '27', 'Telimele', 'GN', '', '', '1'),
(5794, 'GN_25', 'REGION', '25', 'Pita', 'GN', '', '', '1'),
(5793, 'GN_23', 'REGION', '23', 'Mamou', 'GN', '', '', '1'),
(5792, 'GN_22', 'REGION', '22', 'Mali', 'GN', '', '', '1'),
(5791, 'GN_21', 'REGION', '21', 'Macenta', 'GN', '', '', '1'),
(5790, 'GN_19', 'REGION', '19', 'Kouroussa', 'GN', '', '', '1'),
(5789, 'GN_18', 'REGION', '18', 'Koundara', 'GN', '', '', '1'),
(5788, 'GN_17', 'REGION', '17', 'Kissidougou', 'GN', '', '', '1'),
(5787, 'GN_16', 'REGION', '16', 'Kindia', 'GN', '', '', '1'),
(5786, 'GN_15', 'REGION', '15', 'Kerouane', 'GN', '', '', '1'),
(5785, 'GN_13', 'REGION', '13', 'Gueckedou', 'GN', '', '', '1'),
(5784, 'GN_12', 'REGION', '12', 'Gaoual', 'GN', '', '', '1'),
(5783, 'GN_11', 'REGION', '11', 'Fria', 'GN', '', '', '1'),
(5782, 'GN_10', 'REGION', '10', 'Forecariah', 'GN', '', '', '1'),
(5781, 'GN_09', 'REGION', '09', 'Faranah', 'GN', '', '', '1'),
(5780, 'GN_07', 'REGION', '07', 'Dinguiraye', 'GN', '', '', '1'),
(5779, 'GN_06', 'REGION', '06', 'Dalaba', 'GN', '', '', '1'),
(5778, 'GN_05', 'REGION', '05', 'Dabola', 'GN', '', '', '1'),
(5777, 'GN_04', 'REGION', '04', 'Conakry', 'GN', '', '', '1'),
(5776, 'GN_03', 'REGION', '03', 'Boke', 'GN', '', '', '1'),
(5775, 'GN_02', 'REGION', '02', 'Boffa', 'GN', '', '', '1'),
(5774, 'GN_01', 'REGION', '01', 'Beyla', 'GN', '', '', '1'),
(5773, 'GM_07', 'REGION', '07', 'North Bank', 'GM', '', '', '1'),
(5772, 'GM_05', 'REGION', '05', 'Western', 'GM', '', '', '1'),
(5771, 'GM_04', 'REGION', '04', 'Upper River', 'GM', '', '', '1'),
(5770, 'GM_03', 'REGION', '03', 'Central River', 'GM', '', '', '1'),
(5769, 'GM_02', 'REGION', '02', 'Lower River', 'GM', '', '', '1'),
(5768, 'GM_01', 'REGION', '01', 'Banjul', 'GM', '', '', '1'),
(5767, 'GL_03', 'REGION', '03', 'Vestgronland', 'GL', '', '', '1'),
(5766, 'GL_02', 'REGION', '02', 'Ostgronland', 'GL', '', '', '1'),
(5765, 'GL_01', 'REGION', '01', 'Nordgronland', 'GL', '', '', '1'),
(5764, 'GH_11', 'REGION', '11', 'Upper West', 'GH', '', '', '1'),
(5763, 'GH_10', 'REGION', '10', 'Upper East', 'GH', '', '', '1'),
(5762, 'GH_09', 'REGION', '09', 'Western', 'GH', '', '', '1'),
(5761, 'GH_08', 'REGION', '08', 'Volta', 'GH', '', '', '1'),
(5760, 'GH_06', 'REGION', '06', 'Northern', 'GH', '', '', '1'),
(5759, 'GH_05', 'REGION', '05', 'Eastern', 'GH', '', '', '1'),
(5758, 'GH_04', 'REGION', '04', 'Central', 'GH', '', '', '1'),
(5757, 'GH_03', 'REGION', '03', 'Brong-Ahafo', 'GH', '', '', '1'),
(5756, 'GH_02', 'REGION', '02', 'Ashanti', 'GH', '', '', '1'),
(5755, 'GH_01', 'REGION', '01', 'Greater Accra', 'GH', '', '', '1'),
(5754, 'GE_64', 'REGION', '64', 'Zugdidis Raioni', 'GE', '', '', '1'),
(5753, 'GE_63', 'REGION', '63', 'Zugdidi', 'GE', '', '', '1'),
(5752, 'GE_61', 'REGION', '61', 'Vanis Raioni', 'GE', '', '', '1'),
(5751, 'GE_60', 'REGION', '60', 'Tsqaltubo', 'GE', '', '', '1'),
(5750, 'GE_59', 'REGION', '59', 'Tsalkis Raioni', 'GE', '', '', '1'),
(5749, 'GE_58', 'REGION', '58', 'Tsalenjikhis Raioni', 'GE', '', '', '1'),
(5748, 'GE_56', 'REGION', '56', 'Tqibuli', 'GE', '', '', '1'),
(5747, 'GE_50', 'REGION', '50', 'Sighnaghis Raioni', 'GE', '', '', '1'),
(5746, 'GE_49', 'REGION', '49', 'Senakis Raioni', 'GE', '', '', '1'),
(5745, 'GE_48', 'REGION', '48', 'Samtrediis Raioni', 'GE', '', '', '1'),
(5744, 'GE_47', 'REGION', '47', 'Sagarejos Raioni', 'GE', '', '', '1'),
(5743, 'GE_44', 'REGION', '44', 'Qvarlis Raioni', 'GE', '', '', '1'),
(5742, 'GE_43', 'REGION', '43', 'Qazbegis Raioni', 'GE', '', '', '1'),
(5741, 'GE_40', 'REGION', '40', 'Onis Raioni', 'GE', '', '', '1'),
(5740, 'GE_39', 'REGION', '39', 'Ninotsmindis Raioni', 'GE', '', '', '1'),
(5739, 'GE_37', 'REGION', '37', 'Mestiis Raioni', 'GE', '', '', '1'),
(5738, 'GE_36', 'REGION', '36', 'Martvilis Raioni', 'GE', '', '', '1'),
(5737, 'GE_35', 'REGION', '35', 'Marneulis Raioni', 'GE', '', '', '1'),
(5736, 'GE_34', 'REGION', '34', 'Lentekhis Raioni', 'GE', '', '', '1'),
(5735, 'GE_32', 'REGION', '32', 'Lagodekhis Raioni', 'GE', '', '', '1'),
(5734, 'GE_30', 'REGION', '30', 'Khonis Raioni', 'GE', '', '', '1'),
(5733, 'GE_29', 'REGION', '29', 'Khobis Raioni', 'GE', '', '', '1'),
(5732, 'GE_28', 'REGION', '28', 'Khashuris Raioni', 'GE', '', '', '1'),
(5731, 'GE_27', 'REGION', '27', 'Kharagaulis Raioni', 'GE', '', '', '1'),
(5730, 'GE_26', 'REGION', '26', 'Kaspis Raioni', 'GE', '', '', '1'),
(5729, 'GE_24', 'REGION', '24', 'Javis Raioni', 'GE', '', '', '1'),
(5728, 'GE_23', 'REGION', '23', 'Gurjaanis Raioni', 'GE', '', '', '1'),
(5727, 'GE_22', 'REGION', '22', 'Goris Raioni', 'GE', '', '', '1'),
(5726, 'GE_21', 'REGION', '21', 'Gori', 'GE', '', '', '1'),
(5725, 'GE_20', 'REGION', '20', 'Gardabanis Raioni', 'GE', '', '', '1'),
(5724, 'GE_18', 'REGION', '18', 'Dmanisis Raioni', 'GE', '', '', '1'),
(5723, 'GE_13', 'REGION', '13', 'Borjomis Raioni', 'GE', '', '', '1'),
(5722, 'GE_12', 'REGION', '12', 'Bolnisis Raioni', 'GE', '', '', '1'),
(5721, 'GE_10', 'REGION', '10', 'Aspindzis Raioni', 'GE', '', '', '1'),
(5720, 'GE_09', 'REGION', '09', 'Ambrolauris Raioni', 'GE', '', '', '1'),
(5719, 'GE_08', 'REGION', '08', 'Akhmetis Raioni', 'GE', '', '', '1'),
(5718, 'GE_05', 'REGION', '05', 'Akhalgoris Raioni', 'GE', '', '', '1'),
(5717, 'GE_04', 'REGION', '04', 'Ajaria', 'GE', '', '', '1'),
(5716, 'GE_03', 'REGION', '03', 'Adigenis Raioni', 'GE', '', '', '1'),
(5715, 'GE_02', 'REGION', '02', 'Abkhazia', 'GE', '', '', '1'),
(5714, 'GE_01', 'REGION', '01', 'Abashis Raioni', 'GE', '', '', '1'),
(5713, 'GD_06', 'REGION', '06', 'Saint Patrick', 'GD', '', '', '1'),
(5712, 'GD_05', 'REGION', '05', 'Saint Mark', 'GD', '', '', '1'),
(5711, 'GD_04', 'REGION', '04', 'Saint John', 'GD', '', '', '1'),
(5710, 'GD_03', 'REGION', '03', 'Saint George', 'GD', '', '', '1'),
(5709, 'GD_02', 'REGION', '02', 'Saint David', 'GD', '', '', '1'),
(5708, 'GD_01', 'REGION', '01', 'Saint Andrew', 'GD', '', '', '1'),
(5707, 'GB_Z4', 'REGION', 'Z4', 'Wrexham', 'GB', '', '', '1'),
(5706, 'GB_Z3', 'REGION', 'Z3', 'Vale of Glamorgan, The', 'GB', '', '', '1'),
(5705, 'GB_Z2', 'REGION', 'Z2', 'Torfaen', 'GB', '', '', '1'),
(5704, 'GB_Z1', 'REGION', 'Z1', 'Swansea', 'GB', '', '', '1'),
(5703, 'GB_Y9', 'REGION', 'Y9', 'Rhondda Cynon Taff', 'GB', '', '', '1'),
(5702, 'GB_Y8', 'REGION', 'Y8', 'Powys', 'GB', '', '', '1'),
(5701, 'GB_Y7', 'REGION', 'Y7', 'Pembrokeshire', 'GB', '', '', '1'),
(5700, 'GB_Y6', 'REGION', 'Y6', 'Newport', 'GB', '', '', '1'),
(5699, 'GB_Y5', 'REGION', 'Y5', 'Neath Port Talbot', 'GB', '', '', '1'),
(5698, 'GB_Y4', 'REGION', 'Y4', 'Monmouthshire', 'GB', '', '', '1'),
(5697, 'GB_Y3', 'REGION', 'Y3', 'Merthyr Tydfil', 'GB', '', '', '1'),
(5696, 'GB_Y2', 'REGION', 'Y2', 'Gwynedd', 'GB', '', '', '1'),
(5695, 'GB_Y1', 'REGION', 'Y1', 'Flintshire', 'GB', '', '', '1'),
(5694, 'GB_X9', 'REGION', 'X9', 'Denbighshire', 'GB', '', '', '1'),
(5693, 'GB_X8', 'REGION', 'X8', 'Conwy', 'GB', '', '', '1'),
(5692, 'GB_X7', 'REGION', 'X7', 'Carmarthenshire', 'GB', '', '', '1'),
(5691, 'GB_X6', 'REGION', 'X6', 'Ceredigion', 'GB', '', '', '1'),
(5690, 'GB_X5', 'REGION', 'X5', 'Cardiff', 'GB', '', '', '1'),
(5689, 'GB_X4', 'REGION', 'X4', 'Caerphilly', 'GB', '', '', '1'),
(5688, 'GB_X3', 'REGION', 'X3', 'Bridgend', 'GB', '', '', '1'),
(5687, 'GB_X2', 'REGION', 'X2', 'Blaenau Gwent', 'GB', '', '', '1'),
(5686, 'GB_X1', 'REGION', 'X1', 'Isle of Anglesey', 'GB', '', '', '1'),
(5685, 'GB_W9', 'REGION', 'W9', 'West Lothian', 'GB', '', '', '1'),
(5684, 'GB_W8', 'REGION', 'W8', 'Eilean Siar', 'GB', '', '', '1'),
(5683, 'GB_W7', 'REGION', 'W7', 'West Dunbartonshire', 'GB', '', '', '1'),
(5682, 'GB_W6', 'REGION', 'W6', 'Stirling', 'GB', '', '', '1'),
(5681, 'GB_W5', 'REGION', 'W5', 'South Lanarkshire', 'GB', '', '', '1'),
(5680, 'GB_W4', 'REGION', 'W4', 'South Ayrshire', 'GB', '', '', '1'),
(5679, 'GB_W3', 'REGION', 'W3', 'Shetland Islands', 'GB', '', '', '1'),
(5678, 'GB_W2', 'REGION', 'W2', 'Renfrewshire', 'GB', '', '', '1'),
(5677, 'GB_W1', 'REGION', 'W1', 'Perth and Kinross', 'GB', '', '', '1'),
(5676, 'GB_V9', 'REGION', 'V9', 'Orkney', 'GB', '', '', '1'),
(5675, 'GB_V8', 'REGION', 'V8', 'North Lanarkshire', 'GB', '', '', '1'),
(5674, 'GB_V7', 'REGION', 'V7', 'North Ayrshire', 'GB', '', '', '1'),
(5673, 'GB_V6', 'REGION', 'V6', 'Moray', 'GB', '', '', '1');", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(5672, 'GB_V5', 'REGION', 'V5', 'Midlothian', 'GB', '', '', '1'),
(5671, 'GB_V4', 'REGION', 'V4', 'Inverclyde', 'GB', '', '', '1'),
(5670, 'GB_V3', 'REGION', 'V3', 'Highland', 'GB', '', '', '1'),
(5669, 'GB_V2', 'REGION', 'V2', 'Glasgow City', 'GB', '', '', '1'),
(5668, 'GB_V1', 'REGION', 'V1', 'Fife', 'GB', '', '', '1'),
(5667, 'GB_U9', 'REGION', 'U9', 'Falkirk', 'GB', '', '', '1'),
(5666, 'GB_U8', 'REGION', 'U8', 'Edinburgh, City of', 'GB', '', '', '1'),
(5665, 'GB_U7', 'REGION', 'U7', 'East Renfrewshire', 'GB', '', '', '1'),
(5664, 'GB_U6', 'REGION', 'U6', 'East Lothian', 'GB', '', '', '1'),
(5663, 'GB_U5', 'REGION', 'U5', 'East Dunbartonshire', 'GB', '', '', '1'),
(5662, 'GB_U4', 'REGION', 'U4', 'East Ayrshire', 'GB', '', '', '1'),
(5661, 'GB_U3', 'REGION', 'U3', 'Dundee City', 'GB', '', '', '1'),
(5660, 'GB_U2', 'REGION', 'U2', 'Dumfries and Galloway', 'GB', '', '', '1'),
(5659, 'GB_U1', 'REGION', 'U1', 'Clackmannanshire', 'GB', '', '', '1'),
(5658, 'GB_T9', 'REGION', 'T9', 'Scottish Borders, The', 'GB', '', '', '1'),
(5657, 'GB_T8', 'REGION', 'T8', 'Argyll and Bute', 'GB', '', '', '1'),
(5656, 'GB_T7', 'REGION', 'T7', 'Angus', 'GB', '', '', '1'),
(5655, 'GB_T6', 'REGION', 'T6', 'Aberdeenshire', 'GB', '', '', '1'),
(5654, 'GB_T5', 'REGION', 'T5', 'Aberdeen City', 'GB', '', '', '1'),
(5653, 'GB_T4', 'REGION', 'T4', 'Strabane', 'GB', '', '', '1'),
(5652, 'GB_T3', 'REGION', 'T3', 'Omagh', 'GB', '', '', '1'),
(5651, 'GB_T2', 'REGION', 'T2', 'North Down', 'GB', '', '', '1'),
(5650, 'GB_T1', 'REGION', 'T1', 'Newtownabbey', 'GB', '', '', '1'),
(5649, 'GB_S9', 'REGION', 'S9', 'Newry and Mourne', 'GB', '', '', '1'),
(5648, 'GB_S8', 'REGION', 'S8', 'Moyle', 'GB', '', '', '1'),
(5647, 'GB_S7', 'REGION', 'S7', 'Magherafelt', 'GB', '', '', '1'),
(5646, 'GB_S6', 'REGION', 'S6', 'Derry', 'GB', '', '', '1'),
(5645, 'GB_S5', 'REGION', 'S5', 'Lisburn', 'GB', '', '', '1'),
(5644, 'GB_S4', 'REGION', 'S4', 'Limavady', 'GB', '', '', '1'),
(5643, 'GB_S3', 'REGION', 'S3', 'Larne', 'GB', '', '', '1'),
(5642, 'GB_S2', 'REGION', 'S2', 'Fermanagh', 'GB', '', '', '1'),
(5641, 'GB_S1', 'REGION', 'S1', 'Dungannon', 'GB', '', '', '1'),
(5640, 'GB_R9', 'REGION', 'R9', 'Down', 'GB', '', '', '1'),
(5639, 'GB_R8', 'REGION', 'R8', 'Craigavon', 'GB', '', '', '1'),
(5638, 'GB_R7', 'REGION', 'R7', 'Cookstown', 'GB', '', '', '1'),
(5637, 'GB_R6', 'REGION', 'R6', 'Coleraine', 'GB', '', '', '1'),
(5636, 'GB_R5', 'REGION', 'R5', 'Castlereagh', 'GB', '', '', '1'),
(5635, 'GB_R4', 'REGION', 'R4', 'Carrickfergus', 'GB', '', '', '1'),
(5634, 'GB_R3', 'REGION', 'R3', 'Belfast', 'GB', '', '', '1'),
(5633, 'GB_R2', 'REGION', 'R2', 'Banbridge', 'GB', '', '', '1'),
(5632, 'GB_R1', 'REGION', 'R1', 'Ballymoney', 'GB', '', '', '1'),
(5631, 'GB_Q9', 'REGION', 'Q9', 'Ballymena', 'GB', '', '', '1'),
(5630, 'GB_Q8', 'REGION', 'Q8', 'Armagh', 'GB', '', '', '1'),
(5629, 'GB_Q7', 'REGION', 'Q7', 'Ards', 'GB', '', '', '1'),
(5628, 'GB_Q6', 'REGION', 'Q6', 'Antrim', 'GB', '', '', '1'),
(5627, 'GB_Q5', 'REGION', 'Q5', 'York', 'GB', '', '', '1'),
(5626, 'GB_Q4', 'REGION', 'Q4', 'Worcestershire', 'GB', '', '', '1'),
(5625, 'GB_Q3', 'REGION', 'Q3', 'Wolverhampton', 'GB', '', '', '1'),
(5624, 'GB_Q2', 'REGION', 'Q2', 'Wokingham', 'GB', '', '', '1'),
(5623, 'GB_Q1', 'REGION', 'Q1', 'Wirral', 'GB', '', '', '1'),
(5622, 'GB_P9', 'REGION', 'P9', 'Windsor and Maidenhead', 'GB', '', '', '1'),
(5621, 'GB_P8', 'REGION', 'P8', 'Wiltshire', 'GB', '', '', '1'),
(5620, 'GB_P7', 'REGION', 'P7', 'Wigan', 'GB', '', '', '1'),
(5619, 'GB_P6', 'REGION', 'P6', 'West Sussex', 'GB', '', '', '1'),
(5618, 'GB_P5', 'REGION', 'P5', 'Westminster', 'GB', '', '', '1'),
(5617, 'GB_P4', 'REGION', 'P4', 'West Berkshire', 'GB', '', '', '1'),
(5616, 'GB_P3', 'REGION', 'P3', 'Warwickshire', 'GB', '', '', '1'),
(5615, 'GB_P2', 'REGION', 'P2', 'Warrington', 'GB', '', '', '1'),
(5614, 'GB_P1', 'REGION', 'P1', 'Wandsworth', 'GB', '', '', '1'),
(5613, 'GB_O9', 'REGION', 'O9', 'Waltham Forest', 'GB', '', '', '1'),
(5612, 'GB_O8', 'REGION', 'O8', 'Walsall', 'GB', '', '', '1'),
(5611, 'GB_O7', 'REGION', 'O7', 'Wakefield', 'GB', '', '', '1'),
(5610, 'GB_O6', 'REGION', 'O6', 'Trafford', 'GB', '', '', '1'),
(5609, 'GB_O5', 'REGION', 'O5', 'Tower Hamlets', 'GB', '', '', '1'),
(5608, 'GB_O4', 'REGION', 'O4', 'Torbay', 'GB', '', '', '1'),
(5607, 'GB_O3', 'REGION', 'O3', 'Thurrock', 'GB', '', '', '1'),
(5606, 'GB_O2', 'REGION', 'O2', 'Telford and Wrekin', 'GB', '', '', '1'),
(5605, 'GB_O1', 'REGION', 'O1', 'Tameside', 'GB', '', '', '1'),
(5604, 'GB_N9', 'REGION', 'N9', 'Swindon', 'GB', '', '', '1'),
(5603, 'GB_N8', 'REGION', 'N8', 'Sutton', 'GB', '', '', '1'),
(5602, 'GB_N7', 'REGION', 'N7', 'Surrey', 'GB', '', '', '1'),
(5601, 'GB_N6', 'REGION', 'N6', 'Sunderland', 'GB', '', '', '1'),
(5600, 'GB_N5', 'REGION', 'N5', 'Suffolk', 'GB', '', '', '1'),
(5599, 'GB_N4', 'REGION', 'N4', 'Stoke-on-Trent', 'GB', '', '', '1'),
(5598, 'GB_N3', 'REGION', 'N3', 'Stockton-on-Tees', 'GB', '', '', '1'),
(5597, 'GB_N2', 'REGION', 'N2', 'Stockport', 'GB', '', '', '1'),
(5596, 'GB_N1', 'REGION', 'N1', 'St. Helens', 'GB', '', '', '1'),
(5595, 'GB_M9', 'REGION', 'M9', 'Staffordshire', 'GB', '', '', '1'),
(5594, 'GB_M8', 'REGION', 'M8', 'Southwark', 'GB', '', '', '1'),
(5593, 'GB_M7', 'REGION', 'M7', 'South Tyneside', 'GB', '', '', '1'),
(5592, 'GB_M6', 'REGION', 'M6', 'South Gloucestershire', 'GB', '', '', '1'),
(5591, 'GB_M5', 'REGION', 'M5', 'Southend-on-Sea', 'GB', '', '', '1'),
(5590, 'GB_M4', 'REGION', 'M4', 'Southampton', 'GB', '', '', '1'),
(5589, 'GB_M3', 'REGION', 'M3', 'Somerset', 'GB', '', '', '1'),
(5588, 'GB_M2', 'REGION', 'M2', 'Solihull', 'GB', '', '', '1'),
(5587, 'GB_M1', 'REGION', 'M1', 'Slough', 'GB', '', '', '1'),
(5586, 'GB_L9', 'REGION', 'L9', 'Sheffield', 'GB', '', '', '1'),
(5585, 'GB_L8', 'REGION', 'L8', 'Sefton', 'GB', '', '', '1'),
(5584, 'GB_L7', 'REGION', 'L7', 'Sandwell', 'GB', '', '', '1'),
(5583, 'GB_L6', 'REGION', 'L6', 'Shropshire', 'GB', '', '', '1'),
(5582, 'GB_L5', 'REGION', 'L5', 'Salford', 'GB', '', '', '1'),
(5581, 'GB_L4', 'REGION', 'L4', 'Rutland', 'GB', '', '', '1'),
(5580, 'GB_L3', 'REGION', 'L3', 'Rotherham', 'GB', '', '', '1'),
(5579, 'GB_L2', 'REGION', 'L2', 'Rochdale', 'GB', '', '', '1'),
(5578, 'GB_L1', 'REGION', 'L1', 'Richmond upon Thames', 'GB', '', '', '1'),
(5577, 'GB_K9', 'REGION', 'K9', 'Redcar and Cleveland', 'GB', '', '', '1'),
(5576, 'GB_K8', 'REGION', 'K8', 'Redbridge', 'GB', '', '', '1'),
(5575, 'GB_K7', 'REGION', 'K7', 'Reading', 'GB', '', '', '1'),
(5574, 'GB_K6', 'REGION', 'K6', 'Portsmouth', 'GB', '', '', '1'),
(5573, 'GB_K5', 'REGION', 'K5', 'Poole', 'GB', '', '', '1'),
(5572, 'GB_K4', 'REGION', 'K4', 'Plymouth', 'GB', '', '', '1'),
(5571, 'GB_K3', 'REGION', 'K3', 'Peterborough', 'GB', '', '', '1'),
(5570, 'GB_K2', 'REGION', 'K2', 'Oxfordshire', 'GB', '', '', '1'),
(5569, 'GB_K1', 'REGION', 'K1', 'Oldham', 'GB', '', '', '1'),
(5568, 'GB_J9', 'REGION', 'J9', 'Nottinghamshire', 'GB', '', '', '1'),
(5567, 'GB_J8', 'REGION', 'J8', 'Nottingham', 'GB', '', '', '1'),
(5566, 'GB_J7', 'REGION', 'J7', 'North Yorkshire', 'GB', '', '', '1'),
(5565, 'GB_J6', 'REGION', 'J6', 'Northumberland', 'GB', '', '', '1'),
(5564, 'GB_J5', 'REGION', 'J5', 'North Tyneside', 'GB', '', '', '1'),
(5563, 'GB_J4', 'REGION', 'J4', 'North Somerset', 'GB', '', '', '1'),
(5562, 'GB_J3', 'REGION', 'J3', 'North Lincolnshire', 'GB', '', '', '1'),
(5561, 'GB_J2', 'REGION', 'J2', 'North East Lincolnshire', 'GB', '', '', '1'),
(5560, 'GB_J1', 'REGION', 'J1', 'Northamptonshire', 'GB', '', '', '1'),
(5559, 'GB_I9', 'REGION', 'I9', 'Norfolk', 'GB', '', '', '1'),
(5558, 'GB_I8', 'REGION', 'I8', 'Newham', 'GB', '', '', '1'),
(5557, 'GB_I7', 'REGION', 'I7', 'Newcastle upon Tyne', 'GB', '', '', '1'),
(5556, 'GB_I6', 'REGION', 'I6', 'Milton Keynes', 'GB', '', '', '1'),
(5555, 'GB_I5', 'REGION', 'I5', 'Middlesbrough', 'GB', '', '', '1'),
(5554, 'GB_I4', 'REGION', 'I4', 'Merton', 'GB', '', '', '1'),
(5553, 'GB_I3', 'REGION', 'I3', 'Medway', 'GB', '', '', '1'),
(5552, 'GB_I2', 'REGION', 'I2', 'Manchester', 'GB', '', '', '1'),
(5551, 'GB_I1', 'REGION', 'I1', 'Luton', 'GB', '', '', '1'),
(5550, 'GB_H9', 'REGION', 'H9', 'London, City of', 'GB', '', '', '1'),
(5549, 'GB_H8', 'REGION', 'H8', 'Liverpool', 'GB', '', '', '1'),
(5548, 'GB_H7', 'REGION', 'H7', 'Lincolnshire', 'GB', '', '', '1'),
(5547, 'GB_H6', 'REGION', 'H6', 'Lewisham', 'GB', '', '', '1'),
(5546, 'GB_H5', 'REGION', 'H5', 'Leicestershire', 'GB', '', '', '1'),
(5545, 'GB_H4', 'REGION', 'H4', 'Leicester', 'GB', '', '', '1'),
(5544, 'GB_H3', 'REGION', 'H3', 'Leeds', 'GB', '', '', '1'),
(5543, 'GB_H2', 'REGION', 'H2', 'Lancashire', 'GB', '', '', '1'),
(5542, 'GB_H1', 'REGION', 'H1', 'Lambeth', 'GB', '', '', '1'),
(5541, 'GB_G9', 'REGION', 'G9', 'Knowsley', 'GB', '', '', '1'),
(5540, 'GB_G8', 'REGION', 'G8', 'Kirklees', 'GB', '', '', '1'),
(5539, 'GB_G7', 'REGION', 'G7', 'Kingston upon Thames', 'GB', '', '', '1'),
(5538, 'GB_G6', 'REGION', 'G6', 'Kingston upon Hull, City of', 'GB', '', '', '1'),
(5537, 'GB_G5', 'REGION', 'G5', 'Kent', 'GB', '', '', '1'),
(5536, 'GB_G4', 'REGION', 'G4', 'Kensington and Chelsea', 'GB', '', '', '1'),
(5535, 'GB_G3', 'REGION', 'G3', 'Islington', 'GB', '', '', '1'),
(5534, 'GB_G2', 'REGION', 'G2', 'Isle of Wight', 'GB', '', '', '1'),
(5533, 'GB_G1', 'REGION', 'G1', 'Hounslow', 'GB', '', '', '1'),
(5532, 'GB_F9', 'REGION', 'F9', 'Hillingdon', 'GB', '', '', '1'),
(5531, 'GB_F8', 'REGION', 'F8', 'Hertford', 'GB', '', '', '1'),
(5530, 'GB_F7', 'REGION', 'F7', 'Herefordshire', 'GB', '', '', '1'),
(5529, 'GB_F6', 'REGION', 'F6', 'Havering', 'GB', '', '', '1'),
(5528, 'GB_F5', 'REGION', 'F5', 'Hartlepool', 'GB', '', '', '1'),
(5527, 'GB_F4', 'REGION', 'F4', 'Harrow', 'GB', '', '', '1'),
(5526, 'GB_F3', 'REGION', 'F3', 'Haringey', 'GB', '', '', '1'),
(5525, 'GB_F2', 'REGION', 'F2', 'Hampshire', 'GB', '', '', '1'),
(5524, 'GB_F1', 'REGION', 'F1', 'Hammersmith and Fulham', 'GB', '', '', '1'),
(5523, 'GB_E9', 'REGION', 'E9', 'Halton', 'GB', '', '', '1'),
(5522, 'GB_E8', 'REGION', 'E8', 'Hackney', 'GB', '', '', '1'),
(5521, 'GB_E7', 'REGION', 'E7', 'Greenwich', 'GB', '', '', '1'),
(5520, 'GB_E6', 'REGION', 'E6', 'Gloucestershire', 'GB', '', '', '1'),
(5519, 'GB_E5', 'REGION', 'E5', 'Gateshead', 'GB', '', '', '1'),
(5518, 'GB_E4', 'REGION', 'E4', 'Essex', 'GB', '', '', '1'),
(5517, 'GB_E3', 'REGION', 'E3', 'Enfield', 'GB', '', '', '1'),
(5516, 'GB_E2', 'REGION', 'E2', 'East Sussex', 'GB', '', '', '1'),
(5515, 'GB_E1', 'REGION', 'E1', 'East Riding of Yorkshire', 'GB', '', '', '1'),
(5514, 'GB_D9', 'REGION', 'D9', 'Ealing', 'GB', '', '', '1'),
(5513, 'GB_D8', 'REGION', 'D8', 'Durham', 'GB', '', '', '1'),
(5512, 'GB_D7', 'REGION', 'D7', 'Dudley', 'GB', '', '', '1'),
(5511, 'GB_D6', 'REGION', 'D6', 'Dorset', 'GB', '', '', '1'),
(5510, 'GB_D5', 'REGION', 'D5', 'Doncaster', 'GB', '', '', '1'),
(5509, 'GB_D4', 'REGION', 'D4', 'Devon', 'GB', '', '', '1'),
(5508, 'GB_D3', 'REGION', 'D3', 'Derbyshire', 'GB', '', '', '1'),
(5507, 'GB_D2', 'REGION', 'D2', 'Derby', 'GB', '', '', '1'),
(5506, 'GB_D1', 'REGION', 'D1', 'Darlington', 'GB', '', '', '1'),
(5505, 'GB_C9', 'REGION', 'C9', 'Cumbria', 'GB', '', '', '1'),
(5504, 'GB_C8', 'REGION', 'C8', 'Croydon', 'GB', '', '', '1'),
(5503, 'GB_C7', 'REGION', 'C7', 'Coventry', 'GB', '', '', '1'),
(5502, 'GB_C6', 'REGION', 'C6', 'Cornwall', 'GB', '', '', '1'),
(5501, 'GB_C5', 'REGION', 'C5', 'Cheshire', 'GB', '', '', '1'),
(5500, 'GB_C4', 'REGION', 'C4', 'Camden', 'GB', '', '', '1'),
(5499, 'GB_C3', 'REGION', 'C3', 'Cambridgeshire', 'GB', '', '', '1'),
(5498, 'GB_C2', 'REGION', 'C2', 'Calderdale', 'GB', '', '', '1'),
(5497, 'GB_C1', 'REGION', 'C1', 'Bury', 'GB', '', '', '1'),
(5496, 'GB_B9', 'REGION', 'B9', 'Buckinghamshire', 'GB', '', '', '1'),
(5495, 'GB_B8', 'REGION', 'B8', 'Bromley', 'GB', '', '', '1'),
(5494, 'GB_B7', 'REGION', 'B7', 'Bristol, City of', 'GB', '', '', '1'),
(5493, 'GB_B6', 'REGION', 'B6', 'Brighton and Hove', 'GB', '', '', '1'),
(5492, 'GB_B5', 'REGION', 'B5', 'Brent', 'GB', '', '', '1'),
(5491, 'GB_B4', 'REGION', 'B4', 'Bradford', 'GB', '', '', '1'),
(5490, 'GB_B3', 'REGION', 'B3', 'Bracknell Forest', 'GB', '', '', '1'),
(5489, 'GB_B2', 'REGION', 'B2', 'Bournemouth', 'GB', '', '', '1'),
(5488, 'GB_B1', 'REGION', 'B1', 'Bolton', 'GB', '', '', '1'),
(5487, 'GB_A9', 'REGION', 'A9', 'Blackpool', 'GB', '', '', '1'),
(5486, 'GB_A8', 'REGION', 'A8', 'Blackburn with Darwen', 'GB', '', '', '1'),
(5485, 'GB_A7', 'REGION', 'A7', 'Birmingham', 'GB', '', '', '1'),
(5484, 'GB_A6', 'REGION', 'A6', 'Bexley', 'GB', '', '', '1'),
(5483, 'GB_A5', 'REGION', 'A5', 'Bedfordshire', 'GB', '', '', '1'),
(5482, 'GB_A4', 'REGION', 'A4', 'Bath and North East Somerset', 'GB', '', '', '1'),
(5481, 'GB_A3', 'REGION', 'A3', 'Barnsley', 'GB', '', '', '1'),
(5480, 'GB_A2', 'REGION', 'A2', 'Barnet', 'GB', '', '', '1'),
(5479, 'GB_A1', 'REGION', 'A1', 'Barking and Dagenham', 'GB', '', '', '1'),
(5478, 'GB_97', 'REGION', '97', 'West Glamorgan', 'GB', '', '', '1'),
(5477, 'GB_96', 'REGION', '96', 'South Glamorgan', 'GB', '', '', '1'),
(5476, 'GB_94', 'REGION', '94', 'Mid Glamorgan', 'GB', '', '', '1'),
(5475, 'GB_92', 'REGION', '92', 'Gwent', 'GB', '', '', '1'),
(5474, 'GB_91', 'REGION', '91', 'Dyfed', 'GB', '', '', '1'),
(5473, 'GB_90', 'REGION', '90', 'Clwyd', 'GB', '', '', '1'),
(5472, 'GB_88', 'REGION', '88', 'Tayside', 'GB', '', '', '1'),
(5471, 'GB_87', 'REGION', '87', 'Strathclyde', 'GB', '', '', '1'),
(5470, 'GB_84', 'REGION', '84', 'Lothian', 'GB', '', '', '1'),
(5469, 'GB_82', 'REGION', '82', 'Grampian', 'GB', '', '', '1'),
(5468, 'GB_79', 'REGION', '79', 'Central', 'GB', '', '', '1'),
(5467, 'GB_45', 'REGION', '45', 'West Yorkshire', 'GB', '', '', '1'),
(5466, 'GB_43', 'REGION', '43', 'West Midlands', 'GB', '', '', '1'),
(5465, 'GB_41', 'REGION', '41', 'Tyne and Wear', 'GB', '', '', '1'),
(5464, 'GB_37', 'REGION', '37', 'South Yorkshire', 'GB', '', '', '1'),
(5463, 'GB_28', 'REGION', '28', 'Merseyside', 'GB', '', '', '1'),
(5462, 'GB_22', 'REGION', '22', 'Humberside', 'GB', '', '', '1'),
(5461, 'GB_20', 'REGION', '20', 'Hereford and Worcester', 'GB', '', '', '1'),
(5460, 'GB_18', 'REGION', '18', 'Greater Manchester', 'GB', '', '', '1'),
(5459, 'GB_17', 'REGION', '17', 'Greater London', 'GB', '', '', '1'),
(5458, 'GB_07', 'REGION', '07', 'Cleveland', 'GB', '', '', '1'),
(5457, 'GB_03', 'REGION', '03', 'Berkshire', 'GB', '', '', '1'),
(5456, 'GB_01', 'REGION', '01', 'Avon', 'GB', '', '', '1'),
(5455, 'GA_09', 'REGION', '09', 'Woleu-Ntem', 'GA', '', '', '1'),
(5454, 'GA_08', 'REGION', '08', 'Ogooue-Maritime', 'GA', '', '', '1'),
(5453, 'GA_07', 'REGION', '07', 'Ogooue-Lolo', 'GA', '', '', '1'),
(5452, 'GA_06', 'REGION', '06', 'Ogooue-Ivindo', 'GA', '', '', '1'),
(5451, 'GA_05', 'REGION', '05', 'Nyanga', 'GA', '', '', '1'),
(5450, 'GA_04', 'REGION', '04', 'Ngounie', 'GA', '', '', '1'),
(5449, 'GA_03', 'REGION', '03', 'Moyen-Ogooue', 'GA', '', '', '1'),
(5448, 'GA_02', 'REGION', '02', 'Haut-Ogooue', 'GA', '', '', '1'),
(5447, 'GA_01', 'REGION', '01', 'Estuaire', 'GA', '', '', '1'),
(5446, 'FR_C1', 'REGION', 'C1', 'Alsace', 'FR', '', '', '1'),
(5445, 'FR_B9', 'REGION', 'B9', 'Rhone-Alpes', 'FR', '', '', '1'),
(5444, 'FR_B7', 'REGION', 'B7', 'Poitou-Charentes', 'FR', '', '', '1'),
(5443, 'FR_B6', 'REGION', 'B6', 'Picardie', 'FR', '', '', '1'),
(5442, 'FR_B5', 'REGION', 'B5', 'Pays de la Loire', 'FR', '', '', '1'),
(5441, 'FR_B4', 'REGION', 'B4', 'Nord-Pas-de-Calais', 'FR', '', '', '1'),
(5440, 'FR_B3', 'REGION', 'B3', 'Midi-Pyrenees', 'FR', '', '', '1'),
(5439, 'FR_B2', 'REGION', 'B2', 'Lorraine', 'FR', '', '', '1'),
(5438, 'FR_B1', 'REGION', 'B1', 'Limousin', 'FR', '', '', '1'),
(5437, 'FR_A9', 'REGION', 'A9', 'Languedoc-Roussillon', 'FR', '', '', '1'),
(5436, 'FR_A8', 'REGION', 'A8', 'Ile-de-France', 'FR', '', '', '1'),
(5435, 'FR_A7', 'REGION', 'A7', 'Haute-Normandie', 'FR', '', '', '1'),
(5434, 'FR_A6', 'REGION', 'A6', 'Franche-Comte', 'FR', '', '', '1'),
(5433, 'FR_A5', 'REGION', 'A5', 'Corse', 'FR', '', '', '1'),
(5432, 'FR_A4', 'REGION', 'A4', 'Champagne-Ardenne', 'FR', '', '', '1'),
(5431, 'FR_A3', 'REGION', 'A3', 'Centre', 'FR', '', '', '1'),
(5430, 'FR_A2', 'REGION', 'A2', 'Bretagne', 'FR', '', '', '1'),
(5429, 'FR_A1', 'REGION', 'A1', 'Bourgogne', 'FR', '', '', '1'),
(5428, 'FR_99', 'REGION', '99', 'Basse-Normandie', 'FR', '', '', '1'),
(5427, 'FR_98', 'REGION', '98', 'Auvergne', 'FR', '', '', '1'),
(5426, 'FR_97', 'REGION', '97', 'Aquitaine', 'FR', '', '', '1'),
(5425, 'FM_04', 'REGION', '04', 'Yap', 'FM', '', '', '1'),
(5424, 'FM_03', 'REGION', '03', 'Chuuk', 'FM', '', '', '1'),
(5423, 'FM_02', 'REGION', '02', 'Pohnpei', 'FM', '', '', '1'),
(5422, 'FM_01', 'REGION', '01', 'Kosrae', 'FM', '', '', '1'),
(5421, 'FJ_05', 'REGION', '05', 'Western', 'FJ', '', '', '1'),
(5420, 'FJ_04', 'REGION', '04', 'Rotuma', 'FJ', '', '', '1'),
(5419, 'FJ_03', 'REGION', '03', 'Northern', 'FJ', '', '', '1'),
(5418, 'FJ_02', 'REGION', '02', 'Eastern', 'FJ', '', '', '1'),
(5417, 'FJ_01', 'REGION', '01', 'Central', 'FJ', '', '', '1'),
(5416, 'FI_15', 'REGION', '15', 'Western Finland', 'FI', '', '', '1'),
(5415, 'FI_14', 'REGION', '14', 'Eastern Finland', 'FI', '', '', '1'),
(5414, 'FI_13', 'REGION', '13', 'Southern Finland', 'FI', '', '', '1'),
(5413, 'FI_08', 'REGION', '08', 'Oulu', 'FI', '', '', '1'),
(5412, 'FI_06', 'REGION', '06', 'Lapland', 'FI', '', '', '1'),
(5411, 'FI_01', 'REGION', '01', 'Aland', 'FI', '', '', '1'),
(5410, 'ET_54', 'REGION', '54', 'YeDebub Biheroch Bihereseboch na Hizboch', 'ET', '', '', '1'),
(5409, 'ET_53', 'REGION', '53', 'Tigray', 'ET', '', '', '1'),
(5408, 'ET_52', 'REGION', '52', 'Sumale', 'ET', '', '', '1'),
(5407, 'ET_51', 'REGION', '51', 'Oromiya', 'ET', '', '', '1'),
(5406, 'ET_50', 'REGION', '50', 'Hareri Hizb', 'ET', '', '', '1'),
(5405, 'ET_49', 'REGION', '49', 'Gambela Hizboch', 'ET', '', '', '1'),
(5404, 'ET_48', 'REGION', '48', 'Dire Dawa', 'ET', '', '', '1'),
(5403, 'ET_47', 'REGION', '47', 'Binshangul Gumuz', 'ET', '', '', '1'),
(5402, 'ET_46', 'REGION', '46', 'Amara', 'ET', '', '', '1'),
(5401, 'ET_45', 'REGION', '45', 'Afar', 'ET', '', '', '1'),
(5400, 'ET_44', 'REGION', '44', 'Adis Abeba', 'ET', '', '', '1'),
(5399, 'ET_14', 'REGION', '14', 'Afar', 'ET', '', '', '1'),
(5398, 'ET_13', 'REGION', '13', 'Benishangul', 'ET', '', '', '1'),
(5397, 'ET_12', 'REGION', '12', 'Tigray', 'ET', '', '', '1'),
(5396, 'ET_11', 'REGION', '11', 'Southern', 'ET', '', '', '1'),
(5395, 'ET_10', 'REGION', '10', 'Addis Abeba', 'ET', '', '', '1'),
(5394, 'ET_08', 'REGION', '08', 'Gambella', 'ET', '', '', '1'),
(5393, 'ET_07', 'REGION', '07', 'Somali', 'ET', '', '', '1'),
(5392, 'ET_02', 'REGION', '02', 'Amhara', 'ET', '', '', '1'),
(5391, 'ES_60', 'REGION', '60', 'Comunidad Valenciana', 'ES', '', '', '1'),
(5390, 'ES_59', 'REGION', '59', 'Pais Vasco', 'ES', '', '', '1'),
(5389, 'ES_58', 'REGION', '58', 'Galicia', 'ES', '', '', '1'),
(5388, 'ES_57', 'REGION', '57', 'Extremadura', 'ES', '', '', '1'),
(5387, 'ES_56', 'REGION', '56', 'Catalonia', 'ES', '', '', '1'),
(5386, 'ES_55', 'REGION', '55', 'Castilla y Leon', 'ES', '', '', '1'),
(5385, 'ES_54', 'REGION', '54', 'Castilla-La Mancha', 'ES', '', '', '1'),
(5384, 'ES_53', 'REGION', '53', 'Canarias', 'ES', '', '', '1'),
(5383, 'ES_52', 'REGION', '52', 'Aragon', 'ES', '', '', '1'),
(5382, 'ES_51', 'REGION', '51', 'Andalucia', 'ES', '', '', '1'),
(5381, 'ES_39', 'REGION', '39', 'Cantabria', 'ES', '', '', '1'),
(5380, 'ES_34', 'REGION', '34', 'Asturias', 'ES', '', '', '1'),
(5379, 'ES_32', 'REGION', '32', 'Navarra', 'ES', '', '', '1'),
(5378, 'ES_31', 'REGION', '31', 'Murcia', 'ES', '', '', '1'),
(5377, 'ES_29', 'REGION', '29', 'Madrid', 'ES', '', '', '1'),
(5376, 'ES_27', 'REGION', '27', 'La Rioja', 'ES', '', '', '1'),
(5375, 'ES_07', 'REGION', '07', 'Islas Baleares', 'ES', '', '', '1'),
(5374, 'ER_04', 'REGION', '04', 'Gash Barka', 'ER', '', '', '1'),
(5373, 'ER_02', 'REGION', '02', 'Debub', 'ER', '', '', '1'),
(5372, 'ER_01', 'REGION', '01', 'Anseba', 'ER', '', '', '1'),
(5371, 'EG_24', 'REGION', '24', 'Suhaj', 'EG', '', '', '1'),
(5370, 'EG_23', 'REGION', '23', 'Qina', 'EG', '', '', '1'),
(5369, 'EG_22', 'REGION', '22', 'Matruh', 'EG', '', '', '1'),
(5368, 'EG_21', 'REGION', '21', 'Kafr ash Shaykh', 'EG', '', '', '1'),
(5367, 'EG_20', 'REGION', '20', 'Dumyat', 'EG', '', '', '1'),
(5366, 'EG_18', 'REGION', '18', 'Bani Suwayf', 'EG', '', '', '1'),
(5365, 'EG_17', 'REGION', '17', 'Asyut', 'EG', '', '', '1'),
(5364, 'EG_16', 'REGION', '16', 'Aswan', 'EG', '', '', '1'),
(5363, 'EG_15', 'REGION', '15', 'As Suways', 'EG', '', '', '1'),
(5362, 'EG_14', 'REGION', '14', 'Ash Sharqiyah', 'EG', '', '', '1'),
(5361, 'EG_13', 'REGION', '13', 'Al Wadi al Jadid', 'EG', '', '', '1'),
(5360, 'EG_12', 'REGION', '12', 'Al Qalyubiyah', 'EG', '', '', '1'),
(5359, 'EG_11', 'REGION', '11', 'Al Qahirah', 'EG', '', '', '1'),
(5358, 'EG_10', 'REGION', '10', 'Al Minya', 'EG', '', '', '1'),
(5357, 'EG_09', 'REGION', '09', 'Al Minufiyah', 'EG', '', '', '1'),
(5356, 'EG_08', 'REGION', '08', 'Al Jizah', 'EG', '', '', '1'),
(5355, 'EG_06', 'REGION', '06', 'Al Iskandariyah', 'EG', '', '', '1'),
(5354, 'EG_05', 'REGION', '05', 'Al Gharbiyah', 'EG', '', '', '1'),
(5353, 'EG_04', 'REGION', '04', 'Al Fayyum', 'EG', '', '', '1'),
(5352, 'EG_03', 'REGION', '03', 'Al Buhayrah', 'EG', '', '', '1'),
(5351, 'EG_02', 'REGION', '02', 'Al Bahr al Ahmar', 'EG', '', '', '1'),
(5350, 'EG_01', 'REGION', '01', 'Ad Daqahliyah', 'EG', '', '', '1'),
(5349, 'EE_21', 'REGION', '21', 'Vorumaa', 'EE', '', '', '1'),
(5348, 'EE_20', 'REGION', '20', 'Viljandimaa', 'EE', '', '', '1'),
(5347, 'EE_19', 'REGION', '19', 'Valgamaa', 'EE', '', '', '1'),
(5346, 'EE_18', 'REGION', '18', 'Tartumaa', 'EE', '', '', '1'),
(5345, 'EE_17', 'REGION', '17', 'Tartu', 'EE', '', '', '1'),
(5344, 'EE_16', 'REGION', '16', 'Tallinn', 'EE', '', '', '1'),
(5343, 'EE_15', 'REGION', '15', 'Sillamae', 'EE', '', '', '1'),
(5342, 'EE_14', 'REGION', '14', 'Saaremaa', 'EE', '', '', '1'),
(5341, 'EE_13', 'REGION', '13', 'Raplamaa', 'EE', '', '', '1'),
(5340, 'EE_12', 'REGION', '12', 'Polvamaa', 'EE', '', '', '1'),
(5339, 'EE_11', 'REGION', '11', 'Parnumaa', 'EE', '', '', '1'),
(5338, 'EE_10', 'REGION', '10', 'Parnu', 'EE', '', '', '1'),
(5337, 'EE_09', 'REGION', '09', 'Narva', 'EE', '', '', '1'),
(5336, 'EE_08', 'REGION', '08', 'Laane-Virumaa', 'EE', '', '', '1'),
(5335, 'EE_07', 'REGION', '07', 'Laanemaa', 'EE', '', '', '1'),
(5334, 'EE_06', 'REGION', '06', 'Kohtla-Jarve', 'EE', '', '', '1'),
(5333, 'EE_05', 'REGION', '05', 'Jogevamaa', 'EE', '', '', '1'),
(5332, 'EE_04', 'REGION', '04', 'Jarvamaa', 'EE', '', '', '1'),
(5331, 'EE_03', 'REGION', '03', 'Ida-Virumaa', 'EE', '', '', '1'),
(5330, 'EE_02', 'REGION', '02', 'Hiiumaa', 'EE', '', '', '1'),
(5329, 'EE_01', 'REGION', '01', 'Harjumaa', 'EE', '', '', '1'),
(5328, 'EC_24', 'REGION', '24', 'Orellana', 'EC', '', '', '1'),
(5327, 'EC_23', 'REGION', '23', 'Napo', 'EC', '', '', '1'),
(5326, 'EC_22', 'REGION', '22', 'Sucumbios', 'EC', '', '', '1'),
(5325, 'EC_20', 'REGION', '20', 'Zamora-Chinchipe', 'EC', '', '', '1'),
(5324, 'EC_19', 'REGION', '19', 'Tungurahua', 'EC', '', '', '1'),
(5323, 'EC_18', 'REGION', '18', 'Pichincha', 'EC', '', '', '1'),
(5322, 'EC_17', 'REGION', '17', 'Pastaza', 'EC', '', '', '1'),
(5321, 'EC_15', 'REGION', '15', 'Morona-Santiago', 'EC', '', '', '1'),
(5320, 'EC_14', 'REGION', '14', 'Manabi', 'EC', '', '', '1'),
(5319, 'EC_13', 'REGION', '13', 'Los Rios', 'EC', '', '', '1'),
(5318, 'EC_12', 'REGION', '12', 'Loja', 'EC', '', '', '1'),
(5317, 'EC_11', 'REGION', '11', 'Imbabura', 'EC', '', '', '1'),
(5316, 'EC_10', 'REGION', '10', 'Guayas', 'EC', '', '', '1'),
(5315, 'EC_09', 'REGION', '09', 'Esmeraldas', 'EC', '', '', '1'),
(5314, 'EC_08', 'REGION', '08', 'El Oro', 'EC', '', '', '1'),
(5313, 'EC_07', 'REGION', '07', 'Cotopaxi', 'EC', '', '', '1'),
(5312, 'EC_06', 'REGION', '06', 'Chimborazo', 'EC', '', '', '1'),
(5311, 'EC_05', 'REGION', '05', 'Carchi', 'EC', '', '', '1'),
(5310, 'EC_04', 'REGION', '04', 'Canar', 'EC', '', '', '1'),
(5309, 'EC_03', 'REGION', '03', 'Bolivar', 'EC', '', '', '1'),
(5308, 'EC_02', 'REGION', '02', 'Azuay', 'EC', '', '', '1'),
(5307, 'EC_01', 'REGION', '01', 'Galapagos', 'EC', '', '', '1'),
(5306, 'DZ_56', 'REGION', '56', 'Tissemsilt', 'DZ', '', '', '1'),
(5305, 'DZ_55', 'REGION', '55', 'Tipaza', 'DZ', '', '', '1'),
(5304, 'DZ_54', 'REGION', '54', 'Tindouf', 'DZ', '', '', '1'),
(5303, 'DZ_53', 'REGION', '53', 'Tamanghasset', 'DZ', '', '', '1'),
(5302, 'DZ_52', 'REGION', '52', 'Souk Ahras', 'DZ', '', '', '1'),
(5301, 'DZ_51', 'REGION', '51', 'Relizane', 'DZ', '', '', '1'),
(5300, 'DZ_50', 'REGION', '50', 'Ouargla', 'DZ', '', '', '1'),
(5299, 'DZ_49', 'REGION', '49', 'Naama', 'DZ', '', '', '1'),
(5298, 'DZ_48', 'REGION', '48', 'Mila', 'DZ', '', '', '1'),
(5297, 'DZ_47', 'REGION', '47', 'Khenchela', 'DZ', '', '', '1'),
(5296, 'DZ_46', 'REGION', '46', 'Illizi', 'DZ', '', '', '1'),
(5295, 'DZ_45', 'REGION', '45', 'Ghardaia', 'DZ', '', '', '1'),
(5294, 'DZ_44', 'REGION', '44', 'El Tarf', 'DZ', '', '', '1'),
(5293, 'DZ_43', 'REGION', '43', 'El Oued', 'DZ', '', '', '1'),
(5292, 'DZ_42', 'REGION', '42', 'El Bayadh', 'DZ', '', '', '1'),
(5291, 'DZ_41', 'REGION', '41', 'Chlef', 'DZ', '', '', '1'),
(5290, 'DZ_40', 'REGION', '40', 'Boumerdes', 'DZ', '', '', '1'),
(5289, 'DZ_39', 'REGION', '39', 'Bordj Bou Arreridj', 'DZ', '', '', '1'),
(5288, 'DZ_38', 'REGION', '38', 'Bechar', 'DZ', '', '', '1'),
(5287, 'DZ_37', 'REGION', '37', 'Annaba', 'DZ', '', '', '1'),
(5286, 'DZ_36', 'REGION', '36', 'Ain Temouchent', 'DZ', '', '', '1'),
(5285, 'DZ_35', 'REGION', '35', 'Ain Defla', 'DZ', '', '', '1'),
(5284, 'DZ_34', 'REGION', '34', 'Adrar', 'DZ', '', '', '1'),
(5283, 'DZ_33', 'REGION', '33', 'Tebessa', 'DZ', '', '', '1'),
(5282, 'DZ_31', 'REGION', '31', 'Skikda', 'DZ', '', '', '1'),
(5281, 'DZ_30', 'REGION', '30', 'Sidi Bel Abbes', 'DZ', '', '', '1'),
(5280, 'DZ_29', 'REGION', '29', 'Oum el Bouaghi', 'DZ', '', '', '1'),
(5279, 'DZ_26', 'REGION', '26', 'Mascara', 'DZ', '', '', '1'),
(5278, 'DZ_25', 'REGION', '25', 'Laghouat', 'DZ', '', '', '1'),
(5277, 'DZ_24', 'REGION', '24', 'Jijel', 'DZ', '', '', '1'),
(5276, 'DZ_23', 'REGION', '23', 'Guelma', 'DZ', '', '', '1'),
(5275, 'DZ_22', 'REGION', '22', 'Djelfa', 'DZ', '', '', '1'),
(5274, 'DZ_21', 'REGION', '21', 'Bouira', 'DZ', '', '', '1'),
(5273, 'DZ_20', 'REGION', '20', 'Blida', 'DZ', '', '', '1'),
(5272, 'DZ_19', 'REGION', '19', 'Biskra', 'DZ', '', '', '1'),
(5271, 'DZ_18', 'REGION', '18', 'Bejaia', 'DZ', '', '', '1'),
(5270, 'DZ_15', 'REGION', '15', 'Tlemcen', 'DZ', '', '', '1'),
(5269, 'DZ_14', 'REGION', '14', 'Tizi Ouzou', 'DZ', '', '', '1'),
(5268, 'DZ_13', 'REGION', '13', 'Tiaret', 'DZ', '', '', '1'),
(5267, 'DZ_12', 'REGION', '12', 'Setif', 'DZ', '', '', '1'),
(5266, 'DZ_10', 'REGION', '10', 'Saida', 'DZ', '', '', '1'),
(5265, 'DZ_09', 'REGION', '09', 'Oran', 'DZ', '', '', '1'),
(5264, 'DZ_07', 'REGION', '07', 'Mostaganem', 'DZ', '', '', '1'),
(5263, 'DZ_06', 'REGION', '06', 'Medea', 'DZ', '', '', '1'),
(5262, 'DZ_04', 'REGION', '04', 'Constantine', 'DZ', '', '', '1'),
(5261, 'DZ_03', 'REGION', '03', 'Batna', 'DZ', '', '', '1'),
(5260, 'DZ_01', 'REGION', '01', 'Alger', 'DZ', '', '', '1'),
(5259, 'DO_37', 'REGION', '37', 'Santo Domingo', 'DO', '', '', '1'),
(5258, 'DO_36', 'REGION', '36', 'San Jose de Ocoa', 'DO', '', '', '1'),
(5257, 'DO_35', 'REGION', '35', 'Peravia', 'DO', '', '', '1'),
(5256, 'DO_34', 'REGION', '34', 'Distrito Nacional', 'DO', '', '', '1'),
(5255, 'DO_33', 'REGION', '33', 'San Cristobal', 'DO', '', '', '1'),
(5254, 'DO_32', 'REGION', '32', 'Monte Plata', 'DO', '', '', '1'),
(5253, 'DO_31', 'REGION', '31', 'Monsenor Nouel', 'DO', '', '', '1'),
(5252, 'DO_30', 'REGION', '30', 'La Vega', 'DO', '', '', '1'),
(5251, 'DO_29', 'REGION', '29', 'Hato Mayor', 'DO', '', '', '1'),
(5250, 'DO_28', 'REGION', '28', 'El Seibo', 'DO', '', '', '1'),
(5249, 'DO_27', 'REGION', '27', 'Valverde', 'DO', '', '', '1'),
(5248, 'DO_26', 'REGION', '26', 'Santiago Rodriguez', 'DO', '', '', '1'),
(5247, 'DO_25', 'REGION', '25', 'Santiago', 'DO', '', '', '1'),
(5246, 'DO_24', 'REGION', '24', 'San Pedro De Macoris', 'DO', '', '', '1'),
(5245, 'DO_23', 'REGION', '23', 'San Juan', 'DO', '', '', '1'),
(5244, 'DO_21', 'REGION', '21', 'Sanchez Ramirez', 'DO', '', '', '1'),
(5243, 'DO_20', 'REGION', '20', 'Samana', 'DO', '', '', '1'),
(5242, 'DO_19', 'REGION', '19', 'Salcedo', 'DO', '', '', '1'),
(5241, 'DO_18', 'REGION', '18', 'Puerto Plata', 'DO', '', '', '1'),
(5240, 'DO_17', 'REGION', '17', 'Peravia', 'DO', '', '', '1'),
(5239, 'DO_16', 'REGION', '16', 'Pedernales', 'DO', '', '', '1'),
(5238, 'DO_15', 'REGION', '15', 'Monte Cristi', 'DO', '', '', '1'),
(5237, 'DO_14', 'REGION', '14', 'Maria Trinidad Sanchez', 'DO', '', '', '1'),
(5236, 'DO_12', 'REGION', '12', 'La Romana', 'DO', '', '', '1'),
(5235, 'DO_11', 'REGION', '11', 'Elias Pina', 'DO', '', '', '1'),
(5234, 'DO_10', 'REGION', '10', 'La Altagracia', 'DO', '', '', '1'),
(5233, 'DO_09', 'REGION', '09', 'Independencia', 'DO', '', '', '1'),
(5232, 'DO_08', 'REGION', '08', 'Espaillat', 'DO', '', '', '1'),
(5231, 'DO_06', 'REGION', '06', 'Duarte', 'DO', '', '', '1'),
(5230, 'DO_05', 'REGION', '05', 'Distrito Nacional', 'DO', '', '', '1'),
(5229, 'DO_04', 'REGION', '04', 'Dajabon', 'DO', '', '', '1'),
(5228, 'DO_03', 'REGION', '03', 'Barahona', 'DO', '', '', '1'),
(5227, 'DO_02', 'REGION', '02', 'Baoruco', 'DO', '', '', '1'),
(5226, 'DO_01', 'REGION', '01', 'Azua', 'DO', '', '', '1'),
(5225, 'DM_11', 'REGION', '11', 'Saint Peter', 'DM', '', '', '1'),
(5224, 'DM_10', 'REGION', '10', 'Saint Paul', 'DM', '', '', '1'),
(5223, 'DM_09', 'REGION', '09', 'Saint Patrick', 'DM', '', '', '1'),
(5222, 'DM_08', 'REGION', '08', 'Saint Mark', 'DM', '', '', '1'),
(5221, 'DM_07', 'REGION', '07', 'Saint Luke', 'DM', '', '', '1'),
(5220, 'DM_06', 'REGION', '06', 'Saint Joseph', 'DM', '', '', '1'),
(5219, 'DM_05', 'REGION', '05', 'Saint John', 'DM', '', '', '1'),
(5218, 'DM_04', 'REGION', '04', 'Saint George', 'DM', '', '', '1'),
(5217, 'DM_03', 'REGION', '03', 'Saint David', 'DM', '', '', '1'),
(5216, 'DM_02', 'REGION', '02', 'Saint Andrew', 'DM', '', '', '1'),
(5215, 'DK_21', 'REGION', '21', 'Syddanmark', 'DK', '', '', '1'),
(5214, 'DK_20', 'REGION', '20', 'Sjelland', 'DK', '', '', '1'),
(5213, 'DK_19', 'REGION', '19', 'Nordjylland', 'DK', '', '', '1'),
(5212, 'DK_18', 'REGION', '18', 'Midtjyllen', 'DK', '', '', '1'),
(5211, 'DK_17', 'REGION', '17', 'Hovedstaden', 'DK', '', '', '1'),
(5210, 'DK_15', 'REGION', '15', 'Viborg', 'DK', '', '', '1'),
(5209, 'DK_14', 'REGION', '14', 'Vestsjalland', 'DK', '', '', '1'),
(5208, 'DK_13', 'REGION', '13', 'Vejle', 'DK', '', '', '1'),
(5207, 'DK_12', 'REGION', '12', 'Storstrom', 'DK', '', '', '1'),
(5206, 'DK_11', 'REGION', '11', 'Sonderjylland', 'DK', '', '', '1'),
(5205, 'DK_10', 'REGION', '10', 'Roskilde', 'DK', '', '', '1'),
(5204, 'DK_09', 'REGION', '09', 'Ringkobing', 'DK', '', '', '1'),
(5203, 'DK_08', 'REGION', '08', 'Ribe', 'DK', '', '', '1'),
(5202, 'DK_07', 'REGION', '07', 'Nordjylland', 'DK', '', '', '1'),
(5201, 'DK_06', 'REGION', '06', 'Staden Kobenhavn', 'DK', '', '', '1'),
(5200, 'DK_05', 'REGION', '05', 'Kobenhavn', 'DK', '', '', '1'),
(5199, 'DK_04', 'REGION', '04', 'Fyn', 'DK', '', '', '1'),
(5198, 'DK_03', 'REGION', '03', 'Frederiksborg', 'DK', '', '', '1'),
(5197, 'DK_02', 'REGION', '02', 'Bornholm', 'DK', '', '', '1'),
(5196, 'DK_01', 'REGION', '01', 'Arhus', 'DK', '', '', '1'),
(5195, 'DJ_08', 'REGION', '08', 'Arta', 'DJ', '', '', '1'),
(5194, 'DJ_07', 'REGION', '07', 'Djibouti', 'DJ', '', '', '1'),
(5193, 'DJ_06', 'REGION', '06', 'Dikhil', 'DJ', '', '', '1'),
(5192, 'DJ_05', 'REGION', '05', 'Tadjoura', 'DJ', '', '', '1'),
(5191, 'DJ_04', 'REGION', '04', 'Obock', 'DJ', '', '', '1'),
(5190, 'DJ_01', 'REGION', '01', 'Ali Sabieh', 'DJ', '', '', '1'),
(5189, 'CZ_90', 'REGION', '90', 'Zlinsky kraj', 'CZ', '', '', '1'),
(5188, 'CZ_89', 'REGION', '89', 'Ustecky kraj', 'CZ', '', '', '1'),
(5187, 'CZ_88', 'REGION', '88', 'Stredocesky kraj', 'CZ', '', '', '1'),
(5186, 'CZ_87', 'REGION', '87', 'Plzensky kraj', 'CZ', '', '', '1'),
(5185, 'CZ_86', 'REGION', '86', 'Pardubicky kraj', 'CZ', '', '', '1'),
(5184, 'CZ_85', 'REGION', '85', 'Moravskoslezsky kraj', 'CZ', '', '', '1'),
(5183, 'CZ_84', 'REGION', '84', 'Olomoucky kraj', 'CZ', '', '', '1'),
(5182, 'CZ_83', 'REGION', '83', 'Liberecky kraj', 'CZ', '', '', '1'),
(5181, 'CZ_82', 'REGION', '82', 'Kralovehradecky kraj', 'CZ', '', '', '1'),
(5180, 'CZ_81', 'REGION', '81', 'Karlovarsky kraj', 'CZ', '', '', '1'),
(5179, 'CZ_80', 'REGION', '80', 'Vysocina', 'CZ', '', '', '1'),
(5178, 'CZ_79', 'REGION', '79', 'Jihocesky kraj', 'CZ', '', '', '1'),
(5177, 'CZ_78', 'REGION', '78', 'Jihomoravsky kraj', 'CZ', '', '', '1'),
(5176, 'CZ_70', 'REGION', '70', 'Trutnov', 'CZ', '', '', '1'),
(5175, 'CZ_61', 'REGION', '61', 'Semily', 'CZ', '', '', '1'),
(5174, 'CZ_52', 'REGION', '52', 'Hlavni mesto Praha', 'CZ', '', '', '1'),
(5173, 'CZ_45', 'REGION', '45', 'Pardubice', 'CZ', '', '', '1'),
(5172, 'CZ_41', 'REGION', '41', 'Nymburk', 'CZ', '', '', '1'),
(5171, 'CZ_39', 'REGION', '39', 'Nachod', 'CZ', '', '', '1'),
(5170, 'CZ_37', 'REGION', '37', 'Mlada Boleslav', 'CZ', '', '', '1'),
(5169, 'CZ_36', 'REGION', '36', 'Melnik', 'CZ', '', '', '1'),
(5168, 'CZ_33', 'REGION', '33', 'Liberec', 'CZ', '', '', '1'),
(5167, 'CZ_30', 'REGION', '30', 'Kolin', 'CZ', '', '', '1'),
(5166, 'CZ_24', 'REGION', '24', 'Jihlava', 'CZ', '', '', '1'),
(5165, 'CZ_23', 'REGION', '23', 'Jicin', 'CZ', '', '', '1'),
(5164, 'CZ_21', 'REGION', '21', 'Jablonec nad Nisou', 'CZ', '', '', '1'),
(5163, 'CZ_20', 'REGION', '20', 'Hradec Kralove', 'CZ', '', '', '1'),
(5162, 'CZ_04', 'REGION', '04', 'Breclav', 'CZ', '', '', '1'),
(5161, 'CZ_03', 'REGION', '03', 'Blansko', 'CZ', '', '', '1'),
(5160, 'CY_06', 'REGION', '06', 'Paphos', 'CY', '', '', '1'),
(5159, 'CY_05', 'REGION', '05', 'Limassol', 'CY', '', '', '1'),
(5158, 'CY_04', 'REGION', '04', 'Nicosia', 'CY', '', '', '1'),
(5157, 'CY_03', 'REGION', '03', 'Larnaca', 'CY', '', '', '1'),
(5156, 'CY_02', 'REGION', '02', 'Kyrenia', 'CY', '', '', '1'),
(5155, 'CY_01', 'REGION', '01', 'Famagusta', 'CY', '', '', '1'),
(5154, 'CV_20', 'REGION', '20', 'Tarrafal', 'CV', '', '', '1'),
(5153, 'CV_19', 'REGION', '19', 'Sao Miguel', 'CV', '', '', '1'),
(5152, 'CV_18', 'REGION', '18', 'Sao Filipe', 'CV', '', '', '1'),
(5151, 'CV_17', 'REGION', '17', 'Sao Domingos', 'CV', '', '', '1'),
(5150, 'CV_16', 'REGION', '16', 'Santa Cruz', 'CV', '', '', '1'),
(5149, 'CV_15', 'REGION', '15', 'Santa Catarina', 'CV', '', '', '1'),
(5148, 'CV_14', 'REGION', '14', 'Praia', 'CV', '', '', '1'),
(5147, 'CV_13', 'REGION', '13', 'Mosteiros', 'CV', '', '', '1'),
(5146, 'CV_11', 'REGION', '11', 'Sao Vicente', 'CV', '', '', '1'),
(5145, 'CV_10', 'REGION', '10', 'Sao Nicolau', 'CV', '', '', '1'),
(5144, 'CV_08', 'REGION', '08', 'Sal', 'CV', '', '', '1'),
(5143, 'CV_07', 'REGION', '07', 'Ribeira Grande', 'CV', '', '', '1'),
(5142, 'CV_05', 'REGION', '05', 'Paul', 'CV', '', '', '1'),
(5141, 'CV_04', 'REGION', '04', 'Maio', 'CV', '', '', '1'),
(5140, 'CV_02', 'REGION', '02', 'Brava', 'CV', '', '', '1'),
(5139, 'CV_01', 'REGION', '01', 'Boa Vista', 'CV', '', '', '1'),
(5138, 'CU_16', 'REGION', '16', 'Villa Clara', 'CU', '', '', '1'),
(5137, 'CU_15', 'REGION', '15', 'Santiago de Cuba', 'CU', '', '', '1'),
(5136, 'CU_14', 'REGION', '14', 'Sancti Spiritus', 'CU', '', '', '1'),
(5135, 'CU_13', 'REGION', '13', 'Las Tunas', 'CU', '', '', '1'),
(5134, 'CU_12', 'REGION', '12', 'Holguin', 'CU', '', '', '1'),
(5133, 'CU_11', 'REGION', '11', 'La Habana', 'CU', '', '', '1'),
(5132, 'CU_10', 'REGION', '10', 'Guantanamo', 'CU', '', '', '1'),
(5131, 'CU_09', 'REGION', '09', 'Granma', 'CU', '', '', '1'),
(5130, 'CU_08', 'REGION', '08', 'Cienfuegos', 'CU', '', '', '1'),
(5129, 'CU_07', 'REGION', '07', 'Ciego de Avila', 'CU', '', '', '1'),
(5128, 'CU_05', 'REGION', '05', 'Camaguey', 'CU', '', '', '1'),
(5127, 'CU_04', 'REGION', '04', 'Isla de la Juventud', 'CU', '', '', '1'),
(5126, 'CU_03', 'REGION', '03', 'Matanzas', 'CU', '', '', '1'),
(5125, 'CU_02', 'REGION', '02', 'Ciudad de la Habana', 'CU', '', '', '1'),
(5124, 'CU_01', 'REGION', '01', 'Pinar del Rio', 'CU', '', '', '1'),
(5123, 'CR_08', 'REGION', '08', 'San Jose', 'CR', '', '', '1'),
(5122, 'CR_07', 'REGION', '07', 'Puntarenas', 'CR', '', '', '1'),
(5121, 'CR_06', 'REGION', '06', 'Limon', 'CR', '', '', '1'),
(5120, 'CR_04', 'REGION', '04', 'Heredia', 'CR', '', '', '1'),
(5119, 'CR_03', 'REGION', '03', 'Guanacaste', 'CR', '', '', '1'),
(5118, 'CR_02', 'REGION', '02', 'Cartago', 'CR', '', '', '1'),
(5117, 'CR_01', 'REGION', '01', 'Alajuela', 'CR', '', '', '1'),
(5116, 'CO_38', 'REGION', '38', 'Magdalena', 'CO', '', '', '1'),
(5115, 'CO_37', 'REGION', '37', 'Caldas', 'CO', '', '', '1'),
(5114, 'CO_36', 'REGION', '36', 'Boyaca', 'CO', '', '', '1'),
(5113, 'CO_35', 'REGION', '35', 'Bolivar', 'CO', '', '', '1'),
(5112, 'CO_34', 'REGION', '34', 'Distrito Especial', 'CO', '', '', '1'),
(5111, 'CO_33', 'REGION', '33', 'Cundinamarca', 'CO', '', '', '1'),
(5110, 'CO_32', 'REGION', '32', 'Casanare', 'CO', '', '', '1'),
(5109, 'CO_31', 'REGION', '31', 'Vichada', 'CO', '', '', '1'),
(5108, 'CO_30', 'REGION', '30', 'Vaupes', 'CO', '', '', '1'),
(5107, 'CO_29', 'REGION', '29', 'Valle del Cauca', 'CO', '', '', '1'),
(5106, 'CO_28', 'REGION', '28', 'Tolima', 'CO', '', '', '1'),
(5105, 'CO_27', 'REGION', '27', 'Sucre', 'CO', '', '', '1'),
(5104, 'CO_26', 'REGION', '26', 'Santander', 'CO', '', '', '1'),
(5103, 'CO_25', 'REGION', '25', 'San Andres y Providencia', 'CO', '', '', '1'),
(5102, 'CO_24', 'REGION', '24', 'Risaralda', 'CO', '', '', '1'),
(5101, 'CO_23', 'REGION', '23', 'Quindio', 'CO', '', '', '1'),
(5100, 'CO_22', 'REGION', '22', 'Putumayo', 'CO', '', '', '1'),
(5099, 'CO_21', 'REGION', '21', 'Norte de Santander', 'CO', '', '', '1'),
(5098, 'CO_20', 'REGION', '20', 'Narino', 'CO', '', '', '1'),
(5097, 'CO_19', 'REGION', '19', 'Meta', 'CO', '', '', '1'),
(5096, 'CO_18', 'REGION', '18', 'Magdalena Department', 'CO', '', '', '1'),
(5095, 'CO_17', 'REGION', '17', 'La Guajira', 'CO', '', '', '1'),
(5094, 'CO_16', 'REGION', '16', 'Huila', 'CO', '', '', '1'),
(5093, 'CO_15', 'REGION', '15', 'Guainia', 'CO', '', '', '1'),
(5092, 'CO_14', 'REGION', '14', 'Guaviare', 'CO', '', '', '1'),
(5091, 'CO_12', 'REGION', '12', 'Cordoba', 'CO', '', '', '1'),
(5090, 'CO_11', 'REGION', '11', 'Choco', 'CO', '', '', '1'),
(5089, 'CO_10', 'REGION', '10', 'Cesar', 'CO', '', '', '1'),
(5088, 'CO_09', 'REGION', '09', 'Cauca', 'CO', '', '', '1'),
(5087, 'CO_08', 'REGION', '08', 'Caqueta', 'CO', '', '', '1'),
(5086, 'CO_07', 'REGION', '07', 'Caldas Department', 'CO', '', '', '1'),
(5085, 'CO_06', 'REGION', '06', 'Boyaca Department', 'CO', '', '', '1'),
(5084, 'CO_05', 'REGION', '05', 'Bolivar Department', 'CO', '', '', '1'),
(5083, 'CO_04', 'REGION', '04', 'Atlantico', 'CO', '', '', '1'),
(5082, 'CO_03', 'REGION', '03', 'Arauca', 'CO', '', '', '1'),
(5081, 'CO_02', 'REGION', '02', 'Antioquia', 'CO', '', '', '1'),
(5080, 'CO_01', 'REGION', '01', 'Amazonas', 'CO', '', '', '1'),
(5079, 'CN_33', 'REGION', '33', 'Chongqing', 'CN', '', '', '1'),
(5078, 'CN_32', 'REGION', '32', 'Sichuan', 'CN', '', '', '1'),
(5077, 'CN_31', 'REGION', '31', 'Hainan', 'CN', '', '', '1'),
(5076, 'CN_30', 'REGION', '30', 'Guangdong', 'CN', '', '', '1'),
(5075, 'CN_29', 'REGION', '29', 'Yunnan', 'CN', '', '', '1'),
(5074, 'CN_28', 'REGION', '28', 'Tianjin', 'CN', '', '', '1'),
(5073, 'CN_26', 'REGION', '26', 'Shaanxi', 'CN', '', '', '1'),
(5072, 'CN_25', 'REGION', '25', 'Shandong', 'CN', '', '', '1'),
(5071, 'CN_24', 'REGION', '24', 'Shanxi', 'CN', '', '', '1'),
(5070, 'CN_23', 'REGION', '23', 'Shanghai', 'CN', '', '', '1'),
(5069, 'CN_22', 'REGION', '22', 'Beijing', 'CN', '', '', '1'),
(5068, 'CN_21', 'REGION', '21', 'Ningxia', 'CN', '', '', '1'),
(5067, 'CN_20', 'REGION', '20', 'Nei Mongol', 'CN', '', '', '1'),
(5066, 'CN_19', 'REGION', '19', 'Liaoning', 'CN', '', '', '1'),
(5065, 'CN_18', 'REGION', '18', 'Guizhou', 'CN', '', '', '1'),
(5064, 'CN_16', 'REGION', '16', 'Guangxi', 'CN', '', '', '1'),
(5063, 'CN_15', 'REGION', '15', 'Gansu', 'CN', '', '', '1'),
(5062, 'CN_14', 'REGION', '14', 'Xizang', 'CN', '', '', '1'),
(5061, 'CN_13', 'REGION', '13', 'Xinjiang', 'CN', '', '', '1'),
(5060, 'CN_12', 'REGION', '12', 'Hubei', 'CN', '', '', '1'),
(5059, 'CN_11', 'REGION', '11', 'Hunan', 'CN', '', '', '1'),
(5058, 'CN_10', 'REGION', '10', 'Hebei', 'CN', '', '', '1'),
(5057, 'CN_09', 'REGION', '09', 'Henan', 'CN', '', '', '1'),
(5056, 'CN_08', 'REGION', '08', 'Heilongjiang', 'CN', '', '', '1'),
(5055, 'CN_07', 'REGION', '07', 'Fujian', 'CN', '', '', '1'),
(5054, 'CN_06', 'REGION', '06', 'Qinghai', 'CN', '', '', '1'),
(5053, 'CN_05', 'REGION', '05', 'Jilin', 'CN', '', '', '1'),
(5052, 'CN_04', 'REGION', '04', 'Jiangsu', 'CN', '', '', '1'),
(5051, 'CN_03', 'REGION', '03', 'Jiangxi', 'CN', '', '', '1'),
(5050, 'CN_02', 'REGION', '02', 'Zhejiang', 'CN', '', '', '1'),
(5049, 'CN_01', 'REGION', '01', 'Anhui', 'CN', '', '', '1'),
(5048, 'CM_14', 'REGION', '14', 'Sud', 'CM', '', '', '1'),
(5047, 'CM_13', 'REGION', '13', 'Nord', 'CM', '', '', '1'),
(5046, 'CM_12', 'REGION', '12', 'Extreme-Nord', 'CM', '', '', '1'),
(5045, 'CM_11', 'REGION', '11', 'Centre', 'CM', '', '', '1'),
(5044, 'CM_10', 'REGION', '10', 'Adamaoua', 'CM', '', '', '1'),
(5043, 'CM_09', 'REGION', '09', 'Sud-Ouest', 'CM', '', '', '1'),
(5042, 'CM_08', 'REGION', '08', 'Ouest', 'CM', '', '', '1'),
(5041, 'CM_07', 'REGION', '07', 'Nord-Ouest', 'CM', '', '', '1'),
(5040, 'CM_05', 'REGION', '05', 'Littoral', 'CM', '', '', '1'),
(5039, 'CM_04', 'REGION', '04', 'Est', 'CM', '', '', '1'),
(5038, 'CL_13', 'REGION', '13', 'Tarapaca', 'CL', '', '', '1'),
(5037, 'CL_12', 'REGION', '12', 'Region Metropolitana', 'CL', '', '', '1'),
(5036, 'CL_11', 'REGION', '11', 'Maule', 'CL', '', '', '1'),
(5035, 'CL_10', 'REGION', '10', 'Magallanes y de la Antartica Chilena', 'CL', '', '', '1'),
(5034, 'CL_09', 'REGION', '09', 'Los Lagos', 'CL', '', '', '1'),
(5033, 'CL_07', 'REGION', '07', 'Coquimbo', 'CL', '', '', '1'),
(5032, 'CL_06', 'REGION', '06', 'Bio-Bio', 'CL', '', '', '1'),
(5031, 'CL_05', 'REGION', '05', 'Atacama', 'CL', '', '', '1'),
(5030, 'CL_04', 'REGION', '04', 'Araucania', 'CL', '', '', '1'),
(5029, 'CL_03', 'REGION', '03', 'Antofagasta', 'CL', '', '', '1'),
(5028, 'CL_02', 'REGION', '02', 'Aisen del General Carlos Ibanez del Campo', 'CL', '', '', '1'),
(5027, 'CL_01', 'REGION', '01', 'Valparaiso', 'CL', '', '', '1'),
(5026, 'CI_92', 'REGION', '92', 'Zanzan', 'CI', '', '', '1'),
(5025, 'CI_91', 'REGION', '91', 'Worodougou', 'CI', '', '', '1'),
(5024, 'CI_90', 'REGION', '90', 'Vallee du Bandama', 'CI', '', '', '1'),
(5023, 'CI_89', 'REGION', '89', 'Sud-Comoe', 'CI', '', '', '1'),
(5022, 'CI_88', 'REGION', '88', 'Sud-Bandama', 'CI', '', '', '1'),
(5021, 'CI_87', 'REGION', '87', 'Savanes', 'CI', '', '', '1'),
(5020, 'CI_85', 'REGION', '85', 'Moyen-Comoe', 'CI', '', '', '1'),
(5019, 'CI_84', 'REGION', '84', 'Moyen-Cavally', 'CI', '', '', '1'),
(5018, 'CI_83', 'REGION', '83', 'Marahoue', 'CI', '', '', '1'),
(5017, 'CI_82', 'REGION', '82', 'Lagunes', 'CI', '', '', '1'),
(5016, 'CI_81', 'REGION', '81', 'Lacs', 'CI', '', '', '1'),
(5015, 'CI_80', 'REGION', '80', 'Haut-Sassandra', 'CI', '', '', '1'),
(5014, 'CI_79', 'REGION', '79', 'Fromager', 'CI', '', '', '1'),
(5013, 'CI_78', 'REGION', '78', 'Dix-Huit Montagnes', 'CI', '', '', '1'),
(5012, 'CI_77', 'REGION', '77', 'Denguele', 'CI', '', '', '1'),
(5011, 'CI_76', 'REGION', '76', 'Bas-Sassandra', 'CI', '', '', '1'),
(5010, 'CI_75', 'REGION', '75', 'Bafing', 'CI', '', '', '1'),
(5009, 'CI_74', 'REGION', '74', 'Agneby', 'CI', '', '', '1'),
(5008, 'CI_61', 'REGION', '61', 'Abidjan', 'CI', '', '', '1'),
(5007, 'CI_51', 'REGION', '51', 'Sassandra', 'CI', '', '', '1'),
(5006, 'CI_06', 'REGION', '06', 'Biobio', 'CI', '', '', '1'),
(5005, 'CI_05', 'REGION', '05', 'Atacama', 'CI', '', '', '1'),
(5004, 'CH_26', 'REGION', '26', 'Jura', 'CH', '', '', '1'),
(5003, 'CH_25', 'REGION', '25', 'Zurich', 'CH', '', '', '1'),
(5002, 'CH_24', 'REGION', '24', 'Zug', 'CH', '', '', '1'),
(5001, 'CH_23', 'REGION', '23', 'Vaud', 'CH', '', '', '1'),
(5000, 'CH_22', 'REGION', '22', 'Valais', 'CH', '', '', '1'),
(4999, 'CH_21', 'REGION', '21', 'Uri', 'CH', '', '', '1'),
(4998, 'CH_20', 'REGION', '20', 'Ticino', 'CH', '', '', '1'),
(4997, 'CH_19', 'REGION', '19', 'Thurgau', 'CH', '', '', '1'),
(4996, 'CH_18', 'REGION', '18', 'Solothurn', 'CH', '', '', '1'),
(4995, 'CH_17', 'REGION', '17', 'Schwyz', 'CH', '', '', '1'),
(4994, 'CH_16', 'REGION', '16', 'Schaffhausen', 'CH', '', '', '1'),
(4993, 'CH_15', 'REGION', '15', 'Sankt Gallen', 'CH', '', '', '1'),
(4992, 'CH_14', 'REGION', '14', 'Obwalden', 'CH', '', '', '1'),
(4991, 'CH_13', 'REGION', '13', 'Nidwalden', 'CH', '', '', '1'),
(4990, 'CH_12', 'REGION', '12', 'Neuchatel', 'CH', '', '', '1'),
(4989, 'CH_11', 'REGION', '11', 'Luzern', 'CH', '', '', '1'),
(4988, 'CH_10', 'REGION', '10', 'Inner-Rhoden', 'CH', '', '', '1'),
(4987, 'CH_09', 'REGION', '09', 'Graubunden', 'CH', '', '', '1'),
(4986, 'CH_08', 'REGION', '08', 'Glarus', 'CH', '', '', '1'),
(4985, 'CH_07', 'REGION', '07', 'Geneve', 'CH', '', '', '1'),
(4984, 'CH_06', 'REGION', '06', 'Fribourg', 'CH', '', '', '1'),
(4983, 'CH_05', 'REGION', '05', 'Bern', 'CH', '', '', '1'),
(4982, 'CH_04', 'REGION', '04', 'Basel-Stadt', 'CH', '', '', '1'),
(4981, 'CH_03', 'REGION', '03', 'Basel-Landschaft', 'CH', '', '', '1'),
(4980, 'CH_02', 'REGION', '02', 'Ausser-Rhoden', 'CH', '', '', '1'),
(4979, 'CH_01', 'REGION', '01', 'Aargau', 'CH', '', '', '1'),
(4978, 'CG_12', 'REGION', '12', 'Brazzaville', 'CG', '', '', '1'),
(4977, 'CG_11', 'REGION', '11', 'Pool', 'CG', '', '', '1'),
(4976, 'CG_10', 'REGION', '10', 'Sangha', 'CG', '', '', '1'),
(4975, 'CG_08', 'REGION', '08', 'Plateaux', 'CG', '', '', '1'),
(4974, 'CG_07', 'REGION', '07', 'Niari', 'CG', '', '', '1'),
(4973, 'CG_06', 'REGION', '06', 'Likouala', 'CG', '', '', '1'),
(4972, 'CG_05', 'REGION', '05', 'Lekoumou', 'CG', '', '', '1'),
(4971, 'CG_04', 'REGION', '04', 'Kouilou', 'CG', '', '', '1'),
(4970, 'CG_03', 'REGION', '03', 'Cuvette', 'CG', '', '', '1'),
(4969, 'CG_01', 'REGION', '01', 'Bouenza', 'CG', '', '', '1'),
(4968, 'CF_18', 'REGION', '18', 'Bangui', 'CF', '', '', '1'),
(4967, 'CF_17', 'REGION', '17', 'Ombella-Mpoko', 'CF', '', '', '1'),
(4966, 'CF_16', 'REGION', '16', 'Sangha-Mbaere', 'CF', '', '', '1'),
(4965, 'CF_15', 'REGION', '15', 'Nana-Grebizi', 'CF', '', '', '1'),
(4964, 'CF_14', 'REGION', '14', 'Cuvette-Ouest', 'CF', '', '', '1'),
(4963, 'CF_13', 'REGION', '13', 'Ouham-Pende', 'CF', '', '', '1'),
(4962, 'CF_12', 'REGION', '12', 'Ouham', 'CF', '', '', '1'),
(4961, 'CF_11', 'REGION', '11', 'Ouaka', 'CF', '', '', '1'),
(4960, 'CF_09', 'REGION', '09', 'Nana-Mambere', 'CF', '', '', '1'),
(4959, 'CF_08', 'REGION', '08', 'Mbomou', 'CF', '', '', '1'),
(4958, 'CF_07', 'REGION', '07', 'Lobaye', 'CF', '', '', '1'),
(4957, 'CF_06', 'REGION', '06', 'Kemo', 'CF', '', '', '1'),
(4956, 'CF_05', 'REGION', '05', 'Haut-Mbomou', 'CF', '', '', '1'),
(4955, 'CF_04', 'REGION', '04', 'Mambere-Kadei', 'CF', '', '', '1'),
(4954, 'CF_03', 'REGION', '03', 'Haute-Kotto', 'CF', '', '', '1'),
(4953, 'CF_02', 'REGION', '02', 'Basse-Kotto', 'CF', '', '', '1'),
(4952, 'CF_01', 'REGION', '01', 'Bamingui-Bangoran', 'CF', '', '', '1'),
(4951, 'CD_13', 'REGION', '13', 'Cuvette', 'CD', '', '', '1'),
(4950, 'CD_12', 'REGION', '12', 'Sud-Kivu', 'CD', '', '', '1'),
(4949, 'CD_11', 'REGION', '11', 'Nord-Kivu', 'CD', '', '', '1'),
(4948, 'CD_10', 'REGION', '10', 'Maniema', 'CD', '', '', '1'),
(4947, 'CD_09', 'REGION', '09', 'Orientale', 'CD', '', '', '1'),
(4946, 'CD_08', 'REGION', '08', 'Bas-Congo', 'CD', '', '', '1'),
(4945, 'CD_07', 'REGION', '07', 'Kivu', 'CD', '', '', '1'),
(4944, 'CD_06', 'REGION', '06', 'Kinshasa', 'CD', '', '', '1'),
(4943, 'CD_05', 'REGION', '05', 'Katanga', 'CD', '', '', '1'),
(4942, 'CD_04', 'REGION', '04', 'Kasai-Oriental', 'CD', '', '', '1'),
(4941, 'CD_02', 'REGION', '02', 'Equateur', 'CD', '', '', '1'),
(4940, 'CD_01', 'REGION', '01', 'Bandundu', 'CD', '', '', '1'),
(4939, 'CA_YT', 'REGION', 'YT', 'Yukon Territory', 'CA', '', '', '1'),
(4938, 'CA_SK', 'REGION', 'SK', 'Saskatchewan', 'CA', '', '', '1'),
(4937, 'CA_QC', 'REGION', 'QC', 'Quebec', 'CA', '', '', '1'),
(4936, 'CA_PE', 'REGION', 'PE', 'Prince Edward Island', 'CA', '', '', '1'),
(4935, 'CA_ON', 'REGION', 'ON', 'Ontario', 'CA', '', '', '1'),
(4934, 'CA_NU', 'REGION', 'NU', 'Nunavut', 'CA', '', '', '1'),
(4933, 'CA_NT', 'REGION', 'NT', 'Northwest Territories', 'CA', '', '', '1'),
(4932, 'CA_NS', 'REGION', 'NS', 'Nova Scotia', 'CA', '', '', '1'),
(4931, 'CA_NL', 'REGION', 'NL', 'Newfoundland', 'CA', '', '', '1'),
(4930, 'CA_NB', 'REGION', 'NB', 'New Brunswick', 'CA', '', '', '1'),
(4929, 'CA_MB', 'REGION', 'MB', 'Manitoba', 'CA', '', '', '1'),
(4928, 'CA_BC', 'REGION', 'BC', 'British Columbia', 'CA', '', '', '1'),
(4927, 'CA_AB', 'REGION', 'AB', 'Alberta', 'CA', '', '', '1'),
(4926, 'BZ_06', 'REGION', '06', 'Toledo', 'BZ', '', '', '1'),
(4925, 'BZ_05', 'REGION', '05', 'Stann Creek', 'BZ', '', '', '1'),
(4924, 'BZ_04', 'REGION', '04', 'Orange Walk', 'BZ', '', '', '1'),
(4923, 'BZ_03', 'REGION', '03', 'Corozal', 'BZ', '', '', '1'),
(4922, 'BZ_02', 'REGION', '02', 'Cayo', 'BZ', '', '', '1'),
(4921, 'BZ_01', 'REGION', '01', 'Belize', 'BZ', '', '', '1'),
(4920, 'BY_04', 'REGION', '04', 'Minsk', 'BY', '', '', '1'),
(4919, 'BW_11', 'REGION', '11', 'North-West', 'BW', '', '', '1'),
(4918, 'BW_10', 'REGION', '10', 'Southern', 'BW', '', '', '1'),
(4917, 'BW_09', 'REGION', '09', 'South-East', 'BW', '', '', '1'),
(4916, 'BW_08', 'REGION', '08', 'North-East', 'BW', '', '', '1'),
(4915, 'BW_06', 'REGION', '06', 'Kweneng', 'BW', '', '', '1'),
(4914, 'BW_05', 'REGION', '05', 'Kgatleng', 'BW', '', '', '1'),
(4913, 'BW_04', 'REGION', '04', 'Kgalagadi', 'BW', '', '', '1'),
(4912, 'BW_03', 'REGION', '03', 'Ghanzi', 'BW', '', '', '1'),
(4911, 'BW_01', 'REGION', '01', 'Central', 'BW', '', '', '1'),
(4910, 'BT_22', 'REGION', '22', 'Wangdi Phodrang', 'BT', '', '', '1'),
(4909, 'BT_21', 'REGION', '21', 'Tongsa', 'BT', '', '', '1'),
(4908, 'BT_20', 'REGION', '20', 'Thimphu', 'BT', '', '', '1'),
(4907, 'BT_19', 'REGION', '19', 'Tashigang', 'BT', '', '', '1'),
(4906, 'BT_18', 'REGION', '18', 'Shemgang', 'BT', '', '', '1'),
(4905, 'BT_17', 'REGION', '17', 'Samdrup', 'BT', '', '', '1'),
(4904, 'BT_16', 'REGION', '16', 'Samchi', 'BT', '', '', '1'),
(4903, 'BT_15', 'REGION', '15', 'Punakha', 'BT', '', '', '1'),
(4902, 'BT_14', 'REGION', '14', 'Pemagatsel', 'BT', '', '', '1'),
(4901, 'BT_13', 'REGION', '13', 'Paro', 'BT', '', '', '1'),
(4900, 'BT_12', 'REGION', '12', 'Mongar', 'BT', '', '', '1'),
(4899, 'BT_11', 'REGION', '11', 'Lhuntshi', 'BT', '', '', '1'),
(4898, 'BT_10', 'REGION', '10', 'Ha', 'BT', '', '', '1'),
(4897, 'BT_09', 'REGION', '09', 'Geylegphug', 'BT', '', '', '1'),
(4896, 'BT_08', 'REGION', '08', 'Daga', 'BT', '', '', '1'),
(4895, 'BT_07', 'REGION', '07', 'Chirang', 'BT', '', '', '1'),
(4894, 'BT_06', 'REGION', '06', 'Chhukha', 'BT', '', '', '1'),
(4893, 'BT_05', 'REGION', '05', 'Bumthang', 'BT', '', '', '1'),
(4892, 'BS_35', 'REGION', '35', 'San Salvador and Rum Cay', 'BS', '', '', '1'),
(4891, 'BS_34', 'REGION', '34', 'Sandy Point', 'BS', '', '', '1'),
(4890, 'BS_33', 'REGION', '33', 'Rock Sound', 'BS', '', '', '1');", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(4889, 'BS_32', 'REGION', '32', 'Nichollstown and Berry Islands', 'BS', '', '', '1'),
(4888, 'BS_31', 'REGION', '31', 'Marsh Harbour', 'BS', '', '', '1'),
(4887, 'BS_30', 'REGION', '30', 'Kemps Bay', 'BS', '', '', '1'),
(4886, 'BS_29', 'REGION', '29', 'High Rock', 'BS', '', '', '1'),
(4885, 'BS_28', 'REGION', '28', 'Green Turtle Cay', 'BS', '', '', '1'),
(4884, 'BS_26', 'REGION', '26', 'Fresh Creek', 'BS', '', '', '1'),
(4883, 'BS_25', 'REGION', '25', 'Freeport', 'BS', '', '', '1'),
(4882, 'BS_24', 'REGION', '24', 'Acklins and Crooked Islands', 'BS', '', '', '1'),
(4881, 'BS_23', 'REGION', '23', 'New Providence', 'BS', '', '', '1'),
(4880, 'BS_22', 'REGION', '22', 'Harbour Island', 'BS', '', '', '1'),
(4879, 'BS_18', 'REGION', '18', 'Ragged Island', 'BS', '', '', '1'),
(4878, 'BS_16', 'REGION', '16', 'Mayaguana', 'BS', '', '', '1'),
(4877, 'BS_15', 'REGION', '15', 'Long Island', 'BS', '', '', '1'),
(4876, 'BS_13', 'REGION', '13', 'Inagua', 'BS', '', '', '1'),
(4875, 'BS_10', 'REGION', '10', 'Exuma', 'BS', '', '', '1'),
(4874, 'BS_06', 'REGION', '06', 'Cat Island', 'BS', '', '', '1'),
(4873, 'BS_05', 'REGION', '05', 'Bimini', 'BS', '', '', '1'),
(4872, 'BR_31', 'REGION', '31', 'Tocantins', 'BR', '', '', '1'),
(4871, 'BR_30', 'REGION', '30', 'Pernambuco', 'BR', '', '', '1'),
(4870, 'BR_29', 'REGION', '29', 'Goias', 'BR', '', '', '1'),
(4869, 'BR_28', 'REGION', '28', 'Sergipe', 'BR', '', '', '1'),
(4868, 'BR_27', 'REGION', '27', 'Sao Paulo', 'BR', '', '', '1'),
(4867, 'BR_26', 'REGION', '26', 'Santa Catarina', 'BR', '', '', '1'),
(4866, 'BR_25', 'REGION', '25', 'Roraima', 'BR', '', '', '1'),
(4865, 'BR_24', 'REGION', '24', 'Rondonia', 'BR', '', '', '1'),
(4864, 'BR_23', 'REGION', '23', 'Rio Grande do Sul', 'BR', '', '', '1'),
(4863, 'BR_22', 'REGION', '22', 'Rio Grande do Norte', 'BR', '', '', '1'),
(4862, 'BR_21', 'REGION', '21', 'Rio de Janeiro', 'BR', '', '', '1'),
(4861, 'BR_20', 'REGION', '20', 'Piaui', 'BR', '', '', '1'),
(4860, 'BR_18', 'REGION', '18', 'Parana', 'BR', '', '', '1'),
(4859, 'BR_17', 'REGION', '17', 'Paraiba', 'BR', '', '', '1'),
(4858, 'BR_16', 'REGION', '16', 'Para', 'BR', '', '', '1'),
(4857, 'BR_15', 'REGION', '15', 'Minas Gerais', 'BR', '', '', '1'),
(4856, 'BR_14', 'REGION', '14', 'Mato Grosso', 'BR', '', '', '1'),
(4855, 'BR_13', 'REGION', '13', 'Maranhao', 'BR', '', '', '1'),
(4854, 'BR_11', 'REGION', '11', 'Mato Grosso do Sul', 'BR', '', '', '1'),
(4853, 'BR_08', 'REGION', '08', 'Espirito Santo', 'BR', '', '', '1'),
(4852, 'BR_07', 'REGION', '07', 'Distrito Federal', 'BR', '', '', '1'),
(4851, 'BR_06', 'REGION', '06', 'Ceara', 'BR', '', '', '1'),
(4850, 'BR_05', 'REGION', '05', 'Bahia', 'BR', '', '', '1'),
(4849, 'BR_04', 'REGION', '04', 'Amazonas', 'BR', '', '', '1'),
(4848, 'BR_03', 'REGION', '03', 'Amapa', 'BR', '', '', '1'),
(4847, 'BR_02', 'REGION', '02', 'Alagoas', 'BR', '', '', '1'),
(4846, 'BR_01', 'REGION', '01', 'Acre', 'BR', '', '', '1'),
(4845, 'BO_09', 'REGION', '09', 'Tarija', 'BO', '', '', '1'),
(4844, 'BO_08', 'REGION', '08', 'Santa Cruz', 'BO', '', '', '1'),
(4843, 'BO_07', 'REGION', '07', 'Potosi', 'BO', '', '', '1'),
(4842, 'BO_06', 'REGION', '06', 'Pando', 'BO', '', '', '1'),
(4841, 'BO_05', 'REGION', '05', 'Oruro', 'BO', '', '', '1'),
(4840, 'BO_04', 'REGION', '04', 'La Paz', 'BO', '', '', '1'),
(4839, 'BO_03', 'REGION', '03', 'El Beni', 'BO', '', '', '1'),
(4838, 'BO_02', 'REGION', '02', 'Cochabamba', 'BO', '', '', '1'),
(4837, 'BO_01', 'REGION', '01', 'Chuquisaca', 'BO', '', '', '1'),
(4836, 'BN_18', 'REGION', '18', 'Zou', 'BN', '', '', '1'),
(4835, 'BN_17', 'REGION', '17', 'Plateau', 'BN', '', '', '1'),
(4834, 'BN_16', 'REGION', '16', 'Oueme', 'BN', '', '', '1'),
(4833, 'BN_15', 'REGION', '15', 'Tutong', 'BN', '', '', '1'),
(4832, 'BN_14', 'REGION', '14', 'Littoral', 'BN', '', '', '1'),
(4831, 'BN_13', 'REGION', '13', 'Donga', 'BN', '', '', '1'),
(4830, 'BN_12', 'REGION', '12', 'Kouffo', 'BN', '', '', '1'),
(4829, 'BN_11', 'REGION', '11', 'Collines', 'BN', '', '', '1'),
(4828, 'BN_10', 'REGION', '10', 'Temburong', 'BN', '', '', '1'),
(4827, 'BN_09', 'REGION', '09', 'Brunei and Muara', 'BN', '', '', '1'),
(4826, 'BN_08', 'REGION', '08', 'Belait', 'BN', '', '', '1'),
(4825, 'BN_07', 'REGION', '07', 'Alibori', 'BN', '', '', '1'),
(4824, 'BM_11', 'REGION', '11', 'Warwick', 'BM', '', '', '1'),
(4823, 'BM_10', 'REGION', '10', 'Southampton', 'BM', '', '', '1'),
(4822, 'BM_09', 'REGION', '09', 'Smiths', 'BM', '', '', '1'),
(4821, 'BM_08', 'REGION', '08', 'Sandys', 'BM', '', '', '1'),
(4820, 'BM_06', 'REGION', '06', 'Saint George', 'BM', '', '', '1'),
(4819, 'BM_05', 'REGION', '05', 'Pembroke', 'BM', '', '', '1'),
(4818, 'BM_04', 'REGION', '04', 'Paget', 'BM', '', '', '1'),
(4817, 'BM_03', 'REGION', '03', 'Hamilton', 'BM', '', '', '1'),
(4816, 'BM_02', 'REGION', '02', 'Hamilton', 'BM', '', '', '1'),
(4815, 'BM_01', 'REGION', '01', 'Devonshire', 'BM', '', '', '1'),
(4814, 'BJ_18', 'REGION', '18', 'Zou', 'BJ', '', '', '1'),
(4813, 'BJ_17', 'REGION', '17', 'Plateau', 'BJ', '', '', '1'),
(4812, 'BJ_16', 'REGION', '16', 'Oueme', 'BJ', '', '', '1'),
(4811, 'BJ_15', 'REGION', '15', 'Mono', 'BJ', '', '', '1'),
(4810, 'BJ_14', 'REGION', '14', 'Littoral', 'BJ', '', '', '1'),
(4809, 'BJ_13', 'REGION', '13', 'Donga', 'BJ', '', '', '1'),
(4808, 'BJ_12', 'REGION', '12', 'Kouffo', 'BJ', '', '', '1'),
(4807, 'BJ_11', 'REGION', '11', 'Collines', 'BJ', '', '', '1'),
(4806, 'BJ_10', 'REGION', '10', 'Borgou', 'BJ', '', '', '1'),
(4805, 'BJ_09', 'REGION', '09', 'Atlanyique', 'BJ', '', '', '1'),
(4804, 'BJ_08', 'REGION', '08', 'Atakora', 'BJ', '', '', '1'),
(4803, 'BJ_07', 'REGION', '07', 'Alibori', 'BJ', '', '', '1'),
(4802, 'BJ_06', 'REGION', '06', 'Zou', 'BJ', '', '', '1'),
(4801, 'BJ_05', 'REGION', '05', 'Oueme', 'BJ', '', '', '1'),
(4800, 'BJ_04', 'REGION', '04', 'Mono', 'BJ', '', '', '1'),
(4799, 'BJ_03', 'REGION', '03', 'Borgou', 'BJ', '', '', '1'),
(4798, 'BJ_02', 'REGION', '02', 'Atlantique', 'BJ', '', '', '1'),
(4797, 'BJ_01', 'REGION', '01', 'Atakora', 'BJ', '', '', '1'),
(4796, 'BI_23', 'REGION', '23', 'Mwaro', 'BI', '', '', '1'),
(4795, 'BI_22', 'REGION', '22', 'Muramvya', 'BI', '', '', '1'),
(4794, 'BI_21', 'REGION', '21', 'Ruyigi', 'BI', '', '', '1'),
(4793, 'BI_20', 'REGION', '20', 'Rutana', 'BI', '', '', '1'),
(4792, 'BI_19', 'REGION', '19', 'Ngozi', 'BI', '', '', '1'),
(4791, 'BI_18', 'REGION', '18', 'Muyinga', 'BI', '', '', '1'),
(4790, 'BI_17', 'REGION', '17', 'Makamba', 'BI', '', '', '1'),
(4789, 'BI_16', 'REGION', '16', 'Kirundo', 'BI', '', '', '1'),
(4788, 'BI_15', 'REGION', '15', 'Kayanza', 'BI', '', '', '1'),
(4787, 'BI_14', 'REGION', '14', 'Karuzi', 'BI', '', '', '1'),
(4786, 'BI_13', 'REGION', '13', 'Gitega', 'BI', '', '', '1'),
(4785, 'BI_12', 'REGION', '12', 'Cibitoke', 'BI', '', '', '1'),
(4784, 'BI_11', 'REGION', '11', 'Cankuzo', 'BI', '', '', '1'),
(4783, 'BI_10', 'REGION', '10', 'Bururi', 'BI', '', '', '1'),
(4782, 'BI_09', 'REGION', '09', 'Bubanza', 'BI', '', '', '1'),
(4781, 'BI_02', 'REGION', '02', 'Bujumbura', 'BI', '', '', '1'),
(4780, 'BH_19', 'REGION', '19', 'Al Wusta', 'BH', '', '', '1'),
(4779, 'BH_18', 'REGION', '18', 'Ash Shamaliyah', 'BH', '', '', '1'),
(4778, 'BH_17', 'REGION', '17', 'Al Janubiyah', 'BH', '', '', '1'),
(4777, 'BH_16', 'REGION', '16', 'Al Asimah', 'BH', '', '', '1'),
(4776, 'BH_15', 'REGION', '15', 'Al Muharraq', 'BH', '', '', '1'),
(4775, 'BH_14', 'REGION', '14', 'Madinat Hamad', 'BH', '', '', '1'),
(4774, 'BH_13', 'REGION', '13', 'Ar Rifa', 'BH', '', '', '1'),
(4773, 'BH_12', 'REGION', '12', 'Madinat', 'BH', '', '', '1'),
(4772, 'BH_11', 'REGION', '11', 'Al Mintaqah al Wusta', 'BH', '', '', '1'),
(4771, 'BH_10', 'REGION', '10', 'Al Mintaqah ash Shamaliyah', 'BH', '', '', '1'),
(4770, 'BH_09', 'REGION', '09', 'Mintaqat Juzur Hawar', 'BH', '', '', '1'),
(4769, 'BH_08', 'REGION', '08', 'Al Mintaqah al Gharbiyah', 'BH', '', '', '1'),
(4768, 'BH_06', 'REGION', '06', 'Sitrah', 'BH', '', '', '1'),
(4767, 'BH_05', 'REGION', '05', 'Jidd Hafs', 'BH', '', '', '1'),
(4766, 'BH_03', 'REGION', '03', 'Al Muharraq', 'BH', '', '', '1'),
(4765, 'BH_02', 'REGION', '02', 'Al Manamah', 'BH', '', '', '1'),
(4764, 'BH_01', 'REGION', '01', 'Al Hadd', 'BH', '', '', '1'),
(4763, 'BG_65', 'REGION', '65', 'Yambol', 'BG', '', '', '1'),
(4762, 'BG_64', 'REGION', '64', 'Vratsa', 'BG', '', '', '1'),
(4761, 'BG_63', 'REGION', '63', 'Vidin', 'BG', '', '', '1'),
(4760, 'BG_62', 'REGION', '62', 'Veliko Turnovo', 'BG', '', '', '1'),
(4759, 'BG_61', 'REGION', '61', 'Varna', 'BG', '', '', '1'),
(4758, 'BG_60', 'REGION', '60', 'Turgovishte', 'BG', '', '', '1'),
(4757, 'BG_59', 'REGION', '59', 'Stara Zagora', 'BG', '', '', '1'),
(4756, 'BG_58', 'REGION', '58', 'Sofiya', 'BG', '', '', '1'),
(4755, 'BG_57', 'REGION', '57', 'Smolyan', 'BG', '', '', '1'),
(4754, 'BG_56', 'REGION', '56', 'Sliven', 'BG', '', '', '1'),
(4753, 'BG_55', 'REGION', '55', 'Silistra', 'BG', '', '', '1'),
(4752, 'BG_54', 'REGION', '54', 'Shumen', 'BG', '', '', '1'),
(4751, 'BG_53', 'REGION', '53', 'Ruse', 'BG', '', '', '1'),
(4750, 'BG_52', 'REGION', '52', 'Razgrad', 'BG', '', '', '1'),
(4749, 'BG_51', 'REGION', '51', 'Plovdiv', 'BG', '', '', '1'),
(4748, 'BG_50', 'REGION', '50', 'Pleven', 'BG', '', '', '1'),
(4747, 'BG_49', 'REGION', '49', 'Pernik', 'BG', '', '', '1'),
(4746, 'BG_48', 'REGION', '48', 'Pazardzhik', 'BG', '', '', '1'),
(4745, 'BG_47', 'REGION', '47', 'Montana', 'BG', '', '', '1'),
(4744, 'BG_46', 'REGION', '46', 'Lovech', 'BG', '', '', '1'),
(4743, 'BG_45', 'REGION', '45', 'Kyustendil', 'BG', '', '', '1'),
(4742, 'BG_44', 'REGION', '44', 'Kurdzhali', 'BG', '', '', '1'),
(4741, 'BG_43', 'REGION', '43', 'Khaskovo', 'BG', '', '', '1'),
(4740, 'BG_42', 'REGION', '42', 'Grad Sofiya', 'BG', '', '', '1'),
(4739, 'BG_41', 'REGION', '41', 'Gabrovo', 'BG', '', '', '1'),
(4738, 'BG_40', 'REGION', '40', 'Dobrich', 'BG', '', '', '1'),
(4737, 'BG_39', 'REGION', '39', 'Burgas', 'BG', '', '', '1'),
(4736, 'BG_38', 'REGION', '38', 'Blagoevgrad', 'BG', '', '', '1'),
(4735, 'BG_33', 'REGION', '33', 'Mikhaylovgrad', 'BG', '', '', '1'),
(4734, 'BF_78', 'REGION', '78', 'Zondoma', 'BF', '', '', '1'),
(4733, 'BF_77', 'REGION', '77', 'Ziro', 'BF', '', '', '1'),
(4732, 'BF_76', 'REGION', '76', 'Yatenga', 'BF', '', '', '1'),
(4731, 'BF_75', 'REGION', '75', 'Yagha', 'BF', '', '', '1'),
(4730, 'BF_74', 'REGION', '74', 'Tuy', 'BF', '', '', '1'),
(4729, 'BF_73', 'REGION', '73', 'Sourou', 'BF', '', '', '1'),
(4728, 'BF_72', 'REGION', '72', 'Sissili', 'BF', '', '', '1'),
(4727, 'BF_71', 'REGION', '71', 'Seno', 'BF', '', '', '1'),
(4726, 'BF_70', 'REGION', '70', 'Sanmatenga', 'BF', '', '', '1'),
(4725, 'BF_69', 'REGION', '69', 'Poni', 'BF', '', '', '1'),
(4724, 'BF_68', 'REGION', '68', 'Oubritenga', 'BF', '', '', '1'),
(4723, 'BF_67', 'REGION', '67', 'Noumbiel', 'BF', '', '', '1'),
(4722, 'BF_66', 'REGION', '66', 'Nayala', 'BF', '', '', '1'),
(4721, 'BF_65', 'REGION', '65', 'Naouri', 'BF', '', '', '1'),
(4720, 'BF_64', 'REGION', '64', 'Namentenga', 'BF', '', '', '1'),
(4719, 'BF_63', 'REGION', '63', 'Mouhoun', 'BF', '', '', '1'),
(4718, 'BF_62', 'REGION', '62', 'Loroum', 'BF', '', '', '1'),
(4717, 'BF_61', 'REGION', '61', 'Leraba', 'BF', '', '', '1'),
(4716, 'BF_60', 'REGION', '60', 'Kourweogo', 'BF', '', '', '1'),
(4715, 'BF_59', 'REGION', '59', 'Koulpelogo', 'BF', '', '', '1'),
(4714, 'BF_58', 'REGION', '58', 'Kossi', 'BF', '', '', '1'),
(4713, 'BF_57', 'REGION', '57', 'Kompienga', 'BF', '', '', '1'),
(4712, 'BF_56', 'REGION', '56', 'Komondjari', 'BF', '', '', '1'),
(4711, 'BF_55', 'REGION', '55', 'Komoe', 'BF', '', '', '1'),
(4710, 'BF_54', 'REGION', '54', 'Kenedougou', 'BF', '', '', '1'),
(4709, 'BF_53', 'REGION', '53', 'Kadiogo', 'BF', '', '', '1'),
(4708, 'BF_52', 'REGION', '52', 'Ioba', 'BF', '', '', '1'),
(4707, 'BF_51', 'REGION', '51', 'Houet', 'BF', '', '', '1'),
(4706, 'BF_50', 'REGION', '50', 'Gourma', 'BF', '', '', '1'),
(4705, 'BF_49', 'REGION', '49', 'Boulgou', 'BF', '', '', '1'),
(4704, 'BF_48', 'REGION', '48', 'Bougouriba', 'BF', '', '', '1'),
(4703, 'BF_47', 'REGION', '47', 'Bazega', 'BF', '', '', '1'),
(4702, 'BF_46', 'REGION', '46', 'Banwa', 'BF', '', '', '1'),
(4701, 'BF_45', 'REGION', '45', 'Bale', 'BF', '', '', '1'),
(4700, 'BF_44', 'REGION', '44', 'Zoundweogo', 'BF', '', '', '1'),
(4699, 'BF_42', 'REGION', '42', 'Tapoa', 'BF', '', '', '1'),
(4698, 'BF_40', 'REGION', '40', 'Soum', 'BF', '', '', '1'),
(4697, 'BF_36', 'REGION', '36', 'Sanguie', 'BF', '', '', '1'),
(4696, 'BF_34', 'REGION', '34', 'Passore', 'BF', '', '', '1'),
(4695, 'BF_33', 'REGION', '33', 'Oudalan', 'BF', '', '', '1'),
(4694, 'BF_28', 'REGION', '28', 'Kouritenga', 'BF', '', '', '1'),
(4693, 'BF_21', 'REGION', '21', 'Gnagna', 'BF', '', '', '1'),
(4692, 'BF_20', 'REGION', '20', 'Ganzourgou', 'BF', '', '', '1'),
(4691, 'BF_19', 'REGION', '19', 'Boulkiemde', 'BF', '', '', '1'),
(4690, 'BF_15', 'REGION', '15', 'Bam', 'BF', '', '', '1'),
(4689, 'BE_12', 'REGION', '12', 'Vlaams-Brabant', 'BE', '', '', '1'),
(4688, 'BE_11', 'REGION', '11', 'Brussels Hoofdstedelijk Gewest', 'BE', '', '', '1'),
(4687, 'BE_10', 'REGION', '10', 'Brabant Wallon', 'BE', '', '', '1'),
(4686, 'BE_09', 'REGION', '09', 'West-Vlaanderen', 'BE', '', '', '1'),
(4685, 'BE_08', 'REGION', '08', 'Oost-Vlaanderen', 'BE', '', '', '1'),
(4684, 'BE_07', 'REGION', '07', 'Namur', 'BE', '', '', '1'),
(4683, 'BE_06', 'REGION', '06', 'Luxembourg', 'BE', '', '', '1'),
(4682, 'BE_05', 'REGION', '05', 'Limburg', 'BE', '', '', '1'),
(4681, 'BE_04', 'REGION', '04', 'Liege', 'BE', '', '', '1'),
(4680, 'BE_03', 'REGION', '03', 'Hainaut', 'BE', '', '', '1'),
(4679, 'BE_02', 'REGION', '02', 'Brabant', 'BE', '', '', '1'),
(4678, 'BE_01', 'REGION', '01', 'Antwerpen', 'BE', '', '', '1'),
(4677, 'BD_86', 'REGION', '86', 'Sylhet', 'BD', '', '', '1'),
(4676, 'BD_85', 'REGION', '85', 'Barisal', 'BD', '', '', '1'),
(4675, 'BD_84', 'REGION', '84', 'Chittagong', 'BD', '', '', '1'),
(4674, 'BD_83', 'REGION', '83', 'Rajshahi', 'BD', '', '', '1'),
(4673, 'BD_82', 'REGION', '82', 'Khulna', 'BD', '', '', '1'),
(4672, 'BD_81', 'REGION', '81', 'Dhaka', 'BD', '', '', '1'),
(4671, 'BD_79', 'REGION', '79', 'Thakurgaon', 'BD', '', '', '1'),
(4670, 'BD_78', 'REGION', '78', 'Tangail', 'BD', '', '', '1'),
(4669, 'BD_77', 'REGION', '77', 'Sylhet', 'BD', '', '', '1'),
(4668, 'BD_76', 'REGION', '76', 'Sunamganj', 'BD', '', '', '1'),
(4667, 'BD_75', 'REGION', '75', 'Sirajganj', 'BD', '', '', '1'),
(4666, 'BD_74', 'REGION', '74', 'Sherpur', 'BD', '', '', '1'),
(4665, 'BD_73', 'REGION', '73', 'Shariyatpur', 'BD', '', '', '1'),
(4664, 'BD_72', 'REGION', '72', 'Satkhira', 'BD', '', '', '1'),
(4663, 'BD_71', 'REGION', '71', 'Rangpur', 'BD', '', '', '1'),
(4662, 'BD_70', 'REGION', '70', 'Rajshahi', 'BD', '', '', '1'),
(4661, 'BD_69', 'REGION', '69', 'Rajbari', 'BD', '', '', '1'),
(4660, 'BD_68', 'REGION', '68', 'Pirojpur', 'BD', '', '', '1'),
(4659, 'BD_67', 'REGION', '67', 'Parbattya Chattagram', 'BD', '', '', '1'),
(4658, 'BD_66', 'REGION', '66', 'Panchagar', 'BD', '', '', '1'),
(4657, 'BD_65', 'REGION', '65', 'Pabna', 'BD', '', '', '1'),
(4656, 'BD_64', 'REGION', '64', 'Nilphamari', 'BD', '', '', '1'),
(4655, 'BD_63', 'REGION', '63', 'Netrakona', 'BD', '', '', '1'),
(4654, 'BD_62', 'REGION', '62', 'Nator', 'BD', '', '', '1'),
(4653, 'BD_61', 'REGION', '61', 'Narsingdi', 'BD', '', '', '1'),
(4652, 'BD_60', 'REGION', '60', 'Narayanganj', 'BD', '', '', '1'),
(4651, 'BD_59', 'REGION', '59', 'Narail', 'BD', '', '', '1'),
(4650, 'BD_58', 'REGION', '58', 'Naogaon', 'BD', '', '', '1'),
(4649, 'BD_57', 'REGION', '57', 'Munshiganj', 'BD', '', '', '1'),
(4648, 'BD_56', 'REGION', '56', 'Moulavibazar', 'BD', '', '', '1'),
(4647, 'BD_55', 'REGION', '55', 'Meherpur', 'BD', '', '', '1'),
(4646, 'BD_54', 'REGION', '54', 'Manikganj', 'BD', '', '', '1'),
(4645, 'BD_53', 'REGION', '53', 'Magura', 'BD', '', '', '1'),
(4644, 'BD_52', 'REGION', '52', 'Madaripur', 'BD', '', '', '1'),
(4643, 'BD_51', 'REGION', '51', 'Lalmonirhat', 'BD', '', '', '1'),
(4642, 'BD_50', 'REGION', '50', 'Laksmipur', 'BD', '', '', '1'),
(4641, 'BD_49', 'REGION', '49', 'Kushtia', 'BD', '', '', '1'),
(4640, 'BD_48', 'REGION', '48', 'Kurigram', 'BD', '', '', '1'),
(4639, 'BD_47', 'REGION', '47', 'Kishorganj', 'BD', '', '', '1'),
(4638, 'BD_46', 'REGION', '46', 'Khulna', 'BD', '', '', '1'),
(4637, 'BD_45', 'REGION', '45', 'Khagrachari', 'BD', '', '', '1'),
(4636, 'BD_44', 'REGION', '44', 'Jhenaidah', 'BD', '', '', '1'),
(4635, 'BD_43', 'REGION', '43', 'Jhalakati', 'BD', '', '', '1'),
(4634, 'BD_42', 'REGION', '42', 'Jessore', 'BD', '', '', '1'),
(4633, 'BD_41', 'REGION', '41', 'Jamalpur', 'BD', '', '', '1'),
(4632, 'BD_40', 'REGION', '40', 'Jaipurhat', 'BD', '', '', '1'),
(4631, 'BD_39', 'REGION', '39', 'Habiganj', 'BD', '', '', '1'),
(4630, 'BD_38', 'REGION', '38', 'Gopalganj', 'BD', '', '', '1'),
(4629, 'BD_37', 'REGION', '37', 'Gazipur', 'BD', '', '', '1'),
(4628, 'BD_36', 'REGION', '36', 'Gaibandha', 'BD', '', '', '1'),
(4627, 'BD_35', 'REGION', '35', 'Feni', 'BD', '', '', '1'),
(4626, 'BD_34', 'REGION', '34', 'Faridpur', 'BD', '', '', '1'),
(4625, 'BD_33', 'REGION', '33', 'Dinajpur', 'BD', '', '', '1'),
(4624, 'BD_32', 'REGION', '32', 'Dhaka', 'BD', '', '', '1'),
(4623, 'BD_30', 'REGION', '30', 'Chuadanga', 'BD', '', '', '1'),
(4622, 'BD_29', 'REGION', '29', 'Chattagram', 'BD', '', '', '1'),
(4621, 'BD_28', 'REGION', '28', 'Chapai Nawabganj', 'BD', '', '', '1'),
(4620, 'BD_27', 'REGION', '27', 'Chandpur', 'BD', '', '', '1'),
(4619, 'BD_26', 'REGION', '26', 'Brahmanbaria', 'BD', '', '', '1'),
(4618, 'BD_25', 'REGION', '25', 'Barguna', 'BD', '', '', '1'),
(4617, 'BD_24', 'REGION', '24', 'Bogra', 'BD', '', '', '1'),
(4616, 'BD_23', 'REGION', '23', 'Bhola', 'BD', '', '', '1'),
(4615, 'BD_22', 'REGION', '22', 'Bagerhat', 'BD', '', '', '1'),
(4614, 'BD_15', 'REGION', '15', 'Patuakhali', 'BD', '', '', '1'),
(4613, 'BD_13', 'REGION', '13', 'Noakhali', 'BD', '', '', '1'),
(4612, 'BD_12', 'REGION', '12', 'Mymensingh', 'BD', '', '', '1'),
(4611, 'BD_05', 'REGION', '05', 'Comilla', 'BD', '', '', '1'),
(4610, 'BD_04', 'REGION', '04', 'Bandarban', 'BD', '', '', '1'),
(4609, 'BD_01', 'REGION', '01', 'Barisal', 'BD', '', '', '1'),
(4608, 'BB_11', 'REGION', '11', 'Saint Thomas', 'BB', '', '', '1'),
(4607, 'BB_10', 'REGION', '10', 'Saint Philip', 'BB', '', '', '1'),
(4606, 'BB_09', 'REGION', '09', 'Saint Peter', 'BB', '', '', '1'),
(4605, 'BB_08', 'REGION', '08', 'Saint Michael', 'BB', '', '', '1'),
(4604, 'BB_07', 'REGION', '07', 'Saint Lucy', 'BB', '', '', '1'),
(4603, 'BB_06', 'REGION', '06', 'Saint Joseph', 'BB', '', '', '1'),
(4602, 'BB_05', 'REGION', '05', 'Saint John', 'BB', '', '', '1'),
(4601, 'BB_04', 'REGION', '04', 'Saint James', 'BB', '', '', '1'),
(4600, 'BB_03', 'REGION', '03', 'Saint George', 'BB', '', '', '1'),
(4599, 'BB_02', 'REGION', '02', 'Saint Andrew', 'BB', '', '', '1'),
(4598, 'BB_01', 'REGION', '01', 'Christ Church', 'BB', '', '', '1'),
(4597, 'BA_02', 'REGION', '02', 'Republika Srpska', 'BA', '', '', '1'),
(4596, 'BA_01', 'REGION', '01', 'Federation of Bosnia and Herzegovina', 'BA', '', '', '1'),
(4595, 'AZ_71', 'REGION', '71', 'Zardab', 'AZ', '', '', '1'),
(4594, 'AZ_70', 'REGION', '70', 'Zaqatala', 'AZ', '', '', '1'),
(4593, 'AZ_69', 'REGION', '69', 'Zangilan', 'AZ', '', '', '1'),
(4592, 'AZ_68', 'REGION', '68', 'Yevlax', 'AZ', '', '', '1'),
(4591, 'AZ_67', 'REGION', '67', 'Yevlax', 'AZ', '', '', '1'),
(4590, 'AZ_66', 'REGION', '66', 'Yardimli', 'AZ', '', '', '1'),
(4589, 'AZ_65', 'REGION', '65', 'Xocavand', 'AZ', '', '', '1'),
(4588, 'AZ_64', 'REGION', '64', 'Xocali', 'AZ', '', '', '1'),
(4587, 'AZ_63', 'REGION', '63', 'Xizi', 'AZ', '', '', '1'),
(4586, 'AZ_62', 'REGION', '62', 'Xanlar', 'AZ', '', '', '1'),
(4585, 'AZ_61', 'REGION', '61', 'Xankandi', 'AZ', '', '', '1'),
(4584, 'AZ_60', 'REGION', '60', 'Xacmaz', 'AZ', '', '', '1'),
(4583, 'AZ_59', 'REGION', '59', 'Ucar', 'AZ', '', '', '1'),
(4582, 'AZ_58', 'REGION', '58', 'Tovuz', 'AZ', '', '', '1'),
(4581, 'AZ_57', 'REGION', '57', 'Tartar', 'AZ', '', '', '1'),
(4580, 'AZ_56', 'REGION', '56', 'Susa', 'AZ', '', '', '1'),
(4579, 'AZ_55', 'REGION', '55', 'Susa', 'AZ', '', '', '1'),
(4578, 'AZ_54', 'REGION', '54', 'Sumqayit', 'AZ', '', '', '1'),
(4577, 'AZ_53', 'REGION', '53', 'Siyazan', 'AZ', '', '', '1'),
(4576, 'AZ_52', 'REGION', '52', 'Samux', 'AZ', '', '', '1'),
(4575, 'AZ_51', 'REGION', '51', 'Samkir', 'AZ', '', '', '1'),
(4574, 'AZ_50', 'REGION', '50', 'Samaxi', 'AZ', '', '', '1'),
(4573, 'AZ_49', 'REGION', '49', 'Salyan', 'AZ', '', '', '1'),
(4572, 'AZ_48', 'REGION', '48', 'Saki', 'AZ', '', '', '1'),
(4571, 'AZ_47', 'REGION', '47', 'Saki', 'AZ', '', '', '1'),
(4570, 'AZ_46', 'REGION', '46', 'Sabirabad', 'AZ', '', '', '1'),
(4569, 'AZ_45', 'REGION', '45', 'Saatli', 'AZ', '', '', '1'),
(4568, 'AZ_44', 'REGION', '44', 'Qusar', 'AZ', '', '', '1'),
(4567, 'AZ_43', 'REGION', '43', 'Qubadli', 'AZ', '', '', '1'),
(4566, 'AZ_42', 'REGION', '42', 'Quba', 'AZ', '', '', '1'),
(4565, 'AZ_41', 'REGION', '41', 'Qobustan', 'AZ', '', '', '1'),
(4564, 'AZ_40', 'REGION', '40', 'Qazax', 'AZ', '', '', '1'),
(4563, 'AZ_39', 'REGION', '39', 'Qax', 'AZ', '', '', '1'),
(4562, 'AZ_38', 'REGION', '38', 'Qabala', 'AZ', '', '', '1'),
(4561, 'AZ_37', 'REGION', '37', 'Oguz', 'AZ', '', '', '1'),
(4560, 'AZ_36', 'REGION', '36', 'Neftcala', 'AZ', '', '', '1'),
(4559, 'AZ_35', 'REGION', '35', 'Naxcivan', 'AZ', '', '', '1'),
(4558, 'AZ_34', 'REGION', '34', 'Naftalan', 'AZ', '', '', '1'),
(4557, 'AZ_33', 'REGION', '33', 'Mingacevir', 'AZ', '', '', '1'),
(4556, 'AZ_32', 'REGION', '32', 'Masalli', 'AZ', '', '', '1'),
(4555, 'AZ_31', 'REGION', '31', 'Lerik', 'AZ', '', '', '1'),
(4554, 'AZ_30', 'REGION', '30', 'Lankaran', 'AZ', '', '', '1'),
(4553, 'AZ_29', 'REGION', '29', 'Lankaran', 'AZ', '', '', '1'),
(4552, 'AZ_28', 'REGION', '28', 'Lacin', 'AZ', '', '', '1'),
(4551, 'AZ_27', 'REGION', '27', 'Kurdamir', 'AZ', '', '', '1'),
(4550, 'AZ_26', 'REGION', '26', 'Kalbacar', 'AZ', '', '', '1'),
(4549, 'AZ_25', 'REGION', '25', 'Ismayilli', 'AZ', '', '', '1'),
(4548, 'AZ_24', 'REGION', '24', 'Imisli', 'AZ', '', '', '1'),
(4547, 'AZ_23', 'REGION', '23', 'Haciqabul', 'AZ', '', '', '1'),
(4546, 'AZ_22', 'REGION', '22', 'Goycay', 'AZ', '', '', '1'),
(4545, 'AZ_21', 'REGION', '21', 'Goranboy', 'AZ', '', '', '1'),
(4544, 'AZ_20', 'REGION', '20', 'Ganca', 'AZ', '', '', '1'),
(4543, 'AZ_19', 'REGION', '19', 'Gadabay', 'AZ', '', '', '1'),
(4542, 'AZ_18', 'REGION', '18', 'Fuzuli', 'AZ', '', '', '1'),
(4541, 'AZ_17', 'REGION', '17', 'Davaci', 'AZ', '', '', '1'),
(4540, 'AZ_16', 'REGION', '16', 'Daskasan', 'AZ', '', '', '1'),
(4539, 'AZ_15', 'REGION', '15', 'Calilabad', 'AZ', '', '', '1'),
(4538, 'AZ_14', 'REGION', '14', 'Cabrayil', 'AZ', '', '', '1'),
(4537, 'AZ_13', 'REGION', '13', 'Bilasuvar', 'AZ', '', '', '1'),
(4536, 'AZ_12', 'REGION', '12', 'Beylaqan', 'AZ', '', '', '1'),
(4535, 'AZ_11', 'REGION', '11', 'Barda', 'AZ', '', '', '1'),
(4534, 'AZ_10', 'REGION', '10', 'Balakan', 'AZ', '', '', '1'),
(4533, 'AZ_09', 'REGION', '09', 'Baki', 'AZ', '', '', '1'),
(4532, 'AZ_08', 'REGION', '08', 'Astara', 'AZ', '', '', '1'),
(4531, 'AZ_07', 'REGION', '07', 'Ali Bayramli', 'AZ', '', '', '1'),
(4530, 'AZ_06', 'REGION', '06', 'Agsu', 'AZ', '', '', '1'),
(4529, 'AZ_05', 'REGION', '05', 'Agstafa', 'AZ', '', '', '1'),
(4528, 'AZ_04', 'REGION', '04', 'Agdas', 'AZ', '', '', '1'),
(4527, 'AZ_03', 'REGION', '03', 'Agdam', 'AZ', '', '', '1'),
(4526, 'AZ_02', 'REGION', '02', 'Agcabadi', 'AZ', '', '', '1'),
(4525, 'AZ_01', 'REGION', '01', 'Abseron', 'AZ', '', '', '1'),
(4524, 'AU_08', 'REGION', '08', 'Western Australia', 'AU', '', '', '1'),
(4523, 'AU_07', 'REGION', '07', 'Victoria', 'AU', '', '', '1'),
(4522, 'AU_06', 'REGION', '06', 'Tasmania', 'AU', '', '', '1'),
(4521, 'AU_05', 'REGION', '05', 'South Australia', 'AU', '', '', '1'),
(4520, 'AU_04', 'REGION', '04', 'Queensland', 'AU', '', '', '1'),
(4519, 'AU_03', 'REGION', '03', 'Northern Territory', 'AU', '', '', '1'),
(4518, 'AU_02', 'REGION', '02', 'New South Wales', 'AU', '', '', '1'),
(4517, 'AU_01', 'REGION', '01', 'Australian Capital Territory', 'AU', '', '', '1'),
(4516, 'AR_24', 'REGION', '24', 'Tucuman', 'AR', '', '', '1'),
(4515, 'AR_23', 'REGION', '23', 'Tierra del Fuego', 'AR', '', '', '1'),
(4514, 'AR_22', 'REGION', '22', 'Santiago del Estero', 'AR', '', '', '1'),
(4513, 'AR_21', 'REGION', '21', 'Santa Fe', 'AR', '', '', '1'),
(4512, 'AR_20', 'REGION', '20', 'Santa Cruz', 'AR', '', '', '1'),
(4511, 'AR_19', 'REGION', '19', 'San Luis', 'AR', '', '', '1'),
(4510, 'AR_18', 'REGION', '18', 'San Juan', 'AR', '', '', '1'),
(4509, 'AR_17', 'REGION', '17', 'Salta', 'AR', '', '', '1'),
(4508, 'AR_16', 'REGION', '16', 'Rio Negro', 'AR', '', '', '1'),
(4507, 'AR_15', 'REGION', '15', 'Neuquen', 'AR', '', '', '1'),
(4506, 'AR_14', 'REGION', '14', 'Misiones', 'AR', '', '', '1'),
(4505, 'AR_13', 'REGION', '13', 'Mendoza', 'AR', '', '', '1'),
(4504, 'AR_12', 'REGION', '12', 'La Rioja', 'AR', '', '', '1'),
(4503, 'AR_11', 'REGION', '11', 'La Pampa', 'AR', '', '', '1'),
(4502, 'AR_10', 'REGION', '10', 'Jujuy', 'AR', '', '', '1'),
(4501, 'AR_09', 'REGION', '09', 'Formosa', 'AR', '', '', '1'),
(4500, 'AR_08', 'REGION', '08', 'Entre Rios', 'AR', '', '', '1'),
(4499, 'AR_07', 'REGION', '07', 'Distrito Federal', 'AR', '', '', '1'),
(4498, 'AR_06', 'REGION', '06', 'Corrientes', 'AR', '', '', '1'),
(4497, 'AR_05', 'REGION', '05', 'Cordoba', 'AR', '', '', '1'),
(4496, 'AR_04', 'REGION', '04', 'Chubut', 'AR', '', '', '1'),
(4495, 'AR_03', 'REGION', '03', 'Chaco', 'AR', '', '', '1'),
(4494, 'AR_02', 'REGION', '02', 'Catamarca', 'AR', '', '', '1'),
(4493, 'AR_01', 'REGION', '01', 'Buenos Aires', 'AR', '', '', '1'),
(4492, 'AO_20', 'REGION', '20', 'Luanda', 'AO', '', '', '1'),
(4491, 'AO_19', 'REGION', '19', 'Bengo', 'AO', '', '', '1'),
(4490, 'AO_18', 'REGION', '18', 'Lunda Sul', 'AO', '', '', '1'),
(4489, 'AO_17', 'REGION', '17', 'Lunda Norte', 'AO', '', '', '1'),
(4488, 'AO_16', 'REGION', '16', 'Zaire', 'AO', '', '', '1'),
(4487, 'AO_15', 'REGION', '15', 'Uige', 'AO', '', '', '1'),
(4486, 'AO_14', 'REGION', '14', 'Moxico', 'AO', '', '', '1'),
(4485, 'AO_13', 'REGION', '13', 'Namibe', 'AO', '', '', '1'),
(4484, 'AO_12', 'REGION', '12', 'Malanje', 'AO', '', '', '1'),
(4483, 'AO_10', 'REGION', '10', 'Luanda', 'AO', '', '', '1'),
(4482, 'AO_09', 'REGION', '09', 'Huila', 'AO', '', '', '1'),
(4481, 'AO_08', 'REGION', '08', 'Huambo', 'AO', '', '', '1'),
(4480, 'AO_07', 'REGION', '07', 'Cunene', 'AO', '', '', '1'),
(4479, 'AO_06', 'REGION', '06', 'Cuanza Sul', 'AO', '', '', '1'),
(4478, 'AO_05', 'REGION', '05', 'Cuanza Norte', 'AO', '', '', '1'),
(4477, 'AO_04', 'REGION', '04', 'Cuando Cubango', 'AO', '', '', '1'),
(4476, 'AO_03', 'REGION', '03', 'Cabinda', 'AO', '', '', '1'),
(4475, 'AO_02', 'REGION', '02', 'Bie', 'AO', '', '', '1'),
(4474, 'AO_01', 'REGION', '01', 'Benguela', 'AO', '', '', '1'),
(4473, 'AM_11', 'REGION', '11', 'Yerevan', 'AM', '', '', '1'),
(4472, 'AM_09', 'REGION', '09', 'Tavush', 'AM', '', '', '1'),
(4471, 'AM_07', 'REGION', '07', 'Shirak', 'AM', '', '', '1'),
(4470, 'AM_06', 'REGION', '06', 'Lorri', 'AM', '', '', '1'),
(4469, 'AM_03', 'REGION', '03', 'Armavir', 'AM', '', '', '1'),
(4468, 'AM_02', 'REGION', '02', 'Ararat', 'AM', '', '', '1'),
(4467, 'AM_01', 'REGION', '01', 'Aragatsotn', 'AM', '', '', '1'),
(4466, 'AL_51', 'REGION', '51', 'Vlore', 'AL', '', '', '1'),
(4465, 'AL_50', 'REGION', '50', 'Tirane', 'AL', '', '', '1'),
(4464, 'AL_49', 'REGION', '49', 'Shkoder', 'AL', '', '', '1'),
(4463, 'AL_48', 'REGION', '48', 'Lezhe', 'AL', '', '', '1'),
(4462, 'AL_47', 'REGION', '47', 'Kukes', 'AL', '', '', '1'),
(4461, 'AL_46', 'REGION', '46', 'Korce', 'AL', '', '', '1'),
(4460, 'AL_45', 'REGION', '45', 'Gjirokaster', 'AL', '', '', '1'),
(4459, 'AL_44', 'REGION', '44', 'Fier', 'AL', '', '', '1'),
(4458, 'AL_43', 'REGION', '43', 'Elbasan', 'AL', '', '', '1'),
(4457, 'AL_42', 'REGION', '42', 'Durres', 'AL', '', '', '1'),
(4456, 'AL_41', 'REGION', '41', 'Diber', 'AL', '', '', '1'),
(4455, 'AL_40', 'REGION', '40', 'Berat', 'AL', '', '', '1'),
(4454, 'AG_08', 'REGION', '08', 'Saint Philip', 'AG', '', '', '1'),
(4453, 'AG_07', 'REGION', '07', 'Saint Peter', 'AG', '', '', '1'),
(4452, 'AG_06', 'REGION', '06', 'Saint Paul', 'AG', '', '', '1'),
(4451, 'AG_05', 'REGION', '05', 'Saint Mary', 'AG', '', '', '1'),
(4450, 'AG_04', 'REGION', '04', 'Saint John', 'AG', '', '', '1'),
(4449, 'AG_03', 'REGION', '03', 'Saint George', 'AG', '', '', '1'),
(4448, 'AG_01', 'REGION', '01', 'Barbuda', 'AG', '', '', '1'),
(4447, 'AF_42', 'REGION', '42', 'Panjshir', 'AF', '', '', '1'),
(4446, 'AF_41', 'REGION', '41', 'Daykondi', 'AF', '', '', '1'),
(4445, 'AF_40', 'REGION', '40', 'Parvan', 'AF', '', '', '1'),
(4444, 'AF_39', 'REGION', '39', 'Oruzgan', 'AF', '', '', '1'),
(4443, 'AF_38', 'REGION', '38', 'Nurestan', 'AF', '', '', '1'),
(4442, 'AF_37', 'REGION', '37', 'Khowst', 'AF', '', '', '1'),
(4441, 'AF_36', 'REGION', '36', 'Paktia', 'AF', '', '', '1'),
(4440, 'AF_35', 'REGION', '35', 'Laghman', 'AF', '', '', '1'),
(4439, 'AF_34', 'REGION', '34', 'Konar', 'AF', '', '', '1'),
(4438, 'AF_33', 'REGION', '33', 'Sar-e Pol', 'AF', '', '', '1'),
(4437, 'AF_32', 'REGION', '32', 'Samangan', 'AF', '', '', '1'),
(4436, 'AF_31', 'REGION', '31', 'Jowzjan', 'AF', '', '', '1'),
(4435, 'AF_30', 'REGION', '30', 'Balkh', 'AF', '', '', '1'),
(4434, 'AF_29', 'REGION', '29', 'Paktika', 'AF', '', '', '1'),
(4433, 'AF_28', 'REGION', '28', 'Zabol', 'AF', '', '', '1'),
(4432, 'AF_27', 'REGION', '27', 'Vardak', 'AF', '', '', '1'),
(4431, 'AF_26', 'REGION', '26', 'Takhar', 'AF', '', '', '1'),
(4430, 'AF_24', 'REGION', '24', 'Kondoz', 'AF', '', '', '1'),
(4429, 'AF_23', 'REGION', '23', 'Kandahar', 'AF', '', '', '1'),
(4428, 'AF_22', 'REGION', '22', 'Parvan', 'AF', '', '', '1'),
(4427, 'AF_21', 'REGION', '21', 'Paktia', 'AF', '', '', '1'),
(4426, 'AF_19', 'REGION', '19', 'Nimruz', 'AF', '', '', '1'),
(4425, 'AF_18', 'REGION', '18', 'Nangarhar', 'AF', '', '', '1'),
(4424, 'AF_17', 'REGION', '17', 'Lowgar', 'AF', '', '', '1'),
(4423, 'AF_16', 'REGION', '16', 'Laghman', 'AF', '', '', '1'),
(4422, 'AF_15', 'REGION', '15', 'Konar', 'AF', '', '', '1'),
(4421, 'AF_14', 'REGION', '14', 'Kapisa', 'AF', '', '', '1'),
(4420, 'AF_13', 'REGION', '13', 'Kabol', 'AF', '', '', '1'),
(4419, 'AF_11', 'REGION', '11', 'Herat', 'AF', '', '', '1'),
(4418, 'AF_10', 'REGION', '10', 'Helmand', 'AF', '', '', '1'),
(4417, 'AF_09', 'REGION', '09', 'Ghowr', 'AF', '', '', '1'),
(4416, 'AF_08', 'REGION', '08', 'Ghazni', 'AF', '', '', '1'),
(4415, 'AF_07', 'REGION', '07', 'Faryab', 'AF', '', '', '1'),
(4414, 'AF_06', 'REGION', '06', 'Farah', 'AF', '', '', '1'),
(4413, 'AF_05', 'REGION', '05', 'Bamian', 'AF', '', '', '1'),
(4412, 'AF_03', 'REGION', '03', 'Baghlan', 'AF', '', '', '1'),
(4411, 'AF_02', 'REGION', '02', 'Badghis', 'AF', '', '', '1'),
(4410, 'AF_01', 'REGION', '01', 'Badakhshan', 'AF', '', '', '1'),
(4409, 'AE_07', 'REGION', '07', 'Umm Al Quwain', 'AE', '', '', '1'),
(4408, 'AE_06', 'REGION', '06', 'Sharjah', 'AE', '', '', '1'),
(4407, 'AE_05', 'REGION', '05', 'Ras Al Khaimah', 'AE', '', '', '1'),
(4406, 'AE_04', 'REGION', '04', 'Fujairah', 'AE', '', '', '1'),
(4405, 'AE_03', 'REGION', '03', 'Dubai', 'AE', '', '', '1'),
(4404, 'AE_02', 'REGION', '02', 'Ajman', 'AE', '', '', '1'),
(4403, 'AE_01', 'REGION', '01', 'Abu Dhabi', 'AE', '', '', '1'),
(4402, 'AD_08', 'REGION', '08', 'Escaldes-Engordany', 'AD', '', '', '1'),
(4401, 'AD_07', 'REGION', '07', 'Andorra la Vella', 'AD', '', '', '1'),
(4400, 'AD_06', 'REGION', '06', 'Sant Julia de Loria', 'AD', '', '', '1'),
(4399, 'AD_05', 'REGION', '05', 'Ordino', 'AD', '', '', '1'),
(4398, 'AD_04', 'REGION', '04', 'La Massana', 'AD', '', '', '1'),
(4397, 'AD_03', 'REGION', '03', 'Encamp', 'AD', '', '', '1'),
(4396, 'AD_02', 'REGION', '02', 'Canillo', 'AD', '', '', '1'),
(6990, 'NA_15', 'REGION', '15', 'Owambo', 'NA', '', '', '1'),
(6991, 'NA_16', 'REGION', '16', 'Rehoboth', 'NA', '', '', '1'),
(6992, 'NA_17', 'REGION', '17', 'Swakopmund', 'NA', '', '', '1'),
(6993, 'NA_18', 'REGION', '18', 'Tsumeb', 'NA', '', '', '1'),
(6994, 'NA_20', 'REGION', '20', 'Karasburg', 'NA', '', '', '1'),
(6995, 'NA_21', 'REGION', '21', 'Windhoek', 'NA', '', '', '1'),
(6996, 'NA_22', 'REGION', '22', 'Damaraland', 'NA', '', '', '1'),
(6997, 'NA_23', 'REGION', '23', 'Hereroland Oos', 'NA', '', '', '1'),
(6998, 'NA_24', 'REGION', '24', 'Hereroland Wes', 'NA', '', '', '1'),
(6999, 'NA_25', 'REGION', '25', 'Kavango', 'NA', '', '', '1'),
(7000, 'NA_26', 'REGION', '26', 'Mariental', 'NA', '', '', '1'),
(7001, 'NA_27', 'REGION', '27', 'Namaland', 'NA', '', '', '1'),
(7002, 'NA_28', 'REGION', '28', 'Caprivi', 'NA', '', '', '1'),
(7003, 'NA_29', 'REGION', '29', 'Erongo', 'NA', '', '', '1'),
(7004, 'NA_30', 'REGION', '30', 'Hardap', 'NA', '', '', '1'),
(7005, 'NA_31', 'REGION', '31', 'Karas', 'NA', '', '', '1'),
(7006, 'NA_32', 'REGION', '32', 'Kunene', 'NA', '', '', '1'),
(7007, 'NA_33', 'REGION', '33', 'Ohangwena', 'NA', '', '', '1'),
(7008, 'NA_34', 'REGION', '34', 'Okavango', 'NA', '', '', '1'),
(7009, 'NA_35', 'REGION', '35', 'Omaheke', 'NA', '', '', '1'),
(7010, 'NA_36', 'REGION', '36', 'Omusati', 'NA', '', '', '1'),
(7011, 'NA_37', 'REGION', '37', 'Oshana', 'NA', '', '', '1'),
(7012, 'NA_38', 'REGION', '38', 'Oshikoto', 'NA', '', '', '1'),
(7013, 'NA_39', 'REGION', '39', 'Otjozondjupa', 'NA', '', '', '1'),
(7014, 'NE_01', 'REGION', '01', 'Agadez', 'NE', '', '', '1'),
(7015, 'NE_02', 'REGION', '02', 'Diffa', 'NE', '', '', '1'),
(7016, 'NE_03', 'REGION', '03', 'Dosso', 'NE', '', '', '1'),
(7017, 'NE_04', 'REGION', '04', 'Maradi', 'NE', '', '', '1'),
(7018, 'NE_05', 'REGION', '05', 'Niamey', 'NE', '', '', '1'),
(7019, 'NE_06', 'REGION', '06', 'Tahoua', 'NE', '', '', '1'),
(7020, 'NE_07', 'REGION', '07', 'Zinder', 'NE', '', '', '1'),
(7021, 'NE_08', 'REGION', '08', 'Niamey', 'NE', '', '', '1'),
(7022, 'NG_05', 'REGION', '05', 'Lagos', 'NG', '', '', '1'),
(7023, 'NG_10', 'REGION', '10', 'Rivers', 'NG', '', '', '1'),
(7024, 'NG_11', 'REGION', '11', 'Federal Capital Territory', 'NG', '', '', '1'),
(7025, 'NG_12', 'REGION', '12', 'Gongola', 'NG', '', '', '1'),
(7026, 'NG_16', 'REGION', '16', 'Ogun', 'NG', '', '', '1'),
(7027, 'NG_17', 'REGION', '17', 'Ondo', 'NG', '', '', '1'),
(7028, 'NG_18', 'REGION', '18', 'Oyo', 'NG', '', '', '1'),
(7029, 'NG_21', 'REGION', '21', 'Akwa Ibom', 'NG', '', '', '1'),
(7030, 'NG_22', 'REGION', '22', 'Cross River', 'NG', '', '', '1'),
(7031, 'NG_23', 'REGION', '23', 'Kaduna', 'NG', '', '', '1'),
(7032, 'NG_24', 'REGION', '24', 'Katsina', 'NG', '', '', '1'),
(7033, 'NG_25', 'REGION', '25', 'Anambra', 'NG', '', '', '1'),
(7034, 'NG_26', 'REGION', '26', 'Benue', 'NG', '', '', '1'),
(7035, 'NG_27', 'REGION', '27', 'Borno', 'NG', '', '', '1'),
(7036, 'NG_28', 'REGION', '28', 'Imo', 'NG', '', '', '1'),
(7037, 'NG_29', 'REGION', '29', 'Kano', 'NG', '', '', '1'),
(7038, 'NG_30', 'REGION', '30', 'Kwara', 'NG', '', '', '1'),
(7039, 'NG_31', 'REGION', '31', 'Niger', 'NG', '', '', '1'),
(7040, 'NG_32', 'REGION', '32', 'Oyo', 'NG', '', '', '1'),
(7041, 'NG_35', 'REGION', '35', 'Adamawa', 'NG', '', '', '1'),
(7042, 'NG_36', 'REGION', '36', 'Delta', 'NG', '', '', '1'),
(7043, 'NG_37', 'REGION', '37', 'Edo', 'NG', '', '', '1'),
(7044, 'NG_39', 'REGION', '39', 'Jigawa', 'NG', '', '', '1'),
(7045, 'NG_40', 'REGION', '40', 'Kebbi', 'NG', '', '', '1'),
(7046, 'NG_41', 'REGION', '41', 'Kogi', 'NG', '', '', '1'),
(7047, 'NG_42', 'REGION', '42', 'Osun', 'NG', '', '', '1'),
(7048, 'NG_43', 'REGION', '43', 'Taraba', 'NG', '', '', '1'),
(7049, 'NG_44', 'REGION', '44', 'Yobe', 'NG', '', '', '1'),
(7050, 'NG_45', 'REGION', '45', 'Abia', 'NG', '', '', '1'),
(7051, 'NG_46', 'REGION', '46', 'Bauchi', 'NG', '', '', '1'),
(7052, 'NG_47', 'REGION', '47', 'Enugu', 'NG', '', '', '1'),
(7053, 'NG_48', 'REGION', '48', 'Ondo', 'NG', '', '', '1'),
(7054, 'NG_49', 'REGION', '49', 'Plateau', 'NG', '', '', '1'),
(7055, 'NG_50', 'REGION', '50', 'Rivers', 'NG', '', '', '1'),
(7056, 'NG_51', 'REGION', '51', 'Sokoto', 'NG', '', '', '1'),
(7057, 'NG_52', 'REGION', '52', 'Bayelsa', 'NG', '', '', '1'),
(7058, 'NG_53', 'REGION', '53', 'Ebonyi', 'NG', '', '', '1'),
(7059, 'NG_54', 'REGION', '54', 'Ekiti', 'NG', '', '', '1'),
(7060, 'NG_55', 'REGION', '55', 'Gombe', 'NG', '', '', '1'),
(7061, 'NG_56', 'REGION', '56', 'Nassarawa', 'NG', '', '', '1'),
(7062, 'NG_57', 'REGION', '57', 'Zamfara', 'NG', '', '', '1'),
(7063, 'NI_01', 'REGION', '01', 'Boaco', 'NI', '', '', '1'),
(7064, 'NI_02', 'REGION', '02', 'Carazo', 'NI', '', '', '1'),
(7065, 'NI_03', 'REGION', '03', 'Chinandega', 'NI', '', '', '1'),
(7066, 'NI_04', 'REGION', '04', 'Chontales', 'NI', '', '', '1'),
(7067, 'NI_05', 'REGION', '05', 'Esteli', 'NI', '', '', '1'),
(7068, 'NI_06', 'REGION', '06', 'Granada', 'NI', '', '', '1'),
(7069, 'NI_07', 'REGION', '07', 'Jinotega', 'NI', '', '', '1'),
(7070, 'NI_08', 'REGION', '08', 'Leon', 'NI', '', '', '1'),
(7071, 'NI_09', 'REGION', '09', 'Madriz', 'NI', '', '', '1'),
(7072, 'NI_10', 'REGION', '10', 'Managua', 'NI', '', '', '1'),
(7073, 'NI_11', 'REGION', '11', 'Masaya', 'NI', '', '', '1'),
(7074, 'NI_12', 'REGION', '12', 'Matagalpa', 'NI', '', '', '1'),
(7075, 'NI_13', 'REGION', '13', 'Nueva Segovia', 'NI', '', '', '1'),
(7076, 'NI_14', 'REGION', '14', 'Rio San Juan', 'NI', '', '', '1'),
(7077, 'NI_15', 'REGION', '15', 'Rivas', 'NI', '', '', '1'),
(7078, 'NI_16', 'REGION', '16', 'Zelaya', 'NI', '', '', '1'),
(7079, 'NI_17', 'REGION', '17', 'Autonoma Atlantico Norte', 'NI', '', '', '1'),
(7080, 'NI_18', 'REGION', '18', 'Region Autonoma Atlantico Sur', 'NI', '', '', '1'),
(7081, 'NL_01', 'REGION', '01', 'Drenthe', 'NL', '', '', '1'),
(7082, 'NL_02', 'REGION', '02', 'Friesland', 'NL', '', '', '1'),
(7083, 'NL_03', 'REGION', '03', 'Gelderland', 'NL', '', '', '1'),
(7084, 'NL_04', 'REGION', '04', 'Groningen', 'NL', '', '', '1'),
(7085, 'NL_05', 'REGION', '05', 'Limburg', 'NL', '', '', '1'),
(7086, 'NL_06', 'REGION', '06', 'Noord-Brabant', 'NL', '', '', '1'),
(7087, 'NL_07', 'REGION', '07', 'Noord-Holland', 'NL', '', '', '1'),
(7088, 'NL_08', 'REGION', '08', 'Overijssel', 'NL', '', '', '1'),
(7089, 'NL_09', 'REGION', '09', 'Utrecht', 'NL', '', '', '1'),
(7090, 'NL_10', 'REGION', '10', 'Zeeland', 'NL', '', '', '1'),
(7091, 'NL_11', 'REGION', '11', 'Zuid-Holland', 'NL', '', '', '1'),
(7092, 'NL_12', 'REGION', '12', 'Dronten', 'NL', '', '', '1'),
(7093, 'NL_13', 'REGION', '13', 'Zuidelijke IJsselmeerpolders', 'NL', '', '', '1'),
(7094, 'NL_14', 'REGION', '14', 'Lelystad', 'NL', '', '', '1'),
(7095, 'NL_15', 'REGION', '15', 'Overijssel', 'NL', '', '', '1'),
(7096, 'NL_16', 'REGION', '16', 'Flevoland', 'NL', '', '', '1'),
(7097, 'NO_01', 'REGION', '01', 'Akershus', 'NO', '', '', '1'),
(7098, 'NO_02', 'REGION', '02', 'Aust-Agder', 'NO', '', '', '1'),
(7099, 'NO_04', 'REGION', '04', 'Buskerud', 'NO', '', '', '1'),
(7100, 'NO_05', 'REGION', '05', 'Finnmark', 'NO', '', '', '1'),
(7101, 'NO_06', 'REGION', '06', 'Hedmark', 'NO', '', '', '1'),
(7102, 'NO_07', 'REGION', '07', 'Hordaland', 'NO', '', '', '1'),
(7103, 'NO_08', 'REGION', '08', 'More og Romsdal', 'NO', '', '', '1'),
(7104, 'NO_09', 'REGION', '09', 'Nordland', 'NO', '', '', '1'),
(7105, 'NO_10', 'REGION', '10', 'Nord-Trondelag', 'NO', '', '', '1'),
(7106, 'NO_11', 'REGION', '11', 'Oppland', 'NO', '', '', '1'),
(7107, 'NO_12', 'REGION', '12', 'Oslo', 'NO', '', '', '1'),
(7108, 'NO_13', 'REGION', '13', 'Ostfold', 'NO', '', '', '1'),
(7109, 'NO_14', 'REGION', '14', 'Rogaland', 'NO', '', '', '1'),
(7110, 'NO_15', 'REGION', '15', 'Sogn og Fjordane', 'NO', '', '', '1'),
(7111, 'NO_16', 'REGION', '16', 'Sor-Trondelag', 'NO', '', '', '1'),
(7112, 'NO_17', 'REGION', '17', 'Telemark', 'NO', '', '', '1'),
(7113, 'NO_18', 'REGION', '18', 'Troms', 'NO', '', '', '1'),
(7114, 'NO_19', 'REGION', '19', 'Vest-Agder', 'NO', '', '', '1'),
(7115, 'NO_20', 'REGION', '20', 'Vestfold', 'NO', '', '', '1'),
(7116, 'NP_01', 'REGION', '01', 'Bagmati', 'NP', '', '', '1'),
(7117, 'NP_02', 'REGION', '02', 'Bheri', 'NP', '', '', '1'),
(7118, 'NP_03', 'REGION', '03', 'Dhawalagiri', 'NP', '', '', '1'),
(7119, 'NP_04', 'REGION', '04', 'Gandaki', 'NP', '', '', '1'),
(7120, 'NP_05', 'REGION', '05', 'Janakpur', 'NP', '', '', '1'),
(7121, 'NP_06', 'REGION', '06', 'Karnali', 'NP', '', '', '1'),
(7122, 'NP_07', 'REGION', '07', 'Kosi', 'NP', '', '', '1'),
(7123, 'NP_08', 'REGION', '08', 'Lumbini', 'NP', '', '', '1'),
(7124, 'NP_09', 'REGION', '09', 'Mahakali', 'NP', '', '', '1'),
(7125, 'NP_10', 'REGION', '10', 'Mechi', 'NP', '', '', '1'),
(7126, 'NP_11', 'REGION', '11', 'Narayani', 'NP', '', '', '1'),
(7127, 'NP_12', 'REGION', '12', 'Rapti', 'NP', '', '', '1'),
(7128, 'NP_13', 'REGION', '13', 'Sagarmatha', 'NP', '', '', '1'),
(7129, 'NP_14', 'REGION', '14', 'Seti', 'NP', '', '', '1'),
(7130, 'NR_01', 'REGION', '01', 'Aiwo', 'NR', '', '', '1'),
(7131, 'NR_02', 'REGION', '02', 'Anabar', 'NR', '', '', '1'),
(7132, 'NR_03', 'REGION', '03', 'Anetan', 'NR', '', '', '1'),
(7133, 'NR_04', 'REGION', '04', 'Anibare', 'NR', '', '', '1'),
(7134, 'NR_05', 'REGION', '05', 'Baiti', 'NR', '', '', '1'),
(7135, 'NR_06', 'REGION', '06', 'Boe', 'NR', '', '', '1'),
(7136, 'NR_07', 'REGION', '07', 'Buada', 'NR', '', '', '1'),
(7137, 'NR_08', 'REGION', '08', 'Denigomodu', 'NR', '', '', '1'),
(7138, 'NR_09', 'REGION', '09', 'Ewa', 'NR', '', '', '1'),
(7139, 'NR_10', 'REGION', '10', 'Ijuw', 'NR', '', '', '1'),
(7140, 'NR_11', 'REGION', '11', 'Meneng', 'NR', '', '', '1'),
(7141, 'NR_12', 'REGION', '12', 'Nibok', 'NR', '', '', '1'),
(7142, 'NR_13', 'REGION', '13', 'Uaboe', 'NR', '', '', '1'),
(7143, 'NR_14', 'REGION', '14', 'Yaren', 'NR', '', '', '1'),
(7144, 'NZ_10', 'REGION', '10', 'Chatham Islands', 'NZ', '', '', '1'),
(7145, 'NZ_85', 'REGION', '85', 'Waikato', 'NZ', '', '', '1'),
(7146, 'NZ_E7', 'REGION', 'E7', 'Auckland', 'NZ', '', '', '1'),
(7147, 'NZ_E8', 'REGION', 'E8', 'Bay of Plenty', 'NZ', '', '', '1'),
(7148, 'NZ_E9', 'REGION', 'E9', 'Canterbury', 'NZ', '', '', '1'),
(7149, 'NZ_F1', 'REGION', 'F1', 'Gisborne', 'NZ', '', '', '1'),
(7150, 'NZ_F3', 'REGION', 'F3', 'Manawatu-Wanganui', 'NZ', '', '', '1'),
(7151, 'NZ_F4', 'REGION', 'F4', 'Marlborough', 'NZ', '', '', '1'),
(7152, 'NZ_F5', 'REGION', 'F5', 'Nelson', 'NZ', '', '', '1'),
(7153, 'NZ_F6', 'REGION', 'F6', 'Northland', 'NZ', '', '', '1'),
(7154, 'NZ_F7', 'REGION', 'F7', 'Otago', 'NZ', '', '', '1'),
(7155, 'NZ_F8', 'REGION', 'F8', 'Southland', 'NZ', '', '', '1'),
(7156, 'NZ_F9', 'REGION', 'F9', 'Taranaki', 'NZ', '', '', '1'),
(7157, 'NZ_G1', 'REGION', 'G1', 'Waikato', 'NZ', '', '', '1'),
(7158, 'NZ_G2', 'REGION', 'G2', 'Wellington', 'NZ', '', '', '1'),
(7159, 'NZ_G3', 'REGION', 'G3', 'West Coast', 'NZ', '', '', '1'),
(7160, 'OM_01', 'REGION', '01', 'Ad Dakhiliyah', 'OM', '', '', '1'),
(7161, 'OM_02', 'REGION', '02', 'Al Batinah', 'OM', '', '', '1'),
(7162, 'OM_03', 'REGION', '03', 'Al Wusta', 'OM', '', '', '1'),
(7163, 'OM_04', 'REGION', '04', 'Ash Sharqiyah', 'OM', '', '', '1'),
(7164, 'OM_05', 'REGION', '05', 'Az Zahirah', 'OM', '', '', '1'),
(7165, 'OM_06', 'REGION', '06', 'Masqat', 'OM', '', '', '1'),
(7166, 'OM_07', 'REGION', '07', 'Musandam', 'OM', '', '', '1'),
(7167, 'OM_08', 'REGION', '08', 'Zufar', 'OM', '', '', '1'),
(7168, 'PA_01', 'REGION', '01', 'Bocas del Toro', 'PA', '', '', '1'),
(7169, 'PA_02', 'REGION', '02', 'Chiriqui', 'PA', '', '', '1'),
(7170, 'PA_03', 'REGION', '03', 'Cocle', 'PA', '', '', '1'),
(7171, 'PA_04', 'REGION', '04', 'Colon', 'PA', '', '', '1'),
(7172, 'PA_05', 'REGION', '05', 'Darien', 'PA', '', '', '1'),
(7173, 'PA_06', 'REGION', '06', 'Herrera', 'PA', '', '', '1'),
(7174, 'PA_07', 'REGION', '07', 'Los Santos', 'PA', '', '', '1'),
(7175, 'PA_08', 'REGION', '08', 'Panama', 'PA', '', '', '1'),
(7176, 'PA_09', 'REGION', '09', 'San Blas', 'PA', '', '', '1'),
(7177, 'PA_10', 'REGION', '10', 'Veraguas', 'PA', '', '', '1'),
(7178, 'PE_01', 'REGION', '01', 'Amazonas', 'PE', '', '', '1'),
(7179, 'PE_02', 'REGION', '02', 'Ancash', 'PE', '', '', '1'),
(7180, 'PE_03', 'REGION', '03', 'Apurimac', 'PE', '', '', '1'),
(7181, 'PE_04', 'REGION', '04', 'Arequipa', 'PE', '', '', '1'),
(7182, 'PE_05', 'REGION', '05', 'Ayacucho', 'PE', '', '', '1'),
(7183, 'PE_06', 'REGION', '06', 'Cajamarca', 'PE', '', '', '1'),
(7184, 'PE_07', 'REGION', '07', 'Callao', 'PE', '', '', '1'),
(7185, 'PE_08', 'REGION', '08', 'Cusco', 'PE', '', '', '1'),
(7186, 'PE_09', 'REGION', '09', 'Huancavelica', 'PE', '', '', '1'),
(7187, 'PE_10', 'REGION', '10', 'Huanuco', 'PE', '', '', '1'),
(7188, 'PE_11', 'REGION', '11', 'Ica', 'PE', '', '', '1'),
(7189, 'PE_12', 'REGION', '12', 'Junin', 'PE', '', '', '1'),
(7190, 'PE_13', 'REGION', '13', 'La Libertad', 'PE', '', '', '1'),
(7191, 'PE_14', 'REGION', '14', 'Lambayeque', 'PE', '', '', '1'),
(7192, 'PE_15', 'REGION', '15', 'Lima', 'PE', '', '', '1'),
(7193, 'PE_16', 'REGION', '16', 'Loreto', 'PE', '', '', '1'),
(7194, 'PE_17', 'REGION', '17', 'Madre de Dios', 'PE', '', '', '1'),
(7195, 'PE_18', 'REGION', '18', 'Moquegua', 'PE', '', '', '1'),
(7196, 'PE_19', 'REGION', '19', 'Pasco', 'PE', '', '', '1'),
(7197, 'PE_20', 'REGION', '20', 'Piura', 'PE', '', '', '1'),
(7198, 'PE_21', 'REGION', '21', 'Puno', 'PE', '', '', '1'),
(7199, 'PE_22', 'REGION', '22', 'San Martin', 'PE', '', '', '1'),
(7200, 'PE_23', 'REGION', '23', 'Tacna', 'PE', '', '', '1'),
(7201, 'PE_24', 'REGION', '24', 'Tumbes', 'PE', '', '', '1'),
(7202, 'PE_25', 'REGION', '25', 'Ucayali', 'PE', '', '', '1'),
(7203, 'PG_01', 'REGION', '01', 'Central', 'PG', '', '', '1'),
(7204, 'PG_02', 'REGION', '02', 'Gulf', 'PG', '', '', '1'),
(7205, 'PG_03', 'REGION', '03', 'Milne Bay', 'PG', '', '', '1'),
(7206, 'PG_04', 'REGION', '04', 'Northern', 'PG', '', '', '1'),
(7207, 'PG_05', 'REGION', '05', 'Southern Highlands', 'PG', '', '', '1'),
(7208, 'PG_06', 'REGION', '06', 'Western', 'PG', '', '', '1'),
(7209, 'PG_07', 'REGION', '07', 'North Solomons', 'PG', '', '', '1'),
(7210, 'PG_08', 'REGION', '08', 'Chimbu', 'PG', '', '', '1'),
(7211, 'PG_09', 'REGION', '09', 'Eastern Highlands', 'PG', '', '', '1'),
(7212, 'PG_10', 'REGION', '10', 'East New Britain', 'PG', '', '', '1'),
(7213, 'PG_11', 'REGION', '11', 'East Sepik', 'PG', '', '', '1'),
(7214, 'PG_12', 'REGION', '12', 'Madang', 'PG', '', '', '1'),
(7215, 'PG_13', 'REGION', '13', 'Manus', 'PG', '', '', '1'),
(7216, 'PG_14', 'REGION', '14', 'Morobe', 'PG', '', '', '1'),
(7217, 'PG_15', 'REGION', '15', 'New Ireland', 'PG', '', '', '1'),
(7218, 'PG_16', 'REGION', '16', 'Western Highlands', 'PG', '', '', '1'),
(7219, 'PG_17', 'REGION', '17', 'West New Britain', 'PG', '', '', '1'),
(7220, 'PG_18', 'REGION', '18', 'Sandaun', 'PG', '', '', '1'),
(7221, 'PG_19', 'REGION', '19', 'Enga', 'PG', '', '', '1'),
(7222, 'PG_20', 'REGION', '20', 'National Capital', 'PG', '', '', '1'),
(7223, 'PH_01', 'REGION', '01', 'Abra', 'PH', '', '', '1'),
(7224, 'PH_02', 'REGION', '02', 'Agusan del Norte', 'PH', '', '', '1'),
(7225, 'PH_03', 'REGION', '03', 'Agusan del Sur', 'PH', '', '', '1'),
(7226, 'PH_04', 'REGION', '04', 'Aklan', 'PH', '', '', '1'),
(7227, 'PH_05', 'REGION', '05', 'Albay', 'PH', '', '', '1'),
(7228, 'PH_06', 'REGION', '06', 'Antique', 'PH', '', '', '1'),
(7229, 'PH_07', 'REGION', '07', 'Bataan', 'PH', '', '', '1'),
(7230, 'PH_08', 'REGION', '08', 'Batanes', 'PH', '', '', '1'),
(7231, 'PH_09', 'REGION', '09', 'Batangas', 'PH', '', '', '1'),
(7232, 'PH_10', 'REGION', '10', 'Benguet', 'PH', '', '', '1'),
(7233, 'PH_11', 'REGION', '11', 'Bohol', 'PH', '', '', '1'),
(7234, 'PH_12', 'REGION', '12', 'Bukidnon', 'PH', '', '', '1'),
(7235, 'PH_13', 'REGION', '13', 'Bulacan', 'PH', '', '', '1'),
(7236, 'PH_14', 'REGION', '14', 'Cagayan', 'PH', '', '', '1'),
(7237, 'PH_15', 'REGION', '15', 'Camarines Norte', 'PH', '', '', '1'),
(7238, 'PH_16', 'REGION', '16', 'Camarines Sur', 'PH', '', '', '1'),
(7239, 'PH_17', 'REGION', '17', 'Camiguin', 'PH', '', '', '1'),
(7240, 'PH_18', 'REGION', '18', 'Capiz', 'PH', '', '', '1'),
(7241, 'PH_19', 'REGION', '19', 'Catanduanes', 'PH', '', '', '1'),
(7242, 'PH_20', 'REGION', '20', 'Cavite', 'PH', '', '', '1'),
(7243, 'PH_21', 'REGION', '21', 'Cebu', 'PH', '', '', '1'),
(7244, 'PH_22', 'REGION', '22', 'Basilan', 'PH', '', '', '1'),
(7245, 'PH_23', 'REGION', '23', 'Eastern Samar', 'PH', '', '', '1'),
(7246, 'PH_24', 'REGION', '24', 'Davao', 'PH', '', '', '1'),
(7247, 'PH_25', 'REGION', '25', 'Davao del Sur', 'PH', '', '', '1'),
(7248, 'PH_26', 'REGION', '26', 'Davao Oriental', 'PH', '', '', '1'),
(7249, 'PH_27', 'REGION', '27', 'Ifugao', 'PH', '', '', '1'),
(7250, 'PH_28', 'REGION', '28', 'Ilocos Norte', 'PH', '', '', '1'),
(7251, 'PH_29', 'REGION', '29', 'Ilocos Sur', 'PH', '', '', '1'),
(7252, 'PH_30', 'REGION', '30', 'Iloilo', 'PH', '', '', '1'),
(7253, 'PH_31', 'REGION', '31', 'Isabela', 'PH', '', '', '1'),
(7254, 'PH_32', 'REGION', '32', 'Kalinga-Apayao', 'PH', '', '', '1'),
(7255, 'PH_33', 'REGION', '33', 'Laguna', 'PH', '', '', '1'),
(7256, 'PH_34', 'REGION', '34', 'Lanao del Norte', 'PH', '', '', '1'),
(7257, 'PH_35', 'REGION', '35', 'Lanao del Sur', 'PH', '', '', '1'),
(7258, 'PH_36', 'REGION', '36', 'La Union', 'PH', '', '', '1'),
(7259, 'PH_37', 'REGION', '37', 'Leyte', 'PH', '', '', '1'),
(7260, 'PH_38', 'REGION', '38', 'Marinduque', 'PH', '', '', '1'),
(7261, 'PH_39', 'REGION', '39', 'Masbate', 'PH', '', '', '1'),
(7262, 'PH_40', 'REGION', '40', 'Mindoro Occidental', 'PH', '', '', '1'),
(7263, 'PH_41', 'REGION', '41', 'Mindoro Oriental', 'PH', '', '', '1'),
(7264, 'PH_42', 'REGION', '42', 'Misamis Occidental', 'PH', '', '', '1'),
(7265, 'PH_43', 'REGION', '43', 'Misamis Oriental', 'PH', '', '', '1'),
(7266, 'PH_44', 'REGION', '44', 'Mountain', 'PH', '', '', '1'),
(7267, 'PH_45', 'REGION', '45', 'Negros Occidental', 'PH', '', '', '1'),
(7268, 'PH_46', 'REGION', '46', 'Negros Oriental', 'PH', '', '', '1'),
(7269, 'PH_47', 'REGION', '47', 'Nueva Ecija', 'PH', '', '', '1'),
(7270, 'PH_48', 'REGION', '48', 'Nueva Vizcaya', 'PH', '', '', '1'),
(7271, 'PH_49', 'REGION', '49', 'Palawan', 'PH', '', '', '1'),
(7272, 'PH_50', 'REGION', '50', 'Pampanga', 'PH', '', '', '1'),
(7273, 'PH_51', 'REGION', '51', 'Pangasinan', 'PH', '', '', '1'),
(7274, 'PH_53', 'REGION', '53', 'Rizal', 'PH', '', '', '1'),
(7275, 'PH_54', 'REGION', '54', 'Romblon', 'PH', '', '', '1'),
(7276, 'PH_55', 'REGION', '55', 'Samar', 'PH', '', '', '1'),
(7277, 'PH_56', 'REGION', '56', 'Maguindanao', 'PH', '', '', '1'),
(7278, 'PH_57', 'REGION', '57', 'North Cotabato', 'PH', '', '', '1'),
(7279, 'PH_58', 'REGION', '58', 'Sorsogon', 'PH', '', '', '1'),
(7280, 'PH_59', 'REGION', '59', 'Southern Leyte', 'PH', '', '', '1'),
(7281, 'PH_60', 'REGION', '60', 'Sulu', 'PH', '', '', '1'),
(7282, 'PH_61', 'REGION', '61', 'Surigao del Norte', 'PH', '', '', '1'),
(7283, 'PH_62', 'REGION', '62', 'Surigao del Sur', 'PH', '', '', '1'),
(7284, 'PH_63', 'REGION', '63', 'Tarlac', 'PH', '', '', '1'),
(7285, 'PH_64', 'REGION', '64', 'Zambales', 'PH', '', '', '1'),
(7286, 'PH_65', 'REGION', '65', 'Zamboanga del Norte', 'PH', '', '', '1'),
(7287, 'PH_66', 'REGION', '66', 'Zamboanga del Sur', 'PH', '', '', '1'),
(7288, 'PH_67', 'REGION', '67', 'Northern Samar', 'PH', '', '', '1'),
(7289, 'PH_68', 'REGION', '68', 'Quirino', 'PH', '', '', '1'),
(7290, 'PH_69', 'REGION', '69', 'Siquijor', 'PH', '', '', '1'),
(7291, 'PH_70', 'REGION', '70', 'South Cotabato', 'PH', '', '', '1'),
(7292, 'PH_71', 'REGION', '71', 'Sultan Kudarat', 'PH', '', '', '1'),
(7293, 'PH_72', 'REGION', '72', 'Tawitawi', 'PH', '', '', '1'),
(7294, 'PH_A1', 'REGION', 'A1', 'Angeles', 'PH', '', '', '1');", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(7295, 'PH_A2', 'REGION', 'A2', 'Bacolod', 'PH', '', '', '1'),
(7296, 'PH_A3', 'REGION', 'A3', 'Bago', 'PH', '', '', '1'),
(7297, 'PH_A4', 'REGION', 'A4', 'Baguio', 'PH', '', '', '1'),
(7298, 'PH_A5', 'REGION', 'A5', 'Bais', 'PH', '', '', '1'),
(7299, 'PH_A6', 'REGION', 'A6', 'Basilan City', 'PH', '', '', '1'),
(7300, 'PH_A7', 'REGION', 'A7', 'Batangas City', 'PH', '', '', '1'),
(7301, 'PH_A8', 'REGION', 'A8', 'Butuan', 'PH', '', '', '1'),
(7302, 'PH_A9', 'REGION', 'A9', 'Cabanatuan', 'PH', '', '', '1'),
(7303, 'PH_B1', 'REGION', 'B1', 'Cadiz', 'PH', '', '', '1'),
(7304, 'PH_B2', 'REGION', 'B2', 'Cagayan de Oro', 'PH', '', '', '1'),
(7305, 'PH_B3', 'REGION', 'B3', 'Calbayog', 'PH', '', '', '1'),
(7306, 'PH_B4', 'REGION', 'B4', 'Caloocan', 'PH', '', '', '1'),
(7307, 'PH_B5', 'REGION', 'B5', 'Canlaon', 'PH', '', '', '1'),
(7308, 'PH_B6', 'REGION', 'B6', 'Cavite City', 'PH', '', '', '1'),
(7309, 'PH_B7', 'REGION', 'B7', 'Cebu City', 'PH', '', '', '1'),
(7310, 'PH_B8', 'REGION', 'B8', 'Cotabato', 'PH', '', '', '1'),
(7311, 'PH_B9', 'REGION', 'B9', 'Dagupan', 'PH', '', '', '1'),
(7312, 'PH_C1', 'REGION', 'C1', 'Danao', 'PH', '', '', '1'),
(7313, 'PH_C2', 'REGION', 'C2', 'Dapitan', 'PH', '', '', '1'),
(7314, 'PH_C3', 'REGION', 'C3', 'Davao City', 'PH', '', '', '1'),
(7315, 'PH_C4', 'REGION', 'C4', 'Dipolog', 'PH', '', '', '1'),
(7316, 'PH_C5', 'REGION', 'C5', 'Dumaguete', 'PH', '', '', '1'),
(7317, 'PH_C6', 'REGION', 'C6', 'General Santos', 'PH', '', '', '1'),
(7318, 'PH_C7', 'REGION', 'C7', 'Gingoog', 'PH', '', '', '1'),
(7319, 'PH_C8', 'REGION', 'C8', 'Iligan', 'PH', '', '', '1'),
(7320, 'PH_C9', 'REGION', 'C9', 'Iloilo City', 'PH', '', '', '1'),
(7321, 'PH_D1', 'REGION', 'D1', 'Iriga', 'PH', '', '', '1'),
(7322, 'PH_D2', 'REGION', 'D2', 'La Carlota', 'PH', '', '', '1'),
(7323, 'PH_D3', 'REGION', 'D3', 'Laoag', 'PH', '', '', '1'),
(7324, 'PH_D4', 'REGION', 'D4', 'Lapu-Lapu', 'PH', '', '', '1'),
(7325, 'PH_D5', 'REGION', 'D5', 'Legaspi', 'PH', '', '', '1'),
(7326, 'PH_D6', 'REGION', 'D6', 'Lipa', 'PH', '', '', '1'),
(7327, 'PH_D7', 'REGION', 'D7', 'Lucena', 'PH', '', '', '1'),
(7328, 'PH_D8', 'REGION', 'D8', 'Mandaue', 'PH', '', '', '1'),
(7329, 'PH_D9', 'REGION', 'D9', 'Manila', 'PH', '', '', '1'),
(7330, 'PH_E1', 'REGION', 'E1', 'Marawi', 'PH', '', '', '1'),
(7331, 'PH_E2', 'REGION', 'E2', 'Naga', 'PH', '', '', '1'),
(7332, 'PH_E3', 'REGION', 'E3', 'Olongapo', 'PH', '', '', '1'),
(7333, 'PH_E4', 'REGION', 'E4', 'Ormoc', 'PH', '', '', '1'),
(7334, 'PH_E5', 'REGION', 'E5', 'Oroquieta', 'PH', '', '', '1'),
(7335, 'PH_E6', 'REGION', 'E6', 'Ozamis', 'PH', '', '', '1'),
(7336, 'PH_E7', 'REGION', 'E7', 'Pagadian', 'PH', '', '', '1'),
(7337, 'PH_E8', 'REGION', 'E8', 'Palayan', 'PH', '', '', '1'),
(7338, 'PH_E9', 'REGION', 'E9', 'Pasay', 'PH', '', '', '1'),
(7339, 'PH_F1', 'REGION', 'F1', 'Puerto Princesa', 'PH', '', '', '1'),
(7340, 'PH_F2', 'REGION', 'F2', 'Quezon City', 'PH', '', '', '1'),
(7341, 'PH_F3', 'REGION', 'F3', 'Roxas', 'PH', '', '', '1'),
(7342, 'PH_F4', 'REGION', 'F4', 'San Carlos', 'PH', '', '', '1'),
(7343, 'PH_F5', 'REGION', 'F5', 'San Carlos', 'PH', '', '', '1'),
(7344, 'PH_F6', 'REGION', 'F6', 'San Jose', 'PH', '', '', '1'),
(7345, 'PH_F7', 'REGION', 'F7', 'San Pablo', 'PH', '', '', '1'),
(7346, 'PH_F8', 'REGION', 'F8', 'Silay', 'PH', '', '', '1'),
(7347, 'PH_F9', 'REGION', 'F9', 'Surigao', 'PH', '', '', '1'),
(7348, 'PH_G1', 'REGION', 'G1', 'Tacloban', 'PH', '', '', '1'),
(7349, 'PH_G2', 'REGION', 'G2', 'Tagaytay', 'PH', '', '', '1'),
(7350, 'PH_G3', 'REGION', 'G3', 'Tagbilaran', 'PH', '', '', '1'),
(7351, 'PH_G4', 'REGION', 'G4', 'Tangub', 'PH', '', '', '1'),
(7352, 'PH_G5', 'REGION', 'G5', 'Toledo', 'PH', '', '', '1'),
(7353, 'PH_G6', 'REGION', 'G6', 'Trece Martires', 'PH', '', '', '1'),
(7354, 'PH_G7', 'REGION', 'G7', 'Zamboanga', 'PH', '', '', '1'),
(7355, 'PH_G8', 'REGION', 'G8', 'Aurora', 'PH', '', '', '1'),
(7356, 'PH_H2', 'REGION', 'H2', 'Quezon', 'PH', '', '', '1'),
(7357, 'PH_H3', 'REGION', 'H3', 'Negros Occidental', 'PH', '', '', '1'),
(7358, 'PK_01', 'REGION', '01', 'Federally Administered Tribal Areas', 'PK', '', '', '1'),
(7359, 'PK_02', 'REGION', '02', 'Balochistan', 'PK', '', '', '1'),
(7360, 'PK_03', 'REGION', '03', 'North-West Frontier', 'PK', '', '', '1'),
(7361, 'PK_04', 'REGION', '04', 'Punjab', 'PK', '', '', '1'),
(7362, 'PK_05', 'REGION', '05', 'Sindh', 'PK', '', '', '1'),
(7363, 'PK_06', 'REGION', '06', 'Azad Kashmir', 'PK', '', '', '1'),
(7364, 'PK_07', 'REGION', '07', 'Northern Areas', 'PK', '', '', '1'),
(7365, 'PK_08', 'REGION', '08', 'Islamabad', 'PK', '', '', '1'),
(7366, 'PL_23', 'REGION', '23', 'Biala Podlaska', 'PL', '', '', '1'),
(7367, 'PL_24', 'REGION', '24', 'Bialystok', 'PL', '', '', '1'),
(7368, 'PL_25', 'REGION', '25', 'Bielsko', 'PL', '', '', '1'),
(7369, 'PL_26', 'REGION', '26', 'Bydgoszcz', 'PL', '', '', '1'),
(7370, 'PL_27', 'REGION', '27', 'Chelm', 'PL', '', '', '1'),
(7371, 'PL_28', 'REGION', '28', 'Ciechanow', 'PL', '', '', '1'),
(7372, 'PL_29', 'REGION', '29', 'Czestochowa', 'PL', '', '', '1'),
(7373, 'PL_30', 'REGION', '30', 'Elblag', 'PL', '', '', '1'),
(7374, 'PL_31', 'REGION', '31', 'Gdansk', 'PL', '', '', '1'),
(7375, 'PL_32', 'REGION', '32', 'Gorzow', 'PL', '', '', '1'),
(7376, 'PL_33', 'REGION', '33', 'Jelenia Gora', 'PL', '', '', '1'),
(7377, 'PL_34', 'REGION', '34', 'Kalisz', 'PL', '', '', '1'),
(7378, 'PL_35', 'REGION', '35', 'Katowice', 'PL', '', '', '1'),
(7379, 'PL_36', 'REGION', '36', 'Kielce', 'PL', '', '', '1'),
(7380, 'PL_37', 'REGION', '37', 'Konin', 'PL', '', '', '1'),
(7381, 'PL_38', 'REGION', '38', 'Koszalin', 'PL', '', '', '1'),
(7382, 'PL_39', 'REGION', '39', 'Krakow', 'PL', '', '', '1'),
(7383, 'PL_40', 'REGION', '40', 'Krosno', 'PL', '', '', '1'),
(7384, 'PL_41', 'REGION', '41', 'Legnica', 'PL', '', '', '1'),
(7385, 'PL_42', 'REGION', '42', 'Leszno', 'PL', '', '', '1'),
(7386, 'PL_43', 'REGION', '43', 'Lodz', 'PL', '', '', '1'),
(7387, 'PL_44', 'REGION', '44', 'Lomza', 'PL', '', '', '1'),
(7388, 'PL_45', 'REGION', '45', 'Lublin', 'PL', '', '', '1'),
(7389, 'PL_46', 'REGION', '46', 'Nowy Sacz', 'PL', '', '', '1'),
(7390, 'PL_47', 'REGION', '47', 'Olsztyn', 'PL', '', '', '1'),
(7391, 'PL_48', 'REGION', '48', 'Opole', 'PL', '', '', '1'),
(7392, 'PL_49', 'REGION', '49', 'Ostroleka', 'PL', '', '', '1'),
(7393, 'PL_50', 'REGION', '50', 'Pila', 'PL', '', '', '1'),
(7394, 'PL_51', 'REGION', '51', 'Piotrkow', 'PL', '', '', '1'),
(7395, 'PL_52', 'REGION', '52', 'Plock', 'PL', '', '', '1'),
(7396, 'PL_53', 'REGION', '53', 'Poznan', 'PL', '', '', '1'),
(7397, 'PL_54', 'REGION', '54', 'Przemysl', 'PL', '', '', '1'),
(7398, 'PL_55', 'REGION', '55', 'Radom', 'PL', '', '', '1'),
(7399, 'PL_56', 'REGION', '56', 'Rzeszow', 'PL', '', '', '1'),
(7400, 'PL_57', 'REGION', '57', 'Siedlce', 'PL', '', '', '1'),
(7401, 'PL_58', 'REGION', '58', 'Sieradz', 'PL', '', '', '1'),
(7402, 'PL_59', 'REGION', '59', 'Skierniewice', 'PL', '', '', '1'),
(7403, 'PL_60', 'REGION', '60', 'Slupsk', 'PL', '', '', '1'),
(7404, 'PL_61', 'REGION', '61', 'Suwalki', 'PL', '', '', '1'),
(7405, 'PL_62', 'REGION', '62', 'Szczecin', 'PL', '', '', '1'),
(7406, 'PL_63', 'REGION', '63', 'Tarnobrzeg', 'PL', '', '', '1'),
(7407, 'PL_64', 'REGION', '64', 'Tarnow', 'PL', '', '', '1'),
(7408, 'PL_65', 'REGION', '65', 'Torun', 'PL', '', '', '1'),
(7409, 'PL_66', 'REGION', '66', 'Walbrzych', 'PL', '', '', '1'),
(7410, 'PL_67', 'REGION', '67', 'Warszawa', 'PL', '', '', '1'),
(7411, 'PL_68', 'REGION', '68', 'Wloclawek', 'PL', '', '', '1'),
(7412, 'PL_69', 'REGION', '69', 'Wroclaw', 'PL', '', '', '1'),
(7413, 'PL_70', 'REGION', '70', 'Zamosc', 'PL', '', '', '1'),
(7414, 'PL_71', 'REGION', '71', 'Zielona Gora', 'PL', '', '', '1'),
(7415, 'PL_72', 'REGION', '72', 'Dolnoslaskie', 'PL', '', '', '1'),
(7416, 'PL_73', 'REGION', '73', 'Kujawsko-Pomorskie', 'PL', '', '', '1'),
(7417, 'PL_74', 'REGION', '74', 'Lodzkie', 'PL', '', '', '1'),
(7418, 'PL_75', 'REGION', '75', 'Lubelskie', 'PL', '', '', '1'),
(7419, 'PL_76', 'REGION', '76', 'Lubuskie', 'PL', '', '', '1'),
(7420, 'PL_77', 'REGION', '77', 'Malopolskie', 'PL', '', '', '1'),
(7421, 'PL_78', 'REGION', '78', 'Mazowieckie', 'PL', '', '', '1'),
(7422, 'PL_79', 'REGION', '79', 'Opolskie', 'PL', '', '', '1'),
(7423, 'PL_80', 'REGION', '80', 'Podkarpackie', 'PL', '', '', '1'),
(7424, 'PL_81', 'REGION', '81', 'Podlaskie', 'PL', '', '', '1'),
(7425, 'PL_82', 'REGION', '82', 'Pomorskie', 'PL', '', '', '1'),
(7426, 'PL_83', 'REGION', '83', 'Slaskie', 'PL', '', '', '1'),
(7427, 'PL_84', 'REGION', '84', 'Swietokrzyskie', 'PL', '', '', '1'),
(7428, 'PL_85', 'REGION', '85', 'Warminsko-Mazurskie', 'PL', '', '', '1'),
(7429, 'PL_86', 'REGION', '86', 'Wielkopolskie', 'PL', '', '', '1'),
(7430, 'PL_87', 'REGION', '87', 'Zachodniopomorskie', 'PL', '', '', '1'),
(7431, 'PS_GZ', 'REGION', 'GZ', 'Gaza', 'PS', '', '', '1'),
(7432, 'PS_WE', 'REGION', 'WE', 'West Bank', 'PS', '', '', '1'),
(7433, 'PT_02', 'REGION', '02', 'Aveiro', 'PT', '', '', '1'),
(7434, 'PT_03', 'REGION', '03', 'Beja', 'PT', '', '', '1'),
(7435, 'PT_04', 'REGION', '04', 'Braga', 'PT', '', '', '1'),
(7436, 'PT_05', 'REGION', '05', 'Braganca', 'PT', '', '', '1'),
(7437, 'PT_06', 'REGION', '06', 'Castelo Branco', 'PT', '', '', '1'),
(7438, 'PT_07', 'REGION', '07', 'Coimbra', 'PT', '', '', '1'),
(7439, 'PT_08', 'REGION', '08', 'Evora', 'PT', '', '', '1'),
(7440, 'PT_09', 'REGION', '09', 'Faro', 'PT', '', '', '1'),
(7441, 'PT_10', 'REGION', '10', 'Madeira', 'PT', '', '', '1'),
(7442, 'PT_11', 'REGION', '11', 'Guarda', 'PT', '', '', '1'),
(7443, 'PT_13', 'REGION', '13', 'Leiria', 'PT', '', '', '1'),
(7444, 'PT_14', 'REGION', '14', 'Lisboa', 'PT', '', '', '1'),
(7445, 'PT_16', 'REGION', '16', 'Portalegre', 'PT', '', '', '1'),
(7446, 'PT_17', 'REGION', '17', 'Porto', 'PT', '', '', '1'),
(7447, 'PT_18', 'REGION', '18', 'Santarem', 'PT', '', '', '1'),
(7448, 'PT_19', 'REGION', '19', 'Setubal', 'PT', '', '', '1'),
(7449, 'PT_20', 'REGION', '20', 'Viana do Castelo', 'PT', '', '', '1'),
(7450, 'PT_21', 'REGION', '21', 'Vila Real', 'PT', '', '', '1'),
(7451, 'PT_22', 'REGION', '22', 'Viseu', 'PT', '', '', '1'),
(7452, 'PT_23', 'REGION', '23', 'Azores', 'PT', '', '', '1'),
(7453, 'PY_01', 'REGION', '01', 'Alto Parana', 'PY', '', '', '1'),
(7454, 'PY_02', 'REGION', '02', 'Amambay', 'PY', '', '', '1'),
(7455, 'PY_03', 'REGION', '03', 'Boqueron', 'PY', '', '', '1'),
(7456, 'PY_04', 'REGION', '04', 'Caaguazu', 'PY', '', '', '1'),
(7457, 'PY_05', 'REGION', '05', 'Caazapa', 'PY', '', '', '1'),
(7458, 'PY_06', 'REGION', '06', 'Central', 'PY', '', '', '1'),
(7459, 'PY_07', 'REGION', '07', 'Concepcion', 'PY', '', '', '1'),
(7460, 'PY_08', 'REGION', '08', 'Cordillera', 'PY', '', '', '1'),
(7461, 'PY_10', 'REGION', '10', 'Guaira', 'PY', '', '', '1'),
(7462, 'PY_11', 'REGION', '11', 'Itapua', 'PY', '', '', '1'),
(7463, 'PY_12', 'REGION', '12', 'Misiones', 'PY', '', '', '1'),
(7464, 'PY_13', 'REGION', '13', 'Neembucu', 'PY', '', '', '1'),
(7465, 'PY_15', 'REGION', '15', 'Paraguari', 'PY', '', '', '1'),
(7466, 'PY_16', 'REGION', '16', 'Presidente Hayes', 'PY', '', '', '1'),
(7467, 'PY_17', 'REGION', '17', 'San Pedro', 'PY', '', '', '1'),
(7468, 'PY_19', 'REGION', '19', 'Canindeyu', 'PY', '', '', '1'),
(7469, 'PY_20', 'REGION', '20', 'Chaco', 'PY', '', '', '1'),
(7470, 'PY_21', 'REGION', '21', 'Nueva Asuncion', 'PY', '', '', '1'),
(7471, 'PY_23', 'REGION', '23', 'Alto Paraguay', 'PY', '', '', '1'),
(7472, 'QA_01', 'REGION', '01', 'Ad Dawhah', 'QA', '', '', '1'),
(7473, 'QA_02', 'REGION', '02', 'Al Ghuwariyah', 'QA', '', '', '1'),
(7474, 'QA_03', 'REGION', '03', 'Al Jumaliyah', 'QA', '', '', '1'),
(7475, 'QA_04', 'REGION', '04', 'Al Khawr', 'QA', '', '', '1'),
(7476, 'QA_05', 'REGION', '05', 'Al Wakrah Municipality', 'QA', '', '', '1'),
(7477, 'QA_06', 'REGION', '06', 'Ar Rayyan', 'QA', '', '', '1'),
(7478, 'QA_08', 'REGION', '08', 'Madinat ach Shamal', 'QA', '', '', '1'),
(7479, 'QA_09', 'REGION', '09', 'Umm Salal', 'QA', '', '', '1'),
(7480, 'QA_10', 'REGION', '10', 'Al Wakrah', 'QA', '', '', '1'),
(7481, 'QA_11', 'REGION', '11', 'Jariyan al Batnah', 'QA', '', '', '1'),
(7482, 'RO_01', 'REGION', '01', 'Alba', 'RO', '', '', '1'),
(7483, 'RO_02', 'REGION', '02', 'Arad', 'RO', '', '', '1'),
(7484, 'RO_03', 'REGION', '03', 'Arges', 'RO', '', '', '1'),
(7485, 'RO_04', 'REGION', '04', 'Bacau', 'RO', '', '', '1'),
(7486, 'RO_05', 'REGION', '05', 'Bihor', 'RO', '', '', '1'),
(7487, 'RO_06', 'REGION', '06', 'Bistrita-Nasaud', 'RO', '', '', '1'),
(7488, 'RO_07', 'REGION', '07', 'Botosani', 'RO', '', '', '1'),
(7489, 'RO_08', 'REGION', '08', 'Braila', 'RO', '', '', '1'),
(7490, 'RO_09', 'REGION', '09', 'Brasov', 'RO', '', '', '1'),
(7491, 'RO_10', 'REGION', '10', 'Bucuresti', 'RO', '', '', '1'),
(7492, 'RO_11', 'REGION', '11', 'Buzau', 'RO', '', '', '1'),
(7493, 'RO_12', 'REGION', '12', 'Caras-Severin', 'RO', '', '', '1'),
(7494, 'RO_13', 'REGION', '13', 'Cluj', 'RO', '', '', '1'),
(7495, 'RO_14', 'REGION', '14', 'Constanta', 'RO', '', '', '1'),
(7496, 'RO_15', 'REGION', '15', 'Covasna', 'RO', '', '', '1'),
(7497, 'RO_16', 'REGION', '16', 'Dambovita', 'RO', '', '', '1'),
(7498, 'RO_17', 'REGION', '17', 'Dolj', 'RO', '', '', '1'),
(7499, 'RO_18', 'REGION', '18', 'Galati', 'RO', '', '', '1'),
(7500, 'RO_19', 'REGION', '19', 'Gorj', 'RO', '', '', '1'),
(7501, 'RO_20', 'REGION', '20', 'Harghita', 'RO', '', '', '1'),
(7502, 'RO_21', 'REGION', '21', 'Hunedoara', 'RO', '', '', '1'),
(7503, 'RO_22', 'REGION', '22', 'Ialomita', 'RO', '', '', '1'),
(7504, 'RO_23', 'REGION', '23', 'Iasi', 'RO', '', '', '1'),
(7505, 'RO_25', 'REGION', '25', 'Maramures', 'RO', '', '', '1'),
(7506, 'RO_26', 'REGION', '26', 'Mehedinti', 'RO', '', '', '1'),
(7507, 'RO_27', 'REGION', '27', 'Mures', 'RO', '', '', '1'),
(7508, 'RO_28', 'REGION', '28', 'Neamt', 'RO', '', '', '1'),
(7509, 'RO_29', 'REGION', '29', 'Olt', 'RO', '', '', '1'),
(7510, 'RO_30', 'REGION', '30', 'Prahova', 'RO', '', '', '1'),
(7511, 'RO_31', 'REGION', '31', 'Salaj', 'RO', '', '', '1'),
(7512, 'RO_32', 'REGION', '32', 'Satu Mare', 'RO', '', '', '1'),
(7513, 'RO_33', 'REGION', '33', 'Sibiu', 'RO', '', '', '1'),
(7514, 'RO_34', 'REGION', '34', 'Suceava', 'RO', '', '', '1'),
(7515, 'RO_35', 'REGION', '35', 'Teleorman', 'RO', '', '', '1'),
(7516, 'RO_36', 'REGION', '36', 'Timis', 'RO', '', '', '1'),
(7517, 'RO_37', 'REGION', '37', 'Tulcea', 'RO', '', '', '1'),
(7518, 'RO_38', 'REGION', '38', 'Vaslui', 'RO', '', '', '1'),
(7519, 'RO_39', 'REGION', '39', 'Valcea', 'RO', '', '', '1'),
(7520, 'RO_40', 'REGION', '40', 'Vrancea', 'RO', '', '', '1'),
(7521, 'RO_41', 'REGION', '41', 'Calarasi', 'RO', '', '', '1'),
(7522, 'RO_42', 'REGION', '42', 'Giurgiu', 'RO', '', '', '1'),
(7523, 'RO_43', 'REGION', '43', 'Ilfov', 'RO', '', '', '1'),
(7524, 'RS_01', 'REGION', '01', 'Kosovo', 'RS', '', '', '1'),
(7525, 'RS_02', 'REGION', '02', 'Vojvodina', 'RS', '', '', '1'),
(7526, 'RU_01', 'REGION', '01', 'Adygeya, Republic of', 'RU', '', '', '1'),
(7527, 'RU_02', 'REGION', '02', 'Aginsky Buryatsky AO', 'RU', '', '', '1'),
(7528, 'RU_03', 'REGION', '03', 'Gorno-Altay', 'RU', '', '', '1'),
(7529, 'RU_04', 'REGION', '04', 'Altaisky krai', 'RU', '', '', '1'),
(7530, 'RU_05', 'REGION', '05', 'Amur', 'RU', '', '', '1'),
(7531, 'RU_08', 'REGION', '08', 'Bashkortostan', 'RU', '', '', '1'),
(7532, 'RU_09', 'REGION', '09', 'Belgorod', 'RU', '', '', '1'),
(7533, 'RU_10', 'REGION', '10', 'Bryansk', 'RU', '', '', '1'),
(7534, 'RU_11', 'REGION', '11', 'Buryat', 'RU', '', '', '1'),
(7535, 'RU_12', 'REGION', '12', 'Chechnya', 'RU', '', '', '1'),
(7536, 'RU_13', 'REGION', '13', 'Chelyabinsk', 'RU', '', '', '1'),
(7537, 'RU_14', 'REGION', '14', 'Chita', 'RU', '', '', '1'),
(7538, 'RU_15', 'REGION', '15', 'Chukot', 'RU', '', '', '1'),
(7539, 'RU_16', 'REGION', '16', 'Chuvashia', 'RU', '', '', '1'),
(7540, 'RU_17', 'REGION', '17', 'Dagestan', 'RU', '', '', '1'),
(7541, 'RU_18', 'REGION', '18', 'Evenk', 'RU', '', '', '1'),
(7542, 'RU_19', 'REGION', '19', 'Ingush', 'RU', '', '', '1'),
(7543, 'RU_20', 'REGION', '20', 'Irkutsk', 'RU', '', '', '1'),
(7544, 'RU_21', 'REGION', '21', 'Ivanovo', 'RU', '', '', '1'),
(7545, 'RU_22', 'REGION', '22', 'Kabardin-Balkar', 'RU', '', '', '1'),
(7546, 'RU_23', 'REGION', '23', 'Kaliningrad', 'RU', '', '', '1'),
(7547, 'RU_24', 'REGION', '24', 'Kalmyk', 'RU', '', '', '1'),
(7548, 'RU_25', 'REGION', '25', 'Kaluga', 'RU', '', '', '1'),
(7549, 'RU_26', 'REGION', '26', 'Kamchatka', 'RU', '', '', '1'),
(7550, 'RU_27', 'REGION', '27', 'Karachay-Cherkess', 'RU', '', '', '1'),
(7551, 'RU_28', 'REGION', '28', 'Karelia', 'RU', '', '', '1'),
(7552, 'RU_29', 'REGION', '29', 'Kemerovo', 'RU', '', '', '1'),
(7553, 'RU_30', 'REGION', '30', 'Khabarovsk', 'RU', '', '', '1'),
(7554, 'RU_31', 'REGION', '31', 'Khakass', 'RU', '', '', '1'),
(7555, 'RU_32', 'REGION', '32', 'Khanty-Mansiy', 'RU', '', '', '1'),
(7556, 'RU_33', 'REGION', '33', 'Kirov', 'RU', '', '', '1'),
(7557, 'RU_34', 'REGION', '34', 'Komi', 'RU', '', '', '1'),
(7558, 'RU_35', 'REGION', '35', 'Komi-Permyak', 'RU', '', '', '1'),
(7559, 'RU_36', 'REGION', '36', 'Koryak', 'RU', '', '', '1'),
(7560, 'RU_37', 'REGION', '37', 'Kostroma', 'RU', '', '', '1'),
(7561, 'RU_38', 'REGION', '38', 'Krasnodar', 'RU', '', '', '1'),
(7562, 'RU_39', 'REGION', '39', 'Krasnoyarsk', 'RU', '', '', '1'),
(7563, 'RU_40', 'REGION', '40', 'Kurgan', 'RU', '', '', '1'),
(7564, 'RU_41', 'REGION', '41', 'Kursk', 'RU', '', '', '1'),
(7565, 'RU_42', 'REGION', '42', 'Leningrad', 'RU', '', '', '1'),
(7566, 'RU_43', 'REGION', '43', 'Lipetsk', 'RU', '', '', '1'),
(7567, 'RU_44', 'REGION', '44', 'Magadan', 'RU', '', '', '1'),
(7568, 'RU_45', 'REGION', '45', 'Mariy-El', 'RU', '', '', '1'),
(7569, 'RU_46', 'REGION', '46', 'Mordovia', 'RU', '', '', '1'),
(7570, 'RU_47', 'REGION', '47', 'Moskva', 'RU', '', '', '1'),
(7571, 'RU_48', 'REGION', '48', 'Moscow City', 'RU', '', '', '1'),
(7572, 'RU_49', 'REGION', '49', 'Murmansk', 'RU', '', '', '1'),
(7573, 'RU_50', 'REGION', '50', 'Nenets', 'RU', '', '', '1'),
(7574, 'RU_51', 'REGION', '51', 'Nizhegorod', 'RU', '', '', '1'),
(7575, 'RU_52', 'REGION', '52', 'Novgorod', 'RU', '', '', '1'),
(7576, 'RU_53', 'REGION', '53', 'Novosibirsk', 'RU', '', '', '1'),
(7577, 'RU_54', 'REGION', '54', 'Omsk', 'RU', '', '', '1'),
(7578, 'RU_55', 'REGION', '55', 'Orenburg', 'RU', '', '', '1'),
(7579, 'RU_56', 'REGION', '56', 'Orel', 'RU', '', '', '1'),
(7580, 'RU_57', 'REGION', '57', 'Penza', 'RU', '', '', '1'),
(7581, 'RU_60', 'REGION', '60', 'Pskov', 'RU', '', '', '1'),
(7582, 'RU_61', 'REGION', '61', 'Rostov', 'RU', '', '', '1'),
(7583, 'RU_63', 'REGION', '63', 'Sakha', 'RU', '', '', '1'),
(7584, 'RU_64', 'REGION', '64', 'Sakhalin', 'RU', '', '', '1'),
(7585, 'RU_65', 'REGION', '65', 'Samara', 'RU', '', '', '1'),
(7586, 'RU_66', 'REGION', '66', 'Saint Petersburg City', 'RU', '', '', '1'),
(7587, 'RU_67', 'REGION', '67', 'Saratov', 'RU', '', '', '1'),
(7588, 'RU_68', 'REGION', '68', 'North Ossetia', 'RU', '', '', '1'),
(7589, 'RU_69', 'REGION', '69', 'Smolensk', 'RU', '', '', '1'),
(7590, 'RU_71', 'REGION', '71', 'Sverdlovsk', 'RU', '', '', '1'),
(7591, 'RU_72', 'REGION', '72', 'Tambovskaya oblast', 'RU', '', '', '1'),
(7592, 'RU_73', 'REGION', '73', 'Tatarstan', 'RU', '', '', '1'),
(7593, 'RU_74', 'REGION', '74', 'Taymyr', 'RU', '', '', '1'),
(7594, 'RU_75', 'REGION', '75', 'Tomsk', 'RU', '', '', '1'),
(7595, 'RU_76', 'REGION', '76', 'Tula', 'RU', '', '', '1'),
(7596, 'RU_79', 'REGION', '79', 'Tuva', 'RU', '', '', '1'),
(7597, 'RU_80', 'REGION', '80', 'Udmurt', 'RU', '', '', '1'),
(7598, 'RU_82', 'REGION', '82', 'Ust-Orda Buryat', 'RU', '', '', '1'),
(7599, 'RU_83', 'REGION', '83', 'Vladimir', 'RU', '', '', '1'),
(7600, 'RU_84', 'REGION', '84', 'Volgograd', 'RU', '', '', '1'),
(7601, 'RU_85', 'REGION', '85', 'Vologda', 'RU', '', '', '1'),
(7602, 'RU_86', 'REGION', '86', 'Voronezh', 'RU', '', '', '1'),
(7603, 'RU_87', 'REGION', '87', 'Yamal-Nenets', 'RU', '', '', '1'),
(7604, 'RU_89', 'REGION', '89', 'Yevrey', 'RU', '', '', '1'),
(7605, 'RU_90', 'REGION', '90', 'Permskiy Kray', 'RU', '', '', '1'),
(7606, 'RU_91', 'REGION', '91', 'Krasnoyarskiy Kray', 'RU', '', '', '1'),
(7607, 'RU_CI', 'REGION', 'CI', 'Chechnya Republic', 'RU', '', '', '1'),
(7608, 'RW_01', 'REGION', '01', 'Butare', 'RW', '', '', '1'),
(7609, 'RW_06', 'REGION', '06', 'Gitarama', 'RW', '', '', '1'),
(7610, 'RW_07', 'REGION', '07', 'Kibungo', 'RW', '', '', '1'),
(7611, 'RW_09', 'REGION', '09', 'Kigali', 'RW', '', '', '1'),
(7612, 'RW_11', 'REGION', '11', 'Est', 'RW', '', '', '1'),
(7613, 'RW_12', 'REGION', '12', 'Kigali', 'RW', '', '', '1'),
(7614, 'RW_13', 'REGION', '13', 'Nord', 'RW', '', '', '1'),
(7615, 'RW_14', 'REGION', '14', 'Ouest', 'RW', '', '', '1'),
(7616, 'RW_15', 'REGION', '15', 'Sud', 'RW', '', '', '1'),
(7617, 'SA_02', 'REGION', '02', 'Al Bahah', 'SA', '', '', '1'),
(7618, 'SA_03', 'REGION', '03', 'Al Jawf', 'SA', '', '', '1'),
(7619, 'SA_05', 'REGION', '05', 'Al Madinah', 'SA', '', '', '1'),
(7620, 'SA_06', 'REGION', '06', 'Ash Sharqiyah', 'SA', '', '', '1'),
(7621, 'SA_08', 'REGION', '08', 'Al Qasim', 'SA', '', '', '1'),
(7622, 'SA_09', 'REGION', '09', 'Al Qurayyat', 'SA', '', '', '1'),
(7623, 'SA_10', 'REGION', '10', 'Ar Riyad', 'SA', '', '', '1'),
(7624, 'SA_14', 'REGION', '14', 'Makkah', 'SA', '', '', '1'),
(7625, 'SA_15', 'REGION', '15', 'Al Hudud ash Shamaliyah', 'SA', '', '', '1'),
(7626, 'SA_16', 'REGION', '16', 'Najran', 'SA', '', '', '1'),
(7627, 'SA_17', 'REGION', '17', 'Jizan', 'SA', '', '', '1'),
(7628, 'SA_19', 'REGION', '19', 'Tabuk', 'SA', '', '', '1'),
(7629, 'SA_20', 'REGION', '20', 'Al Jawf', 'SA', '', '', '1'),
(7630, 'SB_03', 'REGION', '03', 'Malaita', 'SB', '', '', '1'),
(7631, 'SB_06', 'REGION', '06', 'Guadalcanal', 'SB', '', '', '1'),
(7632, 'SB_07', 'REGION', '07', 'Isabel', 'SB', '', '', '1'),
(7633, 'SB_08', 'REGION', '08', 'Makira', 'SB', '', '', '1'),
(7634, 'SB_09', 'REGION', '09', 'Temotu', 'SB', '', '', '1'),
(7635, 'SB_10', 'REGION', '10', 'Central', 'SB', '', '', '1'),
(7636, 'SB_11', 'REGION', '11', 'Western', 'SB', '', '', '1'),
(7637, 'SB_12', 'REGION', '12', 'Choiseul', 'SB', '', '', '1'),
(7638, 'SB_13', 'REGION', '13', 'Rennell and Bellona', 'SB', '', '', '1'),
(7639, 'SC_01', 'REGION', '01', 'Anse aux Pins', 'SC', '', '', '1'),
(7640, 'SC_02', 'REGION', '02', 'Anse Boileau', 'SC', '', '', '1'),
(7641, 'SC_03', 'REGION', '03', 'Anse Etoile', 'SC', '', '', '1'),
(7642, 'SC_04', 'REGION', '04', 'Anse Louis', 'SC', '', '', '1'),
(7643, 'SC_05', 'REGION', '05', 'Anse Royale', 'SC', '', '', '1'),
(7644, 'SC_06', 'REGION', '06', 'Baie Lazare', 'SC', '', '', '1'),
(7645, 'SC_07', 'REGION', '07', 'Baie Sainte Anne', 'SC', '', '', '1'),
(7646, 'SC_08', 'REGION', '08', 'Beau Vallon', 'SC', '', '', '1'),
(7647, 'SC_09', 'REGION', '09', 'Bel Air', 'SC', '', '', '1'),
(7648, 'SC_10', 'REGION', '10', 'Bel Ombre', 'SC', '', '', '1'),
(7649, 'SC_11', 'REGION', '11', 'Cascade', 'SC', '', '', '1'),
(7650, 'SC_12', 'REGION', '12', 'Glacis', 'SC', '', '', '1'),
(7651, 'SC_15', 'REGION', '15', 'La Digue', 'SC', '', '', '1'),
(7652, 'SC_16', 'REGION', '16', 'La Riviere Anglaise', 'SC', '', '', '1'),
(7653, 'SC_17', 'REGION', '17', 'Mont Buxton', 'SC', '', '', '1'),
(7654, 'SC_18', 'REGION', '18', 'Mont Fleuri', 'SC', '', '', '1'),
(7655, 'SC_19', 'REGION', '19', 'Plaisance', 'SC', '', '', '1'),
(7656, 'SC_20', 'REGION', '20', 'Pointe La Rue', 'SC', '', '', '1'),
(7657, 'SC_21', 'REGION', '21', 'Port Glaud', 'SC', '', '', '1'),
(7658, 'SC_22', 'REGION', '22', 'Saint Louis', 'SC', '', '', '1'),
(7659, 'SC_23', 'REGION', '23', 'Takamaka', 'SC', '', '', '1'),
(7660, 'SD_27', 'REGION', '27', 'Al Wusta', 'SD', '', '', '1'),
(7661, 'SD_29', 'REGION', '29', 'Al Khartum', 'SD', '', '', '1'),
(7662, 'SD_30', 'REGION', '30', 'Ash Shamaliyah', 'SD', '', '', '1'),
(7663, 'SD_31', 'REGION', '31', 'Ash Sharqiyah', 'SD', '', '', '1'),
(7664, 'SD_32', 'REGION', '32', 'Bahr al Ghazal', 'SD', '', '', '1'),
(7665, 'SD_33', 'REGION', '33', 'Darfur', 'SD', '', '', '1'),
(7666, 'SD_34', 'REGION', '34', 'Kurdufan', 'SD', '', '', '1'),
(7667, 'SD_35', 'REGION', '35', 'Upper Nile', 'SD', '', '', '1'),
(7668, 'SD_40', 'REGION', '40', 'Al Wahadah State', 'SD', '', '', '1'),
(7669, 'SD_44', 'REGION', '44', 'Central Equatoria State', 'SD', '', '', '1'),
(7670, 'SE_01', 'REGION', '01', 'Alvsborgs Lan', 'SE', '', '', '1'),
(7671, 'SE_02', 'REGION', '02', 'Blekinge Lan', 'SE', '', '', '1'),
(7672, 'SE_03', 'REGION', '03', 'Gavleborgs Lan', 'SE', '', '', '1'),
(7673, 'SE_04', 'REGION', '04', 'Goteborgs och Bohus Lan', 'SE', '', '', '1'),
(7674, 'SE_05', 'REGION', '05', 'Gotlands Lan', 'SE', '', '', '1'),
(7675, 'SE_06', 'REGION', '06', 'Hallands Lan', 'SE', '', '', '1'),
(7676, 'SE_07', 'REGION', '07', 'Jamtlands Lan', 'SE', '', '', '1'),
(7677, 'SE_08', 'REGION', '08', 'Jonkopings Lan', 'SE', '', '', '1'),
(7678, 'SE_09', 'REGION', '09', 'Kalmar Lan', 'SE', '', '', '1'),
(7679, 'SE_10', 'REGION', '10', 'Dalarnas Lan', 'SE', '', '', '1'),
(7680, 'SE_11', 'REGION', '11', 'Kristianstads Lan', 'SE', '', '', '1'),
(7681, 'SE_12', 'REGION', '12', 'Kronobergs Lan', 'SE', '', '', '1'),
(7682, 'SE_13', 'REGION', '13', 'Malmohus Lan', 'SE', '', '', '1'),
(7683, 'SE_14', 'REGION', '14', 'Norrbottens Lan', 'SE', '', '', '1'),
(7684, 'SE_15', 'REGION', '15', 'Orebro Lan', 'SE', '', '', '1'),
(7685, 'SE_16', 'REGION', '16', 'Ostergotlands Lan', 'SE', '', '', '1'),
(7686, 'SE_17', 'REGION', '17', 'Skaraborgs Lan', 'SE', '', '', '1'),
(7687, 'SE_18', 'REGION', '18', 'Sodermanlands Lan', 'SE', '', '', '1'),
(7688, 'SE_21', 'REGION', '21', 'Uppsala Lan', 'SE', '', '', '1'),
(7689, 'SE_22', 'REGION', '22', 'Varmlands Lan', 'SE', '', '', '1'),
(7690, 'SE_23', 'REGION', '23', 'Vasterbottens Lan', 'SE', '', '', '1'),
(7691, 'SE_24', 'REGION', '24', 'Vasternorrlands Lan', 'SE', '', '', '1'),
(7692, 'SE_25', 'REGION', '25', 'Vastmanlands Lan', 'SE', '', '', '1'),
(7693, 'SE_26', 'REGION', '26', 'Stockholms Lan', 'SE', '', '', '1'),
(7694, 'SE_27', 'REGION', '27', 'Skane Lan', 'SE', '', '', '1'),
(7695, 'SE_28', 'REGION', '28', 'Vastra Gotaland', 'SE', '', '', '1'),
(7696, 'SH_01', 'REGION', '01', 'Ascension', 'SH', '', '', '1'),
(7697, 'SH_02', 'REGION', '02', 'Saint Helena', 'SH', '', '', '1'),
(7698, 'SH_03', 'REGION', '03', 'Tristan da Cunha', 'SH', '', '', '1'),
(7699, 'SI_01', 'REGION', '01', 'Ajdovscina', 'SI', '', '', '1'),
(7700, 'SI_02', 'REGION', '02', 'Beltinci', 'SI', '', '', '1'),
(7701, 'SI_03', 'REGION', '03', 'Bled', 'SI', '', '', '1'),
(7702, 'SI_04', 'REGION', '04', 'Bohinj', 'SI', '', '', '1'),
(7703, 'SI_05', 'REGION', '05', 'Borovnica', 'SI', '', '', '1'),
(7704, 'SI_06', 'REGION', '06', 'Bovec', 'SI', '', '', '1'),
(7705, 'SI_07', 'REGION', '07', 'Brda', 'SI', '', '', '1'),
(7706, 'SI_08', 'REGION', '08', 'Brezice', 'SI', '', '', '1'),
(7707, 'SI_09', 'REGION', '09', 'Brezovica', 'SI', '', '', '1'),
(7708, 'SI_11', 'REGION', '11', 'Celje', 'SI', '', '', '1'),
(7709, 'SI_12', 'REGION', '12', 'Cerklje na Gorenjskem', 'SI', '', '', '1'),
(7710, 'SI_13', 'REGION', '13', 'Cerknica', 'SI', '', '', '1'),
(7711, 'SI_14', 'REGION', '14', 'Cerkno', 'SI', '', '', '1'),
(7712, 'SI_15', 'REGION', '15', 'Crensovci', 'SI', '', '', '1'),
(7713, 'SI_16', 'REGION', '16', 'Crna na Koroskem', 'SI', '', '', '1'),
(7714, 'SI_17', 'REGION', '17', 'Crnomelj', 'SI', '', '', '1'),
(7715, 'SI_19', 'REGION', '19', 'Divaca', 'SI', '', '', '1'),
(7716, 'SI_20', 'REGION', '20', 'Dobrepolje', 'SI', '', '', '1'),
(7717, 'SI_22', 'REGION', '22', 'Dol pri Ljubljani', 'SI', '', '', '1'),
(7718, 'SI_24', 'REGION', '24', 'Dornava', 'SI', '', '', '1'),
(7719, 'SI_25', 'REGION', '25', 'Dravograd', 'SI', '', '', '1'),
(7720, 'SI_26', 'REGION', '26', 'Duplek', 'SI', '', '', '1'),
(7721, 'SI_27', 'REGION', '27', 'Gorenja Vas-Poljane', 'SI', '', '', '1'),
(7722, 'SI_28', 'REGION', '28', 'Gorisnica', 'SI', '', '', '1'),
(7723, 'SI_29', 'REGION', '29', 'Gornja Radgona', 'SI', '', '', '1'),
(7724, 'SI_30', 'REGION', '30', 'Gornji Grad', 'SI', '', '', '1'),
(7725, 'SI_31', 'REGION', '31', 'Gornji Petrovci', 'SI', '', '', '1'),
(7726, 'SI_32', 'REGION', '32', 'Grosuplje', 'SI', '', '', '1'),
(7727, 'SI_34', 'REGION', '34', 'Hrastnik', 'SI', '', '', '1'),
(7728, 'SI_35', 'REGION', '35', 'Hrpelje-Kozina', 'SI', '', '', '1'),
(7729, 'SI_36', 'REGION', '36', 'Idrija', 'SI', '', '', '1'),
(7730, 'SI_37', 'REGION', '37', 'Ig', 'SI', '', '', '1'),
(7731, 'SI_38', 'REGION', '38', 'Ilirska Bistrica', 'SI', '', '', '1'),
(7732, 'SI_39', 'REGION', '39', 'Ivancna Gorica', 'SI', '', '', '1'),
(7733, 'SI_40', 'REGION', '40', 'Izola-Isola', 'SI', '', '', '1'),
(7734, 'SI_42', 'REGION', '42', 'Jursinci', 'SI', '', '', '1'),
(7735, 'SI_44', 'REGION', '44', 'Kanal', 'SI', '', '', '1'),
(7736, 'SI_45', 'REGION', '45', 'Kidricevo', 'SI', '', '', '1'),
(7737, 'SI_46', 'REGION', '46', 'Kobarid', 'SI', '', '', '1'),
(7738, 'SI_47', 'REGION', '47', 'Kobilje', 'SI', '', '', '1'),
(7739, 'SI_49', 'REGION', '49', 'Komen', 'SI', '', '', '1'),
(7740, 'SI_50', 'REGION', '50', 'Koper-Capodistria', 'SI', '', '', '1'),
(7741, 'SI_51', 'REGION', '51', 'Kozje', 'SI', '', '', '1'),
(7742, 'SI_52', 'REGION', '52', 'Kranj', 'SI', '', '', '1'),
(7743, 'SI_53', 'REGION', '53', 'Kranjska Gora', 'SI', '', '', '1'),
(7744, 'SI_54', 'REGION', '54', 'Krsko', 'SI', '', '', '1'),
(7745, 'SI_55', 'REGION', '55', 'Kungota', 'SI', '', '', '1'),
(7746, 'SI_57', 'REGION', '57', 'Lasko', 'SI', '', '', '1'),
(7747, 'SI_61', 'REGION', '61', 'Ljubljana', 'SI', '', '', '1'),
(7748, 'SI_62', 'REGION', '62', 'Ljubno', 'SI', '', '', '1'),
(7749, 'SI_64', 'REGION', '64', 'Logatec', 'SI', '', '', '1'),
(7750, 'SI_66', 'REGION', '66', 'Loski Potok', 'SI', '', '', '1'),
(7751, 'SI_68', 'REGION', '68', 'Lukovica', 'SI', '', '', '1'),
(7752, 'SI_71', 'REGION', '71', 'Medvode', 'SI', '', '', '1'),
(7753, 'SI_72', 'REGION', '72', 'Menges', 'SI', '', '', '1'),
(7754, 'SI_73', 'REGION', '73', 'Metlika', 'SI', '', '', '1'),
(7755, 'SI_74', 'REGION', '74', 'Mezica', 'SI', '', '', '1'),
(7756, 'SI_76', 'REGION', '76', 'Mislinja', 'SI', '', '', '1'),
(7757, 'SI_77', 'REGION', '77', 'Moravce', 'SI', '', '', '1'),
(7758, 'SI_78', 'REGION', '78', 'Moravske Toplice', 'SI', '', '', '1'),
(7759, 'SI_79', 'REGION', '79', 'Mozirje', 'SI', '', '', '1'),
(7760, 'SI_80', 'REGION', '80', 'Murska Sobota', 'SI', '', '', '1'),
(7761, 'SI_81', 'REGION', '81', 'Muta', 'SI', '', '', '1'),
(7762, 'SI_82', 'REGION', '82', 'Naklo', 'SI', '', '', '1'),
(7763, 'SI_83', 'REGION', '83', 'Nazarje', 'SI', '', '', '1'),
(7764, 'SI_84', 'REGION', '84', 'Nova Gorica', 'SI', '', '', '1'),
(7765, 'SI_86', 'REGION', '86', 'Odranci', 'SI', '', '', '1'),
(7766, 'SI_87', 'REGION', '87', 'Ormoz', 'SI', '', '', '1'),
(7767, 'SI_88', 'REGION', '88', 'Osilnica', 'SI', '', '', '1'),
(7768, 'SI_89', 'REGION', '89', 'Pesnica', 'SI', '', '', '1'),
(7769, 'SI_91', 'REGION', '91', 'Pivka', 'SI', '', '', '1'),
(7770, 'SI_92', 'REGION', '92', 'Podcetrtek', 'SI', '', '', '1'),
(7771, 'SI_94', 'REGION', '94', 'Postojna', 'SI', '', '', '1'),
(7772, 'SI_97', 'REGION', '97', 'Puconci', 'SI', '', '', '1'),
(7773, 'SI_98', 'REGION', '98', 'Racam', 'SI', '', '', '1'),
(7774, 'SI_99', 'REGION', '99', 'Radece', 'SI', '', '', '1'),
(7775, 'SI_A1', 'REGION', 'A1', 'Radenci', 'SI', '', '', '1'),
(7776, 'SI_A2', 'REGION', 'A2', 'Radlje ob Dravi', 'SI', '', '', '1'),
(7777, 'SI_A3', 'REGION', 'A3', 'Radovljica', 'SI', '', '', '1'),
(7778, 'SI_A6', 'REGION', 'A6', 'Rogasovci', 'SI', '', '', '1'),
(7779, 'SI_A7', 'REGION', 'A7', 'Rogaska Slatina', 'SI', '', '', '1'),
(7780, 'SI_A8', 'REGION', 'A8', 'Rogatec', 'SI', '', '', '1'),
(7781, 'SI_B1', 'REGION', 'B1', 'Semic', 'SI', '', '', '1'),
(7782, 'SI_B2', 'REGION', 'B2', 'Sencur', 'SI', '', '', '1'),
(7783, 'SI_B3', 'REGION', 'B3', 'Sentilj', 'SI', '', '', '1'),
(7784, 'SI_B4', 'REGION', 'B4', 'Sentjernej', 'SI', '', '', '1'),
(7785, 'SI_B6', 'REGION', 'B6', 'Sevnica', 'SI', '', '', '1'),
(7786, 'SI_B7', 'REGION', 'B7', 'Sezana', 'SI', '', '', '1'),
(7787, 'SI_B8', 'REGION', 'B8', 'Skocjan', 'SI', '', '', '1'),
(7788, 'SI_B9', 'REGION', 'B9', 'Skofja Loka', 'SI', '', '', '1'),
(7789, 'SI_C1', 'REGION', 'C1', 'Skofljica', 'SI', '', '', '1'),
(7790, 'SI_C2', 'REGION', 'C2', 'Slovenj Gradec', 'SI', '', '', '1'),
(7791, 'SI_C4', 'REGION', 'C4', 'Slovenske Konjice', 'SI', '', '', '1'),
(7792, 'SI_C5', 'REGION', 'C5', 'Smarje pri Jelsah', 'SI', '', '', '1'),
(7793, 'SI_C6', 'REGION', 'C6', 'Smartno ob Paki', 'SI', '', '', '1'),
(7794, 'SI_C7', 'REGION', 'C7', 'Sostanj', 'SI', '', '', '1'),
(7795, 'SI_C8', 'REGION', 'C8', 'Starse', 'SI', '', '', '1'),
(7796, 'SI_C9', 'REGION', 'C9', 'Store', 'SI', '', '', '1'),
(7797, 'SI_D1', 'REGION', 'D1', 'Sveti Jurij', 'SI', '', '', '1'),
(7798, 'SI_D2', 'REGION', 'D2', 'Tolmin', 'SI', '', '', '1'),
(7799, 'SI_D3', 'REGION', 'D3', 'Trbovlje', 'SI', '', '', '1'),
(7800, 'SI_D4', 'REGION', 'D4', 'Trebnje', 'SI', '', '', '1'),
(7801, 'SI_D5', 'REGION', 'D5', 'Trzic', 'SI', '', '', '1'),
(7802, 'SI_D6', 'REGION', 'D6', 'Turnisce', 'SI', '', '', '1'),
(7803, 'SI_D7', 'REGION', 'D7', 'Velenje', 'SI', '', '', '1'),
(7804, 'SI_D8', 'REGION', 'D8', 'Velike Lasce', 'SI', '', '', '1'),
(7805, 'SI_E1', 'REGION', 'E1', 'Vipava', 'SI', '', '', '1'),
(7806, 'SI_E2', 'REGION', 'E2', 'Vitanje', 'SI', '', '', '1'),
(7807, 'SI_E3', 'REGION', 'E3', 'Vodice', 'SI', '', '', '1'),
(7808, 'SI_E5', 'REGION', 'E5', 'Vrhnika', 'SI', '', '', '1'),
(7809, 'SI_E6', 'REGION', 'E6', 'Vuzenica', 'SI', '', '', '1'),
(7810, 'SI_E7', 'REGION', 'E7', 'Zagorje ob Savi', 'SI', '', '', '1'),
(7811, 'SI_E9', 'REGION', 'E9', 'Zavrc', 'SI', '', '', '1'),
(7812, 'SI_F1', 'REGION', 'F1', 'Zelezniki', 'SI', '', '', '1'),
(7813, 'SI_F2', 'REGION', 'F2', 'Ziri', 'SI', '', '', '1'),
(7814, 'SI_F3', 'REGION', 'F3', 'Zrece', 'SI', '', '', '1'),
(7815, 'SI_G4', 'REGION', 'G4', 'Dobrova-Horjul-Polhov Gradec', 'SI', '', '', '1'),
(7816, 'SI_G7', 'REGION', 'G7', 'Domzale', 'SI', '', '', '1'),
(7817, 'SI_H4', 'REGION', 'H4', 'Jesenice', 'SI', '', '', '1'),
(7818, 'SI_H6', 'REGION', 'H6', 'Kamnik', 'SI', '', '', '1'),
(7819, 'SI_H7', 'REGION', 'H7', 'Kocevje', 'SI', '', '', '1'),
(7820, 'SI_I2', 'REGION', 'I2', 'Kuzma', 'SI', '', '', '1'),
(7821, 'SI_I3', 'REGION', 'I3', 'Lenart', 'SI', '', '', '1'),
(7822, 'SI_I5', 'REGION', 'I5', 'Litija', 'SI', '', '', '1'),
(7823, 'SI_I6', 'REGION', 'I6', 'Ljutomer', 'SI', '', '', '1'),
(7824, 'SI_I7', 'REGION', 'I7', 'Loska Dolina', 'SI', '', '', '1'),
(7825, 'SI_I9', 'REGION', 'I9', 'Luce', 'SI', '', '', '1'),
(7826, 'SI_J1', 'REGION', 'J1', 'Majsperk', 'SI', '', '', '1'),
(7827, 'SI_J2', 'REGION', 'J2', 'Maribor', 'SI', '', '', '1'),
(7828, 'SI_J5', 'REGION', 'J5', 'Miren-Kostanjevica', 'SI', '', '', '1'),
(7829, 'SI_J7', 'REGION', 'J7', 'Novo Mesto', 'SI', '', '', '1'),
(7830, 'SI_J9', 'REGION', 'J9', 'Piran', 'SI', '', '', '1'),
(7831, 'SI_K5', 'REGION', 'K5', 'Preddvor', 'SI', '', '', '1'),
(7832, 'SI_K7', 'REGION', 'K7', 'Ptuj', 'SI', '', '', '1'),
(7833, 'SI_L1', 'REGION', 'L1', 'Ribnica', 'SI', '', '', '1'),
(7834, 'SI_L3', 'REGION', 'L3', 'Ruse', 'SI', '', '', '1'),
(7835, 'SI_L7', 'REGION', 'L7', 'Sentjur pri Celju', 'SI', '', '', '1'),
(7836, 'SI_L8', 'REGION', 'L8', 'Slovenska Bistrica', 'SI', '', '', '1'),
(7837, 'SI_N2', 'REGION', 'N2', 'Videm', 'SI', '', '', '1'),
(7838, 'SI_N3', 'REGION', 'N3', 'Vojnik', 'SI', '', '', '1'),
(7839, 'SI_N5', 'REGION', 'N5', 'Zalec', 'SI', '', '', '1'),
(7840, 'SK_01', 'REGION', '01', 'Banska Bystrica', 'SK', '', '', '1'),
(7841, 'SK_02', 'REGION', '02', 'Bratislava', 'SK', '', '', '1'),
(7842, 'SK_03', 'REGION', '03', 'Kosice', 'SK', '', '', '1'),
(7843, 'SK_04', 'REGION', '04', 'Nitra', 'SK', '', '', '1'),
(7844, 'SK_05', 'REGION', '05', 'Presov', 'SK', '', '', '1'),
(7845, 'SK_06', 'REGION', '06', 'Trencin', 'SK', '', '', '1'),
(7846, 'SK_07', 'REGION', '07', 'Trnava', 'SK', '', '', '1'),
(7847, 'SK_08', 'REGION', '08', 'Zilina', 'SK', '', '', '1'),
(7848, 'SL_01', 'REGION', '01', 'Eastern', 'SL', '', '', '1'),
(7849, 'SL_02', 'REGION', '02', 'Northern', 'SL', '', '', '1'),
(7850, 'SL_03', 'REGION', '03', 'Southern', 'SL', '', '', '1'),
(7851, 'SL_04', 'REGION', '04', 'Western Area', 'SL', '', '', '1'),
(7852, 'SM_01', 'REGION', '01', 'Acquaviva', 'SM', '', '', '1'),
(7853, 'SM_02', 'REGION', '02', 'Chiesanuova', 'SM', '', '', '1'),
(7854, 'SM_03', 'REGION', '03', 'Domagnano', 'SM', '', '', '1'),
(7855, 'SM_04', 'REGION', '04', 'Faetano', 'SM', '', '', '1'),
(7856, 'SM_05', 'REGION', '05', 'Fiorentino', 'SM', '', '', '1'),
(7857, 'SM_06', 'REGION', '06', 'Borgo Maggiore', 'SM', '', '', '1'),
(7858, 'SM_07', 'REGION', '07', 'San Marino', 'SM', '', '', '1'),
(7859, 'SM_08', 'REGION', '08', 'Monte Giardino', 'SM', '', '', '1'),
(7860, 'SM_09', 'REGION', '09', 'Serravalle', 'SM', '', '', '1'),
(7861, 'SN_01', 'REGION', '01', 'Dakar', 'SN', '', '', '1'),
(7862, 'SN_03', 'REGION', '03', 'Diourbel', 'SN', '', '', '1'),
(7863, 'SN_04', 'REGION', '04', 'Saint-Louis', 'SN', '', '', '1'),
(7864, 'SN_05', 'REGION', '05', 'Tambacounda', 'SN', '', '', '1'),
(7865, 'SN_07', 'REGION', '07', 'Thies', 'SN', '', '', '1'),
(7866, 'SN_08', 'REGION', '08', 'Louga', 'SN', '', '', '1'),
(7867, 'SN_09', 'REGION', '09', 'Fatick', 'SN', '', '', '1'),
(7868, 'SN_10', 'REGION', '10', 'Kaolack', 'SN', '', '', '1'),
(7869, 'SN_11', 'REGION', '11', 'Kolda', 'SN', '', '', '1'),
(7870, 'SN_12', 'REGION', '12', 'Ziguinchor', 'SN', '', '', '1'),
(7871, 'SN_13', 'REGION', '13', 'Louga', 'SN', '', '', '1'),
(7872, 'SN_14', 'REGION', '14', 'Saint-Louis', 'SN', '', '', '1'),
(7873, 'SN_15', 'REGION', '15', 'Matam', 'SN', '', '', '1'),
(7874, 'SO_01', 'REGION', '01', 'Bakool', 'SO', '', '', '1'),
(7875, 'SO_02', 'REGION', '02', 'Banaadir', 'SO', '', '', '1'),
(7876, 'SO_03', 'REGION', '03', 'Bari', 'SO', '', '', '1'),
(7877, 'SO_04', 'REGION', '04', 'Bay', 'SO', '', '', '1'),
(7878, 'SO_05', 'REGION', '05', 'Galguduud', 'SO', '', '', '1'),
(7879, 'SO_06', 'REGION', '06', 'Gedo', 'SO', '', '', '1'),
(7880, 'SO_07', 'REGION', '07', 'Hiiraan', 'SO', '', '', '1'),
(7881, 'SO_08', 'REGION', '08', 'Jubbada Dhexe', 'SO', '', '', '1'),
(7882, 'SO_09', 'REGION', '09', 'Jubbada Hoose', 'SO', '', '', '1'),
(7883, 'SO_10', 'REGION', '10', 'Mudug', 'SO', '', '', '1'),
(7884, 'SO_11', 'REGION', '11', 'Nugaal', 'SO', '', '', '1'),
(7885, 'SO_12', 'REGION', '12', 'Sanaag', 'SO', '', '', '1'),
(7886, 'SO_13', 'REGION', '13', 'Shabeellaha Dhexe', 'SO', '', '', '1'),
(7887, 'SO_14', 'REGION', '14', 'Shabeellaha Hoose', 'SO', '', '', '1'),
(7888, 'SO_16', 'REGION', '16', 'Woqooyi Galbeed', 'SO', '', '', '1'),
(7889, 'SO_18', 'REGION', '18', 'Nugaal', 'SO', '', '', '1'),
(7890, 'SO_19', 'REGION', '19', 'Togdheer', 'SO', '', '', '1'),
(7891, 'SO_20', 'REGION', '20', 'Woqooyi Galbeed', 'SO', '', '', '1'),
(7892, 'SO_21', 'REGION', '21', 'Awdal', 'SO', '', '', '1'),
(7893, 'SO_22', 'REGION', '22', 'Sool', 'SO', '', '', '1'),
(7894, 'SR_10', 'REGION', '10', 'Brokopondo', 'SR', '', '', '1'),
(7895, 'SR_11', 'REGION', '11', 'Commewijne', 'SR', '', '', '1'),
(7896, 'SR_12', 'REGION', '12', 'Coronie', 'SR', '', '', '1'),
(7897, 'SR_13', 'REGION', '13', 'Marowijne', 'SR', '', '', '1'),
(7898, 'SR_14', 'REGION', '14', 'Nickerie', 'SR', '', '', '1'),
(7899, 'SR_15', 'REGION', '15', 'Para', 'SR', '', '', '1'),
(7900, 'SR_16', 'REGION', '16', 'Paramaribo', 'SR', '', '', '1'),
(7901, 'SR_17', 'REGION', '17', 'Saramacca', 'SR', '', '', '1'),
(7902, 'SR_18', 'REGION', '18', 'Sipaliwini', 'SR', '', '', '1'),
(7903, 'SR_19', 'REGION', '19', 'Wanica', 'SR', '', '', '1'),
(7904, 'ST_01', 'REGION', '01', 'Principe', 'ST', '', '', '1'),
(7905, 'ST_02', 'REGION', '02', 'Sao Tome', 'ST', '', '', '1'),
(7906, 'SV_01', 'REGION', '01', 'Ahuachapan', 'SV', '', '', '1'),
(7907, 'SV_02', 'REGION', '02', 'Cabanas', 'SV', '', '', '1'),
(7908, 'SV_03', 'REGION', '03', 'Chalatenango', 'SV', '', '', '1'),
(7909, 'SV_04', 'REGION', '04', 'Cuscatlan', 'SV', '', '', '1'),
(7910, 'SV_05', 'REGION', '05', 'La Libertad', 'SV', '', '', '1'),
(7911, 'SV_06', 'REGION', '06', 'La Paz', 'SV', '', '', '1'),
(7912, 'SV_07', 'REGION', '07', 'La Union', 'SV', '', '', '1'),
(7913, 'SV_08', 'REGION', '08', 'Morazan', 'SV', '', '', '1'),
(7914, 'SV_09', 'REGION', '09', 'San Miguel', 'SV', '', '', '1'),
(7915, 'SV_10', 'REGION', '10', 'San Salvador', 'SV', '', '', '1'),
(7916, 'SV_11', 'REGION', '11', 'Santa Ana', 'SV', '', '', '1'),
(7917, 'SV_12', 'REGION', '12', 'San Vicente', 'SV', '', '', '1'),
(7918, 'SV_13', 'REGION', '13', 'Sonsonate', 'SV', '', '', '1'),
(7919, 'SV_14', 'REGION', '14', 'Usulutan', 'SV', '', '', '1'),
(7920, 'SY_01', 'REGION', '01', 'Al Hasakah', 'SY', '', '', '1'),
(7921, 'SY_02', 'REGION', '02', 'Al Ladhiqiyah', 'SY', '', '', '1'),
(7922, 'SY_03', 'REGION', '03', 'Al Qunaytirah', 'SY', '', '', '1'),
(7923, 'SY_04', 'REGION', '04', 'Ar Raqqah', 'SY', '', '', '1'),
(7924, 'SY_06', 'REGION', '06', 'Dar', 'SY', '', '', '1'),
(7925, 'SY_07', 'REGION', '07', 'Dayr az Zawr', 'SY', '', '', '1'),
(7926, 'SY_08', 'REGION', '08', 'Rif Dimashq', 'SY', '', '', '1'),
(7927, 'SY_09', 'REGION', '09', 'Halab', 'SY', '', '', '1'),
(7928, 'SY_10', 'REGION', '10', 'Hamah', 'SY', '', '', '1'),
(7929, 'SY_11', 'REGION', '11', 'Hims', 'SY', '', '', '1'),
(7930, 'SY_12', 'REGION', '12', 'Idlib', 'SY', '', '', '1'),
(7931, 'SY_13', 'REGION', '13', 'Dimashq', 'SY', '', '', '1'),
(7932, 'SY_14', 'REGION', '14', 'Tartus', 'SY', '', '', '1'),
(7933, 'SZ_01', 'REGION', '01', 'Hhohho', 'SZ', '', '', '1'),
(7934, 'SZ_02', 'REGION', '02', 'Lubombo', 'SZ', '', '', '1'),
(7935, 'SZ_03', 'REGION', '03', 'Manzini', 'SZ', '', '', '1'),
(7936, 'SZ_04', 'REGION', '04', 'Shiselweni', 'SZ', '', '', '1'),
(7937, 'SZ_05', 'REGION', '05', 'Praslin', 'SZ', '', '', '1'),
(7938, 'TD_01', 'REGION', '01', 'Batha', 'TD', '', '', '1'),
(7939, 'TD_02', 'REGION', '02', 'Biltine', 'TD', '', '', '1'),
(7940, 'TD_03', 'REGION', '03', 'Borkou-Ennedi-Tibesti', 'TD', '', '', '1'),
(7941, 'TD_04', 'REGION', '04', 'Chari-Baguirmi', 'TD', '', '', '1'),
(7942, 'TD_05', 'REGION', '05', 'Guera', 'TD', '', '', '1'),
(7943, 'TD_06', 'REGION', '06', 'Kanem', 'TD', '', '', '1'),
(7944, 'TD_07', 'REGION', '07', 'Lac', 'TD', '', '', '1'),
(7945, 'TD_08', 'REGION', '08', 'Logone Occidental', 'TD', '', '', '1'),
(7946, 'TD_09', 'REGION', '09', 'Logone Oriental', 'TD', '', '', '1'),
(7947, 'TD_10', 'REGION', '10', 'Mayo-Kebbi', 'TD', '', '', '1'),
(7948, 'TD_11', 'REGION', '11', 'Moyen-Chari', 'TD', '', '', '1'),
(7949, 'TD_12', 'REGION', '12', 'Ouaddai', 'TD', '', '', '1'),
(7950, 'TD_13', 'REGION', '13', 'Salamat', 'TD', '', '', '1'),
(7951, 'TD_14', 'REGION', '14', 'Tandjile', 'TD', '', '', '1'),
(7952, 'TG_09', 'REGION', '09', 'Lama-Kara', 'TG', '', '', '1'),
(7953, 'TG_18', 'REGION', '18', 'Tsevie', 'TG', '', '', '1'),
(7954, 'TG_22', 'REGION', '22', 'Centrale', 'TG', '', '', '1'),
(7955, 'TG_23', 'REGION', '23', 'Kara', 'TG', '', '', '1'),
(7956, 'TG_24', 'REGION', '24', 'Maritime', 'TG', '', '', '1'),
(7957, 'TG_25', 'REGION', '25', 'Plateaux', 'TG', '', '', '1'),
(7958, 'TG_26', 'REGION', '26', 'Savanes', 'TG', '', '', '1'),
(7959, 'TH_01', 'REGION', '01', 'Mae Hong Son', 'TH', '', '', '1'),
(7960, 'TH_02', 'REGION', '02', 'Chiang Mai', 'TH', '', '', '1'),
(7961, 'TH_03', 'REGION', '03', 'Chiang Rai', 'TH', '', '', '1'),
(7962, 'TH_04', 'REGION', '04', 'Nan', 'TH', '', '', '1'),
(7963, 'TH_05', 'REGION', '05', 'Lamphun', 'TH', '', '', '1'),
(7964, 'TH_06', 'REGION', '06', 'Lampang', 'TH', '', '', '1'),
(7965, 'TH_07', 'REGION', '07', 'Phrae', 'TH', '', '', '1'),
(7966, 'TH_08', 'REGION', '08', 'Tak', 'TH', '', '', '1'),
(7967, 'TH_09', 'REGION', '09', 'Sukhothai', 'TH', '', '', '1'),
(7968, 'TH_10', 'REGION', '10', 'Uttaradit', 'TH', '', '', '1'),
(7969, 'TH_11', 'REGION', '11', 'Kamphaeng Phet', 'TH', '', '', '1'),
(7970, 'TH_12', 'REGION', '12', 'Phitsanulok', 'TH', '', '', '1'),
(7971, 'TH_13', 'REGION', '13', 'Phichit', 'TH', '', '', '1'),
(7972, 'TH_14', 'REGION', '14', 'Phetchabun', 'TH', '', '', '1'),
(7973, 'TH_15', 'REGION', '15', 'Uthai Thani', 'TH', '', '', '1'),
(7974, 'TH_16', 'REGION', '16', 'Nakhon Sawan', 'TH', '', '', '1'),
(7975, 'TH_17', 'REGION', '17', 'Nong Khai', 'TH', '', '', '1'),
(7976, 'TH_18', 'REGION', '18', 'Loei', 'TH', '', '', '1'),
(7977, 'TH_20', 'REGION', '20', 'Sakon Nakhon', 'TH', '', '', '1'),
(7978, 'TH_21', 'REGION', '21', 'Nakhon Phanom', 'TH', '', '', '1'),
(7979, 'TH_22', 'REGION', '22', 'Khon Kaen', 'TH', '', '', '1'),
(7980, 'TH_23', 'REGION', '23', 'Kalasin', 'TH', '', '', '1'),
(7981, 'TH_24', 'REGION', '24', 'Maha Sarakham', 'TH', '', '', '1'),
(7982, 'TH_25', 'REGION', '25', 'Roi Et', 'TH', '', '', '1'),
(7983, 'TH_26', 'REGION', '26', 'Chaiyaphum', 'TH', '', '', '1'),
(7984, 'TH_27', 'REGION', '27', 'Nakhon Ratchasima', 'TH', '', '', '1'),
(7985, 'TH_28', 'REGION', '28', 'Buriram', 'TH', '', '', '1'),
(7986, 'TH_29', 'REGION', '29', 'Surin', 'TH', '', '', '1'),
(7987, 'TH_30', 'REGION', '30', 'Sisaket', 'TH', '', '', '1'),
(7988, 'TH_31', 'REGION', '31', 'Narathiwat', 'TH', '', '', '1'),
(7989, 'TH_32', 'REGION', '32', 'Chai Nat', 'TH', '', '', '1'),
(7990, 'TH_33', 'REGION', '33', 'Sing Buri', 'TH', '', '', '1'),
(7991, 'TH_34', 'REGION', '34', 'Lop Buri', 'TH', '', '', '1'),
(7992, 'TH_35', 'REGION', '35', 'Ang Thong', 'TH', '', '', '1'),
(7993, 'TH_36', 'REGION', '36', 'Phra Nakhon Si Ayutthaya', 'TH', '', '', '1'),
(7994, 'TH_37', 'REGION', '37', 'Saraburi', 'TH', '', '', '1'),
(7995, 'TH_38', 'REGION', '38', 'Nonthaburi', 'TH', '', '', '1'),
(7996, 'TH_39', 'REGION', '39', 'Pathum Thani', 'TH', '', '', '1'),
(7997, 'TH_40', 'REGION', '40', 'Krung Thep', 'TH', '', '', '1'),
(7998, 'TH_41', 'REGION', '41', 'Phayao', 'TH', '', '', '1'),
(7999, 'TH_42', 'REGION', '42', 'Samut Prakan', 'TH', '', '', '1'),
(8000, 'TH_43', 'REGION', '43', 'Nakhon Nayok', 'TH', '', '', '1'),
(8001, 'TH_44', 'REGION', '44', 'Chachoengsao', 'TH', '', '', '1'),
(8002, 'TH_45', 'REGION', '45', 'Prachin Buri', 'TH', '', '', '1'),
(8003, 'TH_46', 'REGION', '46', 'Chon Buri', 'TH', '', '', '1'),
(8004, 'TH_47', 'REGION', '47', 'Rayong', 'TH', '', '', '1'),
(8005, 'TH_48', 'REGION', '48', 'Chanthaburi', 'TH', '', '', '1'),
(8006, 'TH_49', 'REGION', '49', 'Trat', 'TH', '', '', '1'),
(8007, 'TH_50', 'REGION', '50', 'Kanchanaburi', 'TH', '', '', '1'),
(8008, 'TH_51', 'REGION', '51', 'Suphan Buri', 'TH', '', '', '1'),
(8009, 'TH_52', 'REGION', '52', 'Ratchaburi', 'TH', '', '', '1'),
(8010, 'TH_53', 'REGION', '53', 'Nakhon Pathom', 'TH', '', '', '1'),
(8011, 'TH_54', 'REGION', '54', 'Samut Songkhram', 'TH', '', '', '1'),
(8012, 'TH_55', 'REGION', '55', 'Samut Sakhon', 'TH', '', '', '1'),
(8013, 'TH_56', 'REGION', '56', 'Phetchaburi', 'TH', '', '', '1'),
(8014, 'TH_57', 'REGION', '57', 'Prachuap Khiri Khan', 'TH', '', '', '1'),
(8015, 'TH_58', 'REGION', '58', 'Chumphon', 'TH', '', '', '1'),
(8016, 'TH_59', 'REGION', '59', 'Ranong', 'TH', '', '', '1'),
(8017, 'TH_60', 'REGION', '60', 'Surat Thani', 'TH', '', '', '1'),
(8018, 'TH_61', 'REGION', '61', 'Phangnga', 'TH', '', '', '1'),
(8019, 'TH_62', 'REGION', '62', 'Phuket', 'TH', '', '', '1'),
(8020, 'TH_63', 'REGION', '63', 'Krabi', 'TH', '', '', '1'),
(8021, 'TH_64', 'REGION', '64', 'Nakhon Si Thammarat', 'TH', '', '', '1'),
(8022, 'TH_65', 'REGION', '65', 'Trang', 'TH', '', '', '1'),
(8023, 'TH_66', 'REGION', '66', 'Phatthalung', 'TH', '', '', '1'),
(8024, 'TH_67', 'REGION', '67', 'Satun', 'TH', '', '', '1'),
(8025, 'TH_68', 'REGION', '68', 'Songkhla', 'TH', '', '', '1'),
(8026, 'TH_69', 'REGION', '69', 'Pattani', 'TH', '', '', '1'),
(8027, 'TH_70', 'REGION', '70', 'Yala', 'TH', '', '', '1'),
(8028, 'TH_71', 'REGION', '71', 'Ubon Ratchathani', 'TH', '', '', '1'),
(8029, 'TH_72', 'REGION', '72', 'Yasothon', 'TH', '', '', '1'),
(8030, 'TH_73', 'REGION', '73', 'Nakhon Phanom', 'TH', '', '', '1'),
(8031, 'TH_75', 'REGION', '75', 'Ubon Ratchathani', 'TH', '', '', '1'),
(8032, 'TH_76', 'REGION', '76', 'Udon Thani', 'TH', '', '', '1'),
(8033, 'TH_77', 'REGION', '77', 'Amnat Charoen', 'TH', '', '', '1'),
(8034, 'TH_78', 'REGION', '78', 'Mukdahan', 'TH', '', '', '1'),
(8035, 'TH_79', 'REGION', '79', 'Nong Bua Lamphu', 'TH', '', '', '1'),
(8036, 'TH_80', 'REGION', '80', 'Sa Kaeo', 'TH', '', '', '1'),
(8037, 'TJ_01', 'REGION', '01', 'Kuhistoni Badakhshon', 'TJ', '', '', '1'),
(8038, 'TJ_02', 'REGION', '02', 'Khatlon', 'TJ', '', '', '1'),
(8039, 'TJ_03', 'REGION', '03', 'Sughd', 'TJ', '', '', '1'),
(8040, 'TM_01', 'REGION', '01', 'Ahal', 'TM', '', '', '1'),
(8041, 'TM_02', 'REGION', '02', 'Balkan', 'TM', '', '', '1'),
(8042, 'TM_03', 'REGION', '03', 'Dashoguz', 'TM', '', '', '1'),
(8043, 'TM_04', 'REGION', '04', 'Lebap', 'TM', '', '', '1'),
(8044, 'TM_05', 'REGION', '05', 'Mary', 'TM', '', '', '1'),
(8045, 'TN_02', 'REGION', '02', 'Kasserine', 'TN', '', '', '1'),
(8046, 'TN_03', 'REGION', '03', 'Kairouan', 'TN', '', '', '1'),
(8047, 'TN_06', 'REGION', '06', 'Jendouba', 'TN', '', '', '1'),
(8048, 'TN_14', 'REGION', '14', 'El Kef', 'TN', '', '', '1'),
(8049, 'TN_15', 'REGION', '15', 'Al Mahdia', 'TN', '', '', '1'),
(8050, 'TN_16', 'REGION', '16', 'Al Munastir', 'TN', '', '', '1'),
(8051, 'TN_17', 'REGION', '17', 'Bajah', 'TN', '', '', '1'),
(8052, 'TN_18', 'REGION', '18', 'Bizerte', 'TN', '', '', '1'),
(8053, 'TN_19', 'REGION', '19', 'Nabeul', 'TN', '', '', '1'),
(8054, 'TN_22', 'REGION', '22', 'Siliana', 'TN', '', '', '1'),
(8055, 'TN_23', 'REGION', '23', 'Sousse', 'TN', '', '', '1'),
(8056, 'TN_26', 'REGION', '26', 'Ariana', 'TN', '', '', '1'),
(8057, 'TN_27', 'REGION', '27', 'Ben Arous', 'TN', '', '', '1'),
(8058, 'TN_28', 'REGION', '28', 'Madanin', 'TN', '', '', '1'),
(8059, 'TN_29', 'REGION', '29', 'Gabes', 'TN', '', '', '1'),
(8060, 'TN_30', 'REGION', '30', 'Gafsa', 'TN', '', '', '1'),
(8061, 'TN_31', 'REGION', '31', 'Kebili', 'TN', '', '', '1'),
(8062, 'TN_32', 'REGION', '32', 'Sfax', 'TN', '', '', '1'),
(8063, 'TN_33', 'REGION', '33', 'Sidi Bou Zid', 'TN', '', '', '1'),
(8064, 'TN_34', 'REGION', '34', 'Tataouine', 'TN', '', '', '1'),
(8065, 'TN_35', 'REGION', '35', 'Tozeur', 'TN', '', '', '1'),
(8066, 'TN_36', 'REGION', '36', 'Tunis', 'TN', '', '', '1'),
(8067, 'TN_37', 'REGION', '37', 'Zaghouan', 'TN', '', '', '1'),
(8068, 'TO_01', 'REGION', '01', 'Ha', 'TO', '', '', '1'),
(8069, 'TO_02', 'REGION', '02', 'Tongatapu', 'TO', '', '', '1'),
(8070, 'TO_03', 'REGION', '03', 'Vava', 'TO', '', '', '1'),
(8071, 'TR_02', 'REGION', '02', 'Adiyaman', 'TR', '', '', '1'),
(8072, 'TR_03', 'REGION', '03', 'Afyonkarahisar', 'TR', '', '', '1'),
(8073, 'TR_04', 'REGION', '04', 'Agri', 'TR', '', '', '1'),
(8074, 'TR_05', 'REGION', '05', 'Amasya', 'TR', '', '', '1'),
(8075, 'TR_07', 'REGION', '07', 'Antalya', 'TR', '', '', '1'),
(8076, 'TR_08', 'REGION', '08', 'Artvin', 'TR', '', '', '1'),
(8077, 'TR_09', 'REGION', '09', 'Aydin', 'TR', '', '', '1'),
(8078, 'TR_10', 'REGION', '10', 'Balikesir', 'TR', '', '', '1'),
(8079, 'TR_11', 'REGION', '11', 'Bilecik', 'TR', '', '', '1'),
(8080, 'TR_12', 'REGION', '12', 'Bingol', 'TR', '', '', '1'),
(8081, 'TR_13', 'REGION', '13', 'Bitlis', 'TR', '', '', '1'),
(8082, 'TR_14', 'REGION', '14', 'Bolu', 'TR', '', '', '1'),
(8083, 'TR_15', 'REGION', '15', 'Burdur', 'TR', '', '', '1'),
(8084, 'TR_16', 'REGION', '16', 'Bursa', 'TR', '', '', '1'),
(8085, 'TR_17', 'REGION', '17', 'Canakkale', 'TR', '', '', '1'),
(8086, 'TR_19', 'REGION', '19', 'Corum', 'TR', '', '', '1'),
(8087, 'TR_20', 'REGION', '20', 'Denizli', 'TR', '', '', '1');", $maindb);
mysql_query("INSERT INTO `md_regional_targeting` (`entry_id`, `targeting_code`, `targeting_type`, `region_code`, `region_name`, `head_country`, `head_region`, `head_city`, `entry_status`) VALUES
(8088, 'TR_21', 'REGION', '21', 'Diyarbakir', 'TR', '', '', '1'),
(8089, 'TR_22', 'REGION', '22', 'Edirne', 'TR', '', '', '1'),
(8090, 'TR_23', 'REGION', '23', 'Elazig', 'TR', '', '', '1'),
(8091, 'TR_24', 'REGION', '24', 'Erzincan', 'TR', '', '', '1'),
(8092, 'TR_25', 'REGION', '25', 'Erzurum', 'TR', '', '', '1'),
(8093, 'TR_26', 'REGION', '26', 'Eskisehir', 'TR', '', '', '1'),
(8094, 'TR_28', 'REGION', '28', 'Giresun', 'TR', '', '', '1'),
(8095, 'TR_31', 'REGION', '31', 'Hatay', 'TR', '', '', '1'),
(8096, 'TR_32', 'REGION', '32', 'Icel', 'TR', '', '', '1'),
(8097, 'TR_33', 'REGION', '33', 'Isparta', 'TR', '', '', '1'),
(8098, 'TR_34', 'REGION', '34', 'Istanbul', 'TR', '', '', '1'),
(8099, 'TR_35', 'REGION', '35', 'Izmir', 'TR', '', '', '1'),
(8100, 'TR_37', 'REGION', '37', 'Kastamonu', 'TR', '', '', '1'),
(8101, 'TR_38', 'REGION', '38', 'Kayseri', 'TR', '', '', '1'),
(8102, 'TR_39', 'REGION', '39', 'Kirklareli', 'TR', '', '', '1'),
(8103, 'TR_40', 'REGION', '40', 'Kirsehir', 'TR', '', '', '1'),
(8104, 'TR_41', 'REGION', '41', 'Kocaeli', 'TR', '', '', '1'),
(8105, 'TR_43', 'REGION', '43', 'Kutahya', 'TR', '', '', '1'),
(8106, 'TR_44', 'REGION', '44', 'Malatya', 'TR', '', '', '1'),
(8107, 'TR_45', 'REGION', '45', 'Manisa', 'TR', '', '', '1'),
(8108, 'TR_46', 'REGION', '46', 'Kahramanmaras', 'TR', '', '', '1'),
(8109, 'TR_48', 'REGION', '48', 'Mugla', 'TR', '', '', '1'),
(8110, 'TR_49', 'REGION', '49', 'Mus', 'TR', '', '', '1'),
(8111, 'TR_50', 'REGION', '50', 'Nevsehir', 'TR', '', '', '1'),
(8112, 'TR_52', 'REGION', '52', 'Ordu', 'TR', '', '', '1'),
(8113, 'TR_53', 'REGION', '53', 'Rize', 'TR', '', '', '1'),
(8114, 'TR_54', 'REGION', '54', 'Sakarya', 'TR', '', '', '1'),
(8115, 'TR_55', 'REGION', '55', 'Samsun', 'TR', '', '', '1'),
(8116, 'TR_57', 'REGION', '57', 'Sinop', 'TR', '', '', '1'),
(8117, 'TR_58', 'REGION', '58', 'Sivas', 'TR', '', '', '1'),
(8118, 'TR_59', 'REGION', '59', 'Tekirdag', 'TR', '', '', '1'),
(8119, 'TR_60', 'REGION', '60', 'Tokat', 'TR', '', '', '1'),
(8120, 'TR_61', 'REGION', '61', 'Trabzon', 'TR', '', '', '1'),
(8121, 'TR_62', 'REGION', '62', 'Tunceli', 'TR', '', '', '1'),
(8122, 'TR_63', 'REGION', '63', 'Sanliurfa', 'TR', '', '', '1'),
(8123, 'TR_64', 'REGION', '64', 'Usak', 'TR', '', '', '1'),
(8124, 'TR_65', 'REGION', '65', 'Van', 'TR', '', '', '1'),
(8125, 'TR_66', 'REGION', '66', 'Yozgat', 'TR', '', '', '1'),
(8126, 'TR_68', 'REGION', '68', 'Ankara', 'TR', '', '', '1'),
(8127, 'TR_69', 'REGION', '69', 'Gumushane', 'TR', '', '', '1'),
(8128, 'TR_70', 'REGION', '70', 'Hakkari', 'TR', '', '', '1'),
(8129, 'TR_71', 'REGION', '71', 'Konya', 'TR', '', '', '1'),
(8130, 'TR_72', 'REGION', '72', 'Mardin', 'TR', '', '', '1'),
(8131, 'TR_73', 'REGION', '73', 'Nigde', 'TR', '', '', '1'),
(8132, 'TR_74', 'REGION', '74', 'Siirt', 'TR', '', '', '1'),
(8133, 'TR_75', 'REGION', '75', 'Aksaray', 'TR', '', '', '1'),
(8134, 'TR_76', 'REGION', '76', 'Batman', 'TR', '', '', '1'),
(8135, 'TR_77', 'REGION', '77', 'Bayburt', 'TR', '', '', '1'),
(8136, 'TR_78', 'REGION', '78', 'Karaman', 'TR', '', '', '1'),
(8137, 'TR_79', 'REGION', '79', 'Kirikkale', 'TR', '', '', '1'),
(8138, 'TR_80', 'REGION', '80', 'Sirnak', 'TR', '', '', '1'),
(8139, 'TR_81', 'REGION', '81', 'Adana', 'TR', '', '', '1'),
(8140, 'TR_82', 'REGION', '82', 'Cankiri', 'TR', '', '', '1'),
(8141, 'TR_83', 'REGION', '83', 'Gaziantep', 'TR', '', '', '1'),
(8142, 'TR_84', 'REGION', '84', 'Kars', 'TR', '', '', '1'),
(8143, 'TR_85', 'REGION', '85', 'Zonguldak', 'TR', '', '', '1'),
(8144, 'TR_86', 'REGION', '86', 'Ardahan', 'TR', '', '', '1'),
(8145, 'TR_87', 'REGION', '87', 'Bartin', 'TR', '', '', '1'),
(8146, 'TR_88', 'REGION', '88', 'Igdir', 'TR', '', '', '1'),
(8147, 'TR_89', 'REGION', '89', 'Karabuk', 'TR', '', '', '1'),
(8148, 'TR_90', 'REGION', '90', 'Kilis', 'TR', '', '', '1'),
(8149, 'TR_91', 'REGION', '91', 'Osmaniye', 'TR', '', '', '1'),
(8150, 'TR_92', 'REGION', '92', 'Yalova', 'TR', '', '', '1'),
(8151, 'TR_93', 'REGION', '93', 'Duzce', 'TR', '', '', '1'),
(8152, 'TT_01', 'REGION', '01', 'Arima', 'TT', '', '', '1'),
(8153, 'TT_02', 'REGION', '02', 'Caroni', 'TT', '', '', '1'),
(8154, 'TT_03', 'REGION', '03', 'Mayaro', 'TT', '', '', '1'),
(8155, 'TT_04', 'REGION', '04', 'Nariva', 'TT', '', '', '1'),
(8156, 'TT_05', 'REGION', '05', 'Port-of-Spain', 'TT', '', '', '1'),
(8157, 'TT_06', 'REGION', '06', 'Saint Andrew', 'TT', '', '', '1'),
(8158, 'TT_07', 'REGION', '07', 'Saint David', 'TT', '', '', '1'),
(8159, 'TT_08', 'REGION', '08', 'Saint George', 'TT', '', '', '1'),
(8160, 'TT_09', 'REGION', '09', 'Saint Patrick', 'TT', '', '', '1'),
(8161, 'TT_10', 'REGION', '10', 'San Fernando', 'TT', '', '', '1'),
(8162, 'TT_11', 'REGION', '11', 'Tobago', 'TT', '', '', '1'),
(8163, 'TT_12', 'REGION', '12', 'Victoria', 'TT', '', '', '1'),
(8164, 'TW_01', 'REGION', '01', 'Fu-chien', 'TW', '', '', '1'),
(8165, 'TW_02', 'REGION', '02', 'Kao-hsiung', 'TW', '', '', '1'),
(8166, 'TZ_02', 'REGION', '02', 'Pwani', 'TZ', '', '', '1'),
(8167, 'TZ_03', 'REGION', '03', 'Dodoma', 'TZ', '', '', '1'),
(8168, 'TZ_04', 'REGION', '04', 'Iringa', 'TZ', '', '', '1'),
(8169, 'TZ_05', 'REGION', '05', 'Kigoma', 'TZ', '', '', '1'),
(8170, 'TZ_06', 'REGION', '06', 'Kilimanjaro', 'TZ', '', '', '1'),
(8171, 'TZ_07', 'REGION', '07', 'Lindi', 'TZ', '', '', '1'),
(8172, 'TZ_08', 'REGION', '08', 'Mara', 'TZ', '', '', '1'),
(8173, 'TZ_09', 'REGION', '09', 'Mbeya', 'TZ', '', '', '1'),
(8174, 'TZ_10', 'REGION', '10', 'Morogoro', 'TZ', '', '', '1'),
(8175, 'TZ_11', 'REGION', '11', 'Mtwara', 'TZ', '', '', '1'),
(8176, 'TZ_12', 'REGION', '12', 'Mwanza', 'TZ', '', '', '1'),
(8177, 'TZ_13', 'REGION', '13', 'Pemba North', 'TZ', '', '', '1'),
(8178, 'TZ_14', 'REGION', '14', 'Ruvuma', 'TZ', '', '', '1'),
(8179, 'TZ_15', 'REGION', '15', 'Shinyanga', 'TZ', '', '', '1'),
(8180, 'TZ_16', 'REGION', '16', 'Singida', 'TZ', '', '', '1'),
(8181, 'TZ_17', 'REGION', '17', 'Tabora', 'TZ', '', '', '1'),
(8182, 'TZ_18', 'REGION', '18', 'Tanga', 'TZ', '', '', '1'),
(8183, 'TZ_19', 'REGION', '19', 'Kagera', 'TZ', '', '', '1'),
(8184, 'TZ_20', 'REGION', '20', 'Pemba South', 'TZ', '', '', '1'),
(8185, 'TZ_21', 'REGION', '21', 'Zanzibar Central', 'TZ', '', '', '1'),
(8186, 'TZ_22', 'REGION', '22', 'Zanzibar North', 'TZ', '', '', '1'),
(8187, 'TZ_23', 'REGION', '23', 'Dar es Salaam', 'TZ', '', '', '1'),
(8188, 'TZ_24', 'REGION', '24', 'Rukwa', 'TZ', '', '', '1'),
(8189, 'TZ_25', 'REGION', '25', 'Zanzibar Urban', 'TZ', '', '', '1'),
(8190, 'TZ_26', 'REGION', '26', 'Arusha', 'TZ', '', '', '1'),
(8191, 'TZ_27', 'REGION', '27', 'Manyara', 'TZ', '', '', '1'),
(8192, 'UA_11', 'REGION', '11', 'Krym', 'UA', '', '', '1'),
(8193, 'UA_12', 'REGION', '12', 'Kyyiv', 'UA', '', '', '1'),
(8194, 'UG_05', 'REGION', '05', 'Busoga', 'UG', '', '', '1'),
(8195, 'UG_08', 'REGION', '08', 'Karamoja', 'UG', '', '', '1'),
(8196, 'UG_12', 'REGION', '12', 'South Buganda', 'UG', '', '', '1'),
(8197, 'UG_18', 'REGION', '18', 'Central', 'UG', '', '', '1'),
(8198, 'UG_20', 'REGION', '20', 'Eastern', 'UG', '', '', '1'),
(8199, 'UG_21', 'REGION', '21', 'Nile', 'UG', '', '', '1'),
(8200, 'UG_22', 'REGION', '22', 'North Buganda', 'UG', '', '', '1'),
(8201, 'UG_23', 'REGION', '23', 'Northern', 'UG', '', '', '1'),
(8202, 'UG_24', 'REGION', '24', 'Southern', 'UG', '', '', '1'),
(8203, 'UG_25', 'REGION', '25', 'Western', 'UG', '', '', '1'),
(8204, 'UG_33', 'REGION', '33', 'Jinja', 'UG', '', '', '1'),
(8205, 'UG_36', 'REGION', '36', 'Kalangala', 'UG', '', '', '1'),
(8206, 'UG_37', 'REGION', '37', 'Kampala', 'UG', '', '', '1'),
(8207, 'UG_42', 'REGION', '42', 'Kiboga', 'UG', '', '', '1'),
(8208, 'UG_52', 'REGION', '52', 'Mbarara', 'UG', '', '', '1'),
(8209, 'UG_56', 'REGION', '56', 'Mubende', 'UG', '', '', '1'),
(8210, 'UG_65', 'REGION', '65', 'Adjumani', 'UG', '', '', '1'),
(8211, 'UG_66', 'REGION', '66', 'Bugiri', 'UG', '', '', '1'),
(8212, 'UG_67', 'REGION', '67', 'Busia', 'UG', '', '', '1'),
(8213, 'UG_69', 'REGION', '69', 'Katakwi', 'UG', '', '', '1'),
(8214, 'UG_71', 'REGION', '71', 'Masaka', 'UG', '', '', '1'),
(8215, 'UG_73', 'REGION', '73', 'Nakasongola', 'UG', '', '', '1'),
(8216, 'UG_74', 'REGION', '74', 'Sembabule', 'UG', '', '', '1'),
(8217, 'UG_77', 'REGION', '77', 'Arua', 'UG', '', '', '1'),
(8218, 'UG_78', 'REGION', '78', 'Iganga', 'UG', '', '', '1'),
(8219, 'UG_79', 'REGION', '79', 'Kabarole', 'UG', '', '', '1'),
(8220, 'UG_80', 'REGION', '80', 'Kaberamaido', 'UG', '', '', '1'),
(8221, 'UG_81', 'REGION', '81', 'Kamwenge', 'UG', '', '', '1'),
(8222, 'UG_82', 'REGION', '82', 'Kanungu', 'UG', '', '', '1'),
(8223, 'UG_83', 'REGION', '83', 'Kayunga', 'UG', '', '', '1'),
(8224, 'UG_84', 'REGION', '84', 'Kitgum', 'UG', '', '', '1'),
(8225, 'UG_85', 'REGION', '85', 'Kyenjojo', 'UG', '', '', '1'),
(8226, 'UG_86', 'REGION', '86', 'Mayuge', 'UG', '', '', '1'),
(8227, 'UG_87', 'REGION', '87', 'Mbale', 'UG', '', '', '1'),
(8228, 'UG_88', 'REGION', '88', 'Moroto', 'UG', '', '', '1'),
(8229, 'UG_89', 'REGION', '89', 'Mpigi', 'UG', '', '', '1'),
(8230, 'UG_90', 'REGION', '90', 'Mukono', 'UG', '', '', '1'),
(8231, 'UG_91', 'REGION', '91', 'Nakapiripirit', 'UG', '', '', '1'),
(8232, 'UG_92', 'REGION', '92', 'Pader', 'UG', '', '', '1'),
(8233, 'UG_93', 'REGION', '93', 'Rukungiri', 'UG', '', '', '1'),
(8234, 'UG_94', 'REGION', '94', 'Sironko', 'UG', '', '', '1'),
(8235, 'UG_95', 'REGION', '95', 'Soroti', 'UG', '', '', '1'),
(8236, 'UG_96', 'REGION', '96', 'Wakiso', 'UG', '', '', '1'),
(8237, 'UG_97', 'REGION', '97', 'Yumbe', 'UG', '', '', '1'),
(8238, 'US_AA', 'REGION', 'AA', 'Armed Forces Americas', 'US', '', '', '1'),
(8239, 'US_AE', 'REGION', 'AE', 'Armed Forces Europe, Middle East, & Canada', 'US', '', '', '1'),
(8240, 'US_AK', 'REGION', 'AK', 'Alaska', 'US', '', '', '1'),
(8241, 'US_AL', 'REGION', 'AL', 'Alabama', 'US', '', '', '1'),
(8242, 'US_AP', 'REGION', 'AP', 'Armed Forces Pacific', 'US', '', '', '1'),
(8243, 'US_AR', 'REGION', 'AR', 'Arkansas', 'US', '', '', '1'),
(8244, 'US_AS', 'REGION', 'AS', 'American Samoa', 'US', '', '', '1'),
(8245, 'US_AZ', 'REGION', 'AZ', 'Arizona', 'US', '', '', '1'),
(8246, 'US_CA', 'REGION', 'CA', 'California', 'US', '', '', '1'),
(8247, 'US_CO', 'REGION', 'CO', 'Colorado', 'US', '', '', '1'),
(8248, 'US_CT', 'REGION', 'CT', 'Connecticut', 'US', '', '', '1'),
(8249, 'US_DC', 'REGION', 'DC', 'District of Columbia', 'US', '', '', '1'),
(8250, 'US_DE', 'REGION', 'DE', 'Delaware', 'US', '', '', '1'),
(8251, 'US_FL', 'REGION', 'FL', 'Florida', 'US', '', '', '1'),
(8252, 'US_FM', 'REGION', 'FM', 'Federated States of Micronesia', 'US', '', '', '1'),
(8253, 'US_GA', 'REGION', 'GA', 'Georgia', 'US', '', '', '1'),
(8254, 'US_GU', 'REGION', 'GU', 'Guam', 'US', '', '', '1'),
(8255, 'US_HI', 'REGION', 'HI', 'Hawaii', 'US', '', '', '1'),
(8256, 'US_IA', 'REGION', 'IA', 'Iowa', 'US', '', '', '1'),
(8257, 'US_ID', 'REGION', 'ID', 'Idaho', 'US', '', '', '1'),
(8258, 'US_IL', 'REGION', 'IL', 'Illinois', 'US', '', '', '1'),
(8259, 'US_IN', 'REGION', 'IN', 'Indiana', 'US', '', '', '1'),
(8260, 'US_KS', 'REGION', 'KS', 'Kansas', 'US', '', '', '1'),
(8261, 'US_KY', 'REGION', 'KY', 'Kentucky', 'US', '', '', '1'),
(8262, 'US_LA', 'REGION', 'LA', 'Louisiana', 'US', '', '', '1'),
(8263, 'US_MA', 'REGION', 'MA', 'Massachusetts', 'US', '', '', '1'),
(8264, 'US_MD', 'REGION', 'MD', 'Maryland', 'US', '', '', '1'),
(8265, 'US_ME', 'REGION', 'ME', 'Maine', 'US', '', '', '1'),
(8266, 'US_MH', 'REGION', 'MH', 'Marshall Islands', 'US', '', '', '1'),
(8267, 'US_MI', 'REGION', 'MI', 'Michigan', 'US', '', '', '1'),
(8268, 'US_MN', 'REGION', 'MN', 'Minnesota', 'US', '', '', '1'),
(8269, 'US_MO', 'REGION', 'MO', 'Missouri', 'US', '', '', '1'),
(8270, 'US_MP', 'REGION', 'MP', 'Northern Mariana Islands', 'US', '', '', '1'),
(8271, 'US_MS', 'REGION', 'MS', 'Mississippi', 'US', '', '', '1'),
(8272, 'US_MT', 'REGION', 'MT', 'Montana', 'US', '', '', '1'),
(8273, 'US_NC', 'REGION', 'NC', 'North Carolina', 'US', '', '', '1'),
(8274, 'US_ND', 'REGION', 'ND', 'North Dakota', 'US', '', '', '1'),
(8275, 'US_NE', 'REGION', 'NE', 'Nebraska', 'US', '', '', '1'),
(8276, 'US_NH', 'REGION', 'NH', 'New Hampshire', 'US', '', '', '1'),
(8277, 'US_NJ', 'REGION', 'NJ', 'New Jersey', 'US', '', '', '1'),
(8278, 'US_NM', 'REGION', 'NM', 'New Mexico', 'US', '', '', '1'),
(8279, 'US_NV', 'REGION', 'NV', 'Nevada', 'US', '', '', '1'),
(8280, 'US_NY', 'REGION', 'NY', 'New York', 'US', '', '', '1'),
(8281, 'US_OH', 'REGION', 'OH', 'Ohio', 'US', '', '', '1'),
(8282, 'US_OK', 'REGION', 'OK', 'Oklahoma', 'US', '', '', '1'),
(8283, 'US_OR', 'REGION', 'OR', 'Oregon', 'US', '', '', '1'),
(8284, 'US_PA', 'REGION', 'PA', 'Pennsylvania', 'US', '', '', '1'),
(8285, 'US_PR', 'REGION', 'PR', 'Puerto Rico', 'US', '', '', '1'),
(8286, 'US_PW', 'REGION', 'PW', 'Palau', 'US', '', '', '1'),
(8287, 'US_RI', 'REGION', 'RI', 'Rhode Island', 'US', '', '', '1'),
(8288, 'US_SC', 'REGION', 'SC', 'South Carolina', 'US', '', '', '1'),
(8289, 'US_SD', 'REGION', 'SD', 'South Dakota', 'US', '', '', '1'),
(8290, 'US_TN', 'REGION', 'TN', 'Tennessee', 'US', '', '', '1'),
(8291, 'US_TX', 'REGION', 'TX', 'Texas', 'US', '', '', '1'),
(8292, 'US_UT', 'REGION', 'UT', 'Utah', 'US', '', '', '1'),
(8293, 'US_VA', 'REGION', 'VA', 'Virginia', 'US', '', '', '1'),
(8294, 'US_VI', 'REGION', 'VI', 'Virgin Islands', 'US', '', '', '1'),
(8295, 'US_VT', 'REGION', 'VT', 'Vermont', 'US', '', '', '1'),
(8296, 'US_WA', 'REGION', 'WA', 'Washington', 'US', '', '', '1'),
(8297, 'US_WI', 'REGION', 'WI', 'Wisconsin', 'US', '', '', '1'),
(8298, 'US_WV', 'REGION', 'WV', 'West Virginia', 'US', '', '', '1'),
(8299, 'US_WY', 'REGION', 'WY', 'Wyoming', 'US', '', '', '1'),
(8300, 'UY_01', 'REGION', '01', 'Artigas', 'UY', '', '', '1'),
(8301, 'UY_02', 'REGION', '02', 'Canelones', 'UY', '', '', '1'),
(8302, 'UY_03', 'REGION', '03', 'Cerro Largo', 'UY', '', '', '1'),
(8303, 'UY_04', 'REGION', '04', 'Colonia', 'UY', '', '', '1'),
(8304, 'UY_05', 'REGION', '05', 'Durazno', 'UY', '', '', '1'),
(8305, 'UY_06', 'REGION', '06', 'Flores', 'UY', '', '', '1'),
(8306, 'UY_07', 'REGION', '07', 'Florida', 'UY', '', '', '1'),
(8307, 'UY_08', 'REGION', '08', 'Lavalleja', 'UY', '', '', '1'),
(8308, 'UY_09', 'REGION', '09', 'Maldonado', 'UY', '', '', '1'),
(8309, 'UY_10', 'REGION', '10', 'Montevideo', 'UY', '', '', '1'),
(8310, 'UY_11', 'REGION', '11', 'Paysandu', 'UY', '', '', '1'),
(8311, 'UY_12', 'REGION', '12', 'Rio Negro', 'UY', '', '', '1'),
(8312, 'UY_13', 'REGION', '13', 'Rivera', 'UY', '', '', '1'),
(8313, 'UY_14', 'REGION', '14', 'Rocha', 'UY', '', '', '1'),
(8314, 'UY_15', 'REGION', '15', 'Salto', 'UY', '', '', '1'),
(8315, 'UY_16', 'REGION', '16', 'San Jose', 'UY', '', '', '1'),
(8316, 'UY_17', 'REGION', '17', 'Soriano', 'UY', '', '', '1'),
(8317, 'UY_18', 'REGION', '18', 'Tacuarembo', 'UY', '', '', '1'),
(8318, 'UY_19', 'REGION', '19', 'Treinta y Tres', 'UY', '', '', '1'),
(8319, 'UZ_01', 'REGION', '01', 'Andijon', 'UZ', '', '', '1'),
(8320, 'UZ_02', 'REGION', '02', 'Bukhoro', 'UZ', '', '', '1'),
(8321, 'UZ_03', 'REGION', '03', 'Farghona', 'UZ', '', '', '1'),
(8322, 'UZ_04', 'REGION', '04', 'Jizzakh', 'UZ', '', '', '1'),
(8323, 'UZ_05', 'REGION', '05', 'Khorazm', 'UZ', '', '', '1'),
(8324, 'UZ_06', 'REGION', '06', 'Namangan', 'UZ', '', '', '1'),
(8325, 'UZ_07', 'REGION', '07', 'Nawoiy', 'UZ', '', '', '1'),
(8326, 'UZ_08', 'REGION', '08', 'Qashqadaryo', 'UZ', '', '', '1'),
(8327, 'UZ_09', 'REGION', '09', 'Qoraqalpoghiston', 'UZ', '', '', '1'),
(8328, 'UZ_10', 'REGION', '10', 'Samarqand', 'UZ', '', '', '1'),
(8329, 'UZ_11', 'REGION', '11', 'Sirdaryo', 'UZ', '', '', '1'),
(8330, 'UZ_12', 'REGION', '12', 'Surkhondaryo', 'UZ', '', '', '1'),
(8331, 'UZ_13', 'REGION', '13', 'Toshkent', 'UZ', '', '', '1'),
(8332, 'UZ_14', 'REGION', '14', 'Toshkent', 'UZ', '', '', '1'),
(8333, 'VC_01', 'REGION', '01', 'Charlotte', 'VC', '', '', '1'),
(8334, 'VC_02', 'REGION', '02', 'Saint Andrew', 'VC', '', '', '1'),
(8335, 'VC_03', 'REGION', '03', 'Saint David', 'VC', '', '', '1'),
(8336, 'VC_04', 'REGION', '04', 'Saint George', 'VC', '', '', '1'),
(8337, 'VC_05', 'REGION', '05', 'Saint Patrick', 'VC', '', '', '1'),
(8338, 'VC_06', 'REGION', '06', 'Grenadines', 'VC', '', '', '1'),
(8339, 'VE_01', 'REGION', '01', 'Amazonas', 'VE', '', '', '1'),
(8340, 'VE_02', 'REGION', '02', 'Anzoategui', 'VE', '', '', '1'),
(8341, 'VE_03', 'REGION', '03', 'Apure', 'VE', '', '', '1'),
(8342, 'VE_04', 'REGION', '04', 'Aragua', 'VE', '', '', '1'),
(8343, 'VE_05', 'REGION', '05', 'Barinas', 'VE', '', '', '1'),
(8344, 'VE_06', 'REGION', '06', 'Bolivar', 'VE', '', '', '1'),
(8345, 'VE_07', 'REGION', '07', 'Carabobo', 'VE', '', '', '1'),
(8346, 'VE_08', 'REGION', '08', 'Cojedes', 'VE', '', '', '1'),
(8347, 'VE_09', 'REGION', '09', 'Delta Amacuro', 'VE', '', '', '1'),
(8348, 'VE_11', 'REGION', '11', 'Falcon', 'VE', '', '', '1'),
(8349, 'VE_12', 'REGION', '12', 'Guarico', 'VE', '', '', '1'),
(8350, 'VE_13', 'REGION', '13', 'Lara', 'VE', '', '', '1'),
(8351, 'VE_14', 'REGION', '14', 'Merida', 'VE', '', '', '1'),
(8352, 'VE_15', 'REGION', '15', 'Miranda', 'VE', '', '', '1'),
(8353, 'VE_16', 'REGION', '16', 'Monagas', 'VE', '', '', '1'),
(8354, 'VE_17', 'REGION', '17', 'Nueva Esparta', 'VE', '', '', '1'),
(8355, 'VE_18', 'REGION', '18', 'Portuguesa', 'VE', '', '', '1'),
(8356, 'VE_19', 'REGION', '19', 'Sucre', 'VE', '', '', '1'),
(8357, 'VE_20', 'REGION', '20', 'Tachira', 'VE', '', '', '1'),
(8358, 'VE_21', 'REGION', '21', 'Trujillo', 'VE', '', '', '1'),
(8359, 'VE_22', 'REGION', '22', 'Yaracuy', 'VE', '', '', '1'),
(8360, 'VE_23', 'REGION', '23', 'Zulia', 'VE', '', '', '1'),
(8361, 'VE_24', 'REGION', '24', 'Dependencias Federales', 'VE', '', '', '1'),
(8362, 'VE_25', 'REGION', '25', 'Distrito Federal', 'VE', '', '', '1'),
(8363, 'VE_26', 'REGION', '26', 'Vargas', 'VE', '', '', '1'),
(8364, 'VN_01', 'REGION', '01', 'An Giang', 'VN', '', '', '1'),
(8365, 'VN_02', 'REGION', '02', 'Bac Thai', 'VN', '', '', '1'),
(8366, 'VN_03', 'REGION', '03', 'Ben Tre', 'VN', '', '', '1'),
(8367, 'VN_04', 'REGION', '04', 'Binh Tri Thien', 'VN', '', '', '1'),
(8368, 'VN_05', 'REGION', '05', 'Cao Bang', 'VN', '', '', '1'),
(8369, 'VN_06', 'REGION', '06', 'Cuu Long', 'VN', '', '', '1'),
(8370, 'VN_07', 'REGION', '07', 'Dac Lac', 'VN', '', '', '1'),
(8371, 'VN_09', 'REGION', '09', 'Dong Thap', 'VN', '', '', '1'),
(8372, 'VN_11', 'REGION', '11', 'Ha Bac', 'VN', '', '', '1'),
(8373, 'VN_12', 'REGION', '12', 'Hai Hung', 'VN', '', '', '1'),
(8374, 'VN_13', 'REGION', '13', 'Hai Phong', 'VN', '', '', '1'),
(8375, 'VN_14', 'REGION', '14', 'Ha Nam Ninh', 'VN', '', '', '1'),
(8376, 'VN_15', 'REGION', '15', 'Ha Noi', 'VN', '', '', '1'),
(8377, 'VN_16', 'REGION', '16', 'Ha Son Binh', 'VN', '', '', '1'),
(8378, 'VN_17', 'REGION', '17', 'Ha Tuyen', 'VN', '', '', '1'),
(8379, 'VN_19', 'REGION', '19', 'Hoang Lien Son', 'VN', '', '', '1'),
(8380, 'VN_20', 'REGION', '20', 'Ho Chi Minh', 'VN', '', '', '1'),
(8381, 'VN_21', 'REGION', '21', 'Kien Giang', 'VN', '', '', '1'),
(8382, 'VN_22', 'REGION', '22', 'Lai Chau', 'VN', '', '', '1'),
(8383, 'VN_23', 'REGION', '23', 'Lam Dong', 'VN', '', '', '1'),
(8384, 'VN_24', 'REGION', '24', 'Long An', 'VN', '', '', '1'),
(8385, 'VN_25', 'REGION', '25', 'Minh Hai', 'VN', '', '', '1'),
(8386, 'VN_26', 'REGION', '26', 'Nghe Tinh', 'VN', '', '', '1'),
(8387, 'VN_27', 'REGION', '27', 'Nghia Binh', 'VN', '', '', '1'),
(8388, 'VN_28', 'REGION', '28', 'Phu Khanh', 'VN', '', '', '1'),
(8389, 'VN_29', 'REGION', '29', 'Quang Nam-Da Nang', 'VN', '', '', '1'),
(8390, 'VN_30', 'REGION', '30', 'Quang Ninh', 'VN', '', '', '1'),
(8391, 'VN_31', 'REGION', '31', 'Song Be', 'VN', '', '', '1'),
(8392, 'VN_32', 'REGION', '32', 'Son La', 'VN', '', '', '1'),
(8393, 'VN_33', 'REGION', '33', 'Tay Ninh', 'VN', '', '', '1'),
(8394, 'VN_34', 'REGION', '34', 'Thanh Hoa', 'VN', '', '', '1'),
(8395, 'VN_35', 'REGION', '35', 'Thai Binh', 'VN', '', '', '1'),
(8396, 'VN_36', 'REGION', '36', 'Thuan Hai', 'VN', '', '', '1'),
(8397, 'VN_37', 'REGION', '37', 'Tien Giang', 'VN', '', '', '1'),
(8398, 'VN_38', 'REGION', '38', 'Vinh Phu', 'VN', '', '', '1'),
(8399, 'VN_39', 'REGION', '39', 'Lang Son', 'VN', '', '', '1'),
(8400, 'VN_40', 'REGION', '40', 'Dong Nai', 'VN', '', '', '1'),
(8401, 'VN_43', 'REGION', '43', 'An Giang', 'VN', '', '', '1'),
(8402, 'VN_44', 'REGION', '44', 'Dac Lac', 'VN', '', '', '1'),
(8403, 'VN_45', 'REGION', '45', 'Dong Nai', 'VN', '', '', '1'),
(8404, 'VN_46', 'REGION', '46', 'Dong Thap', 'VN', '', '', '1'),
(8405, 'VN_47', 'REGION', '47', 'Kien Giang', 'VN', '', '', '1'),
(8406, 'VN_48', 'REGION', '48', 'Minh Hai', 'VN', '', '', '1'),
(8407, 'VN_49', 'REGION', '49', 'Song Be', 'VN', '', '', '1'),
(8408, 'VN_50', 'REGION', '50', 'Vinh Phu', 'VN', '', '', '1'),
(8409, 'VN_51', 'REGION', '51', 'Ha Noi', 'VN', '', '', '1'),
(8410, 'VN_52', 'REGION', '52', 'Ho Chi Minh', 'VN', '', '', '1'),
(8411, 'VN_53', 'REGION', '53', 'Ba Ria-Vung Tau', 'VN', '', '', '1'),
(8412, 'VN_54', 'REGION', '54', 'Binh Dinh', 'VN', '', '', '1'),
(8413, 'VN_55', 'REGION', '55', 'Binh Thuan', 'VN', '', '', '1'),
(8414, 'VN_56', 'REGION', '56', 'Can Tho', 'VN', '', '', '1'),
(8415, 'VN_57', 'REGION', '57', 'Gia Lai', 'VN', '', '', '1'),
(8416, 'VN_58', 'REGION', '58', 'Ha Giang', 'VN', '', '', '1'),
(8417, 'VN_59', 'REGION', '59', 'Ha Tay', 'VN', '', '', '1'),
(8418, 'VN_60', 'REGION', '60', 'Ha Tinh', 'VN', '', '', '1'),
(8419, 'VN_61', 'REGION', '61', 'Hoa Binh', 'VN', '', '', '1'),
(8420, 'VN_62', 'REGION', '62', 'Khanh Hoa', 'VN', '', '', '1'),
(8421, 'VN_63', 'REGION', '63', 'Kon Tum', 'VN', '', '', '1'),
(8422, 'VN_64', 'REGION', '64', 'Quang Tri', 'VN', '', '', '1'),
(8423, 'VN_65', 'REGION', '65', 'Nam Ha', 'VN', '', '', '1'),
(8424, 'VN_66', 'REGION', '66', 'Nghe An', 'VN', '', '', '1'),
(8425, 'VN_67', 'REGION', '67', 'Ninh Binh', 'VN', '', '', '1'),
(8426, 'VN_68', 'REGION', '68', 'Ninh Thuan', 'VN', '', '', '1'),
(8427, 'VN_69', 'REGION', '69', 'Phu Yen', 'VN', '', '', '1'),
(8428, 'VN_70', 'REGION', '70', 'Quang Binh', 'VN', '', '', '1'),
(8429, 'VN_71', 'REGION', '71', 'Quang Ngai', 'VN', '', '', '1'),
(8430, 'VN_72', 'REGION', '72', 'Quang Tri', 'VN', '', '', '1'),
(8431, 'VN_73', 'REGION', '73', 'Soc Trang', 'VN', '', '', '1'),
(8432, 'VN_74', 'REGION', '74', 'Thua Thien', 'VN', '', '', '1'),
(8433, 'VN_75', 'REGION', '75', 'Tra Vinh', 'VN', '', '', '1'),
(8434, 'VN_76', 'REGION', '76', 'Tuyen Quang', 'VN', '', '', '1'),
(8435, 'VN_77', 'REGION', '77', 'Vinh Long', 'VN', '', '', '1'),
(8436, 'VN_78', 'REGION', '78', 'Da Nang', 'VN', '', '', '1'),
(8437, 'VN_79', 'REGION', '79', 'Hai Duong', 'VN', '', '', '1'),
(8438, 'VN_80', 'REGION', '80', 'Ha Nam', 'VN', '', '', '1'),
(8439, 'VN_81', 'REGION', '81', 'Hung Yen', 'VN', '', '', '1'),
(8440, 'VN_82', 'REGION', '82', 'Nam Dinh', 'VN', '', '', '1'),
(8441, 'VN_83', 'REGION', '83', 'Phu Tho', 'VN', '', '', '1'),
(8442, 'VN_84', 'REGION', '84', 'Quang Nam', 'VN', '', '', '1'),
(8443, 'VN_85', 'REGION', '85', 'Thai Nguyen', 'VN', '', '', '1'),
(8444, 'VN_86', 'REGION', '86', 'Vinh Puc Province', 'VN', '', '', '1'),
(8445, 'VN_87', 'REGION', '87', 'Can Tho', 'VN', '', '', '1'),
(8446, 'VN_88', 'REGION', '88', 'Dak Lak', 'VN', '', '', '1'),
(8447, 'VN_89', 'REGION', '89', 'Lai Chau', 'VN', '', '', '1'),
(8448, 'VN_90', 'REGION', '90', 'Lao Cai', 'VN', '', '', '1'),
(8449, 'VN_91', 'REGION', '91', 'Dak Nong', 'VN', '', '', '1'),
(8450, 'VN_92', 'REGION', '92', 'Dien Bien', 'VN', '', '', '1'),
(8451, 'VN_93', 'REGION', '93', 'Hau Giang', 'VN', '', '', '1'),
(8452, 'VU_05', 'REGION', '05', 'Ambrym', 'VU', '', '', '1'),
(8453, 'VU_06', 'REGION', '06', 'Aoba', 'VU', '', '', '1'),
(8454, 'VU_07', 'REGION', '07', 'Torba', 'VU', '', '', '1'),
(8455, 'VU_08', 'REGION', '08', 'Efate', 'VU', '', '', '1'),
(8456, 'VU_09', 'REGION', '09', 'Epi', 'VU', '', '', '1'),
(8457, 'VU_10', 'REGION', '10', 'Malakula', 'VU', '', '', '1'),
(8458, 'VU_11', 'REGION', '11', 'Paama', 'VU', '', '', '1'),
(8459, 'VU_12', 'REGION', '12', 'Pentecote', 'VU', '', '', '1'),
(8460, 'VU_13', 'REGION', '13', 'Sanma', 'VU', '', '', '1'),
(8461, 'VU_14', 'REGION', '14', 'Shepherd', 'VU', '', '', '1'),
(8462, 'VU_15', 'REGION', '15', 'Tafea', 'VU', '', '', '1'),
(8463, 'VU_16', 'REGION', '16', 'Malampa', 'VU', '', '', '1'),
(8464, 'VU_17', 'REGION', '17', 'Penama', 'VU', '', '', '1'),
(8465, 'VU_18', 'REGION', '18', 'Shefa', 'VU', '', '', '1'),
(8466, 'WS_02', 'REGION', '02', 'Aiga-i-le-Tai', 'WS', '', '', '1'),
(8467, 'WS_03', 'REGION', '03', 'Atua', 'WS', '', '', '1'),
(8468, 'WS_04', 'REGION', '04', 'Fa', 'WS', '', '', '1'),
(8469, 'WS_05', 'REGION', '05', 'Gaga', 'WS', '', '', '1'),
(8470, 'WS_06', 'REGION', '06', 'Va', 'WS', '', '', '1'),
(8471, 'WS_07', 'REGION', '07', 'Gagaifomauga', 'WS', '', '', '1'),
(8472, 'WS_08', 'REGION', '08', 'Palauli', 'WS', '', '', '1'),
(8473, 'WS_09', 'REGION', '09', 'Satupa', 'WS', '', '', '1'),
(8474, 'WS_10', 'REGION', '10', 'Tuamasaga', 'WS', '', '', '1'),
(8475, 'WS_11', 'REGION', '11', 'Vaisigano', 'WS', '', '', '1'),
(8476, 'YE_01', 'REGION', '01', 'Abyan', 'YE', '', '', '1'),
(8477, 'YE_02', 'REGION', '02', 'Adan', 'YE', '', '', '1'),
(8478, 'YE_03', 'REGION', '03', 'Al Mahrah', 'YE', '', '', '1'),
(8479, 'YE_04', 'REGION', '04', 'Hadramawt', 'YE', '', '', '1'),
(8480, 'YE_05', 'REGION', '05', 'Shabwah', 'YE', '', '', '1'),
(8481, 'YE_06', 'REGION', '06', 'Al Ghaydah', 'YE', '', '', '1'),
(8482, 'YE_08', 'REGION', '08', 'Al Hudaydah', 'YE', '', '', '1'),
(8483, 'YE_10', 'REGION', '10', 'Al Mahwit', 'YE', '', '', '1'),
(8484, 'YE_11', 'REGION', '11', 'Dhamar', 'YE', '', '', '1'),
(8485, 'YE_15', 'REGION', '15', 'Sa', 'YE', '', '', '1'),
(8486, 'YE_16', 'REGION', '16', 'San', 'YE', '', '', '1'),
(8487, 'YE_21', 'REGION', '21', 'Al Jawf', 'YE', '', '', '1'),
(8488, 'YE_22', 'REGION', '22', 'Hajjah', 'YE', '', '', '1'),
(8489, 'YE_23', 'REGION', '23', 'Ibb', 'YE', '', '', '1'),
(8490, 'YE_24', 'REGION', '24', 'Lahij', 'YE', '', '', '1'),
(8491, 'YE_25', 'REGION', '25', 'Ta', 'YE', '', '', '1'),
(8492, 'ZA_01', 'REGION', '01', 'North-Western Province', 'ZA', '', '', '1'),
(8493, 'ZA_02', 'REGION', '02', 'KwaZulu-Natal', 'ZA', '', '', '1'),
(8494, 'ZA_03', 'REGION', '03', 'Free State', 'ZA', '', '', '1'),
(8495, 'ZA_05', 'REGION', '05', 'Eastern Cape', 'ZA', '', '', '1'),
(8496, 'ZA_06', 'REGION', '06', 'Gauteng', 'ZA', '', '', '1'),
(8497, 'ZA_07', 'REGION', '07', 'Mpumalanga', 'ZA', '', '', '1'),
(8498, 'ZA_08', 'REGION', '08', 'Northern Cape', 'ZA', '', '', '1'),
(8499, 'ZA_09', 'REGION', '09', 'Limpopo', 'ZA', '', '', '1'),
(8500, 'ZA_10', 'REGION', '10', 'North-West', 'ZA', '', '', '1'),
(8501, 'ZA_11', 'REGION', '11', 'Western Cape', 'ZA', '', '', '1'),
(8502, 'ZM_01', 'REGION', '01', 'Western', 'ZM', '', '', '1'),
(8503, 'ZM_02', 'REGION', '02', 'Central', 'ZM', '', '', '1'),
(8504, 'ZM_03', 'REGION', '03', 'Eastern', 'ZM', '', '', '1'),
(8505, 'ZM_04', 'REGION', '04', 'Luapula', 'ZM', '', '', '1'),
(8506, 'ZM_05', 'REGION', '05', 'Northern', 'ZM', '', '', '1'),
(8507, 'ZM_06', 'REGION', '06', 'North-Western', 'ZM', '', '', '1'),
(8508, 'ZM_07', 'REGION', '07', 'Southern', 'ZM', '', '', '1'),
(8509, 'ZM_08', 'REGION', '08', 'Copperbelt', 'ZM', '', '', '1'),
(8510, 'ZM_09', 'REGION', '09', 'Lusaka', 'ZM', '', '', '1'),
(8511, 'ZW_01', 'REGION', '01', 'Manicaland', 'ZW', '', '', '1'),
(8512, 'ZW_02', 'REGION', '02', 'Midlands', 'ZW', '', '', '1'),
(8513, 'ZW_03', 'REGION', '03', 'Mashonaland Central', 'ZW', '', '', '1'),
(8514, 'ZW_04', 'REGION', '04', 'Mashonaland East', 'ZW', '', '', '1'),
(8515, 'ZW_05', 'REGION', '05', 'Mashonaland West', 'ZW', '', '', '1'),
(8516, 'ZW_06', 'REGION', '06', 'Matabeleland North', 'ZW', '', '', '1'),
(8517, 'ZW_07', 'REGION', '07', 'Matabeleland South', 'ZW', '', '', '1'),
(8518, 'ZW_08', 'REGION', '08', 'Masvingo', 'ZW', '', '', '1'),
(8519, 'ZW_09', 'REGION', '09', 'Bulawayo', 'ZW', '', '', '1'),
(8520, 'ZW_10', 'REGION', '10', 'Harare', 'ZW', '', '', '1');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_reporting` (
  `entry_id` int(11) NOT NULL auto_increment,
  `type` varchar(100) NOT NULL,
  `time_stamp` varchar(100) NOT NULL,
  `date` date NOT NULL,
  `day` varchar(100) NOT NULL,
  `month` varchar(100) NOT NULL,
  `year` varchar(100) NOT NULL,
  `publication_id` varchar(100) NOT NULL,
  `zone_id` varchar(100) NOT NULL,
  `campaign_id` varchar(100) NOT NULL,
  `creative_id` varchar(100) NOT NULL,
  `network_id` varchar(100) NOT NULL,
  `total_requests` varchar(100) NOT NULL,
  `total_requests_sec` varchar(100) NOT NULL,
  `total_impressions` varchar(100) NOT NULL,
  `total_clicks` varchar(100) NOT NULL,
  `total_cost` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  UNIQUE KEY `reporting_select` (`publication_id`(6),`zone_id`(6),`campaign_id`(6),`creative_id`(6),`network_id`(6),`date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_syslog` (
  `entry_id` int(11) NOT NULL auto_increment,
  `log_type` varchar(100) NOT NULL,
  `time_stamp` varchar(100) NOT NULL,
  `status` varchar(100) NOT NULL,
  `details` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_trafficrequests` (
  `entry_id` int(11) NOT NULL auto_increment,
  `request_id` varchar(100) NOT NULL,
  `network_id` varchar(100) NOT NULL,
  `network_identifier` varchar(100) NOT NULL,
  `request_status` varchar(100) NOT NULL,
  `request_pricing_type` varchar(100) NOT NULL,
  `request_pricing` varchar(100) NOT NULL,
  `request_priority` varchar(100) NOT NULL,
  `request_received_timestamp` varchar(100) NOT NULL,
  `request_sent_timestamp` varchar(100) NOT NULL,
  `request_expiration` date NOT NULL,
  `request_autoapproved` varchar(1) NOT NULL,
  `campaign_name` varchar(255) NOT NULL,
  `campaign_desc` longtext NOT NULL,
  `campaign_start` date NOT NULL,
  `campaign_end` date NOT NULL,
  `target_iphone` varchar(1) NOT NULL,
  `target_ipod` varchar(1) NOT NULL,
  `target_ipad` varchar(1) NOT NULL,
  `target_android` varchar(1) NOT NULL,
  `target_other` varchar(1) NOT NULL,
  `ios_version_min` varchar(100) NOT NULL,
  `ios_version_max` varchar(100) NOT NULL,
  `android_version_min` varchar(100) NOT NULL,
  `android_version_max` varchar(100) NOT NULL,
  `device_target` varchar(1) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_trafficrequests_parameters` (
  `entry_id` int(11) NOT NULL auto_increment,
  `request_id` varchar(100) NOT NULL,
  `parameter_id` varchar(100) NOT NULL,
  `parameter_value` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_uaccounts` (
  `user_id` int(11) NOT NULL auto_increment,
  `email_address` varchar(100) NOT NULL,
  `pass_word` varchar(100) NOT NULL,
  `account_status` char(1) NOT NULL,
  `account_type` varchar(100) NOT NULL,
  `company_name` varchar(100) NOT NULL,
  `first_name` varchar(100) NOT NULL,
  `last_name` varchar(100) NOT NULL,
  `gender` varchar(100) NOT NULL,
  `phone_number` varchar(100) NOT NULL,
  `fax_number` varchar(100) NOT NULL,
  `company_address` varchar(100) NOT NULL,
  `company_city` varchar(100) NOT NULL,
  `company_state` varchar(100) NOT NULL,
  `company_zip` varchar(100) NOT NULL,
  `company_country` varchar(100) NOT NULL,
  `tax_id` varchar(100) NOT NULL,
  `tooltip_setting` varchar(1) NOT NULL,
  `creation_date` varchar(100) NOT NULL,
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;
", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_user_groups` (
  `entry_id` int(11) NOT NULL auto_increment,
  `group_name` varchar(100) NOT NULL,
  `group_description` longtext NOT NULL,
  `group_status` char(1) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3 ;", $maindb);
mysql_query("INSERT INTO `md_user_groups` (`entry_id`, `group_name`, `group_description`, `group_status`) VALUES
(1, 'Administrators', 'This is the Administrator User Group. Users in this group automatically have full administration permissions on the mAdserve ad server.', '1'),
(2, 'Advertisers', 'This is the main Advertiser group. Users in this group can create & manage their own campaigns and can generate reports for campaigns they have originally created.', '1');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_user_rights` (
  `entry_id` int(11) NOT NULL auto_increment,
  `user_id` varchar(100) NOT NULL,
  `group_id` varchar(100) NOT NULL,
  `view_own_campaigns` varchar(1) NOT NULL,
  `view_all_campaigns` varchar(1) NOT NULL,
  `create_campaigns` varchar(1) NOT NULL,
  `view_publications` varchar(1) NOT NULL,
  `modify_publications` varchar(1) NOT NULL,
  `view_advertisers` varchar(1) NOT NULL,
  `modify_advertisers` varchar(1) NOT NULL,
  `ad_networks` varchar(1) NOT NULL,
  `campaign_reporting` varchar(1) NOT NULL,
  `own_campaign_reporting` varchar(1) NOT NULL,
  `publication_reporting` varchar(1) NOT NULL,
  `network_reporting` varchar(1) NOT NULL,
  `configuration` varchar(1) NOT NULL,
  `traffic_requests` varchar(1) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("INSERT INTO `md_user_rights` (`entry_id`, `user_id`, `group_id`, `view_own_campaigns`, `view_all_campaigns`, `create_campaigns`, `view_publications`, `modify_publications`, `view_advertisers`, `modify_advertisers`, `ad_networks`, `campaign_reporting`, `own_campaign_reporting`, `publication_reporting`, `network_reporting`, `configuration`, `traffic_requests`) VALUES
(1, '', '2', '1', '0', '1', '0', '0', '0', '0', '0', '0', '1', '0', '0', '0', '0');", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_usessions` (
  `entry_id` int(11) NOT NULL auto_increment,
  `session_id` varchar(100) NOT NULL,
  `session_timeout` varchar(100) NOT NULL,
  `session_status` varchar(100) NOT NULL,
  `user_identification` varchar(100) NOT NULL,
  `user_password` varchar(100) NOT NULL,
  `session_type` varchar(100) NOT NULL,
  `ip_address` varchar(100) NOT NULL,
  `date_created` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("CREATE TABLE IF NOT EXISTS `md_zones` (
  `entry_id` int(11) NOT NULL auto_increment,
  `publication_id` varchar(100) NOT NULL,
  `zone_hash` varchar(100) NOT NULL,
  `zone_name` varchar(100) NOT NULL,
  `zone_type` varchar(100) NOT NULL,
  `zone_width` varchar(100) NOT NULL,
  `zone_height` varchar(100) NOT NULL,
  `zone_refresh` varchar(100) NOT NULL,
  `zone_channel` varchar(100) NOT NULL,
  `zone_lastrequest` varchar(100) NOT NULL,
  `zone_description` longtext NOT NULL,
  `mobfox_backfill_active` varchar(100) NOT NULL,
  `mobfox_min_cpc_active` varchar(100) NOT NULL,
  `min_cpc` decimal(5,3) NOT NULL,
  `min_cpm` decimal(5,3) NOT NULL,
  `backfill_alt_1` varchar(100) NOT NULL,
  `backfill_alt_2` varchar(100) NOT NULL,
  `backfill_alt_3` varchar(100) NOT NULL,
  PRIMARY KEY  (`entry_id`),
  KEY `publication_id` (`publication_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;", $maindb);
mysql_query("INSERT INTO `md_syslog` (`entry_id`, `log_type`, `time_stamp`, `status`, `details`) VALUES (NULL, 'system_install', '".time()."', '1', '');", $maindb);


if ($data['mobfox_connect_type']==1){
$mobfox_uid=$data['mf_user'];
$mobfox_pass=md5($data['mf_pass']);
}
else if ($data['mobfox_connect_type']==2){
$mobfox_uid=$data['mf_email'];
$mobfox_pass=md5($data['mf_password']);	
}

$madserve_udid=md5(uniqid(time()));

mysql_query("INSERT INTO `md_configuration` (`entry_id`, `var_name`, `var_value`) VALUES
(1, 'adserver_name', '".$mad_basic_configuration['server_name']."'),
(2, 'db_install_version', '2.0'),
(3, 'api_key', 'e10adc3949ba59abbe56e057f20f883e'),
(4, 'last_tafficrequest_id', '0'),
(5, 'mobfox_uid', '".$mobfox_uid."'),
(6, 'mobfox_password', '".$mobfox_pass."'),
(7, 'last_trafficrequest_update', ''),
(8, 'last_limit_update', ''),
(9, 'server_email', '".$mad_basic_configuration['admin_email']."'),
(10, 'last_mf_check', ''),
(11, 'allow_statistical_info', '1'),
(12, 'installation_id', '".$madserve_udid."'),
(13, 'update_check', '1'),
(14, 'default_creative_server', '1'),
(15, 'last_pendingactions_exec', ''),
(16, 'last_cron_job', '');", $maindb);

mysql_query("INSERT INTO `md_uaccounts` ( `email_address`, `pass_word`, `account_status`, `account_type`, `first_name`, `last_name`, `creation_date`) VALUES
('".strtolower($mad_basic_configuration['admin_email'])."', '".md5($mad_basic_configuration['admin_pass'])."', '1', '1', '".$mad_basic_configuration['admin_firstname']."', '".$mad_basic_configuration['admin_lastname']."', '".time()."');", $maindb);

$configfile_content='
;<?php exit; ?>
;*** DO NOT REMOVE THE LINE ABOVE ***
;------------------------------------------------------------------------------------------;
; General mAdserve    Installation Settings                                                      ;
;------------------------------------------------------------------------------------------;

[madserve]
installed                           = true

;------------------------------------------------------------------------------------------;
; Database Settings                                                                        ;
;------------------------------------------------------------------------------------------;

[database]
type                                = mysql
host                                = "'.$mad_db_configuration['db_host'].'"
socket                              =
port                                =
username                            = "'.$mad_db_configuration['db_user'].'"
password                            = "'.$mad_db_configuration['db_pass'].'"
name                                = "'.$mad_db_configuration['db_name'].'"

[reportingdatabase]
useseparatereportingdatabase     = false
type                                = mysql
host                                =
socket                              =
port                                =
username                            =
password                            =
name                                =
';

if (!write_config(MAD_PATH . '/conf/main.config.php', $configfile_content)){
echo "Fatal Error. Unable to write into /conf/ directory. Please check directory permissions and start over.";
exit;	
}


delete_config(MAD_PATH . '/conf/INSTALLTEMP_MAINCONFIG');
delete_config(MAD_PATH . '/conf/INSTALLTEMP_DBCONFIG');

	
if (!fopen(MAD_PATH . '/conf/INSTALLED', 'w')){
global $errormessage;
$errormessage='Could not write to /conf/ directory. Installation failed, please re-start installation';
return false;	
}
	
return true;	
}

function delete_config($file){
if (unlink($file)){
	return true; }
	return false;
}



function read_config($file){
error_reporting(0);
if (!$fh = fopen($file, 'r')){
return false;
}
$theData = fread($fh, filesize($file));
fclose($fh);
return $theData;
}

function write_config($file, $content){
if (!$fh = fopen($file, 'w')){
return false;	
}
if (!fwrite($fh, $content)){
return false;	
}
return true;
}



?>